/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/network","vs/base/common/strings","vs/base/node/pfs","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(Q){for(var e=[],D=0,T=Q.length;D<T;D++)e[D]=oe[Q[D]];return e};define(oe[63],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(O){return(P,I,E)=>{let C=null,w=null;if(typeof E.value=="function"?(C="value",w=E.value):typeof E.get=="function"&&(C="get",w=E.get),!w)throw new Error("not supported");E[C]=O(w,I)}}function T(O,P,I){let E=null,C=null;if(typeof I.value=="function"?(E="value",C=I.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(E="get",C=I.get),!C)throw new Error("not supported");const w=`$memoize$${P}`;I[E]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[w]}}e.memoize=T;function R(O,P,I){return D((E,C)=>{const w=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...y){this[m]||(this[m]=I?I():void 0),clearTimeout(this[w]),P&&(this[m]=P(this[m],...y),y=[this[m]]),this[w]=setTimeout(()=>{E.apply(this,y),this[m]=I?I():void 0},O)}})}e.debounce=R;function c(O,P,I){return D((E,C)=>{const w=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,y=`$throttle$lastRun$${C}`,h=`$throttle$pending$${C}`;return function(...S){if(this[m]||(this[m]=I?I():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...S)),this[h])return;const u=this[y]+O;u<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[m]]),this[m]=I?I():void 0):(this[h]=!0,this[w]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),E.apply(this,[this[m]]),this[m]=I?I():void 0},u-Date.now()))}})}e.throttle=c}),define(oe[9],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?b.isErrorNoTelemetry(r)?new b(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(t=>{t(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=D,e.errorHandler=new D;function T(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=T;function R(i){return!!i&&typeof i=="object"&&i.code==="EPIPE"&&i.syscall==="WRITE"}e.isSigPipeError=R;function c(i){E(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=c;function O(i){E(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=O;function P(i){if(i instanceof Error){const{name:r,message:t}=i,n=i.stacktrace||i.stack;return{$isError:!0,name:r,message:t,stack:n,noTelemetry:b.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=P;const I="Canceled";function E(i){return i instanceof C?!0:i instanceof Error&&i.name===I&&i.message===I}e.isCancellationError=E;class C extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=C;function w(){const i=new Error(I);return i.name=i.message,i}e.canceled=w;function m(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=m;function y(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=y;function h(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function S(i){const r=new Error(`${i} has been disposed`);return r.name="DISPOSED",r}e.disposed=S;function u(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=u;class l extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=l;class g extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=g;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class b extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof b)return r;const t=new b;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class A extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype);debugger}}e.BugIndicatingError=A}),define(oe[21],ae([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function T(K,Z=0){return K[K.length-(1+Z)]}e.tail=T;function R(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=R;function c(K,Z,se=(le,ue)=>le===ue){if(K===Z)return!0;if(!K||!Z||K.length!==Z.length)return!1;for(let le=0,ue=K.length;le<ue;le++)if(!se(K[le],Z[le]))return!1;return!0}e.equals=c;function O(K,Z){const se=K.length-1;Z<se&&(K[Z]=K[se]),K.pop()}e.removeFastWithoutKeepingOrder=O;function P(K,Z,se){return I(K.length,le=>se(K[le],Z))}e.binarySearch=P;function I(K,Z){let se=0,le=K-1;for(;se<=le;){const ue=(se+le)/2|0,pe=Z(ue);if(pe<0)se=ue+1;else if(pe>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=I;function E(K,Z){let se=0,le=K.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);Z(K[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=E;function C(K,Z,se){if(K=K|0,K>=Z.length)throw new TypeError("invalid index");const le=Z[Math.floor(Z.length*Math.random())],ue=[],pe=[],ve=[];for(const be of Z){const Ee=se(be,le);Ee<0?ue.push(be):Ee>0?pe.push(be):ve.push(be)}return K<ue.length?C(K,ue,se):K<ue.length+ve.length?ve[0]:C(K-(ue.length+ve.length),pe,se)}e.quickSelect=C;function w(K,Z){const se=[];let le;for(const ue of K.slice(0).sort(Z))!le||Z(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=w;function m(K,Z,se){const le=[];function ue(be,Ee,Oe){if(Ee===0&&Oe.length===0)return;const Ue=le[le.length-1];Ue&&Ue.start+Ue.deleteCount===be?(Ue.deleteCount+=Ee,Ue.toInsert.push(...Oe)):le.push({start:be,deleteCount:Ee,toInsert:Oe})}let pe=0,ve=0;for(;;){if(pe===K.length){ue(pe,0,Z.slice(ve));break}if(ve===Z.length){ue(pe,K.length-pe,[]);break}const be=K[pe],Ee=Z[ve],Oe=se(be,Ee);Oe===0?(pe+=1,ve+=1):Oe<0?(ue(pe,1,[]),pe+=1):Oe>0&&(ue(pe,0,[Ee]),ve+=1)}return le}e.sortedDiff=m;function y(K,Z,se){const le=m(K,Z,se),ue=[],pe=[];for(const ve of le)ue.push(...K.slice(ve.start,ve.start+ve.deleteCount)),pe.push(...ve.toInsert);return{removed:ue,added:pe}}e.delta=y;function h(K,Z,se){if(se===0)return[];const le=K.slice(0,se).sort(Z);return u(K,Z,le,se,K.length),le}e.top=h;function S(K,Z,se,le,ue){return se===0?Promise.resolve([]):new Promise((pe,ve)=>{(async()=>{const be=K.length,Ee=K.slice(0,se).sort(Z);for(let Oe=se,Ue=Math.min(se+le,be);Oe<be;Oe=Ue,Ue=Math.min(Ue+le,be)){if(Oe>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new D.CancellationError;u(K,Z,Ee,Oe,Ue)}return Ee})().then(pe,ve)})}e.topAsync=S;function u(K,Z,se,le,ue){for(const pe=se.length;le<ue;le++){const ve=K[le];if(Z(ve,se[pe-1])<0){se.pop();const be=E(se,Ee=>Z(ve,Ee)<0);se.splice(be,0,ve)}}}function l(K){return K.filter(Z=>!!Z)}e.coalesce=l;function g(K){let Z=0;for(let se=0;se<K.length;se++)K[se]&&(K[Z]=K[se],Z+=1);K.length=Z}e.coalesceInPlace=g;function p(K,Z,se){K.splice(se,0,K.splice(Z,1)[0])}e.move=p;function b(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=b;function A(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=A;function i(K,Z=se=>se){const se=new Set;return K.filter(le=>{const ue=Z(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=i;function r(K){const Z=new Set;return se=>{const le=K(se);return Z.has(le)?!1:(Z.add(le),!0)}}e.uniqueFilter=r;function t(K,Z){const se=n(K,Z);if(se!==-1)return K[se]}e.findLast=t;function n(K,Z){for(let se=K.length-1;se>=0;se--){const le=K[se];if(Z(le))return se}return-1}e.lastIndex=n;function s(K,Z){return K.length>0?K[0]:Z}e.firstOrDefault=s;function a(K,Z){return K.length>0?K[K.length-1]:Z}e.lastOrDefault=a;function o(K,Z,se=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(K.length,Z.length);ue<pe&&se(K[ue],Z[ue]);ue++)le++;return le}e.commonPrefixLength=o;function f(K){return[].concat(...K)}e.flatten=f;function d(K,Z){let se=typeof Z=="number"?K:0;typeof Z=="number"?se=K:(se=0,Z=K);const le=[];if(se<=Z)for(let ue=se;ue<Z;ue++)le.push(ue);else for(let ue=se;ue>Z;ue--)le.push(ue);return le}e.range=d;function v(K,Z,se){return K.reduce((le,ue)=>(le[Z(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=v;function L(K,Z){return K.push(Z),()=>N(K,Z)}e.insert=L;function N(K,Z){const se=K.indexOf(Z);if(se>-1)return K.splice(se,1),Z}e.remove=N;function F(K,Z,se){const le=K.slice(0,Z),ue=K.slice(Z);return le.concat(se,ue)}e.arrayInsert=F;function M(K,Z){let se;if(typeof Z=="number"){let le=Z;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=K.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),pe=K[le];K[le]=K[ue],K[ue]=pe}}e.shuffle=M;function k(K,Z){const se=K.indexOf(Z);se>-1&&(K.splice(se,1),K.unshift(Z))}e.pushToStart=k;function $(K,Z){const se=K.indexOf(Z);se>-1&&(K.splice(se,1),K.push(Z))}e.pushToEnd=$;function z(K,Z){for(const se of Z)K.push(se)}e.pushMany=z;function x(K,Z){return Array.isArray(K)?K.map(Z):Z(K)}e.mapArrayOrNot=x;function X(K){return Array.isArray(K)?K:[K]}e.asArray=X;function ie(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=ie;function H(K,Z){for(const se of K){const le=Z(se);if(le!==void 0)return le}}e.mapFind=H;function j(K,Z,se){const le=J(K,Z),ue=K.length,pe=se.length;K.length=ue+pe;for(let ve=ue-1;ve>=le;ve--)K[ve+pe]=K[ve];for(let ve=0;ve<pe;ve++)K[ve+le]=se[ve]}e.insertInto=j;function V(K,Z,se,le){const ue=J(K,Z),pe=K.splice(ue,se);return j(K,ue,le),pe}e.splice=V;function J(K,Z){return Z<0?Math.max(Z+K.length,0):Math.min(Z,K.length)}var _;(function(K){function Z(ue){return ue<0}K.isLessThan=Z;function se(ue){return ue>0}K.isGreaterThan=se;function le(ue){return ue===0}K.isNeitherLessOrGreaterThan=le,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(_=e.CompareResult||(e.CompareResult={}));function re(K,Z){return(se,le)=>Z(K(se),K(le))}e.compareBy=re;function te(...K){return(Z,se)=>{for(const le of K){const ue=le(Z,se);if(!_.isNeitherLessOrGreaterThan(ue))return ue}return _.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const U=(K,Z)=>K-Z;e.numberComparator=U;function B(K,Z){if(K.length===0)return;let se=K[0];for(let le=1;le<K.length;le++){const ue=K[le];Z(ue,se)>0&&(se=ue)}return se}e.findMaxBy=B;function W(K,Z){if(K.length===0)return;let se=K[0];for(let le=1;le<K.length;le++){const ue=K[le];Z(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=W;function q(K,Z){return B(K,(se,le)=>-Z(se,le))}e.findMinBy=q;class Y{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let se=this.c;for(;se<this.f.length&&Z(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(Z){let se=this.d;for(;se>=0&&Z(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const se=this.f.slice(this.c,this.c+Z);return this.c+=Z,se}}e.ArrayQueue=Y;class ee{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(se=>(Z(se),!0))}toArray(){const Z=[];return this.iterate(se=>(Z.push(se),!0)),Z}filter(Z){return new ee(se=>this.iterate(le=>Z(le)?se(le):!0))}map(Z){return new ee(se=>this.iterate(le=>se(Z(le))))}some(Z){let se=!1;return this.iterate(le=>(se=Z(le),!se)),se}findFirst(Z){let se;return this.iterate(le=>Z(le)?(se=le,!1):!0),se}findLast(Z){let se;return this.iterate(le=>(Z(le)&&(se=le),!0)),se}findLastMaxBy(Z){let se,le=!0;return this.iterate(ue=>((le||_.isGreaterThan(Z(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=ee,ee.empty=new ee(K=>{})}),define(oe[128],ae([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function T(I,E){if(!I)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=T;function R(I,E="Unreachable"){throw new Error(E)}e.assertNever=R;function c(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=c;function O(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function P(I,E){let C=0;for(;C<I.length-1;){const w=I[C],m=I[C+1];if(!E(w,m))return!1;C++}return!0}e.checkAdjacentItems=P}),define(oe[82],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(T){const R=this;let c=!1,O;return function(){return c||(c=!0,O=T.apply(R,arguments)),O}}e.once=D}),define(oe[64],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function R(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}T.is=R;const c=Object.freeze([]);function O(){return c}T.empty=O;function*P(b){yield b}T.single=P;function I(b){return R(b)?b:P(b)}T.wrap=I;function E(b){return b||c}T.from=E;function C(b){return!b||b[Symbol.iterator]().next().done===!0}T.isEmpty=C;function w(b){return b[Symbol.iterator]().next().value}T.first=w;function m(b,A){for(const i of b)if(A(i))return!0;return!1}T.some=m;function y(b,A){for(const i of b)if(A(i))return i}T.find=y;function*h(b,A){for(const i of b)A(i)&&(yield i)}T.filter=h;function*S(b,A){let i=0;for(const r of b)yield A(r,i++)}T.map=S;function*u(...b){for(const A of b)for(const i of A)yield i}T.concat=u;function l(b,A,i){let r=i;for(const t of b)r=A(r,t);return r}T.reduce=l;function*g(b,A,i=b.length){for(A<0&&(A+=b.length),i<0?i+=b.length:i>b.length&&(i=b.length);A<i;A++)yield b[A]}T.slice=g;function p(b,A=Number.POSITIVE_INFINITY){const i=[];if(A===0)return[i,b];const r=b[Symbol.iterator]();for(let t=0;t<A;t++){const n=r.next();if(n.done)return[i,T.empty()];i.push(n.value)}return[i,{[Symbol.iterator](){return r}}]}T.consume=p})(D=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var c;(function(i){i.DEFAULT={allowTrailingComma:!0}})(c=e.ParseOptions||(e.ParseOptions={}));function O(i,r=!1){let t=0;const n=i.length;let s="",a=0,o=16,f=0;function d($){let z=0,x=0;for(;z<$;){const X=i.charCodeAt(t);if(X>=48&&X<=57)x=x*16+X-48;else if(X>=65&&X<=70)x=x*16+X-65+10;else if(X>=97&&X<=102)x=x*16+X-97+10;else break;t++,z++}return z<$&&(x=-1),x}function v($){t=$,s="",a=0,o=16,f=0}function L(){const $=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&E(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&E(i.charCodeAt(t)))for(t++;t<i.length&&E(i.charCodeAt(t));)t++;else return f=3,i.substring($,t);let z=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&E(i.charCodeAt(t))){for(t++;t<i.length&&E(i.charCodeAt(t));)t++;z=t}else f=3;return i.substring($,z)}function N(){let $="",z=t;for(;;){if(t>=n){$+=i.substring(z,t),f=2;break}const x=i.charCodeAt(t);if(x===34){$+=i.substring(z,t),t++;break}if(x===92){if($+=i.substring(z,t),t++,t>=n){f=2;break}switch(i.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const ie=d(4);ie>=0?$+=String.fromCharCode(ie):f=4;break}default:f=5}z=t;continue}if(x>=0&&x<=31)if(I(x)){$+=i.substring(z,t),f=2;break}else f=6;t++}return $}function F(){if(s="",f=0,a=t,t>=n)return a=n,o=17;let $=i.charCodeAt(t);if(P($)){do t++,s+=String.fromCharCode($),$=i.charCodeAt(t);while(P($));return o=15}if(I($))return t++,s+=String.fromCharCode($),$===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),o=14;switch($){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,s=N(),o=10;case 47:{const z=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!I(i.charCodeAt(t));)t++;return s=i.substring(z,t),o=12}if(i.charCodeAt(t+1)===42){t+=2;const x=n-1;let X=!1;for(;t<x;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,X=!0;break}t++}return X||(t++,f=1),s=i.substring(z,t),o=13}return s+=String.fromCharCode($),t++,o=16}case 45:if(s+=String.fromCharCode($),t++,t===n||!E(i.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=L(),o=11;default:for(;t<n&&M($);)t++,$=i.charCodeAt(t);if(a!==t){switch(s=i.substring(a,t),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode($),t++,o=16}}function M($){if(P($)||I($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let $;do $=F();while($>=12&&$<=15);return $}return{setPosition:v,getPosition:()=>t,scan:r?k:F,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>f}}e.createScanner=O;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function I(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function w(i,r){const t=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(d,v,L,N){a.value=d,a.offset=v,a.length=L,a.type=N,a.colonOffset=void 0,s=a}try{p(i,{onObjectBegin:(d,v)=>{if(r<=d)throw n;s=void 0,o=r>d,t.push("")},onObjectProperty:(d,v,L)=>{if(r<v||(f(d,v,L,"property"),t[t.length-1]=d,r<=v+L))throw n},onObjectEnd:(d,v)=>{if(r<=d)throw n;s=void 0,t.pop()},onArrayBegin:(d,v)=>{if(r<=d)throw n;s=void 0,t.push(0)},onArrayEnd:(d,v)=>{if(r<=d)throw n;s=void 0,t.pop()},onLiteralValue:(d,v,L)=>{if(r<v||(f(d,v,L,A(d)),r<=v+L))throw n},onSeparator:(d,v,L)=>{if(r<=v)throw n;if(d===":"&&s&&s.type==="property")s.colonOffset=v,o=!1,s=void 0;else if(d===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(o=!0,t[t.length-1]=""),s=void 0}}})}catch(d){if(d!==n)throw d}return{path:t,previousNode:s,isAtPropertyKey:o,matches:d=>{let v=0;for(let L=0;v<d.length&&L<t.length;L++)if(d[v]===t[L]||d[v]==="*")v++;else if(d[v]!=="**")return!1;return v===d.length}}}e.getLocation=w;function m(i,r=[],t=c.DEFAULT){let n=null,s=[];const a=[];function o(d){Array.isArray(s)?s.push(d):n!==null&&(s[n]=d)}return p(i,{onObjectBegin:()=>{const d={};o(d),a.push(s),s=d,n=null},onObjectProperty:d=>{n=d},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const d=[];o(d),a.push(s),s=d,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:o,onError:(d,v,L)=>{r.push({error:d,offset:v,length:L})}},t),s[0]}e.parse=m;function y(i,r=[],t=c.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(d){n.type==="property"&&(n.length=d-n.offset,n=n.parent)}function a(d){return n.children.push(d),d}p(i,{onObjectBegin:d=>{n=a({type:"object",offset:d,length:-1,parent:n,children:[]})},onObjectProperty:(d,v,L)=>{n=a({type:"property",offset:v,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:d,offset:v,length:L,parent:n})},onObjectEnd:(d,v)=>{n.length=d+v-n.offset,n=n.parent,s(d+v)},onArrayBegin:(d,v)=>{n=a({type:"array",offset:d,length:-1,parent:n,children:[]})},onArrayEnd:(d,v)=>{n.length=d+v-n.offset,n=n.parent,s(d+v)},onLiteralValue:(d,v,L)=>{a({type:A(d),offset:v,length:L,parent:n,value:d}),s(v+L)},onSeparator:(d,v,L)=>{n.type==="property"&&(d===":"?n.colonOffset=v:d===","&&s(v))},onError:(d,v,L)=>{r.push({error:d,offset:v,length:L})}},t);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=y;function h(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===n){t=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=h;function S(i){if(!i.parent||!i.parent.children)return[];const r=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.getNodePath=S;function u(i){switch(i.type){case"array":return i.children.map(u);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=u(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=u;function l(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.contains=l;function g(i,r,t=!1){if(l(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const a=g(n[s],r,t);if(a)return a}return i}}e.findNodeAtOffset=g;function p(i,r,t=c.DEFAULT){const n=O(i,!1);function s(re){return re?()=>re(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(re){return re?te=>re(te,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),f=a(r.onObjectProperty),d=s(r.onObjectEnd),v=s(r.onArrayBegin),L=s(r.onArrayEnd),N=a(r.onLiteralValue),F=a(r.onSeparator),M=s(r.onComment),k=a(r.onError),$=t&&t.disallowComments,z=t&&t.allowTrailingComma;function x(){for(;;){const re=n.scan();switch(n.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:$||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(re){case 12:case 13:$?X(10):M();break;case 16:X(1);break;case 15:case 14:break;default:return re}}}function X(re,te=[],U=[]){if(k(re),te.length+U.length>0){let B=n.getToken();for(;B!==17;){if(te.indexOf(B)!==-1){x();break}else if(U.indexOf(B)!==-1)break;B=x()}}}function ie(re){const te=n.getTokenValue();return re?N(te):f(te),x(),!0}function H(){switch(n.getToken()){case 11:{let re=0;try{re=JSON.parse(n.getTokenValue()),typeof re!="number"&&(X(2),re=0)}catch{X(2)}N(re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return x(),!0}function j(){return n.getToken()!==10?(X(3,[],[2,5]),!1):(ie(!1),n.getToken()===6?(F(":"),x(),_()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function V(){o(),x();let re=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(re||X(4,[],[]),F(","),x(),n.getToken()===2&&z)break}else re&&X(6,[],[]);j()||X(4,[],[2,5]),re=!0}return d(),n.getToken()!==2?X(7,[2],[]):x(),!0}function J(){v(),x();let re=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(re||X(4,[],[]),F(","),x(),n.getToken()===4&&z)break}else re&&X(6,[],[]);_()||X(4,[],[4,5]),re=!0}return L(),n.getToken()!==4?X(8,[4],[]):x(),!0}function _(){switch(n.getToken()){case 3:return J();case 1:return V();case 10:return ie(!0);default:return H()}}return x(),n.getToken()===17?t.allowEmptyContent?!0:(X(4,[],[]),!1):_()?(n.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=p;function b(i,r){const t=O(i),n=[];let s,a=0,o;do switch(o=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:a!==o&&n.push(i.substring(a,o)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),a=t.getPosition();break}while(s!==17);return n.join("")}e.stripComments=b;function A(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=A}),define(oe[43],ae([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function T(E,C,w){let m,y,h,S,u;if(C){for(S=C.offset,u=S+C.length,h=S;h>0&&!I(E,h-1);)h--;let o=u;for(;o<E.length&&!I(E,o);)o++;y=E.substring(h,o),m=O(y,w)}else y=E,m=0,h=0,S=0,u=E.length;const l=P(w,E);let g=!1,p=0,b;w.insertSpaces?b=c(" ",w.tabSize||4):b="	";const A=(0,D.createScanner)(y,!1);let i=!1;function r(){return l+c(b,m+p)}function t(){let o=A.scan();for(g=!1;o===15||o===14;)g=g||o===14,o=A.scan();return i=o===16||A.getTokenError()!==0,o}const n=[];function s(o,f,d){!i&&f<u&&d>S&&E.substring(f,d)!==o&&n.push({offset:f,length:d-f,content:o})}let a=t();if(a!==17){const o=A.getTokenOffset()+h,f=c(b,m);s(f,h,o)}for(;a!==17;){let o=A.getTokenOffset()+A.getTokenLength()+h,f=t(),d="";for(;!g&&(f===12||f===13);){const L=A.getTokenOffset()+h;s(" ",o,L),o=A.getTokenOffset()+A.getTokenLength()+h,d=f===12?r():"",f=t()}if(f===2)a!==1&&(p--,d=r());else if(f===4)a!==3&&(p--,d=r());else{switch(a){case 3:case 1:p++,d=r();break;case 5:case 12:d=r();break;case 13:g?d=r():d=" ";break;case 6:d=" ";break;case 10:if(f===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?d=" ":f!==5&&f!==17&&(i=!0);break;case 16:i=!0;break}g&&(f===12||f===13)&&(d=r())}const v=A.getTokenOffset()+h;s(d,o,v),a=f}return n}e.format=T;function R(E,C){const w=JSON.stringify(E,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?w.replace(/\r\n|\r|\n/g,C.eol):w}e.toFormattedString=R;function c(E,C){let w="";for(let m=0;m<C;m++)w+=E;return w}function O(E,C){let w=0,m=0;const y=C.tabSize||4;for(;w<E.length;){const h=E.charAt(w);if(h===" ")m++;else if(h==="	")m+=y;else break;w++}return Math.floor(m/y)}function P(E,C){for(let w=0;w<C.length;w++){const m=C.charAt(w);if(m==="\r")return w+1<C.length&&C.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=P;function I(E,C){return`\r
`.indexOf(E.charAt(C))!==-1}e.isEOL=I}),define(oe[83],ae([0,1,35,43]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,C,w){return c(E,C,void 0,w)}e.removeProperty=R;function c(E,C,w,m,y){const h=C.slice(),S=[],u=(0,D.parseTree)(E,S);let l,g;for(;h.length>0&&(g=h.pop(),l=(0,D.findNodeAtLocation)(u,h),l===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(l)if(l.type==="object"&&typeof g=="string"&&Array.isArray(l.children)){const p=(0,D.findNodeAtLocation)(l,[g]);if(p!==void 0)if(w===void 0){if(!p.parent)throw new Error("Malformed AST");const b=l.children.indexOf(p.parent);let A,i=p.parent.offset+p.parent.length;if(b>0){const r=l.children[b-1];A=r.offset+r.length}else A=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return O(E,{offset:A,length:i-A,content:""},m)}else return O(E,{offset:p.offset,length:p.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const b=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,A=y?y(l.children.map(r=>r.children[0].value)):l.children.length;let i;if(A>0){const r=l.children[A-1];i={offset:r.offset+r.length,length:0,content:","+b}}else l.children.length===0?i={offset:l.offset+1,length:0,content:b}:i={offset:l.offset+1,length:0,content:b+","};return O(E,i,m)}}else if(l.type==="array"&&typeof g=="number"&&Array.isArray(l.children))if(w!==void 0){const p=`${JSON.stringify(w)}`;let b;if(l.children.length===0||g===0)b={offset:l.offset+1,length:0,content:l.children.length===0?p:p+","};else{const A=g===-1||g>l.children.length?l.children.length:g,i=l.children[A-1];b={offset:i.offset+i.length,length:0,content:","+p}}return O(E,b,m)}else{const p=g,b=l.children[p];let A;if(l.children.length===1)A={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===p){const i=l.children[p-1],r=i.offset+i.length,t=l.offset+l.length;A={offset:r,length:t-2-r,content:""}}else A={offset:b.offset,length:l.children[p+1].offset-b.offset,content:""};return O(E,A,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${l.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return O(E,{offset:u?u.offset:0,length:u?u.length:0,content:JSON.stringify(w)},m)}}e.setProperty=c;function O(E,C,w){let m=P(E,C),y=C.offset,h=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;y>0&&!(0,T.isEOL)(m,y-1);)y--;for(;h<m.length&&!(0,T.isEOL)(m,h);)h++}const S=(0,T.format)(m,{offset:y,length:h-y},w);for(let l=S.length-1;l>=0;l--){const g=S[l];m=P(m,g),y=Math.min(y,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const u=E.length-(m.length-h)-y;return[{offset:y,length:u,content:m.substring(y,h)}]}e.withFormatting=O;function P(E,C){return E.substring(0,C.offset)+C.content+E.substring(C.offset+C.length)}e.applyEdit=P;function I(E,C){const w=C.slice(0).sort((y,h)=>{const S=y.offset-h.offset;return S===0?y.length-h.length:S});let m=E.length;for(let y=w.length-1;y>=0;y--){const h=w[y];if(h.offset+h.length<=m)E=P(E,h);else throw new Error("Overlapping edit");m=h.offset}return E}e.applyEdits=I}),define(oe[129],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.d=R,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=D}),define(oe[2],ae([0,1,82,64]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let c=null;function O(a){c=a}if(e.setDisposableTracker=O,R){const a="__is_disposable_tracked__";O(new class{trackDisposable(o){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[a]||console.log(f)},3e3)}setParent(o,f){if(o&&o!==g.None)try{o[a]=!0}catch{}}markAsDisposed(o){if(o&&o!==g.None)try{o[a]=!0}catch{}}markAsSingleton(o){}})}function P(a){return c?.trackDisposable(a),a}function I(a){c?.markAsDisposed(a)}function E(a,o){c?.setParent(a,o)}function C(a,o){if(!!c)for(const f of a)c.setParent(f,o)}function w(a){return c?.markAsSingleton(a),a}e.markAsSingleton=w;function m(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=m;function y(a){if(T.Iterable.is(a)){const o=[];for(const f of a)if(f)try{f.dispose()}catch(d){o.push(d)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=y;function h(a){for(const o of a)m(o)&&o.dispose();return[]}e.disposeIfDisposable=h;function S(...a){const o=u(()=>y(a));return C(a,o),o}e.combinedDisposable=S;function u(a){const o=P({dispose:(0,D.once)(()=>{I(o),a()})});return o}e.toDisposable=u;class l{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this.q=new l,P(this),E(this.q,this)}dispose(){I(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&E(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&E(o,null),o}}e.MutableDisposable=p;class b{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=b;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let f=o;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,I(this))},this}}e.SafeDisposable=A;class i{constructor(){this.a=new Map}acquire(o,...f){let d=this.a.get(o);d||(d={counter:0,object:this.b(o,...f)},this.a.set(o,d));const{object:v}=d,L=(0,D.once)(()=>{--d.counter===0&&(this.c(o,d.object),this.a.delete(o))});return d.counter++,{object:v,dispose:L}}}e.ReferenceCollection=i;class r{constructor(o){this.a=o}async acquire(o,...f){const d=this.a.acquire(o,...f);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(v){throw d.dispose(),v}}}e.AsyncReferenceCollection=r;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function n(a){const o=new l;try{a(o)}finally{o.dispose()}}e.disposeOnReturn=n;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,f,d=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),d||this.a.get(o)?.dispose(),this.a.set(o,f)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(oe[84],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(c){this.element=c,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let c=this.a;for(;c!==D.Undefined;){const O=c.next;c.prev=D.Undefined,c.next=D.Undefined,c=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(c){return this.d(c,!1)}push(c){return this.d(c,!0)}d(c,O){const P=new D(c);if(this.a===D.Undefined)this.a=P,this.b=P;else if(O){const E=this.b;this.b=P,P.prev=E,E.next=P}else{const E=this.a;this.a=P,P.next=E,E.prev=P}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(P))}}shift(){if(this.a!==D.Undefined){const c=this.a.element;return this.e(this.a),c}}pop(){if(this.b!==D.Undefined){const c=this.b.element;return this.e(this.b),c}}e(c){if(c.prev!==D.Undefined&&c.next!==D.Undefined){const O=c.prev;O.next=c.next,c.next.prev=O}else c.prev===D.Undefined&&c.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):c.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):c.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let c=this.a;for(;c!==D.Undefined;)yield c.element,c=c.next}}e.LinkedList=T}),define(oe[37],ae([0,1]),function(Q,e){"use strict";var D,T,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function c(h,S,u){let l=h.get(S);return l===void 0&&(l=u,h.set(S,l)),l}e.getOrSet=c;function O(h){const S=[];return h.forEach((u,l)=>{S.push(`${l} => ${u}`)}),`Map(${h.size}) {${S.join(", ")}}`}e.mapToString=O;function P(h){const S=[];return h.forEach(u=>{S.push(u)}),`Set(${h.size}) {${S.join(", ")}}`}e.setToString=P;class I{constructor(S,u){this.uri=S,this.value=u}}class E{constructor(S,u){this[D]="ResourceMap",S instanceof E?(this.b=new Map(S.b),this.c=u??E.a):(this.b=new Map,this.c=S??E.a)}set(S,u){return this.b.set(this.c(S),new I(S,u)),this}get(S){return this.b.get(this.c(S))?.value}has(S){return this.b.has(this.c(S))}get size(){return this.b.size}clear(){this.b.clear()}delete(S){return this.b.delete(this.c(S))}forEach(S,u){typeof u<"u"&&(S=S.bind(u));for(const[l,g]of this.b)S(g.value,g.uri,this)}*values(){for(const S of this.b.values())yield S.value}*keys(){for(const S of this.b.values())yield S.uri}*entries(){for(const S of this.b.values())yield[S.uri,S.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,S]of this.b)yield[S.uri,S.value]}}e.ResourceMap=E,E.a=h=>h.toString();class C{constructor(S,u){this[T]="ResourceSet",!S||typeof S=="function"?this.a=new E(S):(this.a=new E(u),S.forEach(this.add,this))}get size(){return this.a.size}add(S){return this.a.set(S,S),this}clear(){this.a.clear()}delete(S){return this.a.delete(S)}forEach(S,u){this.a.forEach((l,g)=>S.call(u,g,g,this))}has(S){return this.a.has(S)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var w;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class m{constructor(){this[R]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(S){return this.a.has(S)}get(S,u=0){const l=this.a.get(S);if(!!l)return u!==0&&this.j(l,u),l.value}set(S,u,l=0){let g=this.a.get(S);if(g)g.value=u,l!==0&&this.j(g,l);else{switch(g={key:S,value:u,next:void 0,previous:void 0},l){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(S,g),this.d++}return this}delete(S){return!!this.remove(S)}remove(S){const u=this.a.get(S);if(!!u)return this.a.delete(S),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const S=this.b;return this.a.delete(S.key),this.i(S),this.d--,S.value}forEach(S,u){const l=this.e;let g=this.b;for(;g;){if(u?S.bind(u)(g.value,g.key,this):S(g.value,g.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const S=this,u=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(S.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.key,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return g}values(){const S=this,u=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(S.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.value,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return g}entries(){const S=this,u=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(S.e!==u)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:[l.key,l.value],done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return g}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(S){if(S>=this.size)return;if(S===0){this.clear();return}let u=this.b,l=this.size;for(;u&&l>S;)this.a.delete(u.key),u=u.next,l--;this.b=u,this.d=l,u&&(u.previous=void 0),this.e++}g(S){if(!this.b&&!this.c)this.c=S;else if(this.b)S.next=this.b,this.b.previous=S;else throw new Error("Invalid list");this.b=S,this.e++}h(S){if(!this.b&&!this.c)this.b=S;else if(this.c)S.previous=this.c,this.c.next=S;else throw new Error("Invalid list");this.c=S,this.e++}i(S){if(S===this.b&&S===this.c)this.b=void 0,this.c=void 0;else if(S===this.b){if(!S.next)throw new Error("Invalid list");S.next.previous=void 0,this.b=S.next}else if(S===this.c){if(!S.previous)throw new Error("Invalid list");S.previous.next=void 0,this.c=S.previous}else{const u=S.next,l=S.previous;if(!u||!l)throw new Error("Invalid list");u.previous=l,l.next=u}S.next=void 0,S.previous=void 0,this.e++}j(S,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(S===this.b)return;const l=S.next,g=S.previous;S===this.c?(g.next=void 0,this.c=g):(l.previous=g,g.next=l),S.previous=void 0,S.next=this.b,this.b.previous=S,this.b=S,this.e++}else if(u===2){if(S===this.c)return;const l=S.next,g=S.previous;S===this.b?(l.previous=void 0,this.b=l):(l.previous=g,g.next=l),S.next=void 0,S.previous=this.c,this.c.next=S,this.c=S,this.e++}}}toJSON(){const S=[];return this.forEach((u,l)=>{S.push([l,u])}),S}fromJSON(S){this.clear();for(const[u,l]of S)this.set(u,l)}}e.LinkedMap=m;class y extends m{constructor(S,u=1){super(),this.k=S,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(S){this.k=S,this.m()}get ratio(){return this.l}set ratio(S){this.l=Math.min(Math.max(0,S),1),this.m()}get(S,u=2){return super.get(S,u)}peek(S){return super.get(S,0)}set(S,u){return super.set(S,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),define(oe[85],ae([0,1,37]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new D.LRUCache(1e4);function R(E){return I(E,"NFC",T)}e.normalizeNFC=R;const c=new D.LRUCache(1e4);function O(E){return I(E,"NFD",c)}e.normalizeNFD=O;const P=/[^\u0000-\u0080]/;function I(E,C,w){if(!E)return E;const m=w.get(E);if(m)return m;let y;return P.test(E)?y=E.normalize(C):y=E,w.set(E,y),y}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(C){return O(C).replace(E,"")}}()}),define(oe[130],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function D(P,I,E){return Math.min(Math.max(P,I),E)}e.clamp=D;function T(P,I){return(I+P%I)%I}e.rot=T;class R{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=R;class c{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=c;class O{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const E=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=O}),function(){function Q(R){const c=[];typeof R=="number"&&c.push("code/timeOrigin",R);function O(I){c.push(I,Date.now())}function P(){const I=[];for(let E=0;E<c.length;E+=2)I.push({name:c[E],startTime:c[E+1]});return I}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const c=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const O of performance.getEntriesByType("mark"))c.push({name:O.name,startTime:Math.round(R+O.startTime)});return c}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:Q)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(T){if(e[T])return e[T].exports;var R=e[T]={i:T,l:!1,exports:{}};return Q[T].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(T,R,c){D.o(T,R)||Object.defineProperty(T,R,{enumerable:!0,get:c})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,R){if(1&R&&(T=D(T)),8&R||4&R&&typeof T=="object"&&T&&T.__esModule)return T;var c=Object.create(null);if(D.r(c),Object.defineProperty(c,"default",{enumerable:!0,value:T}),2&R&&typeof T!="string")for(var O in T)D.d(c,O,function(P){return T[P]}.bind(null,O));return c},D.n=function(T){var R=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(R,"a",R),R},D.o=function(T,R){return Object.prototype.hasOwnProperty.call(T,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(T){var R;e=Q.exports=U,R=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var c=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],E=0,C=E++;I[C]="0|[1-9]\\d*";var w=E++;I[w]="[0-9]+";var m=E++;I[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;I[y]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var h=E++;I[h]="("+I[w]+")\\.("+I[w]+")\\.("+I[w]+")";var S=E++;I[S]="(?:"+I[C]+"|"+I[m]+")";var u=E++;I[u]="(?:"+I[w]+"|"+I[m]+")";var l=E++;I[l]="(?:-("+I[S]+"(?:\\."+I[S]+")*))";var g=E++;I[g]="(?:-?("+I[u]+"(?:\\."+I[u]+")*))";var p=E++;I[p]="[0-9A-Za-z-]+";var b=E++;I[b]="(?:\\+("+I[p]+"(?:\\."+I[p]+")*))";var A=E++,i="v?"+I[y]+I[l]+"?"+I[b]+"?";I[A]="^"+i+"$";var r="[v=\\s]*"+I[h]+I[g]+"?"+I[b]+"?",t=E++;I[t]="^"+r+"$";var n=E++;I[n]="((?:<|>)?=?)";var s=E++;I[s]=I[w]+"|x|X|\\*";var a=E++;I[a]=I[C]+"|x|X|\\*";var o=E++;I[o]="[v=\\s]*("+I[a]+")(?:\\.("+I[a]+")(?:\\.("+I[a]+")(?:"+I[l]+")?"+I[b]+"?)?)?";var f=E++;I[f]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[g]+")?"+I[b]+"?)?)?";var d=E++;I[d]="^"+I[n]+"\\s*"+I[o]+"$";var v=E++;I[v]="^"+I[n]+"\\s*"+I[f]+"$";var L=E++;I[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=E++;I[N]="(?:~>?)";var F=E++;I[F]="(\\s*)"+I[N]+"\\s+",P[F]=new RegExp(I[F],"g");var M=E++;I[M]="^"+I[N]+I[o]+"$";var k=E++;I[k]="^"+I[N]+I[f]+"$";var $=E++;I[$]="(?:\\^)";var z=E++;I[z]="(\\s*)"+I[$]+"\\s+",P[z]=new RegExp(I[z],"g");var x=E++;I[x]="^"+I[$]+I[o]+"$";var X=E++;I[X]="^"+I[$]+I[f]+"$";var ie=E++;I[ie]="^"+I[n]+"\\s*("+r+")$|^$";var H=E++;I[H]="^"+I[n]+"\\s*("+i+")$|^$";var j=E++;I[j]="(\\s*)"+I[n]+"\\s*("+r+"|"+I[o]+")",P[j]=new RegExp(I[j],"g");var V=E++;I[V]="^\\s*("+I[o]+")\\s+-\\s+("+I[o]+")\\s*$";var J=E++;I[J]="^\\s*("+I[f]+")\\s+-\\s+("+I[f]+")\\s*$";var _=E++;I[_]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)R(re,I[re]),P[re]||(P[re]=new RegExp(I[re]));function te(ce,de){if(ce instanceof U)return ce;if(typeof ce!="string"||ce.length>c||!(de?P[t]:P[A]).test(ce))return null;try{return new U(ce,de)}catch{return null}}function U(ce,de){if(ce instanceof U){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>c)throw new TypeError("version is longer than "+c+" characters");if(!(this instanceof U))return new U(ce,de);R("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?P[t]:P[A]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<O)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ce,de){var ge=te(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=te(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ce){return R("SemVer.compare",this.version,this.loose,ce),ce instanceof U||(ce=new U(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},U.prototype.compareMain=function(ce){return ce instanceof U||(ce=new U(ce,this.loose)),W(this.major,ce.major)||W(this.minor,ce.minor)||W(this.patch,ce.patch)},U.prototype.comparePre=function(ce){if(ce instanceof U||(ce=new U(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(R("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return W(ge,Ce)}while(++de)},U.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new U(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(K(ce,de))return null;var ge=te(ce),Ce=te(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=W;var B=/^[0-9]+$/;function W(ce,de){var ge=B.test(ce),Ce=B.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function q(ce,de,ge){return new U(ce,ge).compare(new U(de,ge))}function Y(ce,de,ge){return q(ce,de,ge)>0}function ee(ce,de,ge){return q(ce,de,ge)<0}function K(ce,de,ge){return q(ce,de,ge)===0}function Z(ce,de,ge){return q(ce,de,ge)!==0}function se(ce,de,ge){return q(ce,de,ge)>=0}function le(ce,de,ge){return q(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=K(ce,ge,Ce);break;case"!=":Pe=Z(ce,ge,Ce);break;case">":Pe=Y(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=ee(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function pe(ce,de){if(ce instanceof pe){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,de);R("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ce,de){return W(de,ce)},e.major=function(ce,de){return new U(ce,de).major},e.minor=function(ce,de){return new U(ce,de).minor},e.patch=function(ce,de){return new U(ce,de).patch},e.compare=q,e.compareLoose=function(ce,de){return q(ce,de,!0)},e.rcompare=function(ce,de,ge){return q(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=Y,e.lt=ee,e.eq=K,e.neq=Z,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=pe;var ve={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof pe)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Oe(ce,de,ge,Ce,Pe,Le,De,je,Te,Fe,ze,ke,Ne){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Te)?"":Ee(Fe)?"<"+(+Te+1)+".0.0":Ee(ze)?"<"+Te+"."+(+Fe+1)+".0":ke?"<="+Te+"."+Fe+"."+ze+"-"+ke:"<="+je)).trim()}function Ue(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(R(ce[ge].semver),ce[ge].semver!==ve&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function Be(ce,de,ge,Ce){var Pe,Le,De,je,Te;switch(ce=new U(ce,Ce),de=new be(de,Ce),ge){case">":Pe=Y,Le=le,De=ee,je=">",Te=">=";break;case"<":Pe=ee,Le=se,De=Y,je="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var ze=de.set[Fe],ke=null,Ne=null;if(ze.forEach(function(ne){ne.semver===ve&&(ne=new pe(">=0.0.0")),ke=ke||ne,Ne=Ne||ne,Pe(ne.semver,ke.semver,Ce)?ke=ne:De(ne.semver,Ne.semver,Ce)&&(Ne=ne)}),ke.operator===je||ke.operator===Te||(!Ne.operator||Ne.operator===je)&&Le(ce,Ne.semver)||Ne.operator===Te&&De(ce,Ne.semver))return!1}return!0}pe.prototype.parse=function(ce){var de=this.loose?P[ie]:P[H],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new U(ge[2],this.loose):this.semver=ve},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return R("Comparator.test",ce,this.loose),this.semver===ve||(typeof ce=="string"&&(ce=new U(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,de){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Le=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Te=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Le&&De||je||Te},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),R("range",ce,de);var ge=de?P[J]:P[V];ce=ce.replace(ge,Oe),R("hyphen replace",ce),ce=ce.replace(P[j],"$1$2$3"),R("comparator trim",ce,P[j]),ce=(ce=(ce=ce.replace(P[F],"$1~")).replace(P[z],"$1^")).split(/\s+/).join(" ");var Ce=de?P[ie]:P[H],Pe=ce.split(" ").map(function(Le){return function(De,je){return R("comp",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(ze){return function(ke,Ne){R("caret",ke,Ne);var ne=Ne?P[X]:P[x];return ke.replace(ne,function(he,fe,me,Se,Ie){var Re;return R("caret",ke,he,fe,me,Se,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(Se)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(R("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+Ie+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+Ie+" <"+(+fe+1)+".0.0"):(R("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+Se+" <"+fe+"."+me+"."+(+Se+1):">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Se+" <"+(+fe+1)+".0.0"),R("caret return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),R("caret",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(ze){return function(ke,Ne){var ne=Ne?P[k]:P[M];return ke.replace(ne,function(he,fe,me,Se,Ie){var Re;return R("tilde",ke,he,fe,me,Se,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(Se)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(R("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+Se+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+Se+" <"+fe+"."+(+me+1)+".0",R("tilde return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),R("tildes",De),De=function(Te,Fe){return R("replaceXRanges",Te,Fe),Te.split(/\s+/).map(function(ze){return function(ke,Ne){ke=ke.trim();var ne=Ne?P[v]:P[d];return ke.replace(ne,function(he,fe,me,Se,Ie,Re){R("xRange",ke,he,fe,me,Se,Ie,Re);var xe=Ee(me),$e=xe||Ee(Se),Ae=$e||Ee(Ie);return fe==="="&&Ae&&(fe=""),xe?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Ae?($e&&(Se=0),Ae&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,Se=0,Ie=0):Ae&&(Se=+Se+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:Se=+Se+1),he=fe+me+"."+Se+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Ae&&(he=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),R("xRange return",he),he})}(ze,Fe)}).join(" ")}(De,je),R("xrange",De),De=function(Te,Fe){return R("replaceStars",Te,Fe),Te.trim().replace(P[_],"")}(De,je),R("stars",De),De}(Le,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Le){return!!Le.match(Ce)})),Pe=Pe.map(function(Le){return new pe(Le,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Le){return Ce.intersects(Le,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new U(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Ue(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Le=new be(de,ge)}catch{return null}return ce.forEach(function(De){Le.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new U(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Le=new be(de,ge)}catch{return null}return ce.forEach(function(De){Le.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new U(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return Be(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return Be(ce,de,">",ge)},e.outside=Be,e.prerelease=function(ce,de){var ge=te(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof U)return ce;if(typeof ce!="string")return null;var de=ce.match(P[L]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,T,R=Q.exports={};function c(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(u){if(D===setTimeout)return setTimeout(u,0);if((D===c||!D)&&setTimeout)return D=setTimeout,setTimeout(u,0);try{return D(u,0)}catch{try{return D.call(null,u,0)}catch{return D.call(this,u,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:c}catch{D=c}try{T=typeof clearTimeout=="function"?clearTimeout:O}catch{T=O}})();var I,E=[],C=!1,w=-1;function m(){C&&I&&(C=!1,I.length?E=I.concat(E):w=-1,E.length&&y())}function y(){if(!C){var u=P(m);C=!0;for(var l=E.length;l;){for(I=E,E=[];++w<l;)I&&I[w].run();w=-1,l=E.length}I=null,C=!1,function(g){if(T===clearTimeout)return clearTimeout(g);if((T===O||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(g);try{T(g)}catch{try{return T.call(null,g)}catch{return T.call(this,g)}}}(u)}}function h(u,l){this.fun=u,this.array=l}function S(){}R.nextTick=function(u){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];E.push(new h(u,l)),E.length!==1||C||P(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function(u){return[]},R.binding=function(u){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(u){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(oe[131],ae([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(P,I,E){this.level=P,this.key=I,this.value=E,this.forward=[]}}const R=void 0;class c{constructor(P,I=2**16){this.comparator=P,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new T(this.c,R,R)}get size(){return this.f}clear(){this.e=new T(this.c,R,R)}has(P){return Boolean(c.g(this,P,this.comparator))}get(P){return c.g(this,P,this.comparator)?.value}set(P,I){return c.h(this,P,I,this.comparator)&&(this.f+=1),this}delete(P){const I=c.k(this,P,this.comparator);return I&&(this.f-=1),I}forEach(P,I){let E=this.e.forward[0];for(;E;)P.call(I,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this.e.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static g(P,I,E){let C=P.e;for(let w=P.d-1;w>=0;w--)for(;C.forward[w]&&E(C.forward[w].key,I)<0;)C=C.forward[w];if(C=C.forward[0],C&&E(C.key,I)===0)return C}static h(P,I,E,C){const w=[];let m=P.e;for(let y=P.d-1;y>=0;y--){for(;m.forward[y]&&C(m.forward[y].key,I)<0;)m=m.forward[y];w[y]=m}if(m=m.forward[0],m&&C(m.key,I)===0)return m.value=E,!1;{const y=c.j(P);if(y>P.d){for(let h=P.d;h<y;h++)w[h]=P.e;P.d=y}m=new T(y,I,E);for(let h=0;h<y;h++)m.forward[h]=w[h].forward[h],w[h].forward[h]=m;return!0}}static j(P,I=.5){let E=1;for(;Math.random()<I&&E<P.c;)E+=1;return E}static k(P,I,E){const C=[];let w=P.e;for(let m=P.d-1;m>=0;m--){for(;w.forward[m]&&E(w.forward[m].key,I)<0;)w=w.forward[m];C[m]=w}if(w=w.forward[0],!w||E(w.key,I)!==0)return!1;for(let m=0;m<P.d&&C[m].forward[m]===w;m++)C[m].forward[m]=w.forward[m];for(;P.d>0&&P.e.forward[P.d-1]===R;)P.d-=1;return!0}}e.SkipList=c}),define(oe[44],ae([0,1,9,2]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(b){const A=b;return A?typeof A.read=="function":!1}e.isReadable=R;function c(b){const A=b;return A?[A.on,A.pause,A.resume,A.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=c;function O(b){const A=b;return A?c(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}e.isReadableBufferedStream=O;function P(b,A){return new I(b,A)}e.newWriteableStream=P;class I{constructor(A,i){this.e=A,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(A){if(!this.a.destroyed){if(this.a.flowing)this.g(A);else if(this.b.data.push(A),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(A){this.a.destroyed||(this.a.flowing?this.h(A):this.b.error.push(A))}end(A){this.a.destroyed||(typeof A<"u"&&this.write(A),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(A){this.c.data.slice(0).forEach(i=>i(A))}h(A){this.c.error.length===0?(0,D.onUnexpectedError)(A):this.c.error.slice(0).forEach(i=>i(A))}i(){this.c.end.slice(0).forEach(A=>A())}on(A,i){if(!this.a.destroyed)switch(A){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(A,i){if(this.a.destroyed)return;let r;switch(A){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const A=this.e(this.b.data);this.g(A),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const A of this.b.error)this.h(A);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(b,A){const i=[];let r;for(;(r=b.read())!==null;)i.push(r);return A(i)}e.consumeReadable=E;function C(b,A,i){const r=[];let t;for(;(t=b.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?A(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return b.read()}}}e.peekReadable=C;function w(b,A){return new Promise((i,r)=>{const t=[];m(b,{onData:n=>{A&&t.push(n)},onError:n=>{A?r(n):i(void 0)},onEnd:()=>{i(A?A(t):void 0)}})})}e.consumeStream=w;function m(b,A){let i=!1;return b.on("error",r=>{i||A.onError(r)}),b.on("end",()=>{i||A.onEnd()}),b.on("data",r=>{i||A.onData(r)}),(0,T.toDisposable)(()=>i=!0)}e.listenStream=m;function y(b,A){return new Promise((i,r)=>{const t=new T.DisposableStore,n=[],s=f=>{if(n.push(f),n.length>A)return t.dispose(),b.pause(),i({stream:b,buffer:n,ended:!1})},a=f=>r(f),o=()=>i({stream:b,buffer:n,ended:!0});t.add((0,T.toDisposable)(()=>b.removeListener("error",a))),b.on("error",a),t.add((0,T.toDisposable)(()=>b.removeListener("end",o))),b.on("end",o),t.add((0,T.toDisposable)(()=>b.removeListener("data",s))),b.on("data",s)})}e.peekStream=y;function h(b,A){const i=P(A);return i.end(b),i}e.toStream=h;function S(){const b=P(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=S;function u(b){let A=!1;return{read:()=>A?null:(A=!0,b)}}e.toReadable=u;function l(b,A,i){const r=P(i);return m(b,{onData:t=>r.write(A.data(t)),onError:t=>r.error(A.error?A.error(t):t),onEnd:()=>r.end()}),r}e.transform=l;function g(b,A,i){let r=!1;return{read:()=>{const t=A.read();return r?t:(r=!0,t!==null?i([b,t]):b)}}}e.prefixedReadable=g;function p(b,A,i){let r=!1;const t=P(i);return m(A,{onData:n=>r?t.write(n):(r=!0,t.write(i([b,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(b)),t.end()}}),t}e.prefixedStream=p}),define(oe[17],ae([0,1,44]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let R,c;class O{static alloc(f){return T?new O(Buffer.allocUnsafe(f)):new O(new Uint8Array(f))}static wrap(f){return T&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new O(f)}static fromString(f,d){return!(d?.dontUseNodeBuffer||!1)&&T?new O(Buffer.from(f)):(R||(R=new TextEncoder),new O(R.encode(f)))}static fromByteArray(f){const d=O.alloc(f.length);for(let v=0,L=f.length;v<L;v++)d.buffer[v]=f[v];return d}static concat(f,d){if(typeof d>"u"){d=0;for(let N=0,F=f.length;N<F;N++)d+=f[N].byteLength}const v=O.alloc(d);let L=0;for(let N=0,F=f.length;N<F;N++){const M=f[N];v.set(M,L),L+=M.byteLength}return v}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=O.alloc(this.byteLength);return f.set(this),f}toString(){return T?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(f,d){return new O(this.buffer.subarray(f,d))}set(f,d){if(f instanceof O)this.buffer.set(f.buffer,d);else if(f instanceof Uint8Array)this.buffer.set(f,d);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),d);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return E(this.buffer,f)}writeUInt32BE(f,d){C(this.buffer,f,d)}readUInt32LE(f){return w(this.buffer,f)}writeUInt32LE(f,d){m(this.buffer,f,d)}readUInt8(f){return y(this.buffer,f)}writeUInt8(f,d){h(this.buffer,f,d)}}e.VSBuffer=O;function P(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0}e.readUInt16LE=P;function I(o,f,d){o[d+0]=f&255,f=f>>>8,o[d+1]=f&255}e.writeUInt16LE=I;function E(o,f){return o[f]*2**24+o[f+1]*2**16+o[f+2]*2**8+o[f+3]}e.readUInt32BE=E;function C(o,f,d){o[d+3]=f,f=f>>>8,o[d+2]=f,f=f>>>8,o[d+1]=f,f=f>>>8,o[d]=f}e.writeUInt32BE=C;function w(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0|o[f+2]<<16>>>0|o[f+3]<<24>>>0}e.readUInt32LE=w;function m(o,f,d){o[d+0]=f&255,f=f>>>8,o[d+1]=f&255,f=f>>>8,o[d+2]=f&255,f=f>>>8,o[d+3]=f&255}e.writeUInt32LE=m;function y(o,f){return o[f]}e.readUInt8=y;function h(o,f,d){o[d]=f}e.writeUInt8=h;function S(o){return D.consumeReadable(o,f=>O.concat(f))}e.readableToBuffer=S;function u(o){return D.toReadable(o)}e.bufferToReadable=u;function l(o){return D.consumeStream(o,f=>O.concat(f))}e.streamToBuffer=l;async function g(o){return o.ended?O.concat(o.buffer):O.concat([...o.buffer,await l(o.stream)])}e.bufferedStreamToBuffer=g;function p(o){return D.toStream(o,f=>O.concat(f))}e.bufferToStream=p;function b(o){return D.transform(o,{data:f=>typeof f=="string"?O.fromString(f):O.wrap(f)},f=>O.concat(f))}e.streamToBufferReadableStream=b;function A(o){return D.newWriteableStream(f=>O.concat(f),o)}e.newWriteableBufferStream=A;function i(o,f){return D.prefixedReadable(o,f,d=>O.concat(d))}e.prefixedBufferReadable=i;function r(o,f){return D.prefixedStream(o,f,d=>O.concat(d))}e.prefixedBufferStream=r;function t(o){let f=0,d=0,v=0;const L=new Uint8Array(Math.floor(o.length/4*3)),N=M=>{switch(d){case 3:L[v++]=f|M,d=0;break;case 2:L[v++]=f|M>>>2,f=M<<6,d=3;break;case 1:L[v++]=f|M>>>4,f=M<<4,d=2;break;default:f=M<<2,d=1}};for(let M=0;M<o.length;M++){const k=o.charCodeAt(M);if(k>=65&&k<=90)N(k-65);else if(k>=97&&k<=122)N(k-97+26);else if(k>=48&&k<=57)N(k-48+52);else if(k===43||k===45)N(62);else if(k===47||k===95)N(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${o[M]}`)}}const F=v;for(;d>0;)N(0);return O.wrap(L).slice(0,F)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},f=!0,d=!1){const v=d?s:n;let L="";const N=o.byteLength%3;let F=0;for(;F<o.byteLength-N;F+=3){const M=o[F+0],k=o[F+1],$=o[F+2];L+=v[M>>>2],L+=v[(M<<4|k>>>4)&63],L+=v[(k<<2|$>>>6)&63],L+=v[$&63]}if(N===1){const M=o[F+0];L+=v[M>>>2],L+=v[M<<4&63],f&&(L+="==")}else if(N===2){const M=o[F+0],k=o[F+1];L+=v[M>>>2],L+=v[(M<<4|k>>>4)&63],L+=v[k<<2&63],f&&(L+="=")}return L}e.encodeBase64=a}),define(oe[12],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(r){return typeof r=="string"}e.isString=D;function T(r){return Array.isArray(r)&&r.every(t=>D(t))}e.isStringArray=T;function R(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=R;function c(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=c;function O(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=O;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function I(r){return r===!0||r===!1}e.isBoolean=I;function E(r){return typeof r>"u"}e.isUndefined=E;function C(r){return!w(r)}e.isDefined=C;function w(r){return E(r)||r===null}e.isUndefinedOrNull=w;function m(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function y(r){if(w(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=y;function h(...r){const t=[];for(let n=0;n<r.length;n++){const s=r[n];if(w(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function u(r){if(!R(r))return!1;for(const t in r)if(S.call(r,t))return!1;return!0}e.isEmptyObject=u;function l(r){return typeof r=="function"}e.isFunction=l;function g(...r){return r.length>0&&r.every(l)}e.areFunctions=g;function p(r,t){const n=Math.min(r.length,t.length);for(let s=0;s<n;s++)b(r[s],t[s])}e.validateConstraints=p;function b(r,t){if(D(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(r instanceof t)return}catch{}if(!w(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b;function A(r){return r===null?void 0:r}e.withNullAsUndefined=A;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(oe[52],ae([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=e.getCodiconAriaLabel=void 0;function T(I){return I?I.replace(/\$\((.*?)\)/g,(E,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=T;const R=Object.create(null);function c(I,E){if((0,D.isString)(E)){const C=R[E];if(C===void 0)throw new Error(`${I} references an unknown codicon: ${E}`);E=C}return R[I]=E,{id:I}}function O(){return R}e.getCodiconFontCharacters=O;function P(){return Object.values(e.Codicon)}e.getAllCodicons=P,e.Codicon={add:c("add",6e4),plus:c("plus",6e4),gistNew:c("gist-new",6e4),repoCreate:c("repo-create",6e4),lightbulb:c("lightbulb",60001),lightBulb:c("light-bulb",60001),repo:c("repo",60002),repoDelete:c("repo-delete",60002),gistFork:c("gist-fork",60003),repoForked:c("repo-forked",60003),gitPullRequest:c("git-pull-request",60004),gitPullRequestAbandoned:c("git-pull-request-abandoned",60004),recordKeys:c("record-keys",60005),keyboard:c("keyboard",60005),tag:c("tag",60006),tagAdd:c("tag-add",60006),tagRemove:c("tag-remove",60006),person:c("person",60007),personFollow:c("person-follow",60007),personOutline:c("person-outline",60007),personFilled:c("person-filled",60007),gitBranch:c("git-branch",60008),gitBranchCreate:c("git-branch-create",60008),gitBranchDelete:c("git-branch-delete",60008),sourceControl:c("source-control",60008),mirror:c("mirror",60009),mirrorPublic:c("mirror-public",60009),star:c("star",60010),starAdd:c("star-add",60010),starDelete:c("star-delete",60010),starEmpty:c("star-empty",60010),comment:c("comment",60011),commentAdd:c("comment-add",60011),alert:c("alert",60012),warning:c("warning",60012),search:c("search",60013),searchSave:c("search-save",60013),logOut:c("log-out",60014),signOut:c("sign-out",60014),logIn:c("log-in",60015),signIn:c("sign-in",60015),eye:c("eye",60016),eyeUnwatch:c("eye-unwatch",60016),eyeWatch:c("eye-watch",60016),circleFilled:c("circle-filled",60017),primitiveDot:c("primitive-dot",60017),closeDirty:c("close-dirty",60017),debugBreakpoint:c("debug-breakpoint",60017),debugBreakpointDisabled:c("debug-breakpoint-disabled",60017),debugHint:c("debug-hint",60017),primitiveSquare:c("primitive-square",60018),edit:c("edit",60019),pencil:c("pencil",60019),info:c("info",60020),issueOpened:c("issue-opened",60020),gistPrivate:c("gist-private",60021),gitForkPrivate:c("git-fork-private",60021),lock:c("lock",60021),mirrorPrivate:c("mirror-private",60021),close:c("close",60022),removeClose:c("remove-close",60022),x:c("x",60022),repoSync:c("repo-sync",60023),sync:c("sync",60023),clone:c("clone",60024),desktopDownload:c("desktop-download",60024),beaker:c("beaker",60025),microscope:c("microscope",60025),vm:c("vm",60026),deviceDesktop:c("device-desktop",60026),file:c("file",60027),fileText:c("file-text",60027),more:c("more",60028),ellipsis:c("ellipsis",60028),kebabHorizontal:c("kebab-horizontal",60028),mailReply:c("mail-reply",60029),reply:c("reply",60029),organization:c("organization",60030),organizationFilled:c("organization-filled",60030),organizationOutline:c("organization-outline",60030),newFile:c("new-file",60031),fileAdd:c("file-add",60031),newFolder:c("new-folder",60032),fileDirectoryCreate:c("file-directory-create",60032),trash:c("trash",60033),trashcan:c("trashcan",60033),history:c("history",60034),clock:c("clock",60034),folder:c("folder",60035),fileDirectory:c("file-directory",60035),symbolFolder:c("symbol-folder",60035),logoGithub:c("logo-github",60036),markGithub:c("mark-github",60036),github:c("github",60036),terminal:c("terminal",60037),console:c("console",60037),repl:c("repl",60037),zap:c("zap",60038),symbolEvent:c("symbol-event",60038),error:c("error",60039),stop:c("stop",60039),variable:c("variable",60040),symbolVariable:c("symbol-variable",60040),array:c("array",60042),symbolArray:c("symbol-array",60042),symbolModule:c("symbol-module",60043),symbolPackage:c("symbol-package",60043),symbolNamespace:c("symbol-namespace",60043),symbolObject:c("symbol-object",60043),symbolMethod:c("symbol-method",60044),symbolFunction:c("symbol-function",60044),symbolConstructor:c("symbol-constructor",60044),symbolBoolean:c("symbol-boolean",60047),symbolNull:c("symbol-null",60047),symbolNumeric:c("symbol-numeric",60048),symbolNumber:c("symbol-number",60048),symbolStructure:c("symbol-structure",60049),symbolStruct:c("symbol-struct",60049),symbolParameter:c("symbol-parameter",60050),symbolTypeParameter:c("symbol-type-parameter",60050),symbolKey:c("symbol-key",60051),symbolText:c("symbol-text",60051),symbolReference:c("symbol-reference",60052),goToFile:c("go-to-file",60052),symbolEnum:c("symbol-enum",60053),symbolValue:c("symbol-value",60053),symbolRuler:c("symbol-ruler",60054),symbolUnit:c("symbol-unit",60054),activateBreakpoints:c("activate-breakpoints",60055),archive:c("archive",60056),arrowBoth:c("arrow-both",60057),arrowDown:c("arrow-down",60058),arrowLeft:c("arrow-left",60059),arrowRight:c("arrow-right",60060),arrowSmallDown:c("arrow-small-down",60061),arrowSmallLeft:c("arrow-small-left",60062),arrowSmallRight:c("arrow-small-right",60063),arrowSmallUp:c("arrow-small-up",60064),arrowUp:c("arrow-up",60065),bell:c("bell",60066),bold:c("bold",60067),book:c("book",60068),bookmark:c("bookmark",60069),debugBreakpointConditionalUnverified:c("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:c("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:c("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:c("debug-breakpoint-data-unverified",60072),debugBreakpointData:c("debug-breakpoint-data",60073),debugBreakpointDataDisabled:c("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:c("debug-breakpoint-log-unverified",60074),debugBreakpointLog:c("debug-breakpoint-log",60075),debugBreakpointLogDisabled:c("debug-breakpoint-log-disabled",60075),briefcase:c("briefcase",60076),broadcast:c("broadcast",60077),browser:c("browser",60078),bug:c("bug",60079),calendar:c("calendar",60080),caseSensitive:c("case-sensitive",60081),check:c("check",60082),checklist:c("checklist",60083),chevronDown:c("chevron-down",60084),dropDownButton:c("drop-down-button",60084),chevronLeft:c("chevron-left",60085),chevronRight:c("chevron-right",60086),chevronUp:c("chevron-up",60087),chromeClose:c("chrome-close",60088),chromeMaximize:c("chrome-maximize",60089),chromeMinimize:c("chrome-minimize",60090),chromeRestore:c("chrome-restore",60091),circle:c("circle",60092),circleOutline:c("circle-outline",60092),debugBreakpointUnverified:c("debug-breakpoint-unverified",60092),circleSlash:c("circle-slash",60093),circuitBoard:c("circuit-board",60094),clearAll:c("clear-all",60095),clippy:c("clippy",60096),closeAll:c("close-all",60097),cloudDownload:c("cloud-download",60098),cloudUpload:c("cloud-upload",60099),code:c("code",60100),collapseAll:c("collapse-all",60101),colorMode:c("color-mode",60102),commentDiscussion:c("comment-discussion",60103),compareChanges:c("compare-changes",60157),creditCard:c("credit-card",60105),dash:c("dash",60108),dashboard:c("dashboard",60109),database:c("database",60110),debugContinue:c("debug-continue",60111),debugDisconnect:c("debug-disconnect",60112),debugPause:c("debug-pause",60113),debugRestart:c("debug-restart",60114),debugStart:c("debug-start",60115),debugStepInto:c("debug-step-into",60116),debugStepOut:c("debug-step-out",60117),debugStepOver:c("debug-step-over",60118),debugStop:c("debug-stop",60119),debug:c("debug",60120),deviceCameraVideo:c("device-camera-video",60121),deviceCamera:c("device-camera",60122),deviceMobile:c("device-mobile",60123),diffAdded:c("diff-added",60124),diffIgnored:c("diff-ignored",60125),diffModified:c("diff-modified",60126),diffRemoved:c("diff-removed",60127),diffRenamed:c("diff-renamed",60128),diff:c("diff",60129),discard:c("discard",60130),editorLayout:c("editor-layout",60131),emptyWindow:c("empty-window",60132),exclude:c("exclude",60133),extensions:c("extensions",60134),eyeClosed:c("eye-closed",60135),fileBinary:c("file-binary",60136),fileCode:c("file-code",60137),fileMedia:c("file-media",60138),filePdf:c("file-pdf",60139),fileSubmodule:c("file-submodule",60140),fileSymlinkDirectory:c("file-symlink-directory",60141),fileSymlinkFile:c("file-symlink-file",60142),fileZip:c("file-zip",60143),files:c("files",60144),filter:c("filter",60145),flame:c("flame",60146),foldDown:c("fold-down",60147),foldUp:c("fold-up",60148),fold:c("fold",60149),folderActive:c("folder-active",60150),folderOpened:c("folder-opened",60151),gear:c("gear",60152),gift:c("gift",60153),gistSecret:c("gist-secret",60154),gist:c("gist",60155),gitCommit:c("git-commit",60156),gitCompare:c("git-compare",60157),gitMerge:c("git-merge",60158),githubAction:c("github-action",60159),githubAlt:c("github-alt",60160),globe:c("globe",60161),grabber:c("grabber",60162),graph:c("graph",60163),gripper:c("gripper",60164),heart:c("heart",60165),home:c("home",60166),horizontalRule:c("horizontal-rule",60167),hubot:c("hubot",60168),inbox:c("inbox",60169),issueClosed:c("issue-closed",60324),issueReopened:c("issue-reopened",60171),issues:c("issues",60172),italic:c("italic",60173),jersey:c("jersey",60174),json:c("json",60175),kebabVertical:c("kebab-vertical",60176),key:c("key",60177),law:c("law",60178),lightbulbAutofix:c("lightbulb-autofix",60179),linkExternal:c("link-external",60180),link:c("link",60181),listOrdered:c("list-ordered",60182),listUnordered:c("list-unordered",60183),liveShare:c("live-share",60184),loading:c("loading",60185),location:c("location",60186),mailRead:c("mail-read",60187),mail:c("mail",60188),markdown:c("markdown",60189),megaphone:c("megaphone",60190),mention:c("mention",60191),milestone:c("milestone",60192),mortarBoard:c("mortar-board",60193),move:c("move",60194),multipleWindows:c("multiple-windows",60195),mute:c("mute",60196),noNewline:c("no-newline",60197),note:c("note",60198),octoface:c("octoface",60199),openPreview:c("open-preview",60200),package_:c("package",60201),paintcan:c("paintcan",60202),pin:c("pin",60203),play:c("play",60204),run:c("run",60204),plug:c("plug",60205),preserveCase:c("preserve-case",60206),preview:c("preview",60207),project:c("project",60208),pulse:c("pulse",60209),question:c("question",60210),quote:c("quote",60211),radioTower:c("radio-tower",60212),reactions:c("reactions",60213),references:c("references",60214),refresh:c("refresh",60215),regex:c("regex",60216),remoteExplorer:c("remote-explorer",60217),remote:c("remote",60218),remove:c("remove",60219),replaceAll:c("replace-all",60220),replace:c("replace",60221),repoClone:c("repo-clone",60222),repoForcePush:c("repo-force-push",60223),repoPull:c("repo-pull",60224),repoPush:c("repo-push",60225),report:c("report",60226),requestChanges:c("request-changes",60227),rocket:c("rocket",60228),rootFolderOpened:c("root-folder-opened",60229),rootFolder:c("root-folder",60230),rss:c("rss",60231),ruby:c("ruby",60232),saveAll:c("save-all",60233),saveAs:c("save-as",60234),save:c("save",60235),screenFull:c("screen-full",60236),screenNormal:c("screen-normal",60237),searchStop:c("search-stop",60238),server:c("server",60240),settingsGear:c("settings-gear",60241),settings:c("settings",60242),shield:c("shield",60243),smiley:c("smiley",60244),sortPrecedence:c("sort-precedence",60245),splitHorizontal:c("split-horizontal",60246),splitVertical:c("split-vertical",60247),squirrel:c("squirrel",60248),starFull:c("star-full",60249),starHalf:c("star-half",60250),symbolClass:c("symbol-class",60251),symbolColor:c("symbol-color",60252),symbolCustomColor:c("symbol-customcolor",60252),symbolConstant:c("symbol-constant",60253),symbolEnumMember:c("symbol-enum-member",60254),symbolField:c("symbol-field",60255),symbolFile:c("symbol-file",60256),symbolInterface:c("symbol-interface",60257),symbolKeyword:c("symbol-keyword",60258),symbolMisc:c("symbol-misc",60259),symbolOperator:c("symbol-operator",60260),symbolProperty:c("symbol-property",60261),wrench:c("wrench",60261),wrenchSubaction:c("wrench-subaction",60261),symbolSnippet:c("symbol-snippet",60262),tasklist:c("tasklist",60263),telescope:c("telescope",60264),textSize:c("text-size",60265),threeBars:c("three-bars",60266),thumbsdown:c("thumbsdown",60267),thumbsup:c("thumbsup",60268),tools:c("tools",60269),triangleDown:c("triangle-down",60270),triangleLeft:c("triangle-left",60271),triangleRight:c("triangle-right",60272),triangleUp:c("triangle-up",60273),twitter:c("twitter",60274),unfold:c("unfold",60275),unlock:c("unlock",60276),unmute:c("unmute",60277),unverified:c("unverified",60278),verified:c("verified",60279),versions:c("versions",60280),vmActive:c("vm-active",60281),vmOutline:c("vm-outline",60282),vmRunning:c("vm-running",60283),watch:c("watch",60284),whitespace:c("whitespace",60285),wholeWord:c("whole-word",60286),window:c("window",60287),wordWrap:c("word-wrap",60288),zoomIn:c("zoom-in",60289),zoomOut:c("zoom-out",60290),listFilter:c("list-filter",60291),listFlat:c("list-flat",60292),listSelection:c("list-selection",60293),selection:c("selection",60293),listTree:c("list-tree",60294),debugBreakpointFunctionUnverified:c("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:c("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:c("debug-breakpoint-function-disabled",60296),debugStackframeActive:c("debug-stackframe-active",60297),circleSmallFilled:c("circle-small-filled",60298),debugStackframeDot:c("debug-stackframe-dot",60298),debugStackframe:c("debug-stackframe",60299),debugStackframeFocused:c("debug-stackframe-focused",60299),debugBreakpointUnsupported:c("debug-breakpoint-unsupported",60300),symbolString:c("symbol-string",60301),debugReverseContinue:c("debug-reverse-continue",60302),debugStepBack:c("debug-step-back",60303),debugRestartFrame:c("debug-restart-frame",60304),callIncoming:c("call-incoming",60306),callOutgoing:c("call-outgoing",60307),menu:c("menu",60308),expandAll:c("expand-all",60309),feedback:c("feedback",60310),groupByRefType:c("group-by-ref-type",60311),ungroupByRefType:c("ungroup-by-ref-type",60312),account:c("account",60313),bellDot:c("bell-dot",60314),debugConsole:c("debug-console",60315),library:c("library",60316),output:c("output",60317),runAll:c("run-all",60318),syncIgnored:c("sync-ignored",60319),pinned:c("pinned",60320),githubInverted:c("github-inverted",60321),debugAlt:c("debug-alt",60305),serverProcess:c("server-process",60322),serverEnvironment:c("server-environment",60323),pass:c("pass",60324),stopCircle:c("stop-circle",60325),playCircle:c("play-circle",60326),record:c("record",60327),debugAltSmall:c("debug-alt-small",60328),vmConnect:c("vm-connect",60329),cloud:c("cloud",60330),merge:c("merge",60331),exportIcon:c("export",60332),graphLeft:c("graph-left",60333),magnet:c("magnet",60334),notebook:c("notebook",60335),redo:c("redo",60336),checkAll:c("check-all",60337),pinnedDirty:c("pinned-dirty",60338),passFilled:c("pass-filled",60339),circleLargeFilled:c("circle-large-filled",60340),circleLarge:c("circle-large",60341),circleLargeOutline:c("circle-large-outline",60341),combine:c("combine",60342),gather:c("gather",60342),table:c("table",60343),variableGroup:c("variable-group",60344),typeHierarchy:c("type-hierarchy",60345),typeHierarchySub:c("type-hierarchy-sub",60346),typeHierarchySuper:c("type-hierarchy-super",60347),gitPullRequestCreate:c("git-pull-request-create",60348),runAbove:c("run-above",60349),runBelow:c("run-below",60350),notebookTemplate:c("notebook-template",60351),debugRerun:c("debug-rerun",60352),workspaceTrusted:c("workspace-trusted",60353),workspaceUntrusted:c("workspace-untrusted",60354),workspaceUnspecified:c("workspace-unspecified",60355),terminalCmd:c("terminal-cmd",60356),terminalDebian:c("terminal-debian",60357),terminalLinux:c("terminal-linux",60358),terminalPowershell:c("terminal-powershell",60359),terminalTmux:c("terminal-tmux",60360),terminalUbuntu:c("terminal-ubuntu",60361),terminalBash:c("terminal-bash",60362),arrowSwap:c("arrow-swap",60363),copy:c("copy",60364),personAdd:c("person-add",60365),filterFilled:c("filter-filled",60366),wand:c("wand",60367),debugLineByLine:c("debug-line-by-line",60368),inspect:c("inspect",60369),layers:c("layers",60370),layersDot:c("layers-dot",60371),layersActive:c("layers-active",60372),compass:c("compass",60373),compassDot:c("compass-dot",60374),compassActive:c("compass-active",60375),azure:c("azure",60376),issueDraft:c("issue-draft",60377),gitPullRequestClosed:c("git-pull-request-closed",60378),gitPullRequestDraft:c("git-pull-request-draft",60379),debugAll:c("debug-all",60380),debugCoverage:c("debug-coverage",60381),runErrors:c("run-errors",60382),folderLibrary:c("folder-library",60383),debugContinueSmall:c("debug-continue-small",60384),beakerStop:c("beaker-stop",60385),graphLine:c("graph-line",60386),graphScatter:c("graph-scatter",60387),pieChart:c("pie-chart",60388),bracket:c("bracket",60388),bracketDot:c("bracket-dot",60389),bracketError:c("bracket-error",60390),lockSmall:c("lock-small",60391),azureDevops:c("azure-devops",60392),verifiedFilled:c("verified-filled",60393),newLine:c("newline",60394),layout:c("layout",60395),layoutActivitybarLeft:c("layout-activitybar-left",60396),layoutActivitybarRight:c("layout-activitybar-right",60397),layoutPanelLeft:c("layout-panel-left",60398),layoutPanelCenter:c("layout-panel-center",60399),layoutPanelJustify:c("layout-panel-justify",60400),layoutPanelRight:c("layout-panel-right",60401),layoutPanel:c("layout-panel",60402),layoutSidebarLeft:c("layout-sidebar-left",60403),layoutSidebarRight:c("layout-sidebar-right",60404),layoutStatusbar:c("layout-statusbar",60405),layoutMenubar:c("layout-menubar",60406),layoutCentered:c("layout-centered",60407),layoutSidebarRightOff:c("layout-sidebar-right-off",60416),layoutPanelOff:c("layout-panel-off",60417),layoutSidebarLeftOff:c("layout-sidebar-left-off",60418),target:c("target",60408),indent:c("indent",60409),recordSmall:c("record-small",60410),errorSmall:c("error-small",60411),arrowCircleDown:c("arrow-circle-down",60412),arrowCircleLeft:c("arrow-circle-left",60413),arrowCircleRight:c("arrow-circle-right",60414),arrowCircleUp:c("arrow-circle-up",60415),heartFilled:c("heart-filled",60420),map:c("map",60421),mapFilled:c("map-filled",60422),circleSmall:c("circle-small",60423),bellSlash:c("bell-slash",60424),bellSlashDot:c("bell-slash-dot",60425),commentUnresolved:c("comment-unresolved",60426),gitPullRequestGoToChanges:c("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:c("git-pull-request-new-changes",60428),searchFuzzy:c("search-fuzzy",60429),commentDraft:c("comment-draft",60430),dialogError:c("dialog-error","error"),dialogWarning:c("dialog-warning","warning"),dialogInfo:c("dialog-info","info"),dialogClose:c("dialog-close","close"),treeItemExpanded:c("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:c("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:c("tree-filter-on-type-off","list-selection"),treeFilterClear:c("tree-filter-clear","close"),treeItemLoading:c("tree-item-loading","loading"),menuSelection:c("menu-selection","check"),menuSubmenu:c("menu-submenu","chevron-right"),menuBarMore:c("menubar-more","more"),scrollbarButtonLeft:c("scrollbar-button-left","triangle-left"),scrollbarButtonRight:c("scrollbar-button-right","triangle-right"),scrollbarButtonUp:c("scrollbar-button-up","triangle-up"),scrollbarButtonDown:c("scrollbar-button-down","triangle-down"),toolBarMore:c("toolbar-more","more"),quickInputBack:c("quick-input-back","arrow-left")}}),define(oe[32],ae([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const g=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([p,b])=>{g[p]=b&&typeof b=="object"?T(b):b}),g}e.deepClone=T;function R(l){if(!l||typeof l!="object")return l;const g=[l];for(;g.length>0;){const p=g.shift();Object.freeze(p);for(const b in p)if(c.call(p,b)){const A=p[b];typeof A=="object"&&!Object.isFrozen(A)&&!(0,D.isTypedArray)(A)&&g.push(A)}}return l}e.deepFreeze=R;const c=Object.prototype.hasOwnProperty;function O(l,g){return P(l,g,new Set)}e.cloneAndChange=O;function P(l,g,p){if((0,D.isUndefinedOrNull)(l))return l;const b=g(l);if(typeof b<"u")return b;if(Array.isArray(l)){const A=[];for(const i of l)A.push(P(i,g,p));return A}if((0,D.isObject)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const A={};for(const i in l)c.call(l,i)&&(A[i]=P(l[i],g,p));return p.delete(l),A}return l}function I(l,g,p=!0){return(0,D.isObject)(l)?((0,D.isObject)(g)&&Object.keys(g).forEach(b=>{b in l?p&&((0,D.isObject)(l[b])&&(0,D.isObject)(g[b])?I(l[b],g[b],p):l[b]=g[b]):l[b]=g[b]}),l):g}e.mixin=I;function E(l,g){if(l===g)return!0;if(l==null||g===null||g===void 0||typeof l!=typeof g||typeof l!="object"||Array.isArray(l)!==Array.isArray(g))return!1;let p,b;if(Array.isArray(l)){if(l.length!==g.length)return!1;for(p=0;p<l.length;p++)if(!E(l[p],g[p]))return!1}else{const A=[];for(b in l)A.push(b);A.sort();const i=[];for(b in g)i.push(b);if(i.sort(),!E(A,i))return!1;for(p=0;p<A.length;p++)if(!E(l[A[p]],g[A[p]]))return!1}return!0}e.equals=E;function C(l){const g=new Set;return JSON.stringify(l,(p,b)=>{if((0,D.isObject)(b)||Array.isArray(b)){if(g.has(b))return"[Circular]";g.add(b)}return b})}e.safeStringify=C;function w(l,g){const p=Object.create(null);return!l||!g||Object.keys(g).forEach(A=>{const i=l[A],r=g[A];E(i,r)||(p[A]=r)}),p}e.distinct=w;function m(l,g){const p=g.toLowerCase(),b=Object.keys(l).find(A=>A.toLowerCase()===p);return b?l[b]:l[g]}e.getCaseInsensitive=m;function y(l,g){const p=Object.create(null);for(const[b,A]of Object.entries(l))g(b,A)&&(p[b]=A);return p}e.filter=y;function h(l){let g=[],p=Object.getPrototypeOf(l);for(;Object.prototype!==p;)g=g.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return g}e.getAllPropertyNames=h;function S(l){const g=[];for(const p of h(l))typeof l[p]=="function"&&g.push(p);return g}e.getAllMethodNames=S;function u(l,g){const p=A=>function(){const i=Array.prototype.slice.call(arguments,0);return g(A,i)},b={};for(const A of l)b[A]=p(A);return b}e.createProxyObject=u}),define(oe[132],ae([0,1,52]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var T;(function(O){function P(I){return I&&typeof I=="object"&&typeof I.id=="string"}O.isThemeColor=P})(T=e.ThemeColor||(e.ThemeColor={}));function R(O){return{id:O}}e.themeColorFromId=R;var c;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function I(g){const p=P.exec(g.id);if(!p)return I(D.Codicon.error);const[,b,A]=p,i=["codicon","codicon-"+b];return A&&i.push("codicon-modifier-"+A.substring(1)),i}O.asClassNameArray=I;function E(g){return I(g).join(" ")}O.asClassName=E;function C(g){return"."+I(g).join(".")}O.asCSSSelector=C;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||T.isThemeColor(g.color))}O.isThemeIcon=w;const m=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function y(g){const p=m.exec(g);if(!p)return;const[,b]=p;return{id:b}}O.fromString=y;function h(g){return{id:g}}O.fromId=h;function S(g,p){let b=g.id;const A=b.lastIndexOf("~");return A!==-1&&(b=b.substring(0,A)),p&&(b=`${b}~${p}`),{id:b}}O.modify=S;function u(g){const p=g.id.lastIndexOf("~");if(p!==-1)return g.id.substring(p+1)}O.getModifier=u;function l(g,p){return g.id===p.id&&g.color?.id===p.color?.id}O.isEqual=l})(c=e.ThemeIcon||(e.ThemeIcon={}))}),define(oe[31],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(R){return D.test(R)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const c=new Uint8Array(16),O=[];for(let P=0;P<256;P++)O.push(P.toString(16).padStart(2,"0"));return function(){R(c),c[6]=c[6]&15|64,c[8]=c[8]&63|128;let I=0,E="";return E+=O[c[I++]],E+=O[c[I++]],E+=O[c[I++]],E+=O[c[I++]],E+="-",E+=O[c[I++]],E+=O[c[I++]],E+="-",E+=O[c[I++]],E+=O[c[I++]],E+="-",E+=O[c[I++]],E+=O[c[I++]],E+="-",E+=O[c[I++]],E+=O[c[I++]],E+=O[c[I++]],E+=O[c[I++]],E+=O[c[I++]],E+=O[c[I++]],E}}()}),define(oe[133],ae([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(O){const P=O.replace(/\-/g,":").toLowerCase();return!T.has(P)}function c(){const O=(0,D.networkInterfaces)();for(const P in O){const I=O[P];if(I){for(const{mac:E}of I)if(R(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=c}),define(oe[134],ae([0,1,86]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function T(P,I,E,C=1){let w=!1;return new Promise(m=>{const y=setTimeout(()=>{if(!w)return w=!0,m(0)},E);R(P,I,C,h=>{if(!w)return w=!0,clearTimeout(y),m(h)})})}e.findFreePort=T;function R(P,I,E,C){if(I===0)return C(0);const w=new D.Socket;w.once("connect",()=>(O(w),R(P+E,I-1,E,C))),w.once("data",()=>{}),w.once("error",m=>(O(w),m.code!=="ECONNREFUSED"?R(P+E,I-1,E,C):C(P))),w.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function c(P,I,E,C="127.0.0.1"){let w=!1,m,y=1;const h=D.createServer({pauseOnConnect:!0});function S(u,l){w||(w=!0,h.removeAllListeners(),h.close(),m&&clearTimeout(m),l(u))}return new Promise(u=>{m=setTimeout(()=>{S(0,u)},E),h.on("listening",()=>{S(P,u)}),h.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&y<I?(P++,y++,h.listen(P,C)):S(0,u)}),h.on("close",()=>{S(0,u)}),h.listen(P,C)})}e.findFreePortFaster=c;function O(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(oe[135],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function T(c){return c instanceof R?!0:c instanceof Error&&c.name===D&&c.message===D}e.isOfflineError=T;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(oe[136],ae([0,1,17,9,135]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function c(I,E){if(!navigator.onLine)throw new R.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((w,m)=>{C.open(I.type||"GET",I.url||"",!0,I.user,I.password),O(C,I),C.responseType="arraybuffer",C.onerror=y=>m(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=y=>{w({res:{statusCode:C.status,headers:P(C)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=y=>m(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(C.timeout=I.timeout),C.send(I.data),E.onCancellationRequested(()=>{C.abort(),m((0,T.canceled)())})})}e.request=c;function O(I,E){if(E.headers){e:for(const C in E.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(C,E.headers[C])}}}function P(I){const E=Object.create(null);for(const C of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const w=C.indexOf(":");E[C.substr(0,w).trim().toLowerCase()]=C.substr(w+1).trim()}return E}}),define(oe[137],ae([10,7]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,137]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,R=T*60,c=R*24,O=c*7,P=c*30,I=c*365;function E(w,m,y,h){typeof w!="number"&&(w=w.getTime());const S=Math.round((new Date().getTime()-w)/1e3);if(S<-30)return(0,D.localize)(0,null,E(new Date().getTime()+S*1e3,!1));if(!h&&S<30)return(0,D.localize)(1,null);let u;return S<T?(u=S,m?u===1?y?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):y?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u):u===1?y?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):y?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):S<R?(u=Math.floor(S/T),m?u===1?y?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):y?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u):u===1?y?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):y?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):S<c?(u=Math.floor(S/R),m?u===1?y?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):y?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u):u===1?y?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):y?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):S<O?(u=Math.floor(S/c),m?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u)):S<P?(u=Math.floor(S/O),m?u===1?y?(0,D.localize)(30,null,u):(0,D.localize)(31,null,u):y?(0,D.localize)(32,null,u):(0,D.localize)(33,null,u):u===1?y?(0,D.localize)(34,null,u):(0,D.localize)(35,null,u):y?(0,D.localize)(36,null,u):(0,D.localize)(37,null,u)):S<I?(u=Math.floor(S/P),m?u===1?y?(0,D.localize)(38,null,u):(0,D.localize)(39,null,u):y?(0,D.localize)(40,null,u):(0,D.localize)(41,null,u):u===1?y?(0,D.localize)(42,null,u):(0,D.localize)(43,null,u):y?(0,D.localize)(44,null,u):(0,D.localize)(45,null,u)):(u=Math.floor(S/I),m?u===1?y?(0,D.localize)(46,null,u):(0,D.localize)(47,null,u):y?(0,D.localize)(48,null,u):(0,D.localize)(49,null,u):u===1?y?(0,D.localize)(50,null,u):(0,D.localize)(51,null,u):y?(0,D.localize)(52,null,u):(0,D.localize)(53,null,u))}e.fromNow=E;function C(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(oe[138],ae([10,7]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,12,138]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function c(w,m){return m&&(w.stack||w.stacktrace)?R.localize(0,null,P(w),O(w.stack)||O(w.stacktrace)):P(w)}function O(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?R.localize(1,null,w.message):w.message||R.localize(2,null)}function I(w=null,m=!1){if(!w)return R.localize(3,null);if(Array.isArray(w)){const y=D.coalesce(w),h=I(y[0],m);return y.length>1?R.localize(4,null,h,y.length):h}if(T.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return c(y.error,m);if(y.exception)return c(y.exception,m)}return w.stack?c(w,m):w.message?w.message:R.localize(5,null)}e.toErrorMessage=I;function E(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=E;function C(w,m){let y;return typeof w=="string"?y=new Error(w):y=w,y.actions=m,y}e.createErrorWithActions=C}),define(oe[139],ae([10,7]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(oe[140],ae([0,1,139]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function T(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=T}),define(oe[141],ae([10,7]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,141]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let T=!1,R=!1,c=!1,O=!1,P=!1,I=!1,E=!1,C=!1,w=!1,m=!1,y,h=e.LANGUAGE_DEFAULT,S,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const g=typeof l?.versions?.electron=="string",p=g&&l?.type==="renderer";if(typeof navigator=="object"&&!p)u=navigator.userAgent,T=u.indexOf("Windows")>=0,R=u.indexOf("Macintosh")>=0,C=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=u.indexOf("Linux")>=0,m=u?.indexOf("Mobi")>=0,I=!0,y=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,h=y;else if(typeof l=="object"){T=l.platform==="win32",R=l.platform==="darwin",c=l.platform==="linux",O=c&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,E=g,w=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const o=l.env.VSCODE_NLS_CONFIG;if(o)try{const f=JSON.parse(o),d=f.availableLanguages["*"];y=f.locale,h=d||e.LANGUAGE_DEFAULT,S=f._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var b;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function A(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=A;let i=0;R?i=1:T?i=3:c&&(i=2),e.isWindows=T,e.isMacintosh=R,e.isLinux=c,e.isLinuxSnap=O,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=m,e.isCI=w,e.platform=i,e.userAgent=u,e.language=h;var r;(function(o){function f(){return e.language}o.value=f;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=d;function v(){return e.language==="en"}o.isDefault=v})(r=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let v=0,L=o.length;v<L;v++){const N=o[v];if(N.id===d.data.vscodeScheduleAsyncWork){o.splice(v,1),N.callback();return}}});let f=0;return d=>{const v=++f;o.push({id:v,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:v},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:T?1:3;let n=!0,s=!1;function a(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,n=new Uint16Array(o.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let T;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;T={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.arch=T.arch}),define(oe[13],ae([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,R=97,c=90,O=122,P=46,I=47,E=92,C=58,w=63;class m extends Error{constructor(r,t,n){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const a=r.indexOf(".")!==-1?"property":"argument";let o=`The "${r}" ${a} ${s} of type ${t}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function y(i,r){if(i===null||typeof i!="object")throw new m(r,"Object",i)}function h(i,r){if(typeof i!="string")throw new m(r,"string",i)}const S=D.platform==="win32";function u(i){return i===I||i===E}function l(i){return i===I}function g(i){return i>=T&&i<=c||i>=R&&i<=O}function p(i,r,t,n){let s="",a=0,o=-1,f=0,d=0;for(let v=0;v<=i.length;++v){if(v<i.length)d=i.charCodeAt(v);else{if(n(d))break;d=I}if(n(d)){if(!(o===v-1||f===1))if(f===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const L=s.lastIndexOf(t);L===-1?(s="",a=0):(s=s.slice(0,L),a=s.length-1-s.lastIndexOf(t)),o=v,f=0;continue}else if(s.length!==0){s="",a=0,o=v,f=0;continue}}r&&(s+=s.length>0?`${t}..`:"..",a=2)}else s.length>0?s+=`${t}${i.slice(o+1,v)}`:s=i.slice(o+1,v),a=v-o-1;o=v,f=0}else d===P&&f!==-1?++f:f=-1}return s}function b(i,r){y(r,"pathObject");const t=r.dir||r.root,n=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${n}`:`${t}${i}${n}`:n}e.win32={resolve(...i){let r="",t="",n=!1;for(let s=i.length-1;s>=-1;s--){let a;if(s>=0){if(a=i[s],h(a,"path"),a.length===0)continue}else r.length===0?a=D.cwd():(a=D.env[`=${r}`]||D.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==r.toLowerCase()&&a.charCodeAt(2)===E)&&(a=`${r}\\`));const o=a.length;let f=0,d="",v=!1;const L=a.charCodeAt(0);if(o===1)u(L)&&(f=1,v=!0);else if(u(L))if(v=!0,u(a.charCodeAt(1))){let N=2,F=N;for(;N<o&&!u(a.charCodeAt(N));)N++;if(N<o&&N!==F){const M=a.slice(F,N);for(F=N;N<o&&u(a.charCodeAt(N));)N++;if(N<o&&N!==F){for(F=N;N<o&&!u(a.charCodeAt(N));)N++;(N===o||N!==F)&&(d=`\\\\${M}\\${a.slice(F,N)}`,f=N)}}}else f=1;else g(L)&&a.charCodeAt(1)===C&&(d=a.slice(0,2),f=2,o>2&&u(a.charCodeAt(2))&&(v=!0,f=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(n){if(r.length>0)break}else if(t=`${a.slice(f)}\\${t}`,n=v,v&&r.length>0)break}return t=p(t,!n,"\\",u),n?`${r}\\${t}`:`${r}${t}`||"."},normalize(i){h(i,"path");const r=i.length;if(r===0)return".";let t=0,n,s=!1;const a=i.charCodeAt(0);if(r===1)return l(a)?"\\":i;if(u(a))if(s=!0,u(i.charCodeAt(1))){let f=2,d=f;for(;f<r&&!u(i.charCodeAt(f));)f++;if(f<r&&f!==d){const v=i.slice(d,f);for(d=f;f<r&&u(i.charCodeAt(f));)f++;if(f<r&&f!==d){for(d=f;f<r&&!u(i.charCodeAt(f));)f++;if(f===r)return`\\\\${v}\\${i.slice(d)}\\`;f!==d&&(n=`\\\\${v}\\${i.slice(d,f)}`,t=f)}}}else t=1;else g(a)&&i.charCodeAt(1)===C&&(n=i.slice(0,2),t=2,r>2&&u(i.charCodeAt(2))&&(s=!0,t=3));let o=t<r?p(i.slice(t),!s,"\\",u):"";return o.length===0&&!s&&(o="."),o.length>0&&u(i.charCodeAt(r-1))&&(o+="\\"),n===void 0?s?`\\${o}`:o:s?`${n}\\${o}`:`${n}${o}`},isAbsolute(i){h(i,"path");const r=i.length;if(r===0)return!1;const t=i.charCodeAt(0);return u(t)||r>2&&g(t)&&i.charCodeAt(1)===C&&u(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,t;for(let a=0;a<i.length;++a){const o=i[a];h(o,"path"),o.length>0&&(r===void 0?r=t=o:r+=`\\${o}`)}if(r===void 0)return".";let n=!0,s=0;if(typeof t=="string"&&u(t.charCodeAt(0))){++s;const a=t.length;a>1&&u(t.charCodeAt(1))&&(++s,a>2&&(u(t.charCodeAt(2))?++s:n=!1))}if(n){for(;s<r.length&&u(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(i,r){if(h(i,"from"),h(r,"to"),i===r)return"";const t=e.win32.resolve(i),n=e.win32.resolve(r);if(t===n||(i=t.toLowerCase(),r=n.toLowerCase(),i===r))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===E;)s++;let a=i.length;for(;a-1>s&&i.charCodeAt(a-1)===E;)a--;const o=a-s;let f=0;for(;f<r.length&&r.charCodeAt(f)===E;)f++;let d=r.length;for(;d-1>f&&r.charCodeAt(d-1)===E;)d--;const v=d-f,L=o<v?o:v;let N=-1,F=0;for(;F<L;F++){const k=i.charCodeAt(s+F);if(k!==r.charCodeAt(f+F))break;k===E&&(N=F)}if(F!==L){if(N===-1)return n}else{if(v>L){if(r.charCodeAt(f+F)===E)return n.slice(f+F+1);if(F===2)return n.slice(f+F)}o>L&&(i.charCodeAt(s+F)===E?N=F:F===2&&(N=3)),N===-1&&(N=0)}let M="";for(F=s+N+1;F<=a;++F)(F===a||i.charCodeAt(F)===E)&&(M+=M.length===0?"..":"\\..");return f+=N,M.length>0?`${M}${n.slice(f,d)}`:(n.charCodeAt(f)===E&&++f,n.slice(f,d))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===E){if(r.charCodeAt(1)===E){const t=r.charCodeAt(2);if(t!==w&&t!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===C&&r.charCodeAt(2)===E)return`\\\\?\\${r}`;return i},dirname(i){h(i,"path");const r=i.length;if(r===0)return".";let t=-1,n=0;const s=i.charCodeAt(0);if(r===1)return u(s)?i:".";if(u(s)){if(t=n=1,u(i.charCodeAt(1))){let f=2,d=f;for(;f<r&&!u(i.charCodeAt(f));)f++;if(f<r&&f!==d){for(d=f;f<r&&u(i.charCodeAt(f));)f++;if(f<r&&f!==d){for(d=f;f<r&&!u(i.charCodeAt(f));)f++;if(f===r)return i;f!==d&&(t=n=f+1)}}}}else g(s)&&i.charCodeAt(1)===C&&(t=r>2&&u(i.charCodeAt(2))?3:2,n=t);let a=-1,o=!0;for(let f=r-1;f>=n;--f)if(u(i.charCodeAt(f))){if(!o){a=f;break}}else o=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,r){r!==void 0&&h(r,"ext"),h(i,"path");let t=0,n=-1,s=!0,a;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(t=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let o=r.length-1,f=-1;for(a=i.length-1;a>=t;--a){const d=i.charCodeAt(a);if(u(d)){if(!s){t=a+1;break}}else f===-1&&(s=!1,f=a+1),o>=0&&(d===r.charCodeAt(o)?--o===-1&&(n=a):(o=-1,n=f))}return t===n?n=f:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=t;--a)if(u(i.charCodeAt(a))){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){h(i,"path");let r=0,t=-1,n=0,s=-1,a=!0,o=0;i.length>=2&&i.charCodeAt(1)===C&&g(i.charCodeAt(0))&&(r=n=2);for(let f=i.length-1;f>=r;--f){const d=i.charCodeAt(f);if(u(d)){if(!a){n=f+1;break}continue}s===-1&&(a=!1,s=f+1),d===P?t===-1?t=f:o!==1&&(o=1):t!==-1&&(o=-1)}return t===-1||s===-1||o===0||o===1&&t===s-1&&t===n+1?"":i.slice(t,s)},format:b.bind(null,"\\"),parse(i){h(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.length;let n=0,s=i.charCodeAt(0);if(t===1)return u(s)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(u(s)){if(n=1,u(i.charCodeAt(1))){let N=2,F=N;for(;N<t&&!u(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&u(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&!u(i.charCodeAt(N));)N++;N===t?n=N:N!==F&&(n=N+1)}}}}else if(g(s)&&i.charCodeAt(1)===C){if(t<=2)return r.root=r.dir=i,r;if(n=2,u(i.charCodeAt(2))){if(t===3)return r.root=r.dir=i,r;n=3}}n>0&&(r.root=i.slice(0,n));let a=-1,o=n,f=-1,d=!0,v=i.length-1,L=0;for(;v>=n;--v){if(s=i.charCodeAt(v),u(s)){if(!d){o=v+1;break}continue}f===-1&&(d=!1,f=v+1),s===P?a===-1?a=v:L!==1&&(L=1):a!==-1&&(L=-1)}return f!==-1&&(a===-1||L===0||L===1&&a===f-1&&a===o+1?r.base=r.name=i.slice(o,f):(r.name=i.slice(o,a),r.base=i.slice(o,f),r.ext=i.slice(a,f))),o>0&&o!==n?r.dir=i.slice(0,o-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const A=(()=>{if(S){const i=/\\/g;return()=>{const r=D.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.posix={resolve(...i){let r="",t=!1;for(let n=i.length-1;n>=-1&&!t;n--){const s=n>=0?i[n]:A();h(s,"path"),s.length!==0&&(r=`${s}/${r}`,t=s.charCodeAt(0)===I)}return r=p(r,!t,"/",l),t?`/${r}`:r.length>0?r:"."},normalize(i){if(h(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===I,t=i.charCodeAt(i.length-1)===I;return i=p(i,!r,"/",l),i.length===0?r?"/":t?"./":".":(t&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return h(i,"path"),i.length>0&&i.charCodeAt(0)===I},join(...i){if(i.length===0)return".";let r;for(let t=0;t<i.length;++t){const n=i[t];h(n,"path"),n.length>0&&(r===void 0?r=n:r+=`/${n}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(h(i,"from"),h(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const t=1,n=i.length,s=n-t,a=1,o=r.length-a,f=s<o?s:o;let d=-1,v=0;for(;v<f;v++){const N=i.charCodeAt(t+v);if(N!==r.charCodeAt(a+v))break;N===I&&(d=v)}if(v===f)if(o>f){if(r.charCodeAt(a+v)===I)return r.slice(a+v+1);if(v===0)return r.slice(a+v)}else s>f&&(i.charCodeAt(t+v)===I?d=v:v===0&&(d=0));let L="";for(v=t+d+1;v<=n;++v)(v===n||i.charCodeAt(v)===I)&&(L+=L.length===0?"..":"/..");return`${L}${r.slice(a+d)}`},toNamespacedPath(i){return i},dirname(i){if(h(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===I;let t=-1,n=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===I){if(!n){t=s;break}}else n=!1;return t===-1?r?"/":".":r&&t===1?"//":i.slice(0,t)},basename(i,r){r!==void 0&&h(r,"ext"),h(i,"path");let t=0,n=-1,s=!0,a;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let o=r.length-1,f=-1;for(a=i.length-1;a>=0;--a){const d=i.charCodeAt(a);if(d===I){if(!s){t=a+1;break}}else f===-1&&(s=!1,f=a+1),o>=0&&(d===r.charCodeAt(o)?--o===-1&&(n=a):(o=-1,n=f))}return t===n?n=f:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===I){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){h(i,"path");let r=-1,t=0,n=-1,s=!0,a=0;for(let o=i.length-1;o>=0;--o){const f=i.charCodeAt(o);if(f===I){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),f===P?r===-1?r=o:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||n===-1||a===0||a===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:b.bind(null,"/"),parse(i){h(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.charCodeAt(0)===I;let n;t?(r.root="/",n=1):n=0;let s=-1,a=0,o=-1,f=!0,d=i.length-1,v=0;for(;d>=n;--d){const L=i.charCodeAt(d);if(L===I){if(!f){a=d+1;break}continue}o===-1&&(f=!1,o=d+1),L===P?s===-1?s=d:v!==1&&(v=1):s!==-1&&(v=-1)}if(o!==-1){const L=a===0&&t?1:a;s===-1||v===0||v===1&&s===o-1&&s===a+1?r.base=r.name=i.slice(L,o):(r.name=i.slice(L,s),r.base=i.slice(L,o),r.ext=i.slice(s,o))}return a>0?r.dir=i.slice(0,a-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S?e.win32.normalize:e.posix.normalize,e.isAbsolute=S?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S?e.win32.join:e.posix.join,e.resolve=S?e.win32.resolve:e.posix.resolve,e.relative=S?e.win32.relative:e.posix.relative,e.dirname=S?e.win32.dirname:e.posix.dirname,e.basename=S?e.win32.basename:e.posix.basename,e.extname=S?e.win32.extname:e.posix.extname,e.format=S?e.win32.format:e.posix.format,e.parse=S?e.win32.parse:e.posix.parse,e.toNamespacedPath=S?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S?e.win32.sep:e.posix.sep,e.delimiter=S?e.win32.delimiter:e.posix.delimiter}),define(oe[142],ae([0,1,13]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(C){const w=(0,D.extname)(C),m=T[w.toLowerCase()];return m!==void 0?m:O(C)}e.getMediaOrTextMime=c;function O(C){const w=(0,D.extname)(C);return R[w.toLowerCase()]}e.getMediaMime=O;function P(C){for(const w in R)if(R[w]===C)return w}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function E(C,w){const m=I.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:C}e.normalizeMimeType=E}),define(oe[87],ae([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(T=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function c(P,...I){const E=I.reduce((m,y)=>(m[y]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(m=>!E[m]).forEach(m=>{for(let y=0;y<C.length;y++)if(m.search(C[y])!==-1){delete P[m];break}})}e.sanitizeProcessEnvironment=c;function O(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(oe[88],ae([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(O=!0){return new R(O)}constructor(O){this.a=T&&O,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(oe[3],ae([0,1,9,82,2,84,88]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var E;(function(a){a.None=()=>R.Disposable.None;function o(q){if(I){const{onDidAddListener:Y}=q,ee=h.create();let K=0;q.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),Y?.()}}}function f(q,Y){return z(q,()=>{},0,void 0,void 0,Y)}a.defer=f;function d(q){return(Y,ee=null,K)=>{let Z=!1,se;return se=q(le=>{if(!Z)return se?se.dispose():Z=!0,Y.call(ee,le)},null,K),Z&&se.dispose(),se}}a.once=d;function v(q,Y,ee){return $((K,Z=null,se)=>q(le=>K.call(Z,Y(le)),null,se),ee)}a.map=v;function L(q,Y,ee){return $((K,Z=null,se)=>q(le=>{Y(le),K.call(Z,le)},null,se),ee)}a.forEach=L;function N(q,Y,ee){return $((K,Z=null,se)=>q(le=>Y(le)&&K.call(Z,le),null,se),ee)}a.filter=N;function F(q){return q}a.signal=F;function M(...q){return(Y,ee=null,K)=>(0,R.combinedDisposable)(...q.map(Z=>Z(se=>Y.call(ee,se),null,K)))}a.any=M;function k(q,Y,ee,K){let Z=ee;return v(q,se=>(Z=Y(Z,se),Z),K)}a.reduce=k;function $(q,Y){let ee;const K={onWillAddFirstListener(){ee=q(Z.fire,Z)},onDidRemoveLastListener(){ee?.dispose()}};Y||o(K);const Z=new u(K);return Y?.add(Z),Z.event}function z(q,Y,ee=100,K=!1,Z,se){let le,ue,pe,ve=0;const be={leakWarningThreshold:Z,onWillAddFirstListener(){le=q(Oe=>{ve++,ue=Y(ue,Oe),K&&!pe&&(Ee.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Ue=ue;ue=void 0,pe=void 0,(!K||ve>1)&&Ee.fire(Ue),ve=0},ee)})},onDidRemoveLastListener(){le.dispose()}};se||o(be);const Ee=new u(be);return se?.add(Ee),Ee.event}a.debounce=z;function x(q,Y=0,ee){return a.debounce(q,(K,Z)=>K?(K.push(Z),K):[Z],Y,void 0,void 0,ee)}a.accumulate=x;function X(q,Y=(K,Z)=>K===Z,ee){let K=!0,Z;return N(q,se=>{const le=K||!Y(se,Z);return K=!1,Z=se,le},ee)}a.latch=X;function ie(q,Y,ee){return[a.filter(q,Y,ee),a.filter(q,K=>!Y(K),ee)]}a.split=ie;function H(q,Y=!1,ee=[]){let K=ee.slice(),Z=q(ue=>{K?K.push(ue):le.fire(ue)});const se=()=>{K?.forEach(ue=>le.fire(ue)),K=null},le=new u({onWillAddFirstListener(){Z||(Z=q(ue=>le.fire(ue)))},onDidAddFirstListener(){K&&(Y?setTimeout(se):se())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return le.event}a.buffer=H;class j{constructor(Y){this.event=Y,this.c=new R.DisposableStore}map(Y){return new j(v(this.event,Y,this.c))}forEach(Y){return new j(L(this.event,Y,this.c))}filter(Y){return new j(N(this.event,Y,this.c))}reduce(Y,ee){return new j(k(this.event,Y,ee,this.c))}latch(){return new j(X(this.event,void 0,this.c))}debounce(Y,ee=100,K=!1,Z){return new j(z(this.event,Y,ee,K,Z,this.c))}on(Y,ee,K){return this.event(Y,ee,K)}once(Y,ee,K){return d(this.event)(Y,ee,K)}dispose(){this.c.dispose()}}function V(q){return new j(q)}a.chain=V;function J(q,Y,ee=K=>K){const K=(...ue)=>le.fire(ee(...ue)),Z=()=>q.on(Y,K),se=()=>q.removeListener(Y,K),le=new u({onWillAddFirstListener:Z,onDidRemoveLastListener:se});return le.event}a.fromNodeEventEmitter=J;function _(q,Y,ee=K=>K){const K=(...ue)=>le.fire(ee(...ue)),Z=()=>q.addEventListener(Y,K),se=()=>q.removeEventListener(Y,K),le=new u({onWillAddFirstListener:Z,onDidRemoveLastListener:se});return le.event}a.fromDOMEventEmitter=_;function re(q){return new Promise(Y=>d(q)(Y))}a.toPromise=re;function te(q,Y){return Y(void 0),q(ee=>Y(ee))}a.runAndSubscribe=te;function U(q,Y){let ee=null;function K(se){ee?.dispose(),ee=new R.DisposableStore,Y(se,ee)}K(void 0);const Z=q(se=>K(se));return(0,R.toDisposable)(()=>{Z.dispose(),ee?.dispose()})}a.runAndSubscribeWithStore=U;class B{constructor(Y,ee){this.obs=Y,this.c=0,this.d=!1;const K={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};ee||o(K),this.emitter=new u(K),ee&&ee.add(this.emitter)}beginUpdate(Y){this.c++}handleChange(Y,ee){this.d=!0}endUpdate(Y){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(q,Y){return new B(q,Y).emitter.event}a.fromObservable=W})(E=e.Event||(e.Event={}));class C{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${C.c++}`,C.all.add(this)}start(o){this.d=new O.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let w=-1;function m(a){const o=w;return w=a,{dispose(){w=o}}}e.setGlobalLeakWarningThreshold=m;class y{constructor(o,f=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=f,this.d=0}dispose(){this.c?.clear()}check(o,f){const d=this.threshold;if(d<=0||f<d)return;this.c||(this.c=new Map);const v=this.c.get(o.value)||0;if(this.c.set(o.value,v+1),this.d-=1,this.d<=0){this.d=d*.5;let L,N=0;for(const[F,M]of this.c)(!L||N<M)&&(L=F,N=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${N}):`),console.warn(L)}return()=>{const L=this.c.get(o.value)||0;this.c.set(o.value,L-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(o,f,d){this.callback=o,this.callbackThis=f,this.stack=d,this.subscription=new R.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class u{constructor(o){this.j=!1,this.d=o,this.f=w>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??w):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const f of o)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,f,d)=>{if(this.q||(this.q=new c.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.Disposable.None;const v=this.q.isEmpty();v&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=h.create(),L=this.f.check(N,this.q.size+1)),P&&(N=N??h.create());const F=new S(o,f,N),M=this.q.push(F);v&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,f);const k=F.subscription.set(()=>{L?.(),this.j||(M(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return d instanceof R.DisposableStore?d.add(k):Array.isArray(d)&&d.push(k),k}),this.l}fire(o){if(this.q){this.m||(this.m=new g);for(const f of this.q)this.m.push(this,f,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=u;class l{constructor(){this.c=new c.LinkedList}get size(){return this.c.size}push(o,f,d){this.c.push(new p(o,f,d))}clear(o){const f=new c.LinkedList;for(const d of this.c)d.emitter!==o&&f.push(d);this.c=f}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(f){(0,D.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=l;class g extends l{clear(o){this.c.clear()}}class p{constructor(o,f,d){this.emitter=o,this.listener=f,this.event=d}}class b extends u{async fireAsync(o,f,d){if(!!this.q){this.c||(this.c=new c.LinkedList);for(const v of this.q)this.c.push([v,o]);for(;this.c.size>0&&!f.isCancellationRequested;){const[v,L]=this.c.shift(),N=[],F={...L,token:f,waitUntil:M=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");d&&(M=d(M,v.callback)),N.push(M)}};try{v.invoke(F)}catch(M){(0,D.onUnexpectedError)(M);continue}Object.freeze(N),await Promise.allSettled(N).then(M=>{for(const k of M)k.status==="rejected"&&(0,D.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=b;class A extends u{constructor(o){super(o),this.h=0,this.s=new c.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=A;class i extends A{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=i;class r extends u{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(f=>super.fire(f)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new u({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const f={event:o,listener:null};this.f.push(f),this.d&&this.j(f);const d=()=>{this.d&&this.k(f);const v=this.f.indexOf(f);this.f.splice(v,1)};return(0,R.toDisposable)((0,T.once)(d))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(f=>this.c.fire(f))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.c=[]}wrapEvent(o){return(f,d,v)=>o(L=>{const N=this.c[this.c.length-1];N?N.push(()=>f.call(d,L)):f.call(d,L)},void 0,v)}bufferEvents(o){const f=[];this.c.push(f);const d=o();return this.c.pop(),f.forEach(v=>v()),d}}e.EventBufferer=n;class s{constructor(){this.c=!1,this.d=E.None,this.f=R.Disposable.None,this.g=new u({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(oe[25],ae([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(P,I){const E=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function I(E){return E===P.None||E===P.Cancelled||E instanceof c?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(R=e.CancellationToken||(e.CancellationToken={}));class c{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new c),this.a}cancel(){this.a?this.a instanceof c&&this.a.cancel():this.a=R.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof c&&this.a.dispose():this.a=R.None}}e.CancellationTokenSource=O}),define(oe[143],ae([0,1,25]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class T{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new D.CancellationTokenSource,I=this.b(P.token);return this.a={promise:I,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=T;class R{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const I=JSON.stringify(P);return this.b!==I&&(this.b=I,this.a=this.c(P)),this.a}}e.LRUCachedFunction=R;class c{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const I=this.b(P);return this.a.set(P,I),I}}e.CachedFunction=c}),define(oe[27],ae([0,1,143,129]),function(Q,e,D,T){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function c(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=c;const O=/{(\d+)}/g;function P(ne,...he){return he.length===0?ne:ne.replace(O,function(fe,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=he.length?fe:he[Se]})}e.format=P;const I=/{([^}]+)}/g;function E(ne,he){return ne.replace(I,(fe,me)=>he[me]??fe)}e.format2=E;function C(ne){return ne.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function m(ne,he){let fe=0;const me=he.charCodeAt(0);for(let Se=ne.length-1;Se>=0;Se--)ne.charCodeAt(Se)===me&&fe++;return fe}e.count=m;function y(ne,he,fe="\u2026"){return ne.length<=he?ne:`${ne.substr(0,he)}${fe}`}e.truncate=y;function h(ne,he=" "){const fe=S(ne,he);return u(fe,he)}e.trim=h;function S(ne,he){if(!ne||!he)return ne;const fe=he.length;if(fe===0||ne.length===0)return ne;let me=0;for(;ne.indexOf(he,me)===me;)me=me+fe;return ne.substring(me)}e.ltrim=S;function u(ne,he){if(!ne||!he)return ne;const fe=he.length,me=ne.length;if(fe===0||me===0)return ne;let Se=me,Ie=-1;for(;Ie=ne.lastIndexOf(he,Se-1),!(Ie===-1||Ie+fe!==Se);){if(Ie===0)return"";Se=Ie}return ne.substring(0,Se)}e.rtrim=u;function l(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function g(ne){return ne.replace(/\*/g,"")}e.stripWildcards=g;function p(ne,he,fe={}){if(!ne)throw new Error("Cannot create regex from empty string");he||(ne=w(ne)),fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ne,me)}e.createRegExp=p;function b(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function A(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=A;function i(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=i;function r(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ne){for(let he=0,fe=ne.length;he<fe;he++){const me=ne.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function n(ne,he=0,fe=ne.length){for(let me=he;me<fe;me++){const Se=ne.charCodeAt(me);if(Se!==32&&Se!==9)return ne.substring(he,me)}return ne.substring(he,fe)}e.getLeadingWhitespace=n;function s(ne,he=ne.length-1){for(let fe=he;fe>=0;fe--){const me=ne.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=s;function a(ne,he,fe){const me=[];let Se=0;for(const Ie of ne.matchAll(he)){if(me.push(ne.slice(Se,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");Se=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ne,Ie.groups))}return me.push(ne.slice(Se)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=a;function o(ne,he){return ne<he?-1:ne>he?1:0}e.compare=o;function f(ne,he,fe=0,me=ne.length,Se=0,Ie=he.length){for(;fe<me&&Se<Ie;fe++,Se++){const $e=ne.charCodeAt(fe),Ae=he.charCodeAt(Se);if($e<Ae)return-1;if($e>Ae)return 1}const Re=me-fe,xe=Ie-Se;return Re<xe?-1:Re>xe?1:0}e.compareSubstring=f;function d(ne,he){return v(ne,he,0,ne.length,0,he.length)}e.compareIgnoreCase=d;function v(ne,he,fe=0,me=ne.length,Se=0,Ie=he.length){for(;fe<me&&Se<Ie;fe++,Se++){let $e=ne.charCodeAt(fe),Ae=he.charCodeAt(Se);if($e===Ae)continue;if($e>=128||Ae>=128)return f(ne.toLowerCase(),he.toLowerCase(),fe,me,Se,Ie);N($e)&&($e-=32),N(Ae)&&(Ae-=32);const qe=$e-Ae;if(qe!==0)return qe}const Re=me-fe,xe=Ie-Se;return Re<xe?-1:Re>xe?1:0}e.compareSubstringIgnoreCase=v;function L(ne){return ne>=48&&ne<=57}e.isAsciiDigit=L;function N(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=N;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function M(ne,he){return ne.length===he.length&&v(ne,he)===0}e.equalsIgnoreCase=M;function k(ne,he){const fe=he.length;return he.length>ne.length?!1:v(ne,he,0,fe)===0}e.startsWithIgnoreCase=k;function $(ne,he){const fe=Math.min(ne.length,he.length);let me;for(me=0;me<fe;me++)if(ne.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=$;function z(ne,he){const fe=Math.min(ne.length,he.length);let me;const Se=ne.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ne.charCodeAt(Se-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function x(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=x;function X(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=X;function ie(ne,he){return(ne-55296<<10)+(he-56320)+65536}e.computeCodePoint=ie;function H(ne,he,fe){const me=ne.charCodeAt(fe);if(x(me)&&fe+1<he){const Se=ne.charCodeAt(fe+1);if(X(Se))return ie(me,Se)}return me}e.getNextCodePoint=H;function j(ne,he){const fe=ne.charCodeAt(he-1);if(X(fe)&&he>1){const me=ne.charCodeAt(he-2);if(x(me))return ie(me,fe)}return fe}class V{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=j(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=H(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=V;class J{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new V(he,fe)}nextGraphemeLength(){const he=Le.getInstance(),fe=this.c,me=fe.offset;let Se=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(Se,Re)){fe.setOffset(Ie);break}Se=Re}return fe.offset-me}prevGraphemeLength(){const he=Le.getInstance(),fe=this.c,me=fe.offset;let Se=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,Se)){fe.setOffset(Ie);break}Se=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function _(ne,he){return new J(ne,he).nextGraphemeLength()}e.nextCharLength=_;function re(ne,he){return new J(ne,he).prevGraphemeLength()}e.prevCharLength=re;function te(ne,he){he>0&&X(ne.charCodeAt(he))&&he--;const fe=he+_(ne,he);return[fe-re(ne,fe),fe]}e.getCharContainingOffset=te;function U(ne){const he=new J(ne);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=U;let B;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(ne){return B||(B=W()),B.test(ne)}e.containsRTL=q;const Y=/^[\t\n\r\x20-\x7E]*$/;function ee(ne){return Y.test(ne)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=K;function Z(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Z;function se(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=se;function le(ne,he){if(ne.length<he)return ne;const fe=/\b/g;let me=0;for(;fe.test(ne)&&!(ne.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ne.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function be(ne){return ne&&(ne=ne.replace(ue,""),ne=ne.replace(pe,""),ne=ne.replace(ve,"")),ne}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Oe(ne){return Ee(ne)?ne.substr(1):ne}e.stripUTF8BOM=Oe;function Ue(ne,he){if(!ne||!he||ne.length<he.length)return!1;const fe=he.length,me=ne.toLowerCase();let Se=0,Ie=-1;for(;Se<fe;){const Re=me.indexOf(he[Se],Ie+1);if(Re<0)return!1;Ie=Re,Se++}return!0}e.fuzzyContains=Ue;function Ye(ne,he=!1){return ne?(he&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Ye;function Be(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=Be;function ce(ne,he=1){if(he===0)return"";let fe=-1;do fe=ne.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ne:(ne[fe-1]==="\r"&&fe--,ne.substr(0,fe))}e.getNLines=ce;function de(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=de;function ge(ne){return Le.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ge;function Ce(ne,he){return ne===0?he!==5&&he!==7:ne===2&&he===3?!1:ne===4||ne===2||ne===3||he===4||he===2||he===3?!0:!(ne===8&&(he===8||he===9||he===11||he===12)||(ne===11||ne===9)&&(he===9||he===10)||(ne===12||ne===10)&&he===10||he===5||he===13||he===7||ne===1||ne===13&&he===14||ne===6&&he===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let Se=1;for(;Se<=me;)if(he<fe[3*Se])Se=2*Se;else if(he>fe[3*Se+1])Se=2*Se+1;else return fe[3*Se+2];return 0}}Le.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,he){if(ne===0)return 0;const fe=Te(ne,he);if(fe!==void 0)return fe;const me=new V(he,ne);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Te(ne,he){const fe=new V(he,ne);let me=fe.prevCodePoint();for(;Fe(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let Se=fe.offset;return Se>0&&fe.prevCodePoint()===8205&&(Se=fe.offset),Se}function Fe(ne){return 127995<=ne&&ne<=127999}var ze;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.c=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new D.LRUCachedFunction(ne=>{function he(Ae){const qe=new Map;for(let He=0;He<Ae.length;He+=2)qe.set(Ae[He],Ae[He+1]);return qe}function fe(Ae,qe){const He=new Map(Ae);for(const[et,rt]of qe)He.set(et,rt);return He}function me(Ae,qe){if(!Ae)return qe;const He=new Map;for(const[et,rt]of Ae)qe.has(et)&&He.set(et,rt);return He}const Se=R.c.value;let Ie=ne.filter(Ae=>!Ae.startsWith("_")&&Ae in Se);Ie.length===0&&(Ie=["_default"]);let Re;for(const Ae of Ie){const qe=he(Se[Ae]);Re=me(Re,qe)}const xe=he(Se._common),$e=fe(xe,Re);return new ke($e)}),ke.e=new T.Lazy(()=>Object.keys(ke.c.value).filter(ne=>!ne.startsWith("_")));class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(he){return Ne.e().has(he)}static get codePoints(){return Ne.e()}}e.InvisibleCharacters=Ne,Ne.d=void 0}),define(oe[48],ae([0,1,13,4,27,12]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(s){return s===47||s===92}e.isPathSeparator=O;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function E(s,a=D.posix.sep){if(!s)return"";const o=s.length,f=s.charCodeAt(0);if(O(f)){if(O(s.charCodeAt(1))&&!O(s.charCodeAt(2))){let v=3;const L=v;for(;v<o&&!O(s.charCodeAt(v));v++);if(L!==v&&!O(s.charCodeAt(v+1))){for(v+=1;v<o;v++)if(O(s.charCodeAt(v)))return s.slice(0,v+1).replace(/[\\/]/g,a)}}return a}else if(l(f)&&s.charCodeAt(1)===58)return O(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let d=s.indexOf("://");if(d!==-1){for(d+=3;d<o;d++)if(O(s.charCodeAt(d)))return s.slice(0,d+1)}return""}e.getRoot=E;function C(s){if(!T.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let o=2;const f=o;for(;o<s.length&&(a=s.charCodeAt(o),a!==92);o++);return!(f===o||(a=s.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=C;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,a=T.isWindows){const o=a?w:m;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||a&&y.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function S(s,a,o){const f=s===a;return!o||f?f:!s||!a?!1:(0,R.equalsIgnoreCase)(s,a)}e.isEqual=S;function u(s,a,o,f=D.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let v=a.length;return a.charAt(a.length-1)===f&&v--,s.charAt(v)===f}return a.charAt(a.length-1)!==f&&(a+=f),s.indexOf(a)===0}e.isEqualOrParent=u;function l(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=l;function g(s,a){return T.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(a,s)),s=(0,D.normalize)(s),T.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=g;function p(s){const a=(0,D.normalize)(s);return T.isWindows?s.length>3?!1:b(a)&&(s.length===2||a.charCodeAt(2)===92):a===D.posix.sep}e.isRootOrDriveLetter=p;function b(s,a=T.isWindows){return a?l(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function A(s){return b(s)?s[0]:void 0}e.getDriveLetter=A;function i(s,a,o){return a.length>s.length?-1:s===a?0:(o&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function r(s){const a=s.split(":");let o,f,d;for(const v of a){const L=Number(v);(0,c.isNumber)(L)?f===void 0?f=L:d===void 0&&(d=L):o=o?[o,v].join(":"):v}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:f!==void 0?f:void 0,column:d!==void 0?d:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,o=8){let f="";for(let v=0;v<o;v++)f+=t.charAt(Math.floor(Math.random()*t.length));let d;return a?d=`${a}-${f}`:d=f,s?(0,D.join)(s,d):d}e.randomPath=n}),define(oe[66],ae([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(l){return R(l,0)}e.hash=T;function R(l,g){switch(typeof l){case"object":return l===null?c(349,g):Array.isArray(l)?I(l,g):E(l,g);case"string":return P(l,g);case"boolean":return O(l,g);case"number":return c(l,g);case"undefined":return c(937,g);default:return c(617,g)}}e.doHash=R;function c(l,g){return(g<<5)-g+l|0}e.numberHash=c;function O(l,g){return c(l?433:863,g)}function P(l,g){g=c(149417,g);for(let p=0,b=l.length;p<b;p++)g=c(l.charCodeAt(p),g);return g}e.stringHash=P;function I(l,g){return g=c(104579,g),l.reduce((p,b)=>R(b,p),g)}function E(l,g){return g=c(181387,g),Object.keys(l).sort().reduce((p,b)=>(p=P(b,p),R(l[b],p)),g)}class C{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=R(g,this.g),this.g}}e.Hasher=C;var w;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(l,g,p=32){const b=p-g,A=~((1<<b)-1);return(l<<g|(A&l)>>>b)>>>0}function y(l,g=0,p=l.byteLength,b=0){for(let A=0;A<p;A++)l[g+A]=b}function h(l,g,p="0"){for(;l.length<g;)l=p+l;return l}function S(l,g=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):h((l>>>0).toString(16),g/4)}e.toHexString=S;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const p=g.length;if(p===0)return;const b=this.p;let A=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=g.charCodeAt(0),t=0);;){let n=r;if(D.isHighSurrogate(r))if(t+1<p){const s=g.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,n=D.computeCodePoint(r,s)):n=65533}else{i=r;break}else D.isLowSurrogate(r)&&(n=65533);if(A=this.w(b,A,n),t++,t<p)r=g.charCodeAt(t);else break}this.r=A,this.u=i}w(g,p,b){return b<128?g[p++]=b:b<2048?(g[p++]=192|(b&1984)>>>6,g[p++]=128|(b&63)>>>0):b<65536?(g[p++]=224|(b&61440)>>>12,g[p++]=128|(b&4032)>>>6,g[p++]=128|(b&63)>>>0):(g[p++]=240|(b&1835008)>>>18,g[p++]=128|(b&258048)>>>12,g[p++]=128|(b&4032)>>>6,g[p++]=128|(b&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=u.g,p=this.q;for(let o=0;o<64;o+=4)g.setUint32(o,p.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)g.setUint32(o,m(g.getUint32(o-12,!1)^g.getUint32(o-32,!1)^g.getUint32(o-56,!1)^g.getUint32(o-64,!1),1),!1);let b=this.h,A=this.l,i=this.m,r=this.n,t=this.o,n,s,a;for(let o=0;o<80;o++)o<20?(n=A&i|~A&r,s=1518500249):o<40?(n=A^i^r,s=1859775393):o<60?(n=A&i|A&r|i&r,s=2400959708):(n=A^i^r,s=3395469782),a=m(b,5)+n+t+s+g.getUint32(o*4,!1)&4294967295,t=r,r=i,i=m(A,30),A=b,b=a;this.h=this.h+b&4294967295,this.l=this.l+A&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=u,u.g=new DataView(new ArrayBuffer(320))}),define(oe[89],ae([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(T||(T={})),function(R){const c="error",O="warning",P="warn",I="info",E="ignore";function C(m){return m?D.equalsIgnoreCase(c,m)?R.Error:D.equalsIgnoreCase(O,m)||D.equalsIgnoreCase(P,m)?R.Warning:D.equalsIgnoreCase(I,m)?R.Info:R.Ignore:R.Ignore}R.fromValue=C;function w(m){switch(m){case R.Error:return c;case R.Warning:return O;case R.Info:return I;default:return E}}R.toString=w}(T||(T={})),e.default=T}),define(oe[49],ae([0,1,21,27]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const h=y.charCodeAt(0),S=this.b.charCodeAt(this.c);return h-S}value(){return this.b[this.c]}}e.StringIterator=R;class c{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,T.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=c;class O{constructor(y=!0,h=!0){this.f=y,this.g=h}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let h=y.length-1;h>=0;h--,this.c--){const S=this.b.charCodeAt(h);if(!(S===47||this.f&&S===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,T.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=O;var P;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(y,h){this.f=y,this.g=h,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,T.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class w{static forUris(y=()=>!1,h=()=>!1){return new w(new I(y,h))}static forPaths(y=!1){return new w(new O(void 0,!y))}static forStrings(){return new w(new R)}static forConfigKeys(){return new w(new c)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,h){if(h){const S=h.slice(0);(0,D.shuffle)(S);for(const u of S)this.set(u,y)}else{const S=y.slice(0);(0,D.shuffle)(S);for(const u of S)this.set(u[0],u[1])}}set(y,h){const S=this.b.reset(y);let u;this.c||(this.c=new E,this.c.segment=S.value());const l=[];for(u=this.c;;){const p=S.cmp(u.segment);if(p>0)u.left||(u.left=new E,u.left.segment=S.value()),l.push([-1,u]),u=u.left;else if(p<0)u.right||(u.right=new E,u.right.segment=S.value()),l.push([1,u]),u=u.right;else if(S.hasNext())S.next(),u.mid||(u.mid=new E,u.mid.segment=S.value()),l.push([0,u]),u=u.mid;else break}const g=u.value;u.value=h,u.key=y;for(let p=l.length-1;p>=0;p--){const b=l[p][1];b.updateHeight();const A=b.balanceFactor();if(A<-1||A>1){const i=l[p][0],r=l[p+1][0];if(i===1&&r===1)l[p][1]=b.rotateLeft();else if(i===-1&&r===-1)l[p][1]=b.rotateRight();else if(i===1&&r===-1)b.right=l[p+1][1]=l[p+1][1].rotateRight(),l[p][1]=b.rotateLeft();else if(i===-1&&r===1)b.left=l[p+1][1]=l[p+1][1].rotateLeft(),l[p][1]=b.rotateRight();else throw new Error;if(p>0)switch(l[p-1][0]){case-1:l[p-1][1].left=l[p][1];break;case 1:l[p-1][1].right=l[p][1];break;case 0:l[p-1][1].mid=l[p][1];break}else this.c=l[0][1]}}return g}get(y){return this.d(y)?.value}d(y){const h=this.b.reset(y);let S=this.c;for(;S;){const u=h.cmp(S.segment);if(u>0)S=S.left;else if(u<0)S=S.right;else if(h.hasNext())h.next(),S=S.mid;else break}return S}has(y){const h=this.d(y);return!(h?.value===void 0&&h?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,h){const S=this.b.reset(y),u=[];let l=this.c;for(;l;){const g=S.cmp(l.segment);if(g>0)u.push([-1,l]),l=l.left;else if(g<0)u.push([1,l]),l=l.right;else if(S.hasNext())S.next(),u.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const g=this.f(l.right);if(g.key){const{key:p,value:b,segment:A}=g;this.e(g.key,!1),l.key=p,l.value=b,l.segment=A}}else{const g=l.left??l.right;if(u.length>0){const[p,b]=u[u.length-1];switch(p){case-1:b.left=g;break;case 0:b.mid=g;break;case 1:b.right=g;break}}else this.c=g}for(let g=u.length-1;g>=0;g--){const p=u[g][1];p.updateHeight();const b=p.balanceFactor();if(b>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),u[g][1]=p.rotateLeft()):b<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),u[g][1]=p.rotateRight()),g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const h=this.b.reset(y);let S=this.c,u;for(;S;){const l=h.cmp(S.segment);if(l>0)S=S.left;else if(l<0)S=S.right;else if(h.hasNext())h.next(),u=S.value||u,S=S.mid;else break}return S&&S.value||u}findSuperstr(y){return this.g(y,!1)}g(y,h){const S=this.b.reset(y);let u=this.c;for(;u;){const l=S.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(S.hasNext())S.next(),u=u.mid;else return u.mid?this.h(u.mid):h?u.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[h,S]of this)y(S,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const h=[];return this.j(y,h),h[Symbol.iterator]()}j(y,h){!y||(y.left&&this.j(y.left,h),y.value&&h.push([y.key,y.value]),y.mid&&this.j(y.mid,h),y.right&&this.j(y.right,h))}_isBalanced(){const y=h=>{if(!h)return!0;const S=h.balanceFactor();return S<-1||S>1?!1:y(h.left)&&y(h.right)};return y(this.c)}}e.TernarySearchTree=w}),define(oe[11],ae([0,1,13,4]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,c=/^\//,O=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!c.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,n){return!t&&!n?"file":t}function E(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const C="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(n){return n instanceof y?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,a,o,f,d=!1){typeof n=="object"?(this.scheme=n.scheme||C,this.authority=n.authority||C,this.path=n.path||C,this.query=n.query||C,this.fragment=n.fragment||C):(this.scheme=I(n,d),this.authority=s||C,this.path=E(this.scheme,a||C),this.query=o||C,this.fragment=f||C,P(this,d))}get fsPath(){return p(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:a,path:o,query:f,fragment:d}=n;return s===void 0?s=this.scheme:s===null&&(s=C),a===void 0?a=this.authority:a===null&&(a=C),o===void 0?o=this.path:o===null&&(o=C),f===void 0?f=this.query:f===null&&(f=C),d===void 0?d=this.fragment:d===null&&(d=C),s===this.scheme&&a===this.authority&&o===this.path&&f===this.query&&d===this.fragment?this:new S(s,a,o,f,d)}static parse(n,s=!1){const a=m.exec(n);return a?new S(a[2]||C,r(a[4]||C),r(a[5]||C),r(a[7]||C),r(a[9]||C),s):new S(C,C,C,C,C)}static file(n){let s=C;if(T.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const a=n.indexOf(w,2);a===-1?(s=n.substring(2),n=w):(s=n.substring(2,a),n=n.substring(a)||w)}return new S("file",s,n,C,C)}static from(n){const s=new S(n.scheme,n.authority,n.path,n.query,n.fragment);return P(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return T.isWindows&&n.scheme==="file"?a=y.file(D.win32.join(p(n,!0),...s)).path:a=D.posix.join(n.path,...s),n.with({path:a})}toString(n=!1){return b(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof y)return n;{const s=new S(n);return s._formatted=n.external,s._fsPath=n._sep===h?n.fsPath:null,s}}else return n}}e.URI=y;const h=T.isWindows?1:void 0;class S extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(n=!1){return n?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,n,s){let a,o=-1;for(let f=0;f<t.length;f++){const d=t.charCodeAt(f);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||n&&d===47||s&&d===91||s&&d===93||s&&d===58)o!==-1&&(a+=encodeURIComponent(t.substring(o,f)),o=-1),a!==void 0&&(a+=t.charAt(f));else{a===void 0&&(a=t.substr(0,f));const v=u[d];v!==void 0?(o!==-1&&(a+=encodeURIComponent(t.substring(o,f)),o=-1),a+=v):o===-1&&(o=f)}}return o!==-1&&(a+=encodeURIComponent(t.substring(o))),a!==void 0?a:t}function g(t){let n;for(let s=0;s<t.length;s++){const a=t.charCodeAt(s);a===35||a===63?(n===void 0&&(n=t.substr(0,s)),n+=u[a]):n!==void 0&&(n+=t[s])}return n!==void 0?n:t}function p(t,n){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,T.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=p;function b(t,n){const s=n?g:l;let a="",{scheme:o,authority:f,path:d,query:v,fragment:L}=t;if(o&&(a+=o,a+=":"),(f||o==="file")&&(a+=w,a+=w),f){let N=f.indexOf("@");if(N!==-1){const F=f.substr(0,N);f=f.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=s(F,!1,!1):(a+=s(F.substr(0,N),!1,!1),a+=":",a+=s(F.substr(N+1),!1,!0)),a+="@"}f=f.toLowerCase(),N=f.lastIndexOf(":"),N===-1?a+=s(f,!1,!0):(a+=s(f.substr(0,N),!1,!0),a+=f.substr(N))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const N=d.charCodeAt(1);N>=65&&N<=90&&(d=`/${String.fromCharCode(N+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const N=d.charCodeAt(0);N>=65&&N<=90&&(d=`${String.fromCharCode(N+32)}:${d.substr(2)}`)}a+=s(d,!0,!1)}return v&&(a+="?",a+=s(v,!1,!1)),L&&(a+="#",a+=n?L:l(L,!1,!1)),a}function A(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+A(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(i)?t.replace(i,n=>A(n)):t}}),define(oe[144],ae([0,1,11]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(E){const C=E;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=T;function R(E){const C=[];let w;try{const m=JSON.parse(E.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),w=y.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",E.arguments)}return{args:C,stack:w}}e.parse=R;function c(E){if(typeof E!="string")return c(R(E).stack);const C=E;if(C){const w=O(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=c;function O(E){if(!E)return E;const C=E.indexOf(`
`);return C===-1?E:E.substring(0,C)}function P(E,C){const{args:w,stack:m}=R(E),y=typeof w[0]=="string"&&w.length===1;let h=O(m);h&&(h=`(${h.trim()})`);let S=[];if(typeof w[0]=="string"?h&&y?S=[`%c[${C}] %c${w[0]} %c${h}`,I("blue"),I(""),I("grey")]:S=[`%c[${C}] %c${w[0]}`,I("blue"),I(""),...w.slice(1)]:S=[`%c[${C}]%`,I("blue"),...w],h&&!y&&S.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,S)}e.log=P;function I(E){return`color: ${E}`}}),define(oe[67],ae([0,1,17,27,11]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function c(E){return JSON.stringify(E,P)}e.stringify=c;function O(E){let C=JSON.parse(E);return C=I(C),C}e.parse=O;function P(E,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,T.regExpFlags)(C)}:C}function I(E,C=0){if(!E||C>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 16:return new Date(E.source)}if(E instanceof D.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let w=0;w<E.length;++w)E[w]=I(E[w],C+1);else for(const w in E)Object.hasOwnProperty.call(E,w)&&(E[w]=I(E[w],C+1))}return E}e.revive=I}),define(oe[26],ae([0,1,9,4,11]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var c;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(c=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${c.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${c.vscodeRemoteResource}`}set(C,w,m){this.a[C]=w,this.b[C]=m}setConnectionToken(C,w){this.c[C]=w}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(u){return D.onUnexpectedError(u),C}const w=C.authority;let m=this.a[w];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const y=this.b[w],h=this.c[w];let S=`path=${encodeURIComponent(C.path)}`;return typeof h=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),R.URI.from({scheme:T.isWeb?this.d:c.vscodeRemoteResource,authority:`${m}:${y}`,path:this.f,query:S})}}e.RemoteAuthorities=new O,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(C){const w=this.b(C,Q);return this.uriToBrowserUri(w)}uriToBrowserUri(C){return C.scheme===c.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===c.file&&(T.isNative||T.isWebWorker&&T.globals.origin===`${c.vscodeFileResource}://${P.a}`)?C.with({scheme:c.vscodeFileResource,authority:C.authority||P.a,query:null,fragment:null}):C}asFileUri(C){const w=this.b(C,Q);return this.uriToFileUri(w)}uriToFileUri(C){return C.scheme===c.vscodeFileResource?C.with({scheme:c.file,authority:C.authority!==P.a?C.authority:null,query:null,fragment:null}):C}b(C,w){return R.URI.isUri(C)?C:R.URI.parse(w.toUrl(C))}}P.a="vscode-app",e.FileAccess=new P;var I;(function(E){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(C.get("3"));const w="vscode-coi";function m(h){let S;typeof h=="string"?S=new URL(h).searchParams:h instanceof URL?S=h.searchParams:R.URI.isUri(h)&&(S=new URL(h.toString(!0)).searchParams);const u=S?.get(w);if(!!u)return C.get(u)}E.getHeadersFromQuery=m;function y(h,S,u){if(!globalThis.crossOriginIsolated)return;const l=S&&u?"3":u?"2":"1";h instanceof URLSearchParams?h.set(w,l):h[w]=l}E.addSearchParam=y})(I=e.COI||(e.COI={}))}),define(oe[22],ae([0,1,48,26,13,4,27,11]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(y){return(0,P.uriToFsPath)(y,!0)}e.originalFSPath=I;class E{constructor(h){this.a=h}compare(h,S,u=!1){return h===S?0:(0,O.compare)(this.getComparisonKey(h,u),this.getComparisonKey(S,u))}isEqual(h,S,u=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,u)===this.getComparisonKey(S,u)}getComparisonKey(h,S=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,S,u=!1){if(h.scheme===S.scheme){if(h.scheme===T.Schemas.file)return D.isEqualOrParent(I(h),I(S),this.a(h))&&h.query===S.query&&(u||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return D.isEqualOrParent(h.path,S.path,this.a(h),"/")&&h.query===S.query&&(u||h.fragment===S.fragment)}return!1}joinPath(h,...S){return P.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===T.Schemas.file?S=P.URI.file(R.dirname(I(h))).path:(S=R.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===T.Schemas.file?S=P.URI.file(R.normalize(I(h))).path:S=R.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===T.Schemas.file){const g=R.relative(I(h),I(S));return c.isWindows?D.toSlashes(g):g}let u=h.path||"/";const l=S.path||"/";if(this.a(h)){let g=0;for(const p=Math.min(u.length,l.length);g<p&&!(u.charCodeAt(g)!==l.charCodeAt(g)&&u.charAt(g).toLowerCase()!==l.charAt(g).toLowerCase());g++);u=l.substr(0,g)+u.substr(g)}return R.posix.relative(u,l)}resolvePath(h,S){if(h.scheme===T.Schemas.file){const u=P.URI.file(R.resolve(I(h),S));return h.with({authority:u.authority,path:u.path})}return S=D.toPosixPath(S),h.with({path:R.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,O.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=R.sep){if(h.scheme===T.Schemas.file){const u=I(h);return u.length>D.getRoot(u).length&&u[u.length-1]===S}else{const u=h.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=R.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=R.sep){let u=!1;if(h.scheme===T.Schemas.file){const l=I(h);u=l!==void 0&&l.length===D.getRoot(l).length&&l[l.length-1]===S}else{S="/";const l=h.path;u=l.length===1&&l.charCodeAt(l.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(y=>y.scheme===T.Schemas.file?!c.isLinux:!0),e.extUriIgnorePathCase=new E(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(y,h){const S=[];for(let u=0;u<y.length;u++){const l=h(y[u]);y.some((g,p)=>p===u?!1:(0,e.isEqualOrParent)(l,h(g)))||S.push(y[u])}return S}e.distinctParents=C;var w;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(S){const u=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(p=>{const[b,A]=p.split(":");b&&A&&u.set(b,A)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&u.set(y.META_DATA_MIME,g),u}y.parseMetaData=h})(w=e.DataUri||(e.DataUri={}));function m(y,h,S){if(h){let u=y.path;return u&&u[0]!==R.posix.sep&&(u=R.posix.sep+u),y.with({scheme:S,authority:h,path:u})}return y.with({scheme:S})}e.toLocalResource=m}),define(oe[6],ae([0,1,25,9,3,2,22,4]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(te){return!!te&&typeof te.then=="function"}e.isThenable=I;function E(te){const U=new D.CancellationTokenSource,B=te(U.token),W=new Promise((q,Y)=>{const ee=U.token.onCancellationRequested(()=>{ee.dispose(),U.dispose(),Y(new T.CancellationError)});Promise.resolve(B).then(K=>{ee.dispose(),U.dispose(),q(K)},K=>{ee.dispose(),U.dispose(),Y(K)})});return new class{cancel(){U.cancel()}then(q,Y){return W.then(q,Y)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=E;function C(te,U,B){return new Promise((W,q)=>{const Y=U.onCancellationRequested(()=>{Y.dispose(),W(B)});te.then(W,q).finally(()=>Y.dispose())})}e.raceCancellation=C;function w(te,U){return new Promise((B,W)=>{const q=U.onCancellationRequested(()=>{q.dispose(),W(new T.CancellationError)});te.then(B,W).finally(()=>q.dispose())})}e.raceCancellationError=w;async function m(te){let U=-1;const B=te.map((q,Y)=>q.then(ee=>(U=Y,ee))),W=await Promise.race(B);return te.forEach((q,Y)=>{Y!==U&&q.cancel()}),W}e.raceCancellablePromises=m;function y(te,U,B){let W;const q=setTimeout(()=>{W?.(void 0),B?.()},U);return Promise.race([te.finally(()=>clearTimeout(q)),new Promise(Y=>W=Y)])}e.raceTimeout=y;function h(te){return new Promise((U,B)=>{const W=te();I(W)?W.then(U,B):U(W)})}e.asPromise=h;class S{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const B=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(B,B).then(W)})}return new Promise((B,W)=>{this.b.then(B,W)})}return this.a=U(),new Promise((B,W)=>{this.a.then(q=>{this.a=null,B(q)},q=>{this.a=null,W(q)})})}}e.Throttler=S;class u{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=u;class l{constructor(){this.a=new Map}queue(U,B){const q=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(U)===q&&this.a.delete(U)});return this.a.set(U,q),q}}e.SequencerByKey=l;const g=(te,U)=>{let B=!0;const W=setTimeout(()=>{B=!1,U()},te);return{isTriggered:()=>B,dispose:()=>{clearTimeout(W),B=!1}}},p=te=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,te())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class b{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,B=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((q,Y)=>{this.d=q,this.f=Y}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=B===e.MicrotaskDelay?p(W):g(B,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=b;class A{constructor(U){this.a=new b(U),this.b=new S}trigger(U,B){return this.a.trigger(()=>this.b.queue(U),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=A;class i{constructor(){this.a=!1,this.b=new Promise((U,B)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class r extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function t(te,U){return U?new Promise((B,W)=>{const q=setTimeout(()=>{Y.dispose(),B()},te),Y=U.onCancellationRequested(()=>{clearTimeout(q),Y.dispose(),W(new T.CancellationError)})}):E(B=>t(te,B))}e.timeout=t;function n(te,U=0){const B=setTimeout(te,U);return(0,c.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=n;function s(te){const U=[];let B=0;const W=te.length;function q(){return B<W?te[B++]():null}function Y(ee){ee!=null&&U.push(ee);const K=q();return K?K.then(Y):Promise.resolve(U)}return Promise.resolve(null).then(Y)}e.sequence=s;function a(te,U=W=>!!W,B=null){let W=0;const q=te.length,Y=()=>{if(W>=q)return Promise.resolve(B);const ee=te[W++];return Promise.resolve(ee()).then(Z=>U(Z)?Promise.resolve(Z):Y())};return Y()}e.first=a;function o(te,U=W=>!!W,B=null){if(te.length===0)return Promise.resolve(B);let W=te.length;const q=()=>{W=-1;for(const Y of te)Y.cancel?.()};return new Promise((Y,ee)=>{for(const K of te)K.then(Z=>{--W>=0&&U(Z)?(q(),Y(Z)):W===0&&Y(B)}).catch(Z=>{--W>=0&&(q(),ee(Z))})})}e.firstParallel=o;class f{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new R.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((B,W)=>{this.f.push({factory:U,c:B,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const B=U.factory();B.then(U.c,U.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class d extends f{constructor(){super(1)}}e.Queue=d;class v{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new H;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,B=O.extUri){const W=B.getComparisonKey(U);let q=this.a.get(W);return q||(q=new d,R.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,q)),q}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=v;class L{constructor(U,B){this.a=-1,typeof U=="function"&&typeof B=="number"&&this.setIfNotSet(U,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},B)}setIfNotSet(U,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},B))}}e.TimeoutTimer=L;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setInterval(()=>{U()},B)}}e.IntervalTimer=N;class F{constructor(U,B){this.b=-1,this.a=U,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=F;class M{constructor(U,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=U,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=M;class k extends F{constructor(U,B){super(U,B),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=k;class $ extends c.Disposable{constructor(U,B){super(),this.g=U,this.h=B,this.a=[],this.b=this.B(new c.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of U)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,P.setTimeout0)(()=>{if(U)return;const B=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(te,U)=>{const B=requestIdleCallback(te,typeof U=="number"?{timeout:U}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(B))}}}}();class z{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function x(te,U,B){let W;for(let q=0;q<B;q++)try{return await te()}catch(Y){W=Y,await t(U)}throw W}e.retry=x;class X{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,B,W){return this.a={taskId:U,cancel:()=>W?.(),promise:B},B.then(()=>this.d(U),()=>this.d(U)),B}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let B,W;const q=new Promise((Y,ee)=>{B=Y,W=ee});this.b={run:U,promise:q,promiseResolve:B,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ie{constructor(U,B=()=>Date.now()){this.d=U,this.f=B,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=ie;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,B)=>{this.a=U,this.b=B})}complete(U){return new Promise(B=>{this.a(U),this.f=!0,B()})}error(U){return new Promise(B=>{this.b(U),this.d=!0,B()})}cancel(){new Promise(U=>{this.b(new T.CancellationError),this.d=!0,U()})}}e.DeferredPromise=H;var j;(function(te){async function U(W){let q;const Y=await Promise.all(W.map(ee=>ee.then(K=>K,K=>{q||(q=K)})));if(typeof q<"u")throw q;return Y}te.settled=U;function B(W){return new Promise(async(q,Y)=>{try{await W(q,Y)}catch(ee){Y(ee)}})}te.withAsyncBody=B})(j=e.Promises||(e.Promises={}));var V;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(V||(V={}));class J{static fromArray(U){return new J(B=>{B.emitMany(U)})}static fromPromise(U){return new J(async B=>{B.emitMany(await U)})}static fromPromises(U){return new J(async B=>{await Promise.all(U.map(async W=>B.emitOne(await W)))})}static merge(U){return new J(async B=>{await Promise.all(U.map(async W=>{for await(const q of W)B.emitOne(q)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new R.Emitter,queueMicrotask(async()=>{const B={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(U(B)),this.j()}catch(W){this.k(W)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(U,B){return new J(async W=>{for await(const q of U)W.emitOne(B(q))})}map(U){return J.map(this,U)}static filter(U,B){return new J(async W=>{for await(const q of U)B(q)&&W.emitOne(q)})}filter(U){return J.filter(this,U)}static coalesce(U){return J.filter(U,B=>!!B)}coalesce(){return J.coalesce(this)}static async toPromise(U){const B=[];for await(const W of U)B.push(W);return B}toPromise(){return J.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class _ extends J{constructor(U,B){super(B),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=_;function re(te){const U=new D.CancellationTokenSource,B=te(U.token);return new _(U,async W=>{const q=U.token.onCancellationRequested(()=>{q.dispose(),U.dispose(),W.reject(new T.CancellationError)});try{for await(const Y of B){if(U.token.isCancellationRequested)return;W.emitOne(Y)}q.dispose(),U.dispose()}catch(Y){q.dispose(),U.dispose(),W.reject(Y)}})}e.createCancelableAsyncIterable=re}),define(oe[90],ae([0,1,21,6,48,37,13,4,27]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",w="[^/\\\\]",m=/\//g;function y(H,j){switch(H){case 0:return"";case 1:return`${w}*?`;default:return`(?:${C}|${w}+${C}${j?`|${C}${w}+`:""})*?`}}function h(H,j){if(!H)return[];const V=[];let J=!1,_=!1,re="";for(const te of H){switch(te){case j:if(!J&&!_){V.push(re),re="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":_=!0;break;case"]":_=!1;break}re+=te}return re&&V.push(re),V}e.splitGlobAware=h;function S(H){if(!H)return"";let j="";const V=h(H,e.GLOB_SPLIT);if(V.every(J=>J===e.GLOBSTAR))j=".*";else{let J=!1;V.forEach((_,re)=>{if(_===e.GLOBSTAR){if(J)return;j+=y(2,re===V.length-1)}else{let te=!1,U="",B=!1,W="";for(const q of _){if(q!=="}"&&te){U+=q;continue}if(B&&(q!=="]"||!W)){let Y;q==="-"?Y=q:(q==="^"||q==="!")&&!W?Y="^":q===e.GLOB_SPLIT?Y="":Y=(0,I.escapeRegExpCharacters)(q),W+=Y;continue}switch(q){case"{":te=!0;continue;case"[":B=!0;continue;case"}":{j+=`(?:${h(U,",").map(K=>S(K)).join("|")})`,te=!1,U="";break}case"]":{j+="["+W+"]",B=!1,W="";break}case"?":j+=w;continue;case"*":j+=y(1);continue;default:j+=(0,I.escapeRegExpCharacters)(q)}}re<V.length-1&&(V[re+1]!==e.GLOBSTAR||re+2<V.length)&&(j+=C)}J=_===e.GLOBSTAR})}return j}const u=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,A=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new c.LRUCache(1e4),r=function(){return!1},t=function(){return null};function n(H,j){if(!H)return t;let V;typeof H!="string"?V=H.pattern:V=H,V=V.trim();const J=`${V}_${!!j.trimForExclusions}`;let _=i.get(J);if(_)return s(_,H);let re;return u.test(V)?_=o(V.substr(4),V):(re=l.exec(a(V,j)))?_=f(re[1],V):(j.trimForExclusions?p:g).test(V)?_=d(V,j):(re=b.exec(a(V,j)))?_=v(re[1].substr(1),V,!0):(re=A.exec(a(V,j)))?_=v(re[1],V,!1):_=L(V),i.set(J,_),s(_,H)}function s(H,j){if(typeof j=="string")return H;const V=function(J,_){return(0,R.isEqualOrParent)(J,j.base,!P.isLinux)?H((0,I.ltrim)(J.substr(j.base.length),O.sep),_):null};return V.allBasenames=H.allBasenames,V.allPaths=H.allPaths,V.basenames=H.basenames,V.patterns=H.patterns,V}function a(H,j){return j.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function o(H,j){return function(V,J){return typeof V=="string"&&V.endsWith(H)?j:null}}function f(H,j){const V=`/${H}`,J=`\\${H}`,_=function(te,U){return typeof te!="string"?null:U?U===H?j:null:te===H||te.endsWith(V)||te.endsWith(J)?j:null},re=[H];return _.basenames=re,_.patterns=[j],_.allBasenames=re,_}function d(H,j){const V=X(H.slice(1,-1).split(",").map(U=>n(U,j)).filter(U=>U!==t),H),J=V.length;if(!J)return t;if(J===1)return V[0];const _=function(U,B){for(let W=0,q=V.length;W<q;W++)if(V[W](U,B))return H;return null},re=V.find(U=>!!U.allBasenames);re&&(_.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(_.allPaths=te),_}function v(H,j,V){const J=O.sep===O.posix.sep,_=J?H:H.replace(m,O.sep),re=O.sep+_,te=O.posix.sep+H;let U;return V?U=function(B,W){return typeof B=="string"&&(B===_||B.endsWith(re)||!J&&(B===H||B.endsWith(te)))?j:null}:U=function(B,W){return typeof B=="string"&&(B===_||!J&&B===H)?j:null},U.allPaths=[(V?"*/":"./")+H],U}function L(H){try{const j=new RegExp(`^${S(H)}$`);return function(V){return j.lastIndex=0,typeof V=="string"&&j.test(V)?H:null}}catch{return t}}function N(H,j,V){return!H||typeof j!="string"?!1:F(H)(j,void 0,V)}e.match=N;function F(H,j={}){if(!H)return r;if(typeof H=="string"||M(H)){const V=n(H,j);if(V===t)return r;const J=function(_,re){return!!V(_,re)};return V.allBasenames&&(J.allBasenames=V.allBasenames),V.allPaths&&(J.allPaths=V.allPaths),J}return z(H,j)}e.parse=F;function M(H){const j=H;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=M;function k(H){return H.allBasenames||[]}e.getBasenameTerms=k;function $(H){return H.allPaths||[]}e.getPathTerms=$;function z(H,j){const V=X(Object.getOwnPropertyNames(H).map(U=>x(U,H[U],j)).filter(U=>U!==t)),J=V.length;if(!J)return t;if(!V.some(U=>!!U.requiresSiblings)){if(J===1)return V[0];const U=function(q,Y){let ee;for(let K=0,Z=V.length;K<Z;K++){const se=V[K](q,Y);if(typeof se=="string")return se;(0,T.isThenable)(se)&&(ee||(ee=[]),ee.push(se))}return ee?(async()=>{for(const K of ee){const Z=await K;if(typeof Z=="string")return Z}return null})():null},B=V.find(q=>!!q.allBasenames);B&&(U.allBasenames=B.allBasenames);const W=V.reduce((q,Y)=>Y.allPaths?q.concat(Y.allPaths):q,[]);return W.length&&(U.allPaths=W),U}const _=function(U,B,W){let q,Y;for(let ee=0,K=V.length;ee<K;ee++){const Z=V[ee];Z.requiresSiblings&&W&&(B||(B=(0,O.basename)(U)),q||(q=B.substr(0,B.length-(0,O.extname)(U).length)));const se=Z(U,B,q,W);if(typeof se=="string")return se;(0,T.isThenable)(se)&&(Y||(Y=[]),Y.push(se))}return Y?(async()=>{for(const ee of Y){const K=await ee;if(typeof K=="string")return K}return null})():null},re=V.find(U=>!!U.allBasenames);re&&(_.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(_.allPaths=te),_}function x(H,j,V){if(j===!1)return t;const J=n(H,V);if(J===t)return t;if(typeof j=="boolean")return J;if(j){const _=j.when;if(typeof _=="string"){const re=(te,U,B,W)=>{if(!W||!J(te,U))return null;const q=_.replace("$(basename)",()=>B),Y=W(q);return(0,T.isThenable)(Y)?Y.then(ee=>ee?H:null):Y?H:null};return re.requiresSiblings=!0,re}}return J}function X(H,j){const V=H.filter(U=>!!U.basenames);if(V.length<2)return H;const J=V.reduce((U,B)=>{const W=B.basenames;return W?U.concat(W):U},[]);let _;if(j){_=[];for(let U=0,B=J.length;U<B;U++)_.push(j)}else _=V.reduce((U,B)=>{const W=B.patterns;return W?U.concat(W):U},[]);const re=function(U,B){if(typeof U!="string")return null;if(!B){let q;for(q=U.length;q>0;q--){const Y=U.charCodeAt(q-1);if(Y===47||Y===92)break}B=U.substr(q)}const W=J.indexOf(B);return W!==-1?_[W]:null};re.basenames=J,re.patterns=_,re.allBasenames=J;const te=H.filter(U=>!U.basenames);return te.push(re),te}function ie(H,j){return(0,D.equals)(H,j,(V,J)=>typeof V=="string"&&typeof J=="string"?V===J:typeof V!="string"&&typeof J!="string"?V.base===J.base&&V.pattern===J.pattern:!1)}e.patternsEquals=ie}),define(oe[145],ae([0,1,17,11]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(w){return w.toJSON()}class c{constructor(m){this.a=m}transformIncoming(m){const y=this.a.transformIncoming(m);return y===m?m:R(T.URI.from(y))}transformOutgoing(m){const y=this.a.transformOutgoing(m);return y===m?m:R(T.URI.from(y))}transformOutgoingURI(m){const y=this.a.transformOutgoing(m);return y===m?m:T.URI.from(y)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=c,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function O(w,m,y){if(!w||y>200)return null;if(typeof w=="object"){if(w instanceof T.URI)return m.transformOutgoing(w);for(const h in w)if(Object.hasOwnProperty.call(w,h)){const S=O(w[h],m,y+1);S!==null&&(w[h]=S)}}return null}function P(w,m){const y=O(w,m,0);return y===null?w:y}e.transformOutgoingURIs=P;function I(w,m,y,h){if(!w||h>200)return null;if(typeof w=="object"){if(w.$mid===1)return y?T.URI.revive(m.transformIncoming(w)):m.transformIncoming(w);if(w instanceof D.VSBuffer)return null;for(const S in w)if(Object.hasOwnProperty.call(w,S)){const u=I(w[S],m,y,h+1);u!==null&&(w[S]=u)}}return null}function E(w,m){const y=I(w,m,!1,0);return y===null?w:y}e.transformIncomingURIs=E;function C(w,m){const y=I(w,m,!0,0);return y===null?w:y}e.transformAndReviveIncomingURIs=C}),define(oe[146],ae([0,1,34,9,49,31,133]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,w=0;const m=(0,D.networkInterfaces)();for(const y in m){const h=m[y];if(h)for(const{mac:S,internal:u}of h)u||(w+=1,this.c(S.toUpperCase())&&(C+=1))}this.b=w>0?C/w:0}return this.b}};let P;async function I(){return P||(P=(async()=>await E()||c.generateUuid())()),P}e.getMachineId=I;async function E(){try{const C=await new Promise((m,y)=>{Q(["crypto"],m,y)}),w=(0,O.getMac)();return C.createHash("sha256").update(w,"utf8").digest("hex")}catch(C){T.onUnexpectedError(C);return}}}),define(oe[28],ae([0,1,53,34,290,6,48,85,13,4,22,11]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function y(z,x=m.UNLINK){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?S(z):h(z)}async function h(z){try{const x=(0,O.randomPath)((0,T.tmpdir)());try{await D.promises.rename(z,x)}catch(X){return X.code==="ENOENT"?void 0:S(z)}S(x).catch(X=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function S(z){return(0,R.promisify)(D.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function u(z){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function l(z,x){return b(await(x?g(z):(0,R.promisify)(D.readdir)(z)))}async function g(z){try{return await(0,R.promisify)(D.readdir)(z,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const x=[],X=await l(z);for(const ie of X){let H=!1,j=!1,V=!1;try{const J=await e.Promises.lstat((0,I.join)(z,ie));H=J.isFile(),j=J.isDirectory(),V=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}x.push({name:ie,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>V})}return x}function p(z){return b(D.readdirSync(z))}e.readdirSync=p;function b(z){return z.map(x=>typeof x=="string"?E.isMacintosh?(0,P.normalizeNFC)(x):x:(x.name=E.isMacintosh?(0,P.normalizeNFC)(x.name):x.name,x))}async function A(z){const x=await l(z),X=[];for(const ie of x)await r.existsDirectory((0,I.join)(z,ie))&&X.push(ie);return X}function i(z,x=1e3){return new Promise(X=>{let ie=!1;const H=setInterval(()=>{ie||(ie=!0,D.access(z,j=>{ie=!1,j&&(clearInterval(H),X(void 0))}))},x)})}e.whenDeleted=i;var r;(function(z){async function x(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(E.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw J}throw V}}z.stat=x;async function X(H){try{const{stat:j,symbolicLink:V}=await z.stat(H);return j.isFile()&&V?.dangling!==!0}catch{}return!1}z.existsFile=X;async function ie(H){try{const{stat:j,symbolicLink:V}=await z.stat(H);return j.isDirectory()&&V?.dangling!==!0}catch{}return!1}z.existsDirectory=ie})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new c.ResourceQueue;function n(z,x,X){return t.queueFor(w.URI.file(z),C.extUriBiasedIgnorePathCase).queue(()=>{const ie=d(X);return new Promise((H,j)=>o(z,x,ie,V=>V?j(V):H()))})}let s=!0;function a(z){s=z}e.configureFlushOnWrite=a;function o(z,x,X,ie){if(!s)return D.writeFile(z,x,{mode:X.mode,flag:X.flag},ie);D.open(z,X.flag,X.mode,(H,j)=>{if(H)return ie(H);D.writeFile(j,x,V=>{if(V)return D.close(j,()=>ie(V));D.fdatasync(j,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),a(!1)),D.close(j,_=>ie(_))))})})}function f(z,x,X){const ie=d(X);if(!s)return D.writeFileSync(z,x,{mode:ie.mode,flag:ie.flag});const H=D.openSync(z,ie.flag,ie.mode);try{D.writeFileSync(H,x);try{D.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),a(!1)}}finally{D.closeSync(H)}}e.writeFileSync=f;function d(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function v(z,x){if(z!==x)try{await e.Promises.rename(z,x)}catch(X){if(z.toLowerCase()!==x.toLowerCase()&&X.code==="EXDEV"||z.endsWith("."))await L(z,x,{preserveSymlinks:!1}),await y(z,m.MOVE);else throw X}}async function L(z,x,X){return F(z,x,{root:{source:z,target:x},options:X,handledSourcePaths:new Set})}const N=511;async function F(z,x,X){if(X.handledSourcePaths.has(z))return;X.handledSourcePaths.add(z);const{stat:ie,symbolicLink:H}=await r.stat(z);if(H){if(X.options.preserveSymlinks)try{return await $(z,x,X)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(H.dangling)return}return ie.isDirectory()?M(z,x,ie.mode&N,X):k(z,x,ie.mode&N)}async function M(z,x,X,ie){await e.Promises.mkdir(x,{recursive:!0,mode:X});const H=await l(z);for(const j of H)await F((0,I.join)(z,j),(0,I.join)(x,j),ie)}async function k(z,x,X){await e.Promises.copyFile(z,x),await e.Promises.chmod(x,X)}async function $(z,x,X){let ie=await e.Promises.readlink(z);(0,O.isEqualOrParent)(ie,X.root.source,!E.isLinux)&&(ie=(0,I.join)(X.root.target,ie.substr(X.root.source.length+1))),await e.Promises.symlink(ie,x)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(z,x,X,ie,H)=>new Promise((j,V)=>{D.read(z,x,X,ie,H,(J,_,re)=>J?V(J):j({bytesRead:_,buffer:re}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(z,x,X,ie,H)=>new Promise((j,V)=>{D.write(z,x,X,ie,H,(J,_,re)=>J?V(J):j({bytesWritten:_,buffer:re}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return A}get writeFile(){return n}get rm(){return y}get move(){return v}get copy(){return L}}}),define(oe[147],ae([0,1,53,13,4,27,28]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(m){if(R.isLinux)return m;const y=(0,T.dirname)(m);if(m===y)return m;const h=((0,T.basename)(m)||m).toLowerCase();try{const u=(0,O.readdirSync)(y).filter(l=>l.toLowerCase()===h);if(u.length===1){const l=P(y);if(l)return(0,T.join)(l,u[0])}else if(u.length>1){const l=u.indexOf(h);if(l>=0){const g=P(y);if(g)return(0,T.join)(g,u[l])}}}catch{}return null}e.realcaseSync=P;async function I(m){if(R.isLinux)return m;const y=(0,T.dirname)(m);if(m===y)return m;const h=((0,T.basename)(m)||m).toLowerCase();try{const u=(await O.Promises.readdir(y)).filter(l=>l.toLowerCase()===h);if(u.length===1){const l=await I(y);if(l)return(0,T.join)(l,u[0])}else if(u.length>1){const l=u.indexOf(h);if(l>=0){const g=await I(y);if(g)return(0,T.join)(g,u[l])}}}catch{}return null}e.realcase=I;async function E(m){try{return await O.Promises.realpath(m)}catch{const h=w(m);return await O.Promises.access(h,D.constants.R_OK),h}}e.realpath=E;function C(m){try{return D.realpathSync(m)}catch{const h=w(m);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=C;function w(m){return(0,c.rtrim)((0,T.normalize)(m),T.sep)}}),define(oe[91],ae([0,1,34,13,28]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const c=/^\d+$/,O=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(I||(I={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class w{constructor(A,i,r){this.exePath=A,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:b=!1}={}){return b?E===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:b=!1,findPreview:A=!1}={}){const i=m({useAlternateBitness:b});if(!i)return null;const r=T.join(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const o of await R.Promises.readdir(r)){let f=-1;if(A){const v=o.indexOf("-");if(v<0)continue;const L=o.substring(0,v);if(!c.test(L)||o.substring(v+1)!=="preview")continue;f=parseInt(L,10)}else{if(!c.test(o))continue;f=parseInt(o,10)}if(f<=t)continue;const d=T.join(r,o,"pwsh.exe");!await R.SymlinkSupport.existsFile(d)||(n=d,t=f)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",a=A?" Preview":"";return new w(n,`PowerShell${a}${s}`,!0)}async function h({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const A=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(A))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=b?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(A))if(i.test(t)){const n=T.join(A,t,"pwsh.exe");return new w(n,r)}return null}function S(){const b=T.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(b,".NET Core PowerShell Global Tool")}function u(){const b=T.join(process.env.windir,E===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(b,"Windows PowerShell",!0)}async function*l(){let b=await y();b&&(yield b),b=await y({useAlternateBitness:!0}),b&&(yield b),b=await h(),b&&(yield b),b=S(),b&&(yield b),b=await y({findPreview:!0}),b&&(yield b),b=await h({findPreview:!0}),b&&(yield b),b=await y({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=u(),b&&(yield b)}async function*g(){for await(const b of l())await b.exists()&&(yield b)}e.enumeratePowerShellInstallations=g;async function p(){for await(const b of g())return b;return null}e.getFirstAvailablePowerShellInstallation=p}),define(oe[92],ae([0,1,13,4,36,87,12,28]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return c.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return c.TerminateResponseCode}});function I(w=R.env){return w.comspec||"cmd.exe"}e.getWindowsShell=I;function E(w){let m=[],y=!1;const h=function(S){if(y){m.push(S);return}(!w.send(S,l=>{if(l&&console.error(l),y=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(p=>h(p))}})||T.isWindows)&&(y=!0)};return{send:h}}e.createQueuedSender=E;var C;(function(w){async function m(y,h,S){if(D.isAbsolute(y))return y;if(h===void 0&&(h=R.cwd()),D.dirname(y)!=="."||(S===void 0&&O.isString(R.env.PATH)&&(S=R.env.PATH.split(D.delimiter)),S===void 0||S.length===0))return D.join(h,y);async function l(g){if(await P.Promises.exists(g)){let p;try{p=await P.Promises.stat(g)}catch(b){b.message.startsWith("EACCES")&&(p=await P.Promises.lstat(g))}return p?!p.isDirectory():!1}return!1}for(const g of S){let p;if(D.isAbsolute(g)?p=D.join(g,y):p=D.join(h,g,y),await l(p))return p;let b=p+".com";if(await l(b)||(b=p+".exe",await l(b)))return b}return D.join(h,y)}w.findExecutable=m})(C=e.win32||(e.win32={}))}),define(oe[148],ae([0,1,50,26]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(O){return new Promise((P,I)=>{let E;const C=new Map;function w(y,h,S,u,l){const g=C.get(h);if(y===O||g){const p={name:m(S),cmd:S,pid:y,ppid:h,load:u,mem:l};C.set(y,p),y===O&&(E=p),g&&(g.children||(g.children=[]),g.children.push(p),g.children.length>1&&(g.children=g.children.sort((b,A)=>b.pid-A.pid)))}}function m(y){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,u=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,p=/--crashes-directory/,b=/\\pipe\\winpty-control/,A=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(p.exec(y))return"electron-crash-reporter";if(b.exec(y))return"winpty-process";if(A.exec(y))return"console-window-host (Windows internal process)";let r=i.exec(y);if(r&&r.length===2){if(r[1]==="renderer")return h.exec(y)?"shared-process":S.exec(y)?"issue-reporter":u.exec(y)?"process-explorer":"window";if(r[1]==="utility"){if(l.exec(y))return"utility-network-service";if(g.exec(y))return"extension-host"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do r=t.exec(y),r&&(n+=r+" ");while(r);return n&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${n}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{Q(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(O,S=>{if(!S){I(new Error(`Root process ${O} not found`));return}h.getProcessCpuUsage(S,u=>{const l=new Map;u.forEach(g=>{const p=y(g.commandLine||"");l.set(g.pid,{name:m(p),cmd:p,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),E=l.get(O),E?(l.forEach(g=>{const p=l.get(g.ppid);p&&(p.children||(p.children=[]),p.children.push(g))}),l.forEach(g=>{g.children&&(g.children=g.children.sort((p,b)=>p.pid-b.pid))}),P(E)):I(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[E];const S=[];for(;h.length;){const l=h.shift();l&&(S.push(l.pid),l.children&&(h=h.concat(l.children)))}let u=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);u+=" "+S.join(" "),(0,D.exec)(u,{},(l,g,p)=>{if(l||p)I(l||new Error(p.toString()));else{const b=g.toString().split(`
`);for(let A=0;A<S.length;A++){const i=C.get(S[A]);i.load=parseFloat(b[A])}if(!E){I(new Error(`Root process ${O} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(h,S,u)=>{if(h||u)if(process.platform!=="linux")I(h||new Error(u.toString()));else{const l=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(g,p,b)=>{g||b?I(g||new Error(b.toString())):(c(p,w),y())})}else{const l=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${l} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,b,A)=>{p||A&&!A.includes("screen size is bogus")?I(p||new Error(A.toString())):(c(b,w),process.platform==="linux"?y():E?P(E):I(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=R;function c(O,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=O.toString().split(`
`);for(const C of E){const w=I.exec(C.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(oe[149],ae([0,1,34,4,91,92]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(w,m){return w===1?T.isWindows?C():c.getWindowsShell(m):I(w,m)}e.getSystemShell=O;let P=null;function I(w,m){if(T.isLinux&&w===2||T.isMacintosh&&w===3)return"/bin/bash";if(!P){let y;if(T.isWindows)y="/bin/bash";else{if(y=m.SHELL,!y)try{y=(0,D.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}P=y}return P}let E=null;async function C(){return E||(E=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),E}});var ye=this&&this.__decorate||function(Q,e,D,T){var R=arguments.length,c=R<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")c=Reflect.decorate(Q,e,D,T);else for(var P=Q.length-1;P>=0;P--)(O=Q[P])&&(c=(R<3?O(c):R>3?O(e,D,c):O(e,D))||c);return R>3&&c&&Object.defineProperty(e,D,c),c};define(oe[39],ae([0,1,21,6,17,25,63,9,3,2,67,27,12]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var y;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(y||(y={}));function h(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(S||(S={}));function u(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(l||(l={}));function g(j){let V=0;for(let J=0;;J+=7){const _=j.read(1);if(V|=(_.buffer[0]&127)<<J,!(_.buffer[0]&128))return V}}const p=t(0);function b(j,V){if(V===0){j.write(p);return}let J=0;for(let re=V;re!==0;re=re>>>7)J++;const _=R.VSBuffer.alloc(J);for(let re=0;V!==0;re++)_.buffer[re]=V&127,V=V>>>7,V>0&&(_.buffer[re]|=128);j.write(_)}class A{constructor(V){this.b=V,this.a=0}read(V){const J=this.b.slice(this.a,this.a+V);return this.a+=J.byteLength,J}}e.BufferReader=A;class i{constructor(){this.a=[]}get buffer(){return R.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=i;var r;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(r||(r={}));function t(j){const V=R.VSBuffer.alloc(1);return V.writeUInt8(j,0),V}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function a(j,V){if(typeof V>"u")j.write(n.Undefined);else if(typeof V=="string"){const J=R.VSBuffer.fromString(V);j.write(n.String),b(j,J.byteLength),j.write(J)}else if(s&&Buffer.isBuffer(V)){const J=R.VSBuffer.wrap(V);j.write(n.Buffer),b(j,J.byteLength),j.write(J)}else if(V instanceof R.VSBuffer)j.write(n.VSBuffer),b(j,V.byteLength),j.write(V);else if(Array.isArray(V)){j.write(n.Array),b(j,V.length);for(const J of V)a(j,J)}else if(typeof V=="number"&&(V|0)===V)j.write(n.Uint),b(j,V);else{const J=R.VSBuffer.fromString(JSON.stringify(V));j.write(n.Object),b(j,J.byteLength),j.write(J)}}e.serialize=a;function o(j){switch(j.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return j.read(g(j)).toString();case r.Buffer:return j.read(g(j)).buffer;case r.VSBuffer:return j.read(g(j));case r.Array:{const J=g(j),_=[];for(let re=0;re<J;re++)_.push(o(j));return _}case r.Object:return JSON.parse(j.read(g(j)).toString());case r.Int:return g(j)}}e.deserialize=o;class f{constructor(V,J,_=null,re=1e3){this.h=V,this.j=J,this.k=_,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(V,J){this.b.set(V,J),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const J=this.o([V.type]);this.k?.logOutgoing(J,0,1,u(V.type));return}case 201:case 202:case 204:case 203:{const J=this.o([V.type,V.id],V.data);this.k?.logOutgoing(J,V.id,1,u(V.type),V.data);return}}}o(V,J=void 0){const _=new i;return a(_,V),a(_,J),this.p(_.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const J=new A(V),_=o(J),re=o(J),te=_[0];switch(te){case 100:return this.k?.logIncoming(V.byteLength,_[1],1,`${h(te)}: ${_[2]}.${_[3]}`,re),this.s({type:te,id:_[1],channelName:_[2],name:_[3],arg:re});case 102:return this.k?.logIncoming(V.byteLength,_[1],1,`${h(te)}: ${_[2]}.${_[3]}`,re),this.t({type:te,id:_[1],channelName:_[2],name:_[3],arg:re});case 101:return this.k?.logIncoming(V.byteLength,_[1],1,`${h(te)}`),this.u({type:te,id:_[1]});case 103:return this.k?.logIncoming(V.byteLength,_[1],1,`${h(te)}`),this.u({type:te,id:_[1]})}}s(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const _=new c.CancellationTokenSource;let re;try{re=J.call(this.j,V.name,V.arg,_.token)}catch(B){re=Promise.reject(B)}const te=V.id;re.then(B=>{this.m({id:te,data:B,type:201}),this.d.delete(V.id)},B=>{B instanceof Error?this.m({id:te,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:te,data:B,type:203}),this.d.delete(V.id)});const U=(0,E.toDisposable)(()=>_.cancel());this.d.set(V.id,U)}t(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const _=V.id,te=J.listen(this.j,V.name,V.arg)(U=>this.m({id:_,data:U,type:204}));this.d.set(V.id,te)}u(V){const J=this.d.get(V.id);J&&(J.dispose(),this.d.delete(V.id))}v(V){let J=this.g.get(V.channelName);J||(J=[],this.g.set(V.channelName,J));const _=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:V,timeoutTimer:_})}w(V){const J=this.g.get(V);if(J){for(const _ of J)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var d;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(V,J=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=J}getChannel(V){const J=this;return{call(_,re,te){return J.a?Promise.reject(new P.CancellationError):J.m(V,_,re,te)},listen(_,re){return J.a?I.Event.None:J.o(V,_,re)}}}m(V,J,_,re=c.CancellationToken.None){const te=this.g++,B={id:te,type:100,channelName:V,name:J,arg:_};if(re.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise((Y,ee)=>{if(re.isCancellationRequested)return ee(new P.CancellationError);const K=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(te),Y(pe.data);break;case 202:{this.f.delete(te);const ve=new Error(pe.data.message);ve.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ve.name=pe.data.name,ee(ve);break}case 203:this.f.delete(te),ee(pe.data);break}};this.f.set(te,ue),this.p(B)};let Z=null;this.b===l.Idle?K():(Z=(0,T.createCancelablePromise)(ue=>this.u()),Z.then(()=>{Z=null,K()}));const se=()=>{Z?(Z.cancel(),Z=null):this.p({id:te,type:101}),ee(new P.CancellationError)},le=re.onCancellationRequested(se);W=(0,E.combinedDisposable)((0,E.toDisposable)(se),le),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(V,J,_){const re=this.g++,U={id:re,type:102,channelName:V,name:J,arg:_};let B=null;const W=new I.Emitter({onWillAddFirstListener:()=>{B=(0,T.createCancelablePromise)(Y=>this.u()),B.then(()=>{B=null,this.d.add(W),this.p(U)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(W),this.p({id:re,type:103}))}}),q=Y=>W.fire(Y.data);return this.f.set(re,q),W.event}p(V){switch(V.type){case 100:case 102:{const J=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(J,V.id,0,`${h(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const J=this.q([V.type,V.id]);this.j?.logOutgoing(J,V.id,0,h(V.type));return}}}q(V,J=void 0){const _=new i;return a(_,V),a(_,J),this.r(_.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const J=new A(V),_=o(J),re=o(J),te=_[0];switch(te){case 200:return this.j?.logIncoming(V.byteLength,0,0,u(te)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,_[1],0,u(te),re),this.t({type:_[0],id:_[1],data:re})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.dispose)(this.d.values()),this.d.clear()}}ye([O.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class L{get connections(){const V=[];return this.f.forEach(J=>V.push(J)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:J,onDidClientDisconnect:_})=>{I.Event.once(J.onMessage)(te=>{const U=new A(te),B=o(U),W=new f(J,B),q=new v(J);this.a.forEach((ee,K)=>W.registerChannel(K,ee));const Y={channelServer:W,channelClient:q,ctx:B};this.f.add(Y),this.g.fire(Y),_(()=>{W.dispose(),q.dispose(),this.f.delete(Y),this.h.fire(Y)})})})}getChannel(V,J){const _=this;return{call(re,te,U){let B;if((0,m.isFunction)(J)){const q=(0,D.getRandomElement)(_.connections.filter(J));B=q?Promise.resolve(q):I.Event.toPromise(I.Event.filter(_.onDidAddConnection,J))}else B=J.routeCall(_,re,te);const W=B.then(q=>q.channelClient.getChannel(V));return F(W).call(re,te,U)},listen(re,te){if((0,m.isFunction)(J))return _.j(V,J,re,te);const U=J.routeEvent(_,re,te).then(B=>B.channelClient.getChannel(V));return F(U).listen(re,te)}}}j(V,J,_,re){const te=this;let U=new E.DisposableStore;const B=new I.Emitter({onWillAddFirstListener:()=>{U=new E.DisposableStore;const W=new I.EventMultiplexer,q=new Map,Y=K=>{const se=K.channelClient.getChannel(V).listen(_,re),le=W.add(se);q.set(K,le)},ee=K=>{const Z=q.get(K);!Z||(Z.dispose(),q.delete(K))};te.connections.filter(J).forEach(Y),I.Event.filter(te.onDidAddConnection,J)(Y,void 0,U),te.onDidRemoveConnection(ee,void 0,U),W.event(B.fire,B,U),U.add(W)},onDidRemoveLastListener:()=>{U.dispose()}});return B.event}registerChannel(V,J){this.a.set(V,J),this.f.forEach(_=>{_.channelServer.registerChannel(V,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class N{constructor(V,J,_=null){const re=new i;a(re,J),V.send(re.buffer),this.a=new v(V,_),this.d=new f(V,J,_)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,J){this.d.registerChannel(V,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function F(j){return{call(V,J,_){return j.then(re=>re.call(V,J,_))},listen(V,J){const _=new I.Relay;return j.then(re=>_.input=re.listen(V,J)),_.event}}}e.getDelayedChannel=F;function M(j){let V=!1;return{call(J,_,re){return V?j.call(J,_,re):(0,T.timeout)(0).then(()=>V=!0).then(()=>j.call(J,_,re))},listen(J,_){if(V)return j.listen(J,_);const re=new I.Relay;return(0,T.timeout)(0).then(()=>V=!0).then(()=>re.input=j.listen(J,_)),re.event}}}e.getNextTickChannel=M;class k{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const J of V.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await I.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=k;var $;(function(j){function V(te,U){const B=te,W=U&&U.disableMarshalling,q=new Map;for(const Y in B)_(Y)&&q.set(Y,I.Event.buffer(B[Y],!0));return new class{listen(Y,ee,K){const Z=q.get(ee);if(Z)return Z;if(re(ee)){const se=B[ee];if(typeof se=="function")return se.call(B,K)}throw new Error(`Event not found: ${ee}`)}call(Y,ee,K){const Z=B[ee];if(typeof Z=="function"){if(!W&&Array.isArray(K))for(let se=0;se<K.length;se++)K[se]=(0,C.revive)(K[se]);return Z.apply(B,K)}throw new Error(`Method not found: ${ee}`)}}}j.fromService=V;function J(te,U){const B=U&&U.disableMarshalling;return new Proxy({},{get(W,q){if(typeof q=="string")return U?.properties?.has(q)?U.properties.get(q):re(q)?function(Y){return te.listen(q,Y)}:_(q)?te.listen(q):async function(...Y){let ee;U&&!(0,m.isUndefinedOrNull)(U.context)?ee=[U.context,...Y]:ee=Y;const K=await te.call(q,ee);return B?K:(0,C.revive)(K)};throw new Error(`Property not found: ${String(q)}`)}})}j.toService=J;function _(te){return te[0]==="o"&&te[1]==="n"&&w.isUpperAsciiLetter(te.charCodeAt(2))}function re(te){return/^onDynamic/.test(te)&&w.isUpperAsciiLetter(te.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const V=j.toString();if(V!=="[object Object]")return V}return j}function X(j){return Array.isArray(j)?j.map(x):x(j)}function ie(j,V,J,_,re,te,U){U=X(U);const B=z[re],W=B[_%B.length];let q=[`%c[${j}]%c[${String(V).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(te)?(q=q.concat(U),q.push(")")):q.push(U),console.log.apply(console,q)}class H{constructor(V,J){this.d=V,this.f=J,this.a=0,this.b=0}logOutgoing(V,J,_,re,te){this.b+=V,ie(this.d,this.b,V,J,_,re,te)}logIncoming(V,J,_,re,te){this.a+=V,ie(this.f,this.a,V,J,_,re,te)}}e.IPCLogger=H}),define(oe[150],ae([0,1,17,3,39]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class c{constructor(I){this.a=I,this.onMessage=T.Event.fromDOMEventEmitter(this.a,"message",E=>D.VSBuffer.wrap(E.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=c;class O extends R.IPCClient{constructor(I,E){const C=new c(I);super(C,E),this.b=C}dispose(){this.b.disconnect()}}e.Client=O}),define(oe[93],ae([0,1,6,17,3,2,39]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(v){v.Created="created",v.Read="read",v.Write="write",v.Open="open",v.Error="error",v.Close="close",v.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",v.NodeEndReceived="nodeEndReceived",v.NodeEndSent="nodeEndSent",v.NodeDrainBegin="nodeDrainBegin",v.NodeDrainEnd="nodeDrainEnd",v.zlibInflateError="zlibInflateError",v.zlibInflateData="zlibInflateData",v.zlibInflateInitialWrite="zlibInflateInitialWrite",v.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",v.zlibInflateWrite="zlibInflateWrite",v.zlibInflateFlushFired="zlibInflateFlushFired",v.zlibDeflateError="zlibDeflateError",v.zlibDeflateData="zlibDeflateData",v.zlibDeflateWrite="zlibDeflateWrite",v.zlibDeflateFlushFired="zlibDeflateFlushFired",v.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",v.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",v.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",v.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",v.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",v.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",v.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",v.ProtocolHeaderRead="protocolHeaderRead",v.ProtocolMessageRead="protocolMessageRead",v.ProtocolHeaderWrite="protocolHeaderWrite",v.ProtocolMessageWrite="protocolMessageWrite",v.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(v){v.enableDiagnostics=!1,v.records=[];const L=new WeakMap;let N=0;function F(k,$){if(!L.has(k)){const z=String(++N);L.set(k,z)}return L.get(k)}function M(k,$,z,x){if(!v.enableDiagnostics)return;const X=F(k,$);if(x instanceof T.VSBuffer||x instanceof Uint8Array||x instanceof ArrayBuffer||ArrayBuffer.isView(x)){const ie=T.VSBuffer.alloc(x.byteLength);ie.set(x),v.records.push({timestamp:Date.now(),id:X,label:$,type:z,buff:ie})}else v.records.push({timestamp:Date.now(),id:X,label:$,type:z,data:x})}v.traceSocketEvent=M})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(v){v[v.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",v[v.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function w(){return C||(C=T.VSBuffer.alloc(0)),C}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(L){this.a.push(L),this.b+=L.byteLength}read(L){return this.c(L,!0)}peek(L){return this.c(L,!1)}c(L,N){if(L===0)return w();if(L>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===L){const $=this.a[0];return N&&(this.a.shift(),this.b-=L),$}if(this.a[0].byteLength>L){const $=this.a[0].slice(0,L);return N&&(this.a[0]=this.a[0].slice(L),this.b-=L),$}const F=T.VSBuffer.alloc(L);let M=0,k=0;for(;L>0;){const $=this.a[k];if($.byteLength>L){const z=$.slice(0,L);F.set(z,M),M+=L,N&&(this.a[k]=$.slice(L),this.b-=L),L-=L}else F.set($,M),M+=$.byteLength,N?(this.a.shift(),this.b-=$.byteLength):k++,L-=$.byteLength}return F}}e.ChunkStream=m;var y;(function(v){v[v.None=0]="None",v[v.Regular=1]="Regular",v[v.Control=2]="Control",v[v.Ack=3]="Ack",v[v.Disconnect=5]="Disconnect",v[v.ReplayRequest=6]="ReplayRequest",v[v.Pause=7]="Pause",v[v.Resume=8]="Resume",v[v.KeepAlive=9]="KeepAlive",v[v.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",v[v.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(y||(y={}));function h(v){switch(v){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var S;(function(v){v[v.HeaderLength=13]="HeaderLength",v[v.AcknowledgeTime=2e3]="AcknowledgeTime",v[v.TimeoutTime=2e4]="TimeoutTime",v[v.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",v[v.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",v[v.KeepAliveSendTime=5e3]="KeepAliveSendTime",v[v.LatencySampleTime=6e4]="LatencySampleTime",v[v.LatencySampleCount=5]="LatencySampleCount",v[v.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",v[v.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(L,N,F,M){this.type=L,this.id=N,this.ack=F,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends c.Disposable{constructor(L){super(),this.f=this.B(new R.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=L,this.b=!1,this.c=new m,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(L){if(!(!L||L.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(L);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,M=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new u(F,M,k,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(L){this.k=null,this.a=!1,this.b=!1,this.c=L,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(L){if(this.a)return;L.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=T.VSBuffer.alloc(13);N.writeUInt8(L.type,0),N.writeUInt32BE(L.id,1),N.writeUInt32BE(L.ack,5),N.writeUInt32BE(L.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(L.type),id:L.id,ack:L.ack,messageSize:L.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",L.data),this.j(N,L.data)}g(L,N){const F=this.f===0;return this.d.push(L,N),this.f+=L.byteLength+N.byteLength,F}h(){const L=T.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,L}j(L,N){this.g(L,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const L=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:L.byteLength}),this.c.write(L)}}class p extends c.Disposable{constructor(L){super(),this.f=new R.Emitter,this.onMessage=this.f.event,this.g=new R.Emitter,this.onDidDispose=this.g.event,this.a=L,this.b=this.B(new g(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(L){this.b.write(new u(1,0,0,L))}}e.Protocol=p;class b extends O.IPCClient{static fromSocket(L,N){return new b(new p(L),N)}get onDidDispose(){return this.b.onDidDispose}constructor(L,N,F=null){super(L,N,F),this.b=L}dispose(){super.dispose();const L=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),L.end()}}e.Client=b;class A{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(L){this.b?this.d.length>0?this.d.push(L):this.a.fire(L):this.d.push(L)}flushBuffer(){this.d=[]}}e.BufferedEmitter=A;class i{constructor(L){this.data=L,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let L=0,N=this.a;for(;N;)N=N.next,L++;return L}peek(){return this.a?this.a.data:null}toArray(){const L=[];let N=0,F=this.a;for(;F;)L[N++]=F.data,F=F.next;return L}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(L){const N=new i(L);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const L=Date.now();for(let N=0;N<t.a;N++)this.c[N]=L-1e3*N;setInterval(()=>{for(let N=t.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const L=Date.now(),N=(1+t.a)*1e3;let F=0;for(let M=0;M<t.a;M++)L-this.c[M]<=N&&F++;return 1-F/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var n;(function(v){v[v.Good=0]="Good",v[v.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function s(v){switch(v){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class a{constructor(L){this.connectionHealth=L}}e.ConnectionHealthChangedEvent=a;class o{constructor(L,N){this.roundTripTime=L,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=o;class f{get unacknowledgedCount(){return this.c-this.d}constructor(L){this.x=new A,this.onControlMessage=this.x.event,this.y=new A,this.onMessage=this.y.event,this.z=new A,this.onDidDispose=this.z.event,this.A=new A,this.onSocketClose=this.A.event,this.B=new A,this.onSocketTimeout=this.B.event,this.C=new A,this.onHighRoundTripTime=this.C.event,this.D=new A,this.onDidChangeConnectionHealth=this.D.event,this.u=L.loadEstimator??t.getInstance(),this.v=L.measureRoundTripTime??!1,this.w=L.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new c.DisposableStore,this.o=L.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),L.initialChunk&&this.q.acceptChunk(L.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const L=new u(5,0,0,w());this.p.write(L),this.p.flush()}sendPause(){const L=new u(7,0,0,w());this.p.write(L)}sendResume(){const L=new u(8,0,0,w());this.p.write(L)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(L,N){this.a=!0,this.t.dispose(),this.t=new c.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=L,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const L=new u(3,0,this.h,w());this.p.write(L);const N=this.b.toArray();for(let F=0,M=N.length;F<M;F++)this.p.write(N[F]);this.G()}acceptDisconnect(){this.z.fire()}E(L){if(L.ack>this.d){this.d=L.ack;do{const N=this.b.peek();if(N&&N.id<=L.ack)this.b.pop();else break}while(!0)}switch(L.type){case 0:break;case 1:{if(L.id>this.g)if(L.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new u(6,0,0,w())))}else this.g=L.id,this.j=Date.now(),this.F(),this.y.fire(L.data);break}case 2:{this.x.fire(L.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let F=0,M=N.length;F<M;F++)this.p.write(N[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(L.data);break}case 11:{this.r.handleResponse(L.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(L){const N=++this.c;this.h=this.g;const F=new u(1,N,this.h,L);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(L){const N=new u(2,0,0,L);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const L=Date.now()-this.j;if(L>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-L+5)}G(){if(this.c<=this.d||this.f||this.a)return;const L=this.b.peek(),N=Date.now()-L.writtenTime,F=Date.now()-this.q.lastReadTime,M=Date.now()-this.n;if(N>=2e4&&F>=2e4&&M>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:F});return}const k=Math.max(2e4-N,2e4-F,2e4-M,500);this.f=setTimeout(()=>{this.f=null,this.G()},k)}H(){if(this.g<=this.h)return;this.h=this.g;const L=new u(3,0,this.h,w());this.p.write(L)}I(){this.h=this.g;const L=new u(9,0,this.h,w());this.p.write(L)}J(L){this.h=this.g;const N=new u(10,0,this.h,L);this.p.write(N)}K(L){this.h=this.g;const N=new u(11,0,this.h,L);this.p.write(N)}}e.PersistentProtocol=f;class d extends c.Disposable{constructor(){super(),this.a=this.B(new R.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new R.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new R.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new D.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},L=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const L=++this.h,N=T.VSBuffer.alloc(4);N.writeUInt32BE(L,0),this.a.fire(N)},6e4)}handleResponse(L){if(L.byteLength!==4)return;const N=L.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const F=Date.now()-this.g,M=this.k++;this.j[M%this.j.length]=F;const k=this.l,$=this.j.filter(z=>z>=1e3).length;this.l=$>=3?1:0,F>1e3&&this.b.fire(new o(F,$)),k!==this.l&&this.c.fire(this.l)}}}),define(oe[151],ae([0,1,94,3,39,150]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends R.IPCServer{static b(){const I=T.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,C)=>C);return T.Event.map(I,E=>{const{port1:C,port2:w}=new MessageChannel,y={protocol:new c.Protocol(C),onDidClientDisconnect:T.Event.fromDOMEventEmitter(C,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[w]),y})}constructor(){super(O.b())}}e.Server=O}),define(oe[68],ae([0,1,50,6,17,25,144,9,3,2,32,92,87,39]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(l){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",g=>R.VSBuffer.wrap(Buffer.from(g,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=h;class S{constructor(l,g){this.i=l,this.j=g,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const p=g&&g.timeout?g.timeout:6e4;this.b=new T.Delayer(p),this.d=null,this.f=null}getChannel(l){const g=this;return{call(p,b,A){return g.k(l,p,b,A)},listen(p,b){return g.l(l,p,b)}}}k(l,g,p,b=c.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const A=this.n(l),i=(0,T.createCancelablePromise)(n=>A.call(g,p,n)),r=b.onCancellationRequested(()=>i.cancel()),t=(0,E.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,g,p){if(!this.b)return I.Event.None;this.b.cancel();let b;const A=new I.Emitter({onWillAddFirstListener:()=>{b=this.n(l).listen(g,p)(A.fire,A),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return A.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,m.removeDangerousEnvVariables)(g.env),this.d=(0,D.fork)(this.i,l,g);const p=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,O.isRemoteConsoleLog)(s)){(0,O.log)(s,`IPC Library: ${this.j.serverName}`);return}p.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const A=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,i=s=>this.d&&this.d.connected&&A.send(s.buffer.toString("base64")),r=p.event,t={send:i,onMessage:r};this.f=new y.ChannelClient(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,E.dispose)(o)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(l){let g=this.g.get(l);return g||(g=this.m.getChannel(l),this.g.set(l,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(oe[152],ae([0,1,17,9,3,2,13,4,31,39,93]),function(Q,e,D,T,R,c,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(o,f){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,f)}constructor(o,f=""){this.f=!0,this.debugLabel=f,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=d=>{if(this.traceSocketEvent("error",{code:d?.code,message:d?.message}),d){if(d.code==="EPIPE")return;(0,T.onUnexpectedError)(d)}},this.socket.on("error",this.a),this.b=d=>{this.traceSocketEvent("close",{hadError:d}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const f=d=>{this.traceSocketEvent("read",d),o(D.VSBuffer.wrap(d))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(o){const f=d=>{o({type:0,hadError:d,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(o){const f=()=>{o()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,T.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,T.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=m;var y;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var h;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(h||(h={}));class S extends c.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,f){this.socket.traceSocketEvent(o,f)}constructor(o,f,d,v){super(),this.f=this.B(new R.Emitter),this.g=this.B(new R.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:d?.byteLength||0,recordInflateBytes:v}),this.a=this.B(new u(this,f,d,v,this.f,(L,N)=>this.k(L,N))),this.B(this.a.onError(L=>{console.error(L),(0,T.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new C.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,f){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let d=2;o.byteLength<126?d+=0:o.byteLength<2**16?d+=2:d+=8;const v=D.VSBuffer.alloc(d);if(f?v.writeUInt8(194,0):v.writeUInt8(130,0),o.byteLength<126)v.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){v.writeUInt8(126,1);let L=1;v.writeUInt8(o.byteLength>>>8&255,++L),v.writeUInt8(o.byteLength>>>0&255,++L)}else{v.writeUInt8(127,1);let L=1;v.writeUInt8(0,++L),v.writeUInt8(0,++L),v.writeUInt8(0,++L),v.writeUInt8(0,++L),v.writeUInt8(o.byteLength>>>24&255,++L),v.writeUInt8(o.byteLength>>>16&255,++L),v.writeUInt8(o.byteLength>>>8&255,++L),v.writeUInt8(o.byteLength>>>0&255,++L)}this.socket.write(D.VSBuffer.concat([v,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),d=f.readUInt8(0),v=(d&128)>>>7,L=(d&64)>>>6,N=f.readUInt8(1),F=(N&128)>>>7,M=N&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=v,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(v),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),d=f.readUInt8(1),v=(d&128)>>>7;let L=d&127,N=1;L===126?L=f.readUInt8(++N)*2**8+f.readUInt8(++N):L===127&&(L=f.readUInt8(++N)*0+f.readUInt8(++N)*0+f.readUInt8(++N)*0+f.readUInt8(++N)*0+f.readUInt8(++N)*2**24+f.readUInt8(++N)*2**16+f.readUInt8(++N)*2**8+f.readUInt8(++N));let F=0;v&&(F=f.readUInt8(++N)*2**24+f.readUInt8(++N)*2**16+f.readUInt8(++N)*2**8+f.readUInt8(++N)),this.j.state=3,this.j.readLen=L,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),p(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(f,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await R.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class u extends c.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(o,f,d,v,L,N){super(),this.k=o,this.l=L,this.m=N,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new R.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,f?(this.b=this.B(new l(this.k,v,d,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const f=await this.r(this.f,o);this.m(f,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,f){return new Promise((d,v)=>{o.write(f),o.flush(L=>d(L))})}acceptFrame(o,f,d){this.h.push({data:o,isCompressed:f,isLastFrameOfMessage:d}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const f=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(f)}else this.l.fire(o.data)}this.s=!1}}u(o,f,d){return new Promise((v,L)=>{o.write(f),d&&o.write(D.VSBuffer.fromByteArray([0,0,255,255])),o.flush(N=>v(N))})}}class l extends c.Disposable{get recordedInflateBytes(){return this.j?D.VSBuffer.concat(this.f):D.VSBuffer.alloc(0)}constructor(o,f,d,v){super(),this.h=o,this.j=f,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=w().zlib.createInflateRaw(v),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(D.VSBuffer.wrap(L))}),d&&(this.h.traceSocketEvent("zlibInflateInitialWrite",d.buffer),this.b.write(d.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=D.VSBuffer.concat(this.g);this.g.length=0,o(f)})}}class g extends c.Disposable{constructor(o,f){super(),this.g=o,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.f=[],this.b=w().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",d=>{this.g.traceSocketEvent("zlibDeflateError",{message:d?.message,code:d?.code}),this.a.fire(d)}),this.b.on("data",d=>{this.g.traceSocketEvent("zlibDeflateData",d),this.f.push(D.VSBuffer.wrap(d))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=D.VSBuffer.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),o(f)})}}function p(a,o){if(o===0)return;const f=a.byteLength>>>2;for(let M=0;M<f;M++){const k=a.readUInt32BE(M*4);a.writeUInt32BE(k^o,M*4)}const d=f*4,v=a.byteLength-d,L=o>>>24&255,N=o>>>16&255,F=o>>>8&255;v>=1&&a.writeUInt8(a.readUInt8(d)^L,d),v>=2&&a.writeUInt8(a.readUInt8(d+1)^N,d+1),v>=3&&a.writeUInt8(a.readUInt8(d+2)^F,d+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const b={[2]:107,[1]:103};function A(){const a=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):o=(0,O.join)(w().os.tmpdir(),`vscode-ipc-${a}.sock`),r(o),o}e.createRandomIPCHandle=A;function i(a,o,f){const d=w().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${f}-${o}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${f}-${o}.sock`):v=(0,O.join)(a,`${f}-${o}.sock`),r(v),v}e.createStaticIPCHandle=i;function r(a){const o=b[P.platform];typeof o=="number"&&a.length>=o&&console.warn(`WARNING: IPC handle "${a}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends E.IPCServer{static b(o){const f=R.Event.fromNodeEventEmitter(o,"connection");return R.Event.map(f,d=>({protocol:new C.Protocol(new m(d,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(d,"close"))}))}constructor(o){super(t.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function n(a){return new Promise((o,f)=>{const d=w().net.createServer();d.on("error",f),d.listen(a,()=>{d.removeListener("error",f),o(new t(d))})})}e.serve=n;function s(a,o){return new Promise((f,d)=>{const v=w().net.createConnection(a,()=>{v.removeListener("error",d),f(C.Client.fromSocket(new m(v,`ipc-client${o}`),o))});v.once("error",d)})}e.connect=s}),define(oe[69],ae([0,1,6,3,2,12]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O=e.StorageHint||(e.StorageHint={}));function P(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class E extends R.Disposable{constructor(m,y=Object.create(null)){super(),this.m=m,this.n=y,this.b=this.B(new T.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new D.ThrottledDelayer(E.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((y,h)=>this.s(h,y)),m.deleted?.forEach(y=>this.s(y,void 0))}s(m,y){if(this.c===I.Closed)return;let h=!1;(0,c.isUndefinedOrNull)(y)?h=this.f.delete(m):this.f.get(m)!==y&&(this.f.set(m,y),h=!0),h&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,y){const h=this.f.get(m);return(0,c.isUndefinedOrNull)(h)?y:h}getBoolean(m,y){const h=this.get(m);return(0,c.isUndefinedOrNull)(h)?y:h==="true"}getNumber(m,y){const h=this.get(m);return(0,c.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(m,y){if(this.c===I.Closed)return;if((0,c.isUndefinedOrNull)(y))return this.delete(m);const h=String(y);if(this.f.get(m)!==h)return this.f.set(m,h),this.j.set(m,h),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===I.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===O.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=E,E.a=100;class C{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((y,h)=>this.a.set(h,y)),m.delete?.forEach(y=>this.a.delete(y))}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[153],ae([10,7]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(oe[154],ae([10,7]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[155],ae([10,7]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(oe[156],ae([10,7]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(oe[157],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[158],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[159],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[160],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[161],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[162],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[163],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[164],ae([10,7]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[165],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(oe[166],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(oe[167],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(oe[168],ae([10,7]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[169],ae([10,7]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[170],ae([10,7]),function(Q,e){return Q.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[171],ae([10,7]),function(Q,e){return Q.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[172],ae([10,7]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(oe[173],ae([10,7]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(oe[174],ae([10,7]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[175],ae([10,7]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[176],ae([10,7]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[177],ae([10,7]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[178],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[179],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[180],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[181],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[182],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[183],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[184],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[185],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[186],ae([10,7]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[187],ae([10,7]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(oe[95],ae([0,1,65,63,26,13,36,22,11]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class E{get appRoot(){return(0,c.dirname)(R.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,c.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,c.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,c.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,c.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,c.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?I.URI.file((0,c.join)(h,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,c.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,c.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,c.resolve)(h):(0,c.normalize)((0,c.join)(R.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?I.URI.file((0,c.resolve)(h)):I.URI.file((0,c.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,c.resolve)(h);const S=O.env.VSCODE_EXTENSIONS;if(S)return S;const u=O.env.VSCODE_PORTABLE;return u?(0,c.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(S=>/^[^:/?#]+?:\/\//.test(S)?I.URI.parse(S):I.URI.file((0,c.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?I.URI.parse(h):I.URI.file((0,c.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const S of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);u&&u[1]&&u[2]&&h.push([u[1],u[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,c.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?I.URI.file((0,c.join)(h,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,S,u){this.a=h,this.b=S,this.c=u,this.editSessionId=this.args.editSessionId}}ye([T.memoize],E.prototype,"appRoot",null),ye([T.memoize],E.prototype,"userHome",null),ye([T.memoize],E.prototype,"userDataPath",null),ye([T.memoize],E.prototype,"appSettingsHome",null),ye([T.memoize],E.prototype,"tmpDir",null),ye([T.memoize],E.prototype,"cacheHome",null),ye([T.memoize],E.prototype,"stateResource",null),ye([T.memoize],E.prototype,"userRoamingDataHome",null),ye([T.memoize],E.prototype,"userDataSyncHome",null),ye([T.memoize],E.prototype,"userDataSyncLogResource",null),ye([T.memoize],E.prototype,"editSessionsLogResource",null),ye([T.memoize],E.prototype,"sync",null),ye([T.memoize],E.prototype,"machineSettingsResource",null),ye([T.memoize],E.prototype,"workspaceStorageHome",null),ye([T.memoize],E.prototype,"localHistoryHome",null),ye([T.memoize],E.prototype,"keyboardLayoutResource",null),ye([T.memoize],E.prototype,"argvResource",null),ye([T.memoize],E.prototype,"isExtensionDevelopment",null),ye([T.memoize],E.prototype,"untitledWorkspacesHome",null),ye([T.memoize],E.prototype,"installSourcePath",null),ye([T.memoize],E.prototype,"builtinExtensionsPath",null),ye([T.memoize],E.prototype,"extensionsPath",null),ye([T.memoize],E.prototype,"extensionDevelopmentLocationURI",null),ye([T.memoize],E.prototype,"extensionDevelopmentKind",null),ye([T.memoize],E.prototype,"extensionTestsLocationURI",null),ye([T.memoize],E.prototype,"debugExtensionHost",null),ye([T.memoize],E.prototype,"logLevel",null),ye([T.memoize],E.prototype,"extensionLogLevel",null),ye([T.memoize],E.prototype,"serviceMachineIdResource",null),ye([T.memoize],E.prototype,"telemetryLogResource",null),ye([T.memoize],E.prototype,"disableWorkspaceTrust",null),ye([T.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function C(y,h){return m(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId,y.extensionEnvironment)}e.parseExtensionHostPort=C;function w(y,h){return m(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,h,y.extensionEnvironment)}e.parsePtyHostPort=w;function m(y,h,S,u,l,g){const b=Number(h||y)||(u?null:S),A=b?Boolean(!!h):!1;let i;if(g)try{i=JSON.parse(g)}catch{}return{port:b,break:A,debugId:l,env:i}}}),define(oe[188],ae([0,1,291,4,155]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const c={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(S,u,l=O){const g=S.find(a=>a.length>0&&a[0]!=="-"),p={},b=["_"],A=[],i={};let r;for(const a in u){const o=u[a];o.type==="subcommand"?a===g&&(r=o):(o.alias&&(p[a]=o.alias),o.type==="string"||o.type==="string[]"?(b.push(a),o.deprecates&&b.push(...o.deprecates)):o.type==="boolean"&&(A.push(a),o.deprecates&&A.push(...o.deprecates)),o.global&&(i[a]=o))}if(r&&g){const a=i;for(const v in r.options)a[v]=r.options[v];const o=S.filter(v=>v!==g),f=l.getSubcommandReporter?l.getSubcommandReporter(g):void 0,d=P(o,a,f);return{[g]:d,_:[]}}const t=D(S,{string:b,boolean:A,alias:p}),n={},s=t;n._=t._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(const a in u){const o=u[a];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let f=s[a];if(o.deprecates)for(const d of o.deprecates)s.hasOwnProperty(d)&&(f||(f=s[d],f&&l.onDeprecatedOption(d,o.deprecationMessage||(0,R.localize)(36,null,a))),delete s[d]);if(typeof f<"u"){if(o.type==="string[]"){if(Array.isArray(f)||(f=[f]),!o.allowEmptyValue){const d=f.filter(v=>v.length>0);d.length!==f.length&&(l.onEmptyValue(a),f=d.length>0?d:void 0)}}else o.type==="string"&&(Array.isArray(f)?(f=f.pop(),l.onMultipleValues(a,f)):!f&&!o.allowEmptyValue&&(l.onEmptyValue(a),f=void 0));n[a]=f,o.deprecationMessage&&l.onDeprecatedOption(a,o.deprecationMessage)}delete s[a]}for(const a in s)l.onUnknownOption(a);return n}e.parseArgs=P;function I(S,u){let l="";return u.args&&(Array.isArray(u.args)?l=` <${u.args.join("> <")}>`:l=` <${u.args}>`),u.alias?`-${u.alias} --${S}${l}`:`--${S}${l}`}function E(S,u){const l=[];for(const g in S){const p=S[g],b=I(g,p);l.push([b,p.description])}return C(l,u)}e.formatOptions=E;function C(S,u){const g=S.reduce((A,i)=>Math.max(A,i[0].length),12)+2+1;if(u-g<25)return S.reduce((A,i)=>A.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const p=u-g-1,b=[];for(const A of S){const i=A[0],r=m(A[1],p),t=w(g-i.length-2);b.push("  "+i+t+r[0]);for(let n=1;n<r.length;n++)b.push(w(g)+r[n])}return b}function w(S){return" ".repeat(S)}function m(S,u){const l=[];for(;S.length;){const g=S.length<u?S.length:S.lastIndexOf(" ",u),p=S.slice(0,g).trim();S=S.slice(g),l.push(p)}return l}function y(S,u,l,g,p){const b=process.stdout.isTTY&&process.stdout.columns||80,A=p?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",i=[`${S} ${l}`];i.push(""),i.push(`${(0,R.localize)(38,null)}: ${u} [${(0,R.localize)(39,null)}]${A}`),i.push(""),p?.noPipe!==!0&&(T.isWindows?i.push((0,R.localize)(40,null,u)):i.push((0,R.localize)(41,null,u)),i.push(""));const r={},t=[];for(const n in g){const s=g[n];if(s.type==="subcommand")s.description&&t.push({command:n,description:s.description});else if(s.description&&s.cat){let a=r[s.cat];a||(r[s.cat]=a={}),a[n]=s}}for(const n in r){const s=n,a=r[s];a&&(i.push(c[s]),i.push(...E(a,b)),i.push(""))}return t.length&&(i.push((0,R.localize)(42,null)),i.push(...C(t.map(n=>[n.command,n.description]),b)),i.push("")),i.join(`
`)}e.buildHelpMessage=y;function h(S,u){return`${S||(0,R.localize)(43,null)}
${u||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=h}),define(oe[189],ae([0,1,292,156,188]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const c=2048;function O(m,y){const h=(b,A)=>{console.warn((0,T.localize)(0,null,b,A))},S=b=>{console.warn((0,T.localize)(1,null,b))},u=(b,A)=>{console.warn((0,T.localize)(2,null,b,A))},l=b=>({onUnknownOption:A=>{b!=="tunnel"&&console.warn((0,T.localize)(3,null,A,b))},onMultipleValues:h,onEmptyValue:S,onDeprecatedOption:u,getSubcommandReporter:b!=="tunnel"?l:void 0}),g={onUnknownOption:b=>{console.warn((0,T.localize)(4,null,b))},onMultipleValues:h,onEmptyValue:S,onDeprecatedOption:u,getSubcommandReporter:l},p=(0,R.parseArgs)(m,R.OPTIONS,y?g:void 0);return p.goto&&p._.forEach(b=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,T.localize)(5,null))),p["max-memory"]&&D(parseInt(p["max-memory"])>=c,`The max-memory argument cannot be specified lower than ${c} MB.`),p}function P(m){const y=m.findIndex(h=>!/^-/.test(h));if(y>-1)return[...m.slice(0,y),...m.slice(y+1)]}function I(m){let[,...y]=m;process.env.VSCODE_DEV&&(y=P(y)||[]);const h=!w(process.env);return O(y,h)}e.parseMainProcessArgv=I;function E(m){let[,,...y]=m;return process.env.VSCODE_DEV&&(y=P(y)||[]),O(y,!0)}e.parseCLIProcessArgv=E;function C(m,...y){const h=m.indexOf("--");return h===-1?m.push(...y):m.splice(h,0,...y),m}e.addArg=C;function w(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Q(e,D,T){function R(O,P){const I=c(O,P),E=[I];return e.isAbsolute(I)||E.unshift(T),e.resolve(...E)}function c(O,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,P);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(w,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,P)}return{getUserDataPath:R}}if(typeof define=="function")define(oe[190],ae([293,34,36]),function(e,D,T){return Q(e,D,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[191],ae([0,1,34,95,190]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class c extends T.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=c}),define(oe[192],ae([0,1,11]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,c=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(u){const l=u.match(O);return l?l[1]:null}function C(u){if(u.indexOf("://")===-1){const l=u.match(T);return l?E(l[2]):null}try{const l=D.URI.parse(u);if(l.authority)return E(l.authority)}catch{}return null}function w(u,l){const g=new Set;let p;for(;p=P.exec(u);){const A=C(p[1]);A&&g.add(A)}const b=new Set(l);return Array.from(g).map(A=>b.has(A)?A:A.replace(I,"a"))}e.getDomainsOfRemotes=w;function m(u){const l=u.match(c);return l?l[2]:null}function y(u,l,g){return u&&l?(g&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${u}${l}`:`${u}/${l}`):null}function h(u,l){if(u.indexOf("://")===-1){const g=u.match(R);if(g)return y(g[2],g[3],l)}try{const g=D.URI.parse(u);if(g.authority)return y(m(g.authority),g.path,l)}catch{}return null}function S(u,l=!1){const g=[];let p;for(;p=P.exec(u);){const b=h(p[1],l);b&&g.push(b)}return g}e.getRemotes=S}),define(oe[193],ae([0,1,12,159]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(O,P,I){try{c(O,P,I)}catch(E){console.error(E?.message??E)}return O}e.localizeManifest=R;function c(O,P,I){const E=(C,w,m)=>{const y=C[w];if((0,D.isString)(y)){const h=y,S=h.length;if(S>1&&h[0]==="%"&&h[S-1]==="%"){const u=h.substr(1,S-2);let l=P[u];l===void 0&&I&&(l=I[u]);const g=typeof l=="string"?l:l?.message,p=I?.[u],b=typeof p=="string"?p:p?.message;if(!g){b||console.warn(`[${O.name}]: ${(0,T.localize)(0,null,u)}`);return}if(m&&(w==="title"||w==="category")&&b&&b!==g){const A={value:g,original:b};C[w]=A}else C[w]=g}}else if((0,D.isObject)(y))for(const h in y)y.hasOwnProperty(h)&&(h==="commands"?E(y,h,!0):E(y,h,m));else if(Array.isArray(y))for(let h=0;h<y.length;h++)E(y,h,m)};for(const C in O)O.hasOwnProperty(C)&&E(O,C)}}),define(oe[194],ae([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(c,O){this.a.set(c,O)}updateManifest(c){if(!(typeof c.main>"u"&&typeof c.browser>"u")&&(c.activationEvents===void 0&&Object.assign(c,{activationEvents:[]}),!(!Array.isArray(c.activationEvents)||!c.contributes)))for(const O in c.contributes){const P=this.a.get(O);if(!P)continue;const I=c.contributes[O],E=Array.isArray(I)?I:[I];try{P(E,c.activationEvents)}catch(C){(0,D.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(oe[195],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(c){this.a=c}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(c,O,P,I){return this.a.call("promptImportantExtensionsInstallNotification",[c,O,P,I])}promptWorkspaceRecommendations(c){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class T{constructor(c){this.a=c}listen(c,O){throw new Error(`Event not found: ${O}`)}call(c,O,P){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(oe[70],ae([0,1,22,89,164,54]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=I;function E(l){if(!I(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(O);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=E;function C(l){if(!l)return null;const g=l.majorBase,p=l.majorMustEqual,b=l.minorBase;let A=l.minorMustEqual;const i=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(g===0||(A=!1),r=!1);let t=0;if(l.preRelease){const n=P.exec(l.preRelease);if(n){const[,s,a,o]=n;t=Date.UTC(Number(s),Number(a)-1,Number(o))}}return{majorBase:g,majorMustEqual:p,minorBase:b,minorMustEqual:A,patchBase:i,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function w(l,g,p){let b;typeof l=="string"?b=C(E(l)):b=l;let A;g instanceof Date?A=g.getTime():typeof g=="string"&&(A=new Date(g).getTime());let i;if(typeof p=="string"?i=C(E(p)):i=p,!b||!i)return!1;const r=b.majorBase,t=b.minorBase,n=b.patchBase;let s=i.majorBase,a=i.minorBase,o=i.patchBase;const f=i.notBefore;let d=i.majorMustEqual,v=i.minorMustEqual,L=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>a?!0:t<a||A&&A<f?!1:n>=o:(r===1&&s===0&&(!d||!v||!L)&&(s=1,a=0,o=0,d=!0,v=!1,L=!1),r<s?!1:r>s?!d:t<a?!1:t>a?!v:n<o?!1:n>o?!L:!(A&&A<f))}e.isValidVersion=w;function m(l,g,p,b,A){const i=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return i.push([T.default.Error,R.localize(0,null)]),i;if(typeof b.name!="string")return i.push([T.default.Error,R.localize(1,null,"name")]),i;if(typeof b.version!="string")return i.push([T.default.Error,R.localize(2,null,"version")]),i;if(!b.engines)return i.push([T.default.Error,R.localize(3,null,"engines")]),i;if(typeof b.engines.vscode!="string")return i.push([T.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof b.extensionDependencies<"u"&&!u(b.extensionDependencies))return i.push([T.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof b.activationEvents<"u"){if(!u(b.activationEvents))return i.push([T.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof b.main>"u"&&typeof b.browser>"u")return i.push([T.default.Error,R.localize(7,null,"activationEvents","main")]),i}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&i.push([T.default.Warning,R.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return i.push([T.default.Error,R.localize(9,null,"main")]),i;{const n=(0,D.joinPath)(p,b.main);(0,D.isEqualOrParent)(n,p)||i.push([T.default.Warning,R.localize(10,null,n.path,p.path)])}if(typeof b.activationEvents>"u")return i.push([T.default.Error,R.localize(11,null,"activationEvents","main")]),i}if(typeof b.browser<"u"){if(typeof b.browser!="string")return i.push([T.default.Error,R.localize(12,null,"browser")]),i;{const n=(0,D.joinPath)(p,b.browser);(0,D.isEqualOrParent)(n,p)||i.push([T.default.Warning,R.localize(13,null,n.path,p.path)])}if(typeof b.activationEvents>"u")return i.push([T.default.Error,R.localize(14,null,"activationEvents","browser")]),i}if(!c.valid(b.version))return i.push([T.default.Error,R.localize(15,null)]),i;const r=[];if(!y(l,g,b,A,r))for(const n of r)i.push([T.default.Error,n]);return i}e.validateExtensionManifest=m;function y(l,g,p,b,A){return b||typeof p.main>"u"&&typeof p.browser>"u"?!0:S(l,g,p.engines.vscode,A)}e.isValidExtensionVersion=y;function h(l,g,p){return l==="*"||S(g,p,l)}e.isEngineValid=h;function S(l,g,p,b=[]){const A=C(E(p));if(!A)return b.push(R.localize(16,null,p)),!1;if(A.majorBase===0){if(!A.majorMustEqual||!A.minorMustEqual)return b.push(R.localize(17,null,p)),!1}else if(!A.majorMustEqual)return b.push(R.localize(18,null,p)),!1;return w(l,g,A)?!0:(b.push(R.localize(19,null,l,p)),!1)}function u(l){if(!Array.isArray(l))return!1;for(let g=0,p=l.length;g<p;g++)if(typeof l[g]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(c,O,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const C=(await O.readFile(c.serviceMachineIdResource)).value.toString();I=(0,T.isUUID)(C)?C:null}catch{I=null}if(!I){I=(0,T.generateUuid)();try{await O.writeFile(c.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=R}),define(oe[55],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,c=[],O=!1){this.ctor=R,this.staticArguments=c,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=D}),define(oe[71],ae([0,1,55]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function c(P,I,E){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(E))),T.push([P,I])}e.registerSingleton=c;function O(){return T}e.getSingletonServiceDescriptors=O}),define(oe[196],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(c,O){this.key=c,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class T{constructor(c){this.b=c,this.a=new Map}roots(){const c=[];for(const O of this.a.values())O.outgoing.size===0&&c.push(O);return c}insertEdge(c,O){const P=this.lookupOrInsertNode(c),I=this.lookupOrInsertNode(O);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(c){const O=this.b(c);this.a.delete(O);for(const P of this.a.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(c){const O=this.b(c);let P=this.a.get(O);return P||(P=new D(O,c),this.a.set(O,P)),P}lookup(c){return this.a.get(this.b(c))}isEmpty(){return this.a.size===0}toString(){const c=[];for(const[O,P]of this.a)c.push(`${O}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return c.join(`
`)}findCycleSlow(){for(const[c,O]of this.a){const P=new Set([c]),I=this.c(O,P);if(I)return I}}c(c,O){for(const[P,I]of c.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const E=this.c(I,O);if(E)return E;O.delete(P)}}}e.Graph=T}),define(oe[5],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function T(O,P,I){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:O,index:I}):(P[D.DI_DEPENDENCIES]=[{id:O,index:I}],P[D.DI_TARGET]=P)}function R(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const P=function(I,E,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(P,I,C)};return P.toString=()=>O,D.serviceIds.set(O,P),P}e.createDecorator=R;function c(O){return O}e.refineServiceDecorator=c}),define(oe[197],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(oe[16],ae([0,1,12,11,5]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function c(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationOverrides=c;function O(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=O;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function E(u,l){const g=Object.create(null);for(const p in u)C(g,p,u[p],l);return g}e.toValuesTree=E;function C(u,l,g,p){const b=l.split("."),A=b.pop();let i=u;for(let r=0;r<b.length;r++){const t=b[r];let n=i[t];switch(typeof n){case"undefined":n=i[t]=Object.create(null);break;case"object":break;default:p(`Ignoring ${l} as ${b.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[A]=g}catch{p(`Ignoring ${l} as ${b.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${l} as ${b.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=C;function w(u,l){const g=l.split(".");m(u,g)}e.removeFromValueTree=w;function m(u,l){const g=l.shift();if(l.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const p=u[g];typeof p=="object"&&!Array.isArray(p)&&(m(p,l),Object.keys(p).length===0&&delete u[g])}}function y(u,l,g){function p(i,r){let t=i;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const b=l.split("."),A=p(u,b);return typeof A>"u"?g:A}e.getConfigurationValue=y;function h(u,l,g){Object.keys(l).forEach(p=>{p!=="__proto__"&&(p in u?D.isObject(u[p])&&D.isObject(l[p])?h(u[p],l[p],g):g&&(u[p]=l[p]):u[p]=l[p])})}e.merge=h;function S(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=S}),define(oe[198],ae([0,1,4,27,5]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",D.isMacintosh),c.set("isLinux",D.isLinux),c.set("isWindows",D.isWindows),c.set("isWeb",D.isWeb),c.set("isMacNative",D.isMacintosh&&!D.isWeb),c.set("isEdge",D.isEdge),c.set("isFirefox",D.isFirefox),c.set("isChrome",D.isChrome),c.set("isSafari",D.isSafari);const O=Object.prototype.hasOwnProperty;var P;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(k){return y.create(k)}static equals(k,$){return h.create(k,$)}static notEquals(k,$){return l.create(k,$)}static regex(k,$){return t.create(k,$)}static in(k,$){return S.create(k,$)}static notIn(k,$){return u.create(k,$)}static not(k){return g.create(k)}static and(...k){return a.create(k,null,!0)}static or(...k){return o.create(k,null,!0)}static greater(k,$){return b.create(k,$)}static greaterEquals(k,$){return A.create(k,$)}static smaller(k,$){return i.create(k,$)}static smallerEquals(k,$){return r.create(k,$)}static deserialize(k,$=!1){if(!!k)return this.c(k,$)}static c(k,$){const z=k.split("||");return o.create(z.map(x=>this.d(x,$)),null,!0)}static d(k,$){const z=k.split("&&");return a.create(z.map(x=>this.f(x,$)),null,!0)}static f(k,$){if(k=k.trim(),k.indexOf("!=")>=0){const z=k.split("!=");return l.create(z[0].trim(),this.g(z[1],$))}if(k.indexOf("==")>=0){const z=k.split("==");return h.create(z[0].trim(),this.g(z[1],$))}if(k.indexOf("=~")>=0){const z=k.split("=~");return t.create(z[0].trim(),this.h(z[1],$))}if(k.indexOf(" not in ")>=0){const z=k.split(" not in ");return u.create(z[0].trim(),this.g(z[1],$))}if(k.indexOf(" in ")>=0){const z=k.split(" in ");return S.create(z[0].trim(),this.g(z[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const z=k.split(">=");return A.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const z=k.split(">");return b.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const z=k.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const z=k.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):y.create(k)}static g(k,$){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const z=/^'([^']*)'$/.exec(k);return z?z[1].trim():k}static h(k,$){if((0,T.isFalsyOrWhitespace)(k)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=k.indexOf("/"),x=k.lastIndexOf("/");if(z===x||z<0){if($)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const X=k.slice(z+1,x),ie=k[x+1]==="i"?"i":"";try{return new RegExp(X,ie)}catch(H){if($)throw new Error(`bad regexp-value '${k}', parse error: ${H}`);return console.warn(`bad regexp-value '${k}', parse error: ${H}`),null}}}e.ContextKeyExpr=I;function E(M,k){const $=M?M.substituteConstants():void 0,z=k?k.substituteConstants():void 0;return!$&&!z?!0:!$||!z?!1:$.equals(z)}e.expressionsAreEqualWithConstantSubstitution=E;function C(M,k){return M.cmp(k)}class w{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class m{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class y{static create(k,$=null){const z=c.get(k);return typeof z=="boolean"?z?m.INSTANCE:w.INSTANCE:new y(k,$)}constructor(k,$){this.key=k,this.c=$,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:d(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=c.get(this.key);return typeof k=="boolean"?k?m.INSTANCE:w.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class h{static create(k,$,z=null){if(typeof $=="boolean")return $?y.create(k,z):g.create(k,z);const x=c.get(k);return typeof x=="boolean"?$===(x?"true":"false")?m.INSTANCE:w.INSTANCE:new h(k,$,z)}constructor(k,$,z){this.c=k,this.d=$,this.f=z,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:v(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=c.get(this.c);if(typeof k=="boolean"){const $=k?"true":"false";return this.d===$?m.INSTANCE:w.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class S{static create(k,$){return new S(k,$)}constructor(k,$){this.d=k,this.f=$,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:v(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const $=k.getValue(this.f),z=k.getValue(this.d);return Array.isArray($)?$.includes(z):typeof z=="string"&&typeof $=="object"&&$!==null?O.call($,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=S;class u{static create(k,$){return new u(k,$)}constructor(k,$){this.d=k,this.f=$,this.type=11,this.c=S.create(k,$)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=u;class l{static create(k,$,z=null){if(typeof $=="boolean")return $?g.create(k,z):y.create(k,z);const x=c.get(k);return typeof x=="boolean"?$===(x?"true":"false")?w.INSTANCE:m.INSTANCE:new l(k,$,z)}constructor(k,$,z){this.c=k,this.d=$,this.f=z,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:v(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=c.get(this.c);if(typeof k=="boolean"){const $=k?"true":"false";return this.d===$?w.INSTANCE:m.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class g{static create(k,$=null){const z=c.get(k);return typeof z=="boolean"?z?w.INSTANCE:m.INSTANCE:new g(k,$)}constructor(k,$){this.c=k,this.d=$,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:d(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=c.get(this.c);return typeof k=="boolean"?k?w.INSTANCE:m.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function p(M,k){if(typeof M=="string"){const $=parseFloat(M);isNaN($)||(M=$)}return typeof M=="string"||typeof M=="number"?k(M):w.INSTANCE}class b{static create(k,$,z=null){return p($,x=>new b(k,x,z))}constructor(k,$,z){this.c=k,this.d=$,this.f=z,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:v(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=b;class A{static create(k,$,z=null){return p($,x=>new A(k,x,z))}constructor(k,$,z){this.c=k,this.d=$,this.f=z,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:v(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=A;class i{static create(k,$,z=null){return p($,x=>new i(k,x,z))}constructor(k,$,z){this.c=k,this.d=$,this.f=z,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:v(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class r{static create(k,$,z=null){return p($,x=>new r(k,x,z))}constructor(k,$,z){this.c=k,this.d=$,this.f=z,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:v(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class t{static create(k,$){return new t(k,$)}constructor(k,$){this.d=k,this.f=$,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const $=this.f?this.f.source:"",z=k.f?k.f.source:"";return $<z?-1:$>z?1:0}equals(k){if(k.type===this.type){const $=this.f?this.f.source:"",z=k.f?k.f.source:"";return this.d===k.d&&$===z}return!1}substituteConstants(){return this}evaluate(k){const $=k.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=n.create(this)),this.c}}e.ContextKeyRegexExpr=t;class n{static create(k){return new n(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(k){return new n(this.c.map(k))}negate(){return this.c}}e.ContextKeyNotRegexExpr=n;function s(M){let k=null;for(let $=0,z=M.length;$<z;$++){const x=M[$].substituteConstants();if(M[$]!==x&&k===null){k=[];for(let X=0;X<$;X++)k[X]=M[X]}k!==null&&(k[$]=x)}return k===null?M:k}class a{static create(k,$,z){return a.d(k,$,z)}constructor(k,$){this.expr=k,this.c=$,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const x=C(this.expr[$],k.expr[$]);if(x!==0)return x}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(k.expr[$]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:a.create(k,this.c,!1)}evaluate(k){for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].evaluate(k))return!1;return!0}static d(k,$,z){const x=[];let X=!1;for(const ie of k)if(!!ie){if(ie.type===1){X=!0;continue}if(ie.type===0)return w.INSTANCE;if(ie.type===6){x.push(...ie.expr);continue}x.push(ie)}if(x.length===0&&X)return m.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(C);for(let ie=1;ie<x.length;ie++)x[ie-1].equals(x[ie])&&(x.splice(ie,1),ie--);if(x.length===1)return x[0];for(;x.length>1;){const ie=x[x.length-1];if(ie.type!==9)break;x.pop();const H=x.pop(),j=x.length===0,V=o.create(ie.expr.map(J=>a.create([J,H],null,z)),null,j);V&&(x.push(V),x.sort(C))}if(x.length===1)return x[0];if(z){for(let ie=0;ie<x.length;ie++)for(let H=ie+1;H<x.length;H++)if(x[ie].negate().equals(x[H]))return w.INSTANCE;if(x.length===1)return x[0]}return new a(x,$)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const $ of this.expr)k.push(...$.keys());return k}map(k){return new a(this.expr.map($=>$.map(k)),null)}negate(){if(!this.c){const k=[];for(const $ of this.expr)k.push($.negate());this.c=o.create(k,this,!0)}return this.c}}class o{static create(k,$,z){return o.d(k,$,z)}constructor(k,$){this.expr=k,this.c=$,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const x=C(this.expr[$],k.expr[$]);if(x!==0)return x}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(k.expr[$]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:o.create(k,this.c,!1)}evaluate(k){for(let $=0,z=this.expr.length;$<z;$++)if(this.expr[$].evaluate(k))return!0;return!1}static d(k,$,z){let x=[],X=!1;if(k){for(let ie=0,H=k.length;ie<H;ie++){const j=k[ie];if(!!j){if(j.type===0){X=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){x=x.concat(j.expr);continue}x.push(j)}}if(x.length===0&&X)return w.INSTANCE;x.sort(C)}if(x.length!==0){if(x.length===1)return x[0];for(let ie=1;ie<x.length;ie++)x[ie-1].equals(x[ie])&&(x.splice(ie,1),ie--);if(x.length===1)return x[0];if(z){for(let ie=0;ie<x.length;ie++)for(let H=ie+1;H<x.length;H++)if(x[ie].negate().equals(x[H]))return m.INSTANCE;if(x.length===1)return x[0]}return new o(x,$)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const $ of this.expr)k.push(...$.keys());return k}map(k){return new o(this.expr.map($=>$.map(k)),null)}negate(){if(!this.c){const k=[];for(const $ of this.expr)k.push($.negate());for(;k.length>1;){const $=k.shift(),z=k.shift(),x=[];for(const X of F($))for(const ie of F(z))x.push(a.create([X,ie],null,!1));k.unshift(o.create(x,null,!1))}this.c=o.create(k,this,!0)}return this.c}}class f extends y{static all(){return f.d.values()}constructor(k,$,z){super(k,null),this.f=$,typeof z=="object"?f.d.push({...z,key:k}):z!==!0&&f.d.push({key:k,description:z,type:$!=null?typeof $:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return h.create(this.key,k)}notEqualsTo(k){return l.create(this.key,k)}}e.RawContextKey=f,f.d=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function d(M,k){return M<k?-1:M>k?1:0}function v(M,k,$,z){return M<$?-1:M>$?1:k<z?-1:k>z?1:0}function L(M,k){if(M.type===0||k.type===1)return!0;if(M.type===9)return k.type===9?N(M.expr,k.expr):!1;if(k.type===9){for(const $ of k.expr)if(L(M,$))return!0;return!1}if(M.type===6){if(k.type===6)return N(k.expr,M.expr);for(const $ of M.expr)if(L($,k))return!0;return!1}return M.equals(k)}e.implies=L;function N(M,k){let $=0,z=0;for(;$<M.length&&z<k.length;){const x=M[$].cmp(k[z]);if(x<0)return!1;x===0&&$++,z++}return $===M.length}function F(M){return M.type===9?M.expr:[M]}}),define(oe[96],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function T(c){return!!c.hostName&&!!c.errorMessage}e.isRemoteDiagnosticError=T;class R{async getPerformanceInfo(O,P){return{}}async getSystemInfo(O,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,P){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.NullDiagnosticsService=R}),define(oe[97],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(oe[15],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[30],ae([0,1,158,5]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function c(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=c;function O(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function P(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(l,g,p){return P(g,p)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===p?!0:E(p).includes(l)}e.isTargetPlatformCompatible=I;function E(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=C;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var y;(function(l){l.Install="install",l.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var S;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(g,p){super(g),this.code=p,this.name=p}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[199],ae([0,1,3,2,67,32,11,145,30]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(u,l){return O.URI.revive(l?l.transformIncoming(u):u)}function C(u,l){return l?l.transformOutgoingURI(u):u}function w(u,l){l=l||P.DefaultURITransformer;const g=u.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...u,manifest:void 0},l),manifest:g}}function m(u,l){return l?(0,c.cloneAndChange)(u,g=>g instanceof O.URI?l.transformOutgoingURI(g):void 0):u}class y{constructor(l,g){this.a=l,this.b=g,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,g){const p=this.b(l);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,b=>b.map(A=>({...A,local:A.local?m(A.local,p):A.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension;case"onDidUpdateExtensionMetadata":return this.onDidUpdateExtensionMetadata}throw new Error("Invalid listen")}call(l,g,p){const b=this.b(l);switch(g){case"zip":return this.a.zip(w(p[0],b)).then(A=>C(A,b));case"unzip":return this.a.unzip(E(p[0],b));case"install":return this.a.install(E(p[0],b),(0,R.revive)(p[1]));case"installFromLocation":return this.a.installFromLocation(E(p[0],b),O.URI.revive(p[1]));case"getManifest":return this.a.getManifest(E(p[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],(0,R.revive)(p[1]));case"uninstall":return this.a.uninstall(w(p[0],b),(0,R.revive)(p[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(w(p[0],b));case"getInstalled":return this.a.getInstalled(p[0],O.URI.revive(p[1])).then(A=>A.map(i=>m(i,b)));case"getMetadata":return this.a.getMetadata(w(p[0],b),O.URI.revive(p[1]));case"updateMetadata":return this.a.updateMetadata(w(p[0],b),p[1],O.URI.revive(p[2])).then(A=>m(A,b));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class h extends T.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.k=l,this.c=this.B(new D.Emitter),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=this.B(new D.Emitter),this.j=this.B(new D.Emitter),this.B(this.k.listen("onInstallExtension")(g=>this.c.fire({identifier:g.identifier,source:this.l(g.source)?O.URI.revive(g.source):g.source,profileLocation:O.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(g=>this.f.fire(g.map(p=>({...p,local:p.local?w(p.local,null):p.local,source:this.l(p.source)?O.URI.revive(p.source):p.source,profileLocation:O.URI.revive(p.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(g=>this.g.fire({identifier:g.identifier,profileLocation:O.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(g=>this.h.fire({...g,profileLocation:O.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(w(g,null))))}l(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.m||(this.m=this.k.call("getTargetPlatform")),this.m}async canInstall(l){const g=await this.getTargetPlatform();return l.allTargetPlatforms.some(p=>(0,I.isTargetPlatformCompatible)(p,l.allTargetPlatforms,g))}zip(l){return Promise.resolve(this.k.call("zip",[l]).then(g=>O.URI.revive(g)))}unzip(l){return Promise.resolve(this.k.call("unzip",[l]))}install(l,g){return Promise.resolve(this.k.call("install",[l,g])).then(p=>w(p,null))}installFromLocation(l,g){return Promise.resolve(this.k.call("installFromLocation",[l,g])).then(p=>w(p,null))}getManifest(l){return Promise.resolve(this.k.call("getManifest",[l]))}installFromGallery(l,g){return Promise.resolve(this.k.call("installFromGallery",[l,g])).then(p=>w(p,null))}uninstall(l,g){return Promise.resolve(this.k.call("uninstall",[l,g]))}reinstallFromGallery(l){return Promise.resolve(this.k.call("reinstallFromGallery",[l])).then(g=>w(g,null))}getInstalled(l=null,g){return Promise.resolve(this.k.call("getInstalled",[l,g])).then(p=>p.map(b=>w(b,null)))}getMetadata(l,g){return Promise.resolve(this.k.call("getMetadata",[l,g]))}updateMetadata(l,g,p){return Promise.resolve(this.k.call("updateMetadata",[l,g,p])).then(b=>w(b,null))}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(l,g){const p=await this.k.call("download",[l,g]);return O.URI.revive(p)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class S{constructor(l){this.a=l}listen(l,g){throw new Error("Invalid listen")}call(l,g,p){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(oe[98],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class T{b(){return this.a||(this.a=new Promise((c,O)=>Q(["node-vsce-sign"],async P=>c(P),O))),this.a}async verify(c,O){let P;try{P=await this.b()}catch{return!1}return P.verify(c,O)}}e.ExtensionSignatureVerificationService=T}),define(oe[99],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function R(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var c;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(c=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[14],ae([0,1,49,13,27,12,11,166,5,4]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function C(j){return j.create===!0}e.isFileOpenForWriteOptions=C;var w;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(w=e.FileType||(e.FileType={}));var m;(function(j){j[j.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var y;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=h;function S(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=S;function u(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=u;function l(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function g(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=g;function p(j){return h(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var b;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class A extends Error{constructor(V,J){super(V),this.code=J}}e.FileSystemProviderError=A;function i(j,V){const J=new A(j.toString(),V);return t(J,V),J}e.createFileSystemProviderError=i;function r(j){return j||i((0,P.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=r;function t(j,V){return j.name=V?`${V} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=t;function n(j){if(!j)return b.Unknown;if(j instanceof A)return j.code;const V=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!V)return b.Unknown;switch(V[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=n;function s(j){if(j instanceof L)return j.fileOperationResult;switch(n(j)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class o{constructor(V,J,_){this.resource=V,this.operation=J,this.target=_}isOperation(V){return this.operation===V}}e.FileOperationEvent=o;var f;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class d{constructor(V,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const _=new Map;for(const re of V){const te=_.get(re.type);switch(te?te.push([re.resource,re]):_.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,te]of _)switch(re){case 1:this.a=D.TernarySearchTree.forUris(()=>J),this.a.fill(te);break;case 0:this.b=D.TernarySearchTree.forUris(()=>J),this.b.fill(te);break;case 2:this.c=D.TernarySearchTree.forUris(()=>J),this.c.fill(te);break}}contains(V,...J){return this.d(V,{includeChildren:!1},...J)}affects(V,...J){return this.d(V,{includeChildren:!0},...J)}d(V,J,..._){if(!V)return!1;const re=_.length>0;return!!((!re||_.includes(1))&&(this.a?.get(V)||J.includeChildren&&this.a?.findSuperstr(V))||(!re||_.includes(0))&&(this.b?.get(V)||J.includeChildren&&this.b?.findSuperstr(V))||(!re||_.includes(2))&&(this.c?.findSubstr(V)||J.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=d;function v(j,V,J){return!j||!V||j===V||V.length>j.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),J?(0,R.startsWithIgnoreCase)(j,V):j.indexOf(V)===0)}e.isParent=v;class L extends Error{constructor(V,J,_){super(V),this.fileOperationResult=J,this.options=_}}e.FileOperationError=L;class N extends L{constructor(V,J,_,re){super(V,J,re),this.fileOperationResult=J,this.size=_}}e.TooLargeFileOperationError=N;class F extends L{constructor(V,J,_){super(V,2,_),this.stat=J}}e.NotModifiedSinceFileOperationError=F;var M;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=$;async function z(j,V){if(!V.hasProvider(O.URI.from({scheme:j.scheme})))return new Promise(J=>{const _=V.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===j.scheme&&re.added&&(_.dispose(),J())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(V){return(0,c.isNumber)(V)||(V=0),V<x.KB?(0,P.localize)(1,null,V.toFixed(0)):V<x.MB?(0,P.localize)(2,null,(V/x.KB).toFixed(2)):V<x.GB?(0,P.localize)(3,null,(V/x.MB).toFixed(2)):V<x.TB?(0,P.localize)(4,null,(V/x.GB).toFixed(2)):(0,P.localize)(5,null,(V/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var X;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(X=e.Arch||(e.Arch={}));function ie(j){return{maxFileSize:j===0?300*x.MB:16*x.GB,maxHeapSize:j===0?700*x.MB:2*700*x.MB}}e.getPlatformFileLimits=ie;function H(j){return E.isWeb?j?10*x.MB:50*x.MB:j?100*x.MB:1024*x.MB}e.getLargeFileConfirmationLimit=H});var G=this&&this.__param||function(Q,e){return function(D,T){e(D,T,Q)}};define(oe[200],ae([0,1,100,44,14]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let c=class{constructor(P){this.a=P}async checksum(P){const I=(await this.a.readFileStream(P)).value;return new Promise((E,C)=>{const w=(0,D.createHash)("md5");(0,T.listenStream)(I,{onData:m=>w.update(m.buffer),onError:m=>C(m),onEnd:()=>E(w.digest("base64").replace(/=+$/,""))})})}};c=ye([G(0,R.IFileService)],c),e.ChecksumService=c}),define(oe[201],ae([0,1,17,38,9,3,2,44,11,31,14]),function(Q,e,D,T,R,c,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends O.Disposable{constructor(y,h){super(),this.a=y,this.b=h,this.onDidChangeCapabilities=c.Event.None,this.f=this.B(new c.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new c.Emitter),this.onDidWatchError=this.g.event,this.h=(0,E.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(y){return this.a.call("stat",[y])}readdir(y){return this.a.call("readdir",[y])}async readFile(y,h){const{buffer:S}=await this.a.call("readFile",[y,h]);return S}readFileStream(y,h,S){const u=(0,P.newWriteableStream)(g=>D.VSBuffer.concat(g.map(p=>D.VSBuffer.wrap(p))).buffer),l=this.a.listen("readFileStream",[y,h])(g=>{if(g instanceof D.VSBuffer)u.write(g.buffer);else{if(g==="end")u.end();else{let p;if(g instanceof Error)p=g;else{const b=g;p=(0,C.createFileSystemProviderError)(b.message??(0,T.toErrorMessage)(b),b.code??C.FileSystemProviderErrorCode.Unknown)}u.error(p),u.end()}l.dispose()}});return S.onCancellationRequested(()=>{u.error((0,R.canceled)()),u.end(),l.dispose()}),u}writeFile(y,h,S){return this.a.call("writeFile",[y,D.VSBuffer.wrap(h),S])}open(y,h){return this.a.call("open",[y,h])}close(y){return this.a.call("close",[y])}async read(y,h,S,u,l){const[g,p]=await this.a.call("read",[y,h,l]);return S.set(g.buffer.slice(0,p),u),p}write(y,h,S,u,l){return this.a.call("write",[y,h,D.VSBuffer.wrap(S),u,l])}mkdir(y){return this.a.call("mkdir",[y])}delete(y,h){return this.a.call("delete",[y,h])}rename(y,h,S){return this.a.call("rename",[y,h,S])}copy(y,h,S){return this.a.call("copy",[y,h,S])}cloneFile(y,h){return this.a.call("cloneFile",[y,h])}i(){this.B(this.a.listen("fileChange",[this.h])(y=>{if(Array.isArray(y)){const h=y;this.f.fire(h.map(S=>({resource:I.URI.revive(S.resource),type:S.type})))}else{const h=y;this.g.fire(h)}}))}watch(y,h){const S=(0,E.generateUuid)();return this.a.call("watch",[this.h,S,y,h]),(0,O.toDisposable)(()=>this.a.call("unwatch",[this.h,S]))}}e.DiskFileSystemProviderClient=w}),define(oe[101],ae([0,1,17,9,167,14]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(C,w,m,y,h,S){let u;try{await P(C,w,m,y,h,S)}catch(l){u=l}finally{u&&h.errorTransformer&&(u=h.errorTransformer(u)),typeof u<"u"&&m.error(u),m.end()}}e.readFileIntoStream=O;async function P(C,w,m,y,h,S){I(S);const u=await C.open(w,{create:!1});try{I(S);let l=0,g=0,p=h&&typeof h.length=="number"?h.length:void 0,b=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof p=="number"?p:h.bufferSize)),A=h&&typeof h.position=="number"?h.position:0,i=0;do g=await C.read(u,A,b.buffer,i,b.byteLength-i),A+=g,i+=g,l+=g,typeof p=="number"&&(p-=g),i===b.byteLength&&(await m.write(y(b)),b=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof p=="number"?p:h.bufferSize)),i=0);while(g>0&&(typeof p!="number"||p>0)&&I(S)&&E(l,h));if(i>0){let r=i;typeof p=="number"&&(r=Math.min(i,p)),m.write(y(b.slice(0,r)))}}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await C.close(u)}}function I(C){if(C.isCancellationRequested)throw(0,T.canceled)();return!0}function E(C,w){if(w?.limits){if(typeof w.limits.memory=="number"&&C>w.limits.memory)throw(0,c.createFileSystemProviderError)((0,R.localize)(0,null),c.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&C>w.limits.size)throw(0,c.createFileSystemProviderError)((0,R.localize)(1,null),c.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[56],ae([0,1,90,2,13,4,11,14]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(l){return l.recursive===!0}e.isRecursiveWatchRequest=I;class E extends T.Disposable{constructor(g,p,b,A){super(),this.h=g,this.i=p,this.j=b,this.k=A,this.c=this.B(new T.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new T.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(p=>this.h(p))),g.add(this.b.onDidLogMessage(p=>this.i(p))),g.add(this.b.onDidError(p=>this.n(p)))}n(g){this.k.restartOnError?this.g<E.a&&this.f?(this.r(`restarting watcher after error: ${g}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${g}`):this.r(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}r(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.a=5;class C extends E{constructor(g,p,b){super(g,p,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class w extends E{constructor(g,p,b){super(g,p,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function m(l){return l.map(g=>({type:g.type,resource:O.URI.file(g.path)}))}e.toFileChanges=m;function y(l){const g=new u;for(const p of l)g.processEvent(p);return g.coalesce()}e.coalesceEvents=y;function h(l,g){return typeof g=="string"&&!g.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(g)?{base:l,pattern:g}:g}e.normalizeWatcherPattern=h;function S(l,g){const p=[];for(const b of g)p.push((0,D.parse)(h(l,b)));return p}e.parseWatcherPatterns=S;class u{constructor(){this.a=new Set,this.b=new Map}c(g){return c.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const p=this.b.get(this.c(g));let b=!1;if(p){const A=p.type,i=g.type;p.path!==g.path&&(g.type===2||g.type===1)?b=!0:A===1&&i===2?(this.b.delete(this.c(g)),this.a.delete(p)):A===2&&i===1?p.type=0:A===1&&i===0||(p.type=i)}else b=!0;b&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],p=[];return Array.from(this.a).filter(b=>b.type!==2?(g.push(b),!1):!0).sort((b,A)=>b.path.length-A.path.length).filter(b=>p.some(A=>(0,P.isParent)(b.path,A,!c.isLinux))?!1:(p.push(b.path),!0)).concat(g)}}}),define(oe[202],ae([0,1,53,6,25,48,2,85,13,4,147,28,56]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends O.Disposable{constructor(u,l,g,p){super(),this.j=u,this.k=l,this.l=g,this.m=p,this.c=this.B(new T.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.k(b))),this.f=this.B(new T.RunOnceWorker(b=>this.u(b),y.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new R.CancellationTokenSource,this.ready=this.n()}async n(){try{const u=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await w.Promises.stat(u);this.B(await this.s(u,l.isDirectory()))}catch(u){u.code!=="ENOENT"?this.w(u):this.z(u)}}async r(u){let l=u.path;try{l=await w.Promises.realpath(u.path),u.path===l&&(l=await(0,C.realcase)(u.path)??u.path),u.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${l})`)}catch{}return l}async s(u,l){if(E.isMacintosh&&(0,c.isEqualOrParent)(u,"/Volumes/",!0))return this.w(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.Disposable.None;const g=new R.CancellationTokenSource(this.i.token),p=new O.DisposableStore;try{const b=(0,I.basename)(u),A=(0,D.watch)(u);p.add((0,O.toDisposable)(()=>{A.removeAllListeners(),A.close()})),this.z(`Started watching: '${u}'`);const i=new Set;if(l)try{for(const t of await w.Promises.readdir(u))i.add(t)}catch(t){this.w(t)}const r=new Map;p.add((0,O.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),A.on("error",(t,n)=>{this.w(`Failed to watch ${u} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),A.on("change",(t,n)=>{if(g.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${n}`);let s="";if(n&&(s=n.toString(),E.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){r.get(s)?.dispose();const a=setTimeout(async()=>{if(r.delete(s),s===b&&!await w.Promises.exists(u)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,I.join)(u,s));if(g.token.isCancellationRequested)return;let f;o?i.has(s)?f=0:(f=1,i.add(s)):(i.delete(s),f=2),this.t({path:(0,I.join)(this.j.path,s),type:f})},y.a);r.set(s,(0,O.toDisposable)(()=>clearTimeout(a)))}else{let a;i.has(s)?a=0:(a=1,i.add(s)),this.t({path:(0,I.join)(this.j.path,s),type:a})}else if(t==="rename"||s!==b){const a=setTimeout(async()=>{const o=await w.Promises.exists(u);g.token.isCancellationRequested||(o?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(u,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},y.a);p.clear(),p.add((0,O.toDisposable)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(b){await w.Promises.exists(u)&&!g.token.isCancellationRequested&&this.w(`Failed to watch ${u} for changes using fs.watch() (${b.toString()})`)}return(0,O.toDisposable)(()=>{g.dispose(!0),p.dispose()})}t(u,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`),!l&&this.g.some(g=>g(u.path))?this.m&&this.z(` >> ignored (excluded) ${u.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(g=>g(u.path))?this.m&&this.z(` >> ignored (not included) ${u.path}`):this.f.work(u))}u(u){const l=(0,m.coalesceEvents)(u);if(l.length>0){if(this.m)for(const p of l)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(u){if(E.isLinux)return w.Promises.exists(u);try{const l=(0,I.basename)(u);return(await w.Promises.readdir((0,I.dirname)(u))).some(p=>p===l)}catch(l){return this.z(l),!1}}setVerboseLogging(u){this.m=u}w(u){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}y(u){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}z(u){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.a=100,y.b=75;async function h(S,u,l,g,p=512){const b=await w.Promises.open(S,"r"),A=Buffer.allocUnsafe(p),i=new R.CancellationTokenSource(g);let r,t=!1;const n={path:S,excludes:[],recursive:!1},s=new y(n,a=>{(async()=>{for(const{type:o}of a)if(o===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:f}=await w.Promises.read(b,A,0,p,null);if(!f||i.token.isCancellationRequested)break;u(A.slice(0,f))}}catch(f){r=new Error(f),i.dispose(!0)}finally{t=!1}}})()});return await s.ready,l(),new Promise((a,o)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await w.Promises.close(b)}catch(f){r=new Error(f)}r?o(r):a()})})}e.watchFileContents=h}),define(oe[203],ae([0,1,3,90,2,4,202]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new D.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(E){const C=this.i(E),w=C.filter(y=>{const h=this.c.get(y.path);return h?!(0,T.patternsEquals)(h.request.excludes,y.excludes)||!(0,T.patternsEquals)(h.request.includes,y.includes):!0}),m=Array.from(this.c.values()).filter(({request:y})=>!C.find(h=>h.path===y.path&&(0,T.patternsEquals)(h.excludes,y.excludes)&&(0,T.patternsEquals)(h.includes,y.includes))).map(({request:y})=>y.path);w.length&&this.j(`Request to start watching: ${w.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const y of m)this.h(y);for(const y of w)this.g(y)}g(E){const C=new O.NodeJSFileWatcherLibrary(E,m=>this.a.fire(m),m=>this.b.fire(m),this.f),w={request:E,instance:C};this.c.set(E.path,w)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const C=this.c.get(E);C&&(this.c.delete(E),C.instance.dispose())}i(E){const C=new Map;for(const w of E){const m=c.isLinux?w.path:w.path.toLowerCase();C.set(m,w)}return Array.from(C.values())}async setVerboseLogging(E){this.f=E;for(const[,C]of this.c)C.instance.setVerboseLogging(E)}j(E){this.f&&this.b.fire({type:"trace",message:this.k(E)})}k(E,C){return C?`[File Watcher (node.js)] ${E} (path: ${C.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=P}),define(oe[204],ae([0,1,56,203]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(O,P,I){super(O,P,I),this.m()}l(){return new T.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(oe[205],ae([0,1,26,39,68,56]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends c.AbstractUniversalWatcherClient{constructor(I,E,C){super(I,E,C),this.m()}l(I){const E=I.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(E.onDidProcessExit(({code:C,signal:w})=>this.n(`terminated by itself with code ${C}, signal: ${w}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(oe[72],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this.a=new Map;for(const[c,O]of R)this.set(c,O)}set(R,c){const O=this.a.get(R);return this.a.set(R,c),O}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.ServiceCollection=D}),define(oe[206],ae([0,1,6,9,2,55,196,5,72,84]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class w extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class m{constructor(u=new I.ServiceCollection,l=!1,g,p=C){this.f=u,this.g=l,this.h=g,this.i=p,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=p?g?._globalGraph??new O.Graph(b=>b):void 0}createChild(u){return new m(u,this.g,this,this.i)}invokeFunction(u,...l){const g=h.traceInvocation(this.i,u);let p=!1;try{return u({get:A=>{if(p)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(A,g);if(!i)throw new Error(`[invokeFunction] unknown service '${A}'`);return i}},...l)}finally{p=!0,g.stop()}}createInstance(u,...l){let g,p;return u instanceof c.SyncDescriptor?(g=h.traceCreation(this.i,u.ctor),p=this.j(u.ctor,u.staticArguments.concat(l),g)):(g=h.traceCreation(this.i,u),p=this.j(u,l,g)),g.stop(),p}j(u,l=[],g){const p=P._util.getServiceDependencies(u).sort((i,r)=>i.index-r.index),b=[];for(const i of p){const r=this.m(i.id,g);r||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${i.id}.`,!1),b.push(r)}const A=p.length>0?p[0].index:l.length;if(l.length!==A){console.trace(`[createInstance] First service dependency of ${u.name} at position ${A+1} conflicts with ${l.length} static arguments`);const i=A-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,A)}return Reflect.construct(u,l.concat(b))}k(u,l){if(this.f.get(u)instanceof c.SyncDescriptor)this.f.set(u,l);else if(this.h)this.h.k(u,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const l=this.f.get(u);return!l&&this.h?this.h.l(u):l}m(u,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const g=this.l(u);return g instanceof c.SyncDescriptor?this.q(u,g,l.branch(u,!0)):(l.branch(u,!1),g)}q(u,l,g){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,l,g)}finally{this.o.delete(u)}}r(u,l,g){const p=new O.Graph(i=>i.id.toString());let b=0;const A=[{id:u,desc:l,_trace:g}];for(;A.length;){const i=A.pop();if(p.lookupOrInsertNode(i),b++>1e3)throw new w(p);for(const r of P._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof c.SyncDescriptor){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};p.insertEdge(i,n),A.push(n)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:r}of i){if(this.l(r.id)instanceof c.SyncDescriptor){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}p.removeNode(r)}}return this.l(u)}s(u,l,g=[],p,b){if(this.f.get(u)instanceof c.SyncDescriptor)return this.t(u,l,g,p,b);if(this.h)return this.h.s(u,l,g,p,b);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(u,l,g=[],p,b){if(p){const A=new m(void 0,this.g,this,this.i);A.c=String(u);const i=new Map,r=new D.IdleValue(()=>{const t=A.j(l,g,b);for(const[n,s]of i){const a=t[n];if(typeof a=="function")for(const o of s)a.apply(t,o)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=i.get(n);return o||(o=new E.LinkedList,i.set(n,o)),(d,v,L)=>{const N=o.push([d,v,L]);return(0,R.toDisposable)(N)}}if(n in t)return t[n];const s=r.value;let a=s[n];return typeof a!="function"||(a=a.bind(s),t[n]=a),a},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,g,b)}u(u,l){if(l&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=m;var y;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(y||(y={}));class h{static traceInvocation(u,l){return u?new h(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(u,l){return u?new h(1,l.name):h.c}constructor(u,l){this.type=u,this.name=l,this.g=Date.now(),this.h=[]}branch(u,l){const g=new h(3,u.toString());return this.h.push([u,l,g]),g}stop(){const u=Date.now()-this.g;h.f+=u;let l=!1;function g(b,A){const i=[],r=new Array(b+1).join("	");for(const[t,n,s]of A.h)if(n&&s){l=!0,i.push(`${r}CREATES -> ${t}`);const a=g(b+1,s);a&&i.push(a)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(u>2||l)&&h.all.add(p.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h.f=0}),define(oe[207],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,c){this.a=R,this.b=c}getChannel(R){return this.a.getChannel(R,this.b)}registerChannel(R,c){this.a.registerChannel(R,c)}}e.MessagePortMainProcessService=D}),define(oe[57],ae([0,1,39,55,71,5]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(y,h,S,u){const l=S.getChannel(y);return P(h)?u.createInstance(new T.SyncDescriptor(h.channelClientCtor,[l])):D.ProxyChannel.toService(l,h?.proxyOptions)}}function P(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,c.createDecorator)("mainProcessService");let I=class extends O{constructor(y,h,S,u){super(y,h,S,u)}};I=ye([G(2,e.IMainProcessService),G(3,c.IInstantiationService)],I);function E(m,y,h){(0,R.registerSingleton)(m,new T.SyncDescriptor(I,[y,h],!0))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,c.createDecorator)("sharedProcessService");let C=class extends O{constructor(y,h,S,u){super(y,h,S,u)}};C=ye([G(2,e.ISharedProcessService),G(3,c.IInstantiationService)],C);function w(m,y,h){(0,R.registerSingleton)(m,new T.SyncDescriptor(C,[y,h],!0))}e.registerSharedProcessRemoteService=w}),define(oe[73],ae([0,1,25,2,4,169,30,5]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(C){return C.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let E=class extends T.Disposable{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new D.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const h=m.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(u=>u.startsWith("lp-"))).map(S=>{const u=S.properties.localizedLanguages?.[0],l=I(S);return{...this.f(l,u,S),extensionId:S.identifier.id,galleryExtension:S}});return h.push({...this.f("en","English"),extensionId:"default"}),h}f(w,m,y){const h=m??w;let S;if(h!==w&&(S=`(${w})`),w.toLowerCase()===R.language.toLowerCase()&&(S??="",S+=(0,c.localize)(0,null)),y?.installCount){S??="";const u=y.installCount;let l;u>1e6?l=`${Math.floor(u/1e5)/10}M`:u>1e3?l=`${Math.floor(u/1e3)}K`:l=String(u),S+=` $(cloud-download) ${l}`}return{id:w,label:h,description:S}}};E=ye([G(0,O.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(oe[208],ae([0,1,2,73]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};R=ye([G(0,T.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(oe[8],ae([0,1,38,3,2,37,4,12,11,5]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function C(){return new Date().toISOString()}function w(f){return(0,P.isNumber)(f)}e.isLogLevel=w;var m;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function y(f,d,v){switch(d){case m.Trace:f.trace(v);break;case m.Debug:f.debug(v);break;case m.Info:f.info(v);break;case m.Warning:f.warn(v);break;case m.Error:f.error(v);break;case m.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=y;function h(f){let d="";for(let v=0;v<f.length;v++){let L=f[v];if(typeof L=="object")try{L=JSON.stringify(L)}catch{}d+=(v>0?" ":"")+L}return d}e.format=h;class S extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==m.Off&&this.b<=d}}e.AbstractLogger=S;class u extends S{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...v){this.f(m.Trace)&&this.g(m.Trace,h([d,...v]))}debug(d,...v){this.f(m.Debug)&&this.g(m.Debug,h([d,...v]))}info(d,...v){this.f(m.Info)&&this.g(m.Info,h([d,...v]))}warn(d,...v){this.f(m.Warning)&&this.g(m.Warning,h([d,...v]))}error(d,...v){if(this.f(m.Error))if(d instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=d.stack,this.g(m.Error,h(L))}else this.g(m.Error,h([d,...v]))}flush(){}}e.AbstractMessageLogger=u;class l extends S{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.g=!O.isWindows}trace(d,...v){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,d,...v):console.log(`[main ${C()}]`,d,...v))}debug(d,...v){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,d,...v):console.log(`[main ${C()}]`,d,...v))}info(d,...v){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,d,...v):console.log(`[main ${C()}]`,d,...v))}warn(d,...v){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,d,...v):console.warn(`[main ${C()}]`,d,...v))}error(d,...v){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,d,...v):console.error(`[main ${C()}]`,d,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=l;class g extends S{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d)}trace(d,...v){this.f(m.Trace)&&console.log("%cTRACE","color: #888",d,...v)}debug(d,...v){this.f(m.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",d,...v)}info(d,...v){this.f(m.Info)&&console.log("%c INFO","color: #33f",d,...v)}warn(d,...v){this.f(m.Warning)&&console.log("%c WARN","color: #993",d,...v)}error(d,...v){this.f(m.Error)&&console.log("%c  ERR","color: #f33",d,...v)}dispose(){}flush(){}}e.ConsoleLogger=g;class p extends S{constructor(d,v=e.DEFAULT_LOG_LEVEL){super(),this.g=d,this.setLevel(v)}trace(d,...v){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(d),...v])}debug(d,...v){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(d),...v])}info(d,...v){this.f(m.Info)&&this.g.log(m.Info,[this.h(d),...v])}warn(d,...v){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(d),...v])}error(d,...v){this.f(m.Error)&&this.g.log(m.Error,[this.h(d),...v])}h(d){return typeof d=="string"?d:(0,D.toErrorMessage)(d,this.f(m.Trace))}dispose(){}flush(){}}e.AdapterLogger=p;class b extends S{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const v of this.g)v.setLevel(d);super.setLevel(d)}trace(d,...v){for(const L of this.g)L.trace(d,...v)}debug(d,...v){for(const L of this.g)L.debug(d,...v)}info(d,...v){for(const L of this.g)L.info(d,...v)}warn(d,...v){for(const L of this.g)L.warn(d,...v)}error(d,...v){for(const L of this.g)L.error(d,...v)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.MultiplexLogger=b;class A extends R.Disposable{constructor(d,v){if(super(),this.j=d,this.b=new c.ResourceMap,this.c=new c.ResourceMap,this.f=this.B(new T.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeVisibility=this.h.event,v)for(const L of v)this.c.set(L.resource,L)}getLogger(d){return this.b.get(d)}createLogger(d,v,L){let N=this.b.get(d);if(!N){const F=v?.logLevel==="always"?m.Trace:v?.logLevel;N=this.k(d,F??this.getLogLevel(d)??this.j,v),this.b.set(d,N),L||this.registerLogger({resource:d,id:v?.id??d.toString(),logLevel:F,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId})}return N}setLogLevel(d,v){if(I.URI.isUri(d)){const L=d,N=v,F=this.c.get(L);F&&N!==F.logLevel&&(F.logLevel=N===this.j?void 0:N,this.b.get(L)?.setLevel(N),this.c.set(F.resource,F),this.g.fire([L,N]))}else{this.j=d;for(const[L,N]of this.b.entries())this.c.get(L)?.logLevel===void 0&&N.setLevel(this.j);this.g.fire(this.j)}}setVisibility(d,v){const L=this.c.get(d);L&&v!==!L.hidden&&(L.hidden=!v,this.c.set(L.resource,L),this.h.fire([d,v]))}getLogLevel(d){let v;return d&&(v=this.c.get(d)?.logLevel),v??this.j}registerLogger(d){const v=this.c.get(d.resource);v?v.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.c.set(d.resource,d),this.f.fire({added:[d],removed:[]}))}deregisterLogger(d){const v=this.c.get(d);if(v){this.c.delete(d);const L=this.b.get(d);L&&(this.b.delete(d),L.dispose()),this.f.fire({added:[],removed:[v]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(d){return this.c.get(d)}dispose(){this.b.forEach(d=>d.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=A;class i{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(d){}getLevel(){return m.Info}trace(d,...v){}debug(d,...v){}info(d,...v){}warn(d,...v){}error(d,...v){}critical(d,...v){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;class t extends A{constructor(){super(m.Info)}k(d,v,L){return new i}}e.NullLoggerService=t;function n(f){if(f.verbose)return m.Trace;if(typeof f.logLevel=="string"){const d=a(f.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function s(f){switch(f){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=s;function a(f){switch(f){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=a;function o(f,d){w(d)?f.setLogLevel(d):f.setLogLevel(d[0],d[1])}e.setLogLevel=o}),define(oe[209],ae([0,1,6,9,2,13,28,15,8]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(w,m){super(),this.a=w,this.b=m,this.B(new D.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,c.basename)(this.a.logsPath),m=(0,c.dirname)(this.a.logsPath),S=(await O.Promises.readdir(m)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==w),u=S.slice(0,Math.max(0,S.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(l=>O.Promises.rm((0,c.join)(m,l)))))}catch(w){(0,T.onUnexpectedError)(w)}}};E=ye([G(0,P.IEnvironmentService),G(1,I.ILogService)],E),e.LogsDataCleaner=E}),define(oe[210],ae([0,1,21,6,9,3,2,13,56,8]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends O.Disposable{constructor(m,y){super(),this.a=m,this.b=y,this.c=this.B(new c.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new c.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new T.ThrottledDelayer(0)),this.s=[],this.t=this.B(new T.ThrottledDelayer(0))}watch(m,y){return y.recursive||this.b?.watcher?.forceUniversal?this.l(m,y):this.u(m,y)}l(m,y){const h={path:this.C(m),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,D.insert)(this.j,h);return this.m(),(0,O.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,R.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(y=>this.c.fire((0,I.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const y of this.j)(0,I.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const y of this.j)(0,I.isRecursiveWatchRequest)(y)&&m.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,y){const h={path:this.C(m),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,D.insert)(this.s,h);return this.v(),(0,O.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,R.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,I.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,P.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(oe[211],ae([0,1,21,6,17,25,3,66,64,2,49,26,102,22,44,165,14,101,8,9]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class extends E.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new O.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new O.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new O.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new T.ResourceQueue)}registerProvider(i,r){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const t=new E.DisposableStore;return this.h.set(i,r),this.c.fire({added:!0,scheme:i,provider:r}),t.add(r.onDidChangeFile(n=>this.R.fire(new u.FileChangesEvent(n,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.S.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:i}))),(0,E.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:r}),this.h.delete(i),(0,E.dispose)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const r=[];this.f.fire({scheme:i,join(t){r.push(t)}}),!this.h.has(i)&&await T.Promises.settled(r)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,r){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return I.Iterable.map(this.h,([i,r])=>({scheme:i,capabilities:r.capabilities}))}async j(i){if(!(0,y.isAbsolutePath)(i))throw new u.FileOperationError((0,S.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const r=this.h.get(i.scheme);if(!r){const t=new p.ErrorNoTelemetry;throw t.message=(0,S.localize)(1,null,i.toString()),t}return r}async k(i){const r=await this.j(i);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r)||(0,u.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const r=await this.j(i);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,r){try{return await this.n(i,r)}catch(t){throw(0,u.toFileSystemProviderErrorCode)(t)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,S.localize)(2,null,this.nb(i)),1):(0,u.ensureFileSystemProviderError)(t)}}async n(i,r){const t=await this.j(i),n=this.O(t),s=r?.resolveTo,a=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,f=await t.stat(i);let d;return this.p(t,i,f,void 0,!!o,(v,L)=>(d||(d=C.TernarySearchTree.forUris(()=>!n),d.set(i,!0),s&&d.fill(!0,s)),d.get(v.resource)||d.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&a?L===1:!1))}async p(i,r,t,n,s,a){const{providerExtUri:o}=this.N(i),f={resource:r,name:o.basename(r),isFile:(t.type&u.FileType.File)!==0,isDirectory:(t.type&u.FileType.Directory)!==0,isSymbolicLink:(t.type&u.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&u.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,u.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(f.isDirectory&&a(f,n)){try{const d=await i.readdir(r),v=await T.Promises.settled(d.map(async([L,N])=>{try{const F=o.joinPath(r,L),M=s?await i.stat(F):{type:N};return await this.p(i,F,M,d.length,s,a)}catch(F){return this.b.trace(F),null}}));f.children=(0,D.coalesce)(v)}catch(d){this.b.trace(d),f.children=[]}return f}return f}async resolveAll(i){return T.Promises.settled(i.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const r=await this.j(i),t=await r.stat(i);return this.p(r,i,t,void 0,!0,()=>!1)}async exists(i){const r=await this.j(i);try{return!!await r.stat(i)}catch{return!1}}async canCreateFile(i,r){try{await this.r(i,r)}catch(t){return t}return!0}async r(i,r){if(!r?.overwrite&&await this.exists(i))throw new u.FileOperationError((0,S.localize)(3,null,this.nb(i)),3,r)}async createFile(i,r=R.VSBuffer.fromString(""),t){await this.r(i,t);const n=await this.writeFile(i,r);return this.m.fire(new u.FileOperationEvent(i,0,n)),n}async writeFile(i,r,t){const n=this.lb(await this.l(i),i),{providerExtUri:s}=this.N(n);try{await this.s(n,i,t)||await this.P(n,s.dirname(i));let o;if((0,u.hasReadWriteCapability)(n)&&!(r instanceof R.VSBuffer))if((0,h.isReadableStream)(r)){const f=await(0,h.peekStream)(r,3);f.ended?o=R.VSBuffer.concat(f.buffer):o=f}else o=(0,h.peekReadable)(r,f=>R.VSBuffer.concat(f),3);else o=r;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&o instanceof R.VSBuffer?await this.cb(n,i,t,o):await this.Y(n,i,t,o instanceof R.VSBuffer?(0,R.bufferToReadable)(o):o),this.m.fire(new u.FileOperationEvent(i,4))}catch(a){throw new u.FileOperationError((0,S.localize)(4,null,this.nb(i),(0,u.ensureFileSystemProviderError)(a).toString()),(0,u.toFileOperationResult)(a),t)}return this.resolve(i,{resolveMetadata:!0})}async s(i,r,t){if(!!t?.unlock&&!(i.capabilities&8192))throw new Error((0,S.localize)(5,null,this.nb(r)));let s;try{s=await i.stat(r)}catch{return}if((s.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,S.localize)(6,null,this.nb(r)),0,t);if(this.mb(r,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==u.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,u.etag)({mtime:t.mtime,size:s.size}))throw new u.FileOperationError((0,S.localize)(7,null),3,t);return s}async readFile(i,r,t){const n=await this.k(i);return r?.atomic?this.t(n,i,r,t):this.u(n,i,r,t)}async t(i,r,t,n){return new Promise((s,a)=>{this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{try{const o=await this.u(i,r,t,n);s(o)}catch(o){a(o)}})})}async u(i,r,t,n){const s=await this.v(i,r,{...t,preferUnbuffered:!0},n);return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(i,r,t){const n=await this.k(i);return this.v(n,i,r,t)}async v(i,r,t,n){const s=new c.CancellationTokenSource(n),a=this.F(r,t).then(f=>f,f=>{throw s.cancel(),f});let o;try{return typeof t?.etag=="string"&&t.etag!==u.ETAG_DISABLED&&await a,t?.atomic&&(0,u.hasFileAtomicReadCapability)(i)||!((0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasFileReadStreamCapability)(i))||(0,u.hasReadWriteCapability)(i)&&t?.preferUnbuffered?o=this.D(i,r,t):(0,u.hasFileReadStreamCapability)(i)?o=this.z(i,r,s.token,t):o=this.C(i,r,s.token,t),{...await a,value:o}}catch(f){throw o&&await(0,h.consumeStream)(o),this.w(f,r,t)}}w(i,r,t){const n=(0,S.localize)(8,null,this.nb(r),(0,u.ensureFileSystemProviderError)(i).toString());return i instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(n,i.stat,t):i instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(n,i.fileOperationResult,i.size,i.options):new u.FileOperationError(n,(0,u.toFileOperationResult)(i),t)}z(i,r,t,n=Object.create(null)){const s=i.readFileStream(r,n,t);return(0,h.transform)(s,{data:a=>a instanceof R.VSBuffer?a:R.VSBuffer.wrap(a),error:a=>this.w(a,r,n)},a=>R.VSBuffer.concat(a))}C(i,r,t,n=Object.create(null)){const s=(0,R.newWriteableBufferStream)();return(0,l.readFileIntoStream)(i,r,s,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,r,n)},t),s}D(i,r,t){const n=(0,h.newWriteableStream)(s=>R.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,u.hasFileAtomicReadCapability)(i)?s=await i.readFile(r,{atomic:!0}):s=await i.readFile(r),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(r,s.byteLength,t),n.end(R.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async F(i,r){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new u.FileOperationError((0,S.localize)(9,null,this.nb(i)),0,r);if(typeof r?.etag=="string"&&r.etag!==u.ETAG_DISABLED&&r.etag===t.etag)throw new u.NotModifiedSinceFileOperationError((0,S.localize)(10,null),t,r);return this.G(i,t.size,r),t}G(i,r,t){if(t?.limits){let n;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&r>t.limits.size&&(n=7),typeof n=="number")throw new u.TooLargeFileOperationError((0,S.localize)(11,null,this.nb(i)),n,r,t)}}async canMove(i,r,t){return this.H(i,r,"move",t)}async canCopy(i,r,t){return this.H(i,r,"copy",t)}async H(i,r,t,n){if(i.toString()!==r.toString())try{const s=t==="move"?this.lb(await this.l(i),i):await this.k(i),a=this.lb(await this.l(r),r);await this.M(s,i,a,r,t,n)}catch(s){return s}return!0}async move(i,r,t){const n=this.lb(await this.l(i),i),s=this.lb(await this.l(r),r),a=await this.I(n,i,s,r,"move",!!t),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(i,a==="move"?2:3,o)),o}async copy(i,r,t){const n=await this.k(i),s=this.lb(await this.l(r),r),a=await this.I(n,i,s,r,"copy",!!t),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(i,a==="copy"?3:2,o)),o}async I(i,r,t,n,s,a){if(r.toString()===n.toString())return s;const{exists:o,isSameResourceWithDifferentPathCase:f}=await this.M(i,r,t,n,s,a);if(o&&!f&&a&&await this.del(n,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(n)),s==="copy"){if(i===t&&(0,u.hasFileFolderCopyCapability)(i))await i.copy(r,n,{overwrite:a});else{const d=await this.resolve(r);d.isDirectory?await this.L(i,d,t,n):await this.J(i,r,t,n)}return s}else return i===t?(await i.rename(r,n,{overwrite:a}),s):(await this.I(i,r,t,n,"copy",a),await this.del(r,{recursive:!0}),"copy")}async J(i,r,t,n){if((0,u.hasOpenReadWriteCloseCapability)(i)&&(0,u.hasOpenReadWriteCloseCapability)(t))return this.eb(i,r,t,n);if((0,u.hasOpenReadWriteCloseCapability)(i)&&(0,u.hasReadWriteCapability)(t))return this.kb(i,r,t,n);if((0,u.hasReadWriteCapability)(i)&&(0,u.hasOpenReadWriteCloseCapability)(t))return this.ib(i,r,t,n);if((0,u.hasReadWriteCapability)(i)&&(0,u.hasReadWriteCapability)(t))return this.gb(i,r,t,n)}async L(i,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await T.Promises.settled(r.children.map(async s=>{const a=this.N(t).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.L(i,await this.resolve(s.resource),t,a):this.J(i,s.resource,t,a)}))}async M(i,r,t,n,s,a){let o=!1;if(i===t){const{providerExtUri:d,isPathCaseSensitive:v}=this.N(i);if(v||(o=d.isEqual(r,n)),o&&s==="copy")throw new Error((0,S.localize)(12,null,this.nb(r),this.nb(n)));if(!o&&d.isEqualOrParent(n,r))throw new Error((0,S.localize)(13,null,this.nb(r),this.nb(n)))}const f=await this.exists(n);if(f&&!o){if(!a)throw new u.FileOperationError((0,S.localize)(14,null,this.nb(r),this.nb(n)),4);if(i===t){const{providerExtUri:d}=this.N(i);if(d.isEqualOrParent(r,n))throw new Error((0,S.localize)(15,null,this.nb(r),this.nb(n)))}}return{exists:f,isSameResourceWithDifferentPathCase:o}}N(i){const r=this.O(i);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const r=this.lb(await this.j(i),i);await this.P(r,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(i,0,t)),t}async P(i,r){const t=[],{providerExtUri:n}=this.N(i);for(;!n.isEqual(r,n.dirname(r));)try{if(((await i.stat(r)).type&u.FileType.Directory)===0)throw new Error((0,S.localize)(16,null,this.nb(r)));break}catch(s){if((0,u.toFileSystemProviderErrorCode)(s)!==u.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(n.basename(r)),r=n.dirname(r)}for(let s=t.length-1;s>=0;s--){r=n.joinPath(r,t[s]);try{await i.mkdir(r)}catch(a){if((0,u.toFileSystemProviderErrorCode)(a)!==u.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,r){try{await this.Q(i,r)}catch(t){return t}return!0}async Q(i,r){const t=this.lb(await this.j(i),i);if(!!r?.useTrash&&!(t.capabilities&4096))throw new Error((0,S.localize)(17,null,this.nb(i)));let s;try{s=await t.stat(i)}catch{}if(s)this.mb(i,s);else throw new u.FileOperationError((0,S.localize)(18,null,this.nb(i)),1);if(!!!r?.recursive){const o=await this.resolve(i);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,S.localize)(19,null,this.nb(i)))}return t}async del(i,r){const t=await this.Q(i,r),n=!!r?.useTrash,s=!!r?.recursive;await t.delete(i,{recursive:s,useTrash:n}),this.m.fire(new u.FileOperationEvent(i,1))}async cloneFile(i,r){const t=await this.j(i),n=this.lb(await this.l(r),r);if(t===n&&this.N(t).providerExtUri.isEqual(i,r))return;if(t===n&&(0,u.hasFileCloneCapability)(t))return t.cloneFile(i,r);await this.P(n,this.N(n).providerExtUri.dirname(r));const s=this.X.queueFor(i,this.N(t).providerExtUri);return t===n&&(0,u.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(i,r,{overwrite:!0})):s.queue(()=>this.J(t,i,n,r))}watch(i,r={recursive:!1,excludes:[]}){const t=new E.DisposableStore;let n=!1,s=()=>{n=!0};return t.add((0,E.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(i,r);n?(0,E.dispose)(a):s=()=>(0,E.dispose)(a)}catch(a){this.b.error(a)}})(),t}async W(i,r){const t=await this.j(i),n=(0,P.hash)([this.N(t).providerExtUri.getComparisonKey(i),r]);let s=this.U.get(n);return s||(s={count:0,disposable:t.watch(i,r)},this.U.set(n,s)),s.count+=1,(0,E.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,E.dispose)(s.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,E.dispose)(i.disposable);this.U.clear()}async Y(i,r,t,n){return this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{const s=await i.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,h.isReadableStream)(n)||(0,h.isReadableBufferedStream)(n)?await this.Z(i,s,n):await this.ab(i,s,n)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await i.close(s)}})}async Z(i,r,t){let n=0,s;if((0,h.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=R.VSBuffer.concat(t.buffer);await this.bb(i,r,a,a.byteLength,n,0),n+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((a,o)=>{(0,h.listenStream)(s,{onData:async f=>{s.pause();try{await this.bb(i,r,f,f.byteLength,n,0)}catch(d){return o(d)}n+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>o(f),onEnd:()=>a()})})}async ab(i,r,t){let n=0,s;for(;(s=t.read())!==null;)await this.bb(i,r,s,s.byteLength,n,0),n+=s.byteLength}async bb(i,r,t,n,s,a){let o=0;for(;o<n;)o+=await i.write(r,s+o,t.buffer,a+o,n-o)}async cb(i,r,t,n){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.db(i,r,t,n))}async db(i,r,t,n){let s;n instanceof R.VSBuffer?s=n:(0,h.isReadableStream)(n)?s=await(0,R.streamToBuffer)(n):(0,h.isReadableBufferedStream)(n)?s=await(0,R.bufferedStreamToBuffer)(n):s=(0,R.readableToBuffer)(n),await i.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(i,r,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.fb(i,r,t,n))}async fb(i,r,t,n){let s,a;try{s=await i.open(r,{create:!1}),a=await t.open(n,{create:!0,unlock:!1});const o=R.VSBuffer.alloc(this.a);let f=0,d=0,v=0;do v=await i.read(s,f,o.buffer,d,o.byteLength-d),await this.bb(t,a,o,v,f,d),f+=v,d+=v,d===o.byteLength&&(d=0);while(v>0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await T.Promises.settled([typeof s=="number"?i.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async gb(i,r,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.hb(i,r,t,n))}async hb(i,r,t,n){return t.writeFile(n,await i.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(i,r,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.jb(i,r,t,n))}async jb(i,r,t,n){const s=await t.open(n,{create:!0,unlock:!1});try{const a=await i.readFile(r);await this.bb(t,s,R.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await t.close(s)}}async kb(i,r,t,n){const s=await(0,R.streamToBuffer)(this.C(i,r,c.CancellationToken.None));await this.cb(t,n,void 0,s)}lb(i,r){if(i.capabilities&2048)throw new u.FileOperationError((0,S.localize)(20,null,this.nb(r)),6);return i}mb(i,r){if((r.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,S.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===w.Schemas.file?i.fsPath:i.toString(!0)}};b=ye([G(0,g.ILogService)],b),e.FileService=b}),define(oe[212],ae([0,1,53,294,6,37,17,3,48,2,13,4,22,44,28,168,14,101,210,38,205,204]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(r)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.H=new c.ResourceMap(s=>m.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,w.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:n,symbolicLink:s}=await h.SymlinkSupport.stat(this.C(t));return{type:this.G(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(t){try{const n=await h.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,m.joinPath)(t,a.name))).type:o=this.G(a),s.push([a.name,o])}catch(o){this.a.trace(o)}})),s}catch(n){throw this.Y(n)}}G(t,n){let s;return n?.dangling?s=u.FileType.Unknown:t.isFile()?s=u.FileType.File:t.isDirectory()?s=u.FileType.Directory:s=u.FileType.Unknown,n&&(s|=u.FileType.SymbolicLink),s}async I(t){const n=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const a=new R.Barrier;return this.H.set(t,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,E.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(t)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.I(t));const a=this.C(t);return await h.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(t){i.D&&this.a.trace(t)}readFileStream(t,n,s){const a=(0,y.newWriteableStream)(o=>O.VSBuffer.concat(o.map(f=>O.VSBuffer.wrap(f))).buffer);return(0,l.readFileIntoStream)(this,t,a,o=>o.buffer,{...n,bufferSize:256*1024},s),a}async writeFile(t,n,s){let a;try{const o=this.C(t);if(!s.create||!s.overwrite){if(await h.Promises.exists(o)){if(!s.overwrite)throw(0,u.createFileSystemProviderError)((0,S.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,u.createFileSystemProviderError)((0,S.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(o){throw await this.Z(t,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){i.O=t}async open(t,n){const s=this.C(t);let a;(0,u.isFileOpenForWriteOptions)(n)&&(a=await this.I(t));let o;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:d}=await h.SymlinkSupport.stat(s);d.mode&128||await h.Promises.chmod(s,d.mode|128)}catch(d){this.a.trace(d)}let f;if((0,u.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await h.Promises.truncate(s,0),f="r+"}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}f||(f="w")}else f="r";o=await h.Promises.open(s,f)}catch(f){throw a?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.Z(t,f):this.Y(f)}if(this.L.set(o,0),(0,u.isFileOpenForWriteOptions)(n)&&this.N.set(o,t),a){const f=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,a),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),f.dispose())}return o}async close(t){const n=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&i.O)try{await h.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await h.Promises.close(t)}catch(s){throw this.Y(s)}finally{n&&(this.M.get(t)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,a,o){const f=this.P(t,n);let d=null;try{d=(await h.Promises.read(t,s,a,o,f)).bytesRead}catch(v){throw this.Y(v)}finally{this.Q(t,f,d)}return d}P(t,n){return n===this.L.get(t)?null:n}Q(t,n,s){const a=this.L.get(t);typeof a=="number"&&(typeof n=="number"||(typeof s=="number"?this.L.set(t,a+s):this.L.delete(t)))}async write(t,n,s,a,o){return(0,R.retry)(()=>this.R(t,n,s,a,o),100,3)}async R(t,n,s,a,o){const f=this.P(t,n);let d=null;try{d=(await h.Promises.write(t,s,a,o,f)).bytesWritten}catch(v){throw await this.Z(this.N.get(t),v)}finally{this.Q(t,f,d)}return d}async mkdir(t){try{await h.Promises.mkdir(this.C(t))}catch(n){throw this.Y(n)}}async delete(t,n){try{const s=this.C(t);n.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,n,s){const a=this.C(t),o=this.C(n);if(a!==o)try{await this.S(t,n,"move",s.overwrite),await h.Promises.move(a,o)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,S.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(o)),f.toString()))),this.Y(f)}}async copy(t,n,s){const a=this.C(t),o=this.C(n);if(a!==o)try{await this.S(t,n,"copy",s.overwrite),await h.Promises.copy(a,o,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,S.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(o)),f.toString()))),this.Y(f)}}async S(t,n,s,a){const o=this.C(t),f=this.C(n);let d=!1;if(!!(this.capabilities&1024)||(d=(0,I.isEqual)(o,f,!0)),d&&s==="copy")throw(0,u.createFileSystemProviderError)((0,S.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!d&&await h.Promises.exists(f)){if(!a)throw(0,u.createFileSystemProviderError)((0,S.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.U(t,n,!1)}async U(t,n,s){const a=this.C(t),o=this.C(n),f=!!(this.capabilities&1024);if((0,I.isEqual)(a,o,!f))return;const d=new E.DisposableStore;try{const[v,L]=await Promise.all([this.I(t),this.I(n)]);d.add(v),d.add(L),s&&await h.Promises.mkdir((0,C.dirname)(o),{recursive:!0}),await h.Promises.copyFile(a,o)}catch(v){if(v.code==="ENOENT"&&!s)return this.U(t,n,!0);throw this.Y(v)}finally{d.dispose()}}p(t,n,s){return new b.UniversalWatcherClient(a=>t(a),a=>n(a),s)}y(t,n,s){return new A.NodeJSWatcherClient(a=>t(a),a=>n(a),s)}Y(t){if(t instanceof u.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(t,n)}async Z(t,n){let s=this.Y(n);if(t&&s.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await h.SymlinkSupport.stat(this.C(t));a.mode&128||(s=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(oe[103],ae([0,1,6,3,2,5,8]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,c.createDecorator)("lifecycleSharedProcessService");let P=class extends R.Disposable{constructor(E){super(),this.c=E,this.a=void 0,this.b=this.B(new T.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this.b.fire({join(C){E.push(C)}}),this.a=(async()=>{try{await D.Promises.settled(E)}catch(C){this.c.error(C)}})(),this.a}};P=ye([G(0,O.ILogService)],P),e.SharedProcessLifecycleService=P}),define(oe[104],ae([0,1,11,8,2]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class c extends T.AbstractLoggerService{constructor(C,w,m,y){super(w,m.map(h=>({...h,resource:D.URI.revive(h.resource),hidden:h.hidden||!!h.extensionId}))),this.l=C,this.m=y,this.B(y.listen("onDidChangeLogLevel",C)(h=>{(0,T.isLogLevel)(h)?super.setLogLevel(h):super.setLogLevel(D.URI.revive(h[0]),h[1])})),this.B(y.listen("onDidChangeVisibility",C)(([h,S])=>super.setVisibility(D.URI.revive(h),S))),this.B(y.listen("onDidChangeLoggers",C)(({added:h,removed:S})=>{for(const u of h)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of S)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new T.AdapterLogger({log:(C,w)=>{this.m.call("consoleLog",[C,w])}})}registerLogger(C){super.registerLogger(C),this.m.call("registerLogger",[C,this.l])}deregisterLogger(C){super.deregisterLogger(C),this.m.call("deregisterLogger",[C,this.l])}setLogLevel(C,w){super.setLogLevel(C,w),this.m.call("setLogLevel",[C,w])}setVisibility(C,w){super.setVisibility(C,w),this.m.call("setVisibility",[C,w])}k(C,w,m){return new O(this.m,C,w,m)}static setLogLevel(C,w,m){return C.call("setLogLevel",[w,m])}}e.LoggerChannelClient=c;class O extends T.AbstractMessageLogger{constructor(C,w,m,y){super(y?.logLevel==="always"),this.m=C,this.n=w,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[w,y]).then(()=>{this.r(this.l),this.k=!0})}g(C,w){const m=[[C,w]];this.k?this.r(m):this.l.push(...m)}r(C){this.m.call("log",[this.n,C])}}class P{constructor(C){this.a=C}listen(C,w,m){switch(w){case"onDidChangeLoggers":return this.a.onDidChangeLoggers;case"onDidChangeVisibility":return this.a.onDidChangeVisibility;case"onDidChangeLogLevel":return this.a.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(C,w,m){switch(w){case"setLogLevel":return(0,T.isLogLevel)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(D.URI.revive(m[0]),m[1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()])}throw new Error(`Call not found: ${w}`)}}e.LoggerChannel=P;class I extends R.Disposable{constructor(C,w){super(),w.call("setLogLevel",[C.getLogLevel()]),this.B(C.onDidChangeLogLevel(m=>w.call("setLogLevel",[m]))),w.call("getRegisteredLoggers").then(m=>{for(const y of m)C.registerLogger({...y,resource:D.URI.revive(y.resource)})}),this.B(w.listen("onDidChangeVisibility")(([m,y])=>C.setVisibility(D.URI.revive(m),y))),this.B(w.listen("onDidChangeLoggers")(({added:m,removed:y})=>{for(const h of m)C.registerLogger({...h,resource:D.URI.revive(h.resource)});for(const h of y)C.deregisterLogger(h.resource)}))}}e.RemoteLoggerChannelClient=I}),define(oe[213],ae([0,1,2,8]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class R extends D.Disposable{constructor(O,P=[]){super(),this.a=new T.MultiplexLogger([O,...P]),this.B(O.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...P){this.a.trace(O,...P)}debug(O,...P){this.a.debug(O,...P)}info(O,...P){this.a.info(O,...P)}warn(O,...P){this.a.warn(O,...P)}error(O,...P){this.a.error(O,...P)}flush(){this.a.flush()}}e.LogService=R}),define(oe[58],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(oe[59],ae([0,1,3,64,2,5]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,c.createDecorator)("policy");class O extends R.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(E){const C=Object.keys(this.f).length;return this.f={...E,...this.f},C!==Object.keys(this.f).length&&await this.i(E),T.Iterable.reduce(this.g.entries(),(w,[m,y])=>({...w,[m]:y}),{})}getPolicyValue(E){return this.g.get(E)}serialize(){return T.Iterable.reduce(Object.entries(this.f),(E,[C,w])=>({...E,[C]:{definition:w,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=O;class P{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(oe[214],ae([0,1,3,2,59]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class c{constructor(I){this.b=I,this.a=new T.DisposableStore}listen(I,E){switch(E){case"onDidChange":return D.Event.map(this.b.onDidChange,C=>C.reduce((w,m)=>({...w,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${E}`)}call(I,E,C){switch(E){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${E}`)}dispose(){this.a.dispose()}}e.PolicyChannel=c;class O extends R.AbstractPolicyService{constructor(I,E){super(),this.a=E;for(const C in I){const{definition:w,value:m}=I[C];this.f[C]=w,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const w in C){const m=C[w];m===null?this.g.delete(w):this.g.set(w,m)}this.h.fire(Object.keys(C))})}async i(I){const E=await this.a.call("updatePolicyDefinitions",I);for(const C in E)this.g.set(C,E[C])}}e.PolicyChannelClient=O}),define(oe[105],ae([0,1,4,36]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.context<"u"){const c=D.globals.vscode.context.configuration();if(c)R=c.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const c=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:c.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(oe[23],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[215],ae([0,1,6,9,2,13,28,8,23]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(w,m,y){super(),this.b=m,this.c=y,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this.B(new D.RunOnceScheduler(()=>{this.f(w)},3e4)).schedule()}async f(w){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),y=(0,c.dirname)(w),h=(0,c.basename)(w),S=await O.Promises.readdir(y);await Promise.all(S.map(async u=>{if(u===h)return;const l=(0,c.join)(y,u),g=await O.Promises.stat(l);if(g.isDirectory()&&m-g.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${u}.`),O.Promises.rm(l)}))}catch(m){(0,T.onUnexpectedError)(m)}}};E=ye([G(1,I.IProductService),G(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(oe[216],ae([0,1,6,9,2,13,28,15,8,23]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends R.Disposable{constructor(m,y,h){super(),this.b=m,this.c=y,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),y=JSON.parse(await O.Promises.readFile((0,c.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(y)){const p=y[g];m[`${p.hash}.${g}`]=!0}const h=(0,c.join)(this.b.userDataPath,"clp");if(!await O.Promises.exists(h))return;const u=await O.Promises.readdir(h);for(const g of u){if(m[g]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await O.Promises.rm((0,c.join)(h,g))}const l=Date.now();for(const g of Object.keys(m)){const p=(0,c.join)(h,g),b=await O.Promises.readdir(p);for(const A of b){if(A==="tcf.json")continue;const i=(0,c.join)(p,A),r=await O.Promises.stat(i);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,c.join)(g,A)}`),await O.Promises.rm(i))}}}catch(m){(0,T.onUnexpectedError)(m)}}};C=ye([G(0,P.INativeEnvironmentService),G(1,I.ILogService),G(2,E.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(oe[217],ae([0,1,21,2,22,192,14,23]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends T.Disposable{constructor(C,w){super(),this.b=C,this.c=w,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const w=[];for(const[m,y]of this.a)if(!(y.configScheme&&y.configScheme!==C.scheme))try{const h=await this.b.readFile((0,R.joinPath)(C,m)),S=new Map;Object.entries(y.recommendations).forEach(([l,g])=>{if((0,D.isNonEmptyArray)(g.remotes))for(const p of g.remotes)S.set(p,{extensionId:l,extensionName:g.name,configName:y.configName,important:!!g.important,isExtensionPack:!!g.isExtensionPack,whenNotInstalled:g.whenNotInstalled});else w.push({extensionId:l,extensionName:g.name,configName:y.configName,important:!!g.important,isExtensionPack:!!g.isExtensionPack,whenNotInstalled:g.whenNotInstalled})});const u=(0,c.getDomainsOfRemotes)(h.value.toString(),[...S.keys()]);for(const l of u){const g=S.get(l);g&&w.push(g)}}catch{}return w}};I=ye([G(0,O.IFileService),G(1,P.IProductService)],I),e.ExtensionTipsService=I}),define(oe[218],ae([0,1,13,5]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,T.createDecorator)("IV8InspectProfilingService");var R;(function(c){function O(I){return Boolean(I.samples&&I.timeDeltas)}c.isValidProfile=O;function P(I,E="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,D.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.join)(E,(0,D.basename)(C.callFrame.url)));return I}c.rewriteAbsolutePaths=P})(R=e.Utils||(e.Utils={}))}),define(oe[219],ae([0,1,31]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class T{constructor(){this.a=new Map}async startProfiling(c){const P=await(await new Promise((E,C)=>{Q(["v8-inspect-profiler"],E,C)})).startProfiling({port:c.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this.a.set(I,P),I}async stopProfiling(c){const O=this.a.get(c);if(!O)throw new Error(`UNKNOWN session '${c}'`);const P=await O.stop();return this.a.delete(c),P.profile}}e.InspectProfilingService=T}),define(oe[40],ae([0,1,128,12]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.a=new Map}add(O,P){D.ok(T.isString(O)),D.ok(T.isObject(P)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,P)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new R}),define(oe[106],ae([0,1,3,40]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class c{constructor(){this.b=new D.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,E){this.a[R(I)]=E,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const O=new c;T.Registry.add(e.Extensions.JSONContribution,O)}),define(oe[46],ae([0,1,21,3,12,154,16,106,40]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(A){A.Multiline="multilineText",A.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(A){A[A.APPLICATION=1]="APPLICATION",A[A.MACHINE=2]="MACHINE",A[A.WINDOW=3]="WINDOW",A[A.RESOURCE=4]="RESOURCE",A[A.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",A[A.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=I.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:c.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const a in n)if(r.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.a.get(a),f=o?.valuesSources??new Map;if(s)for(const N of Object.keys(n[a]))f.set(N,s);const d={...o?.value||{},...n[a]};this.a.set(a,{source:s,value:d,valuesSources:f});const v=(0,O.getLanguageTagSettingPlainKey)(a),L={type:"object",default:d,description:c.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:R.isString(s)?void 0:s,defaultValueSource:s};t.push(...S(a)),this.d[a]=L,this.b.properties[a]=L}else{this.a.set(a,{value:n[a],source:s});const o=this.d[a];o&&(this.w(a,o),this.r(a,o))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const a=this.a.get(s),o=R.isString(n)?n:n?.id,f=R.isString(a?.source)?a?.source:a?.source?.id;if(o===f)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const d=this.d[s];d&&(this.w(s,d),this.r(s,d))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,a){s=R.isUndefinedOrNull(i.scope)?s:i.scope;const o=i.properties;if(o)for(const d in o){const v=o[d];if(r&&p(d,v)){delete o[d];continue}if(v.source=t,v.defaultDefaultValue=o[d].default,this.w(d,v),e.OVERRIDE_PROPERTY_REGEX.test(d)?v.scope=void 0:(v.scope=R.isUndefinedOrNull(v.scope)?s:v.scope,v.restricted=R.isUndefinedOrNull(v.restricted)?!!n?.includes(d):v.restricted),o[d].hasOwnProperty("included")&&!o[d].included){this.f[d]=o[d],delete o[d];continue}else this.d[d]=o[d],o[d].policy?.name&&this.e.set(o[d].policy.name,d);!o[d].deprecationMessage&&o[d].markdownDeprecationMessage&&(o[d].deprecationMessage=o[d].markdownDeprecationMessage),a.add(d)}const f=i.allOf;if(f)for(const d of f)this.p(d,r,t,n,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const a in n)this.r(a,n[a]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:c.localize(2,null),errorMessage:c.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const i={type:"object",description:c.localize(4,null),errorMessage:c.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;R.isUndefined(n)&&(n=r.defaultDefaultValue,s=void 0),R.isUndefined(n)&&(n=l(r.type)),r.default=n,r.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",h=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(A){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(A)){let r=h.exec(A);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=h.exec(A)}}return(0,D.distinct)(i)}e.overrideIdentifiersFromKey=S;function u(A){return A.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=u;function l(A){switch(Array.isArray(A)?A[0]:A){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new m;I.Registry.add(e.Extensions.Configuration,g);function p(A,i){return A.trim()?e.OVERRIDE_PROPERTY_REGEX.test(A)?c.localize(7,null,A):g.getConfigurationProperties()[A]!==void 0?c.localize(8,null,A):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?c.localize(9,null,A,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:c.localize(6,null)}e.validateProperty=p;function b(){const A=[],i=g.getConfigurationProperties();for(const r of Object.keys(i))A.push([r,i[r].scope]);return A.push(["launch",4]),A.push(["task",4]),A}e.getScopes=b}),define(oe[74],ae([0,1,21,3,35,2,37,32,12,11,16,46,40]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function y(r){return Object.isFrozen(r)?r:P.deepFreeze(r)}class h{constructor(t={},n=[],s=[],a){this.b=t,this.c=n,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof h)return n;const s=new S("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const s=this.rawConfiguration.getValue(t),a=n?this.rawConfiguration.getOverrideValue(t,n):void 0,o=n?this.rawConfiguration.override(n).getValue(t):s;return{value:s,override:a,merged:o}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,C.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return D.distinct(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=P.deepClone(this.contents),s=P.deepClone(this.overrides),a=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const f of t)if(o.push(...f.raw?.length?f.raw:[f]),!f.isEmpty()){this.h(n,f.contents);for(const d of f.overrides){const[v]=s.filter(L=>D.equals(L.identifiers,d.identifiers));v?(this.h(v.contents,d.contents),v.keys.push(...d.keys),v.keys=D.distinct(v.keys)):s.push(P.deepClone(d))}for(const d of f.keys)a.indexOf(d)===-1&&a.push(d)}return new h(n,a,s,o.every(f=>f instanceof h)?void 0:o)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[a];const f=n[a];f&&(typeof o=="object"&&typeof f=="object"?(o=P.deepClone(o),this.h(o,f)):o=f),s[a]=o}return new h(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&I.isObject(t[s])&&I.isObject(n[s])){this.h(t[s],n[s]);continue}t[s]=P.deepClone(n[s])}}i(t){let n=null,s=null;const a=o=>{o&&(s?this.h(s,o):s=P.deepClone(o))};for(const o of this.overrides)D.equals(o.identifiers,[t])?n=o.contents:o.identifiers.includes(t)&&a(o.contents);return a(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,C.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>D.equals(s.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}j(t,n,s){(0,C.addToValueTree)(this.contents,t,n,a=>console.error(a)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,C.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=h;class S{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!I.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:a,overrides:o,restricted:f,hasExcludedProperties:d}=this.h(t,n);this.b=new h(s,a,o,d?[t]:void 0),this.c=f||[]}g(t){let n={},s=null,a=[];const o=[],f=[];function d(L){Array.isArray(a)?a.push(L):s!==null&&(a[s]=L)}const v={onObjectBegin:()=>{const L={};d(L),o.push(a),a=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const L=[];d(L),o.push(a),a=L,s=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:d,onError:(L,N,F)=>{f.push({error:L,offset:N,length:F})}};if(t)try{R.visit(t,v),n=a[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(t,n){const s=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.i(t,s,!0,n);t=a.raw;const o=(0,C.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),f=Object.keys(t),d=this.j(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:o,keys:f,overrides:d,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(t,n,s,a){let o=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:o};const f={},d=[];for(const v in t)if(w.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const L=this.i(t[v],n,!1,a);f[v]=L.raw,o=o||L.hasExcludedProperties,d.push(...L.restricted)}else{const L=n[v],N=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&d.push(v),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&!(a.skipRestricted&&L?.restricted)?f[v]=t[v]:o=!0}return{raw:f,restricted:d,hasExcludedProperties:o}}j(t,n){const s=[];for(const a of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(a)){const o={};for(const f in t[a])o[f]=t[a][f];s.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(o),contents:(0,C.toValuesTree)(o,n)})}return s}}e.ConfigurationModelParser=S;class u extends c.Disposable{constructor(t,n,s,a){super(),this.f=t,this.g=n,this.h=a,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new S(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&s.isEqual(o.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new h}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class l{constructor(t,n,s,a,o,f,d,v,L,N,F,M,k){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=a,this.d=o,this.f=f,this.g=d,this.h=v,this.i=L,this.j=N,this.k=F,this.l=M,this.m=k}get value(){return y(this.c)}n(t,n,s){const a=t.inspect(n,s);return{get value(){return y(a.value)},get override(){return y(a.override)},get merged(){return y(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(t,n,s,a,o=new h,f=new h,d=new O.ResourceMap,v=new h,L=new O.ResourceMap){this.c=t,this.d=n,this.f=s,this.g=a,this.h=o,this.i=f,this.j=d,this.l=v,this.m=L,this.a=null,this.b=new O.ResourceMap,this.n=null}getValue(t,n,s){return this.q(t,n,s).getValue(t)}updateValue(t,n,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new h,this.m.set(s.resource,a))):a=this.l,n===void 0?a.removeValue(t):a.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const a=this.q(t,n,s),o=this.u(n.resource,s),f=n.resource?this.m.get(n.resource)||this.l:this.l,d=new Set;for(const v of a.overrides)for(const L of v.identifiers)a.getOverrideValue(t,L)!==void 0&&d.add(L);return new l(t,n,a.getValue(t),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,o||void 0,f)}keys(t){const n=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:a,updated:o,removed:f}=A(this.c,t);n=[...a,...o,...f]}for(const a of n)for(const o of(0,w.overrideIdentifiersFromKey)(a)){const f=this.c.getKeysForOverrideIdentifier(o),d=t.getKeysForOverrideIdentifier(o),v=[...d.filter(L=>f.indexOf(L)===-1),...f.filter(L=>d.indexOf(L)===-1),...f.filter(L=>!P.equals(this.c.override(o).getValue(L),t.override(o).getValue(L)))];s.push([o,v])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:a}=A(this.d,t),o=[...n,...s,...a];return o.length&&this.updatePolicyConfiguration(t),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=A(this.applicationConfiguration,t),f=[...n,...s,...a];return f.length&&this.updateApplicationConfiguration(t),{keys:f,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=A(this.localUserConfiguration,t),f=[...n,...s,...a];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=A(this.remoteUserConfiguration,t),f=[...n,...s,...a];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=A(this.workspaceConfiguration,t),f=[...n,...s,...a];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.p.get(t),{added:a,updated:o,removed:f,overrides:d}=A(s,n),v=[...a,...o,...f];return(v.length||!s)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:d}}compareAndDeleteFolderConfiguration(t){const n=this.p.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:o,overrides:f}=A(n,void 0);return{keys:[...s,...a,...o],overrides:f}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,n,s){let a=this.r(n,s);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(a=a.merge(this.d)),a}r({resource:t},n){let s=this.s();if(n&&t){const a=n.getFolder(t);a&&(s=this.t(a.uri)||s);const o=this.m.get(t);o&&(s=s.merge(o))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let n=this.b.get(t);if(!n){const s=this.s(),a=this.j.get(t);a?(n=s.merge(a),this.b.set(t,n)):n=s}return n}u(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:a,keys:o}=this.j.get(n);return t.push([n,{contents:s,overrides:a,keys:o}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.x(t.defaults),s=this.x(t.policy),a=this.x(t.application),o=this.x(t.user),f=this.x(t.workspace),d=t.folders.reduce((v,L)=>(v.set(E.URI.revive(L[0]),this.x(L[1])),v),new O.ResourceMap);return new g(n,s,a,o,new h,f,d,new h,new O.ResourceMap)}static x(t){return new h(t.contents,t.keys,t.overrides)}}e.Configuration=g;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const a of r)a.keys.forEach(o=>t.add(o)),a.overrides.forEach(([o,f])=>{const d=(0,O.getOrSet)(n,o,new Set);f.forEach(v=>d.add(v))});const s=[];return n.forEach((a,o)=>s.push([o,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=p;class b{constructor(t,n,s,a){this.change=t,this.f=n,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of t.keys)this.affectedKeys.add(o);for(const[,o]of t.overrides)for(const f of o)this.affectedKeys.add(f);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,a=this.d.indexOf(s);if(a<0)return!1;const o=a+s.length;if(o>=this.d.length)return!1;const f=this.d.charCodeAt(o);if(f!==this.b&&f!==this.c)return!1;if(n){const d=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,v=this.g.getValue(t,n,this.h);return!P.equals(d,v)}return!0}}e.ConfigurationChangeEvent=b;function A(r,t){const{added:n,removed:s,updated:a}=i(t?.rawConfiguration,r?.rawConfiguration),o=[],f=r?.getAllOverrideIdentifiers()||[],d=t?.getAllOverrideIdentifiers()||[];if(t){const v=d.filter(L=>!f.includes(L));for(const L of v)o.push([L,t.getKeysForOverrideIdentifier(L)])}if(r){const v=f.filter(L=>!d.includes(L));for(const L of v)o.push([L,r.getKeysForOverrideIdentifier(L)])}if(t&&r){for(const v of f)if(d.includes(v)){const L=i({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});o.push([v,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:s,updated:a,overrides:o}}function i(r,t){const n=r?t?r.keys.filter(o=>t.keys.indexOf(o)===-1):[...r.keys]:[],s=t?r?t.keys.filter(o=>r.keys.indexOf(o)===-1):[...t.keys]:[],a=[];if(r&&t){for(const o of t.keys)if(r.keys.indexOf(o)!==-1){const f=(0,C.getConfigurationValue)(t.contents,o),d=(0,C.getConfigurationValue)(r.contents,o);P.equals(f,d)||a.push(o)}}return{added:n,removed:s,updated:a}}}),define(oe[220],ae([0,1,21,3,2,32,12,74,46,8,59,40]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:l})=>this.c(Array.from(u),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,l){this.h(u,w.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new P.ConfigurationModel;const u=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,l){const g=this.f();for(const p of u){const b=g[p],A=l[p];b!==void 0?this.b.addValue(p,b):A?this.b.addValue(p,A.default):this.b.removeValue(p)}}}e.DefaultConfiguration=m;class y{constructor(){this.onDidChangeConfiguration=T.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let h=class extends R.Disposable{get configurationModel(){return this.b}constructor(u,l,g){super(),this.c=u,this.f=l,this.g=g,this.a=this.B(new T.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const l={},g=[],p=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const b of u){const A=p[b];if(!A){g.push(b);continue}if(A.policy){if(A.type!=="string"&&A.type!=="number"){this.g.warn(`Policy ${A.policy.name} has unsupported type ${A.type}`);continue}g.push(b),l[A.policy.name]={type:A.type}}}return(0,O.isEmptyObject)(l)||await this.f.updatePolicyDefinitions(l),g}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const l=w.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),g=(0,D.coalesce)(u.map(p=>l.get(p)));this.j(g,!0)}j(u,l){this.g.trace("PolicyConfiguration#update",u);const g=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),p=[],b=this.b.isEmpty();for(const A of u){const i=g[A]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(b?r!==void 0:!(0,c.equals)(this.b.getValue(A),r))&&p.push([A,r])}else this.b.getValue(A)!==void 0&&p.push([A,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const A=this.b;this.b=new P.ConfigurationModel;for(const i of A.keys)this.b.setValue(i,A.getValue(i));for(const[i,r]of p)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);l&&this.a.fire(this.b)}}};h=ye([G(1,C.IPolicyService),G(2,E.ILogService)],h),e.PolicyConfiguration=h}),define(oe[221],ae([0,1,6,3,2,22,16,74,220,59]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends R.Disposable{constructor(m,y,h,S){super(),this.i=m,this.h=this.B(new T.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=h instanceof E.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,h,S)),this.f=this.B(new P.UserSettings(this.i,void 0,c.extUriBiasedIgnorePathCase,y)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:l})=>this.k(u,l))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,y,h]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(m,y,new P.ConfigurationModel,h)}getConfigurationData(){return this.a.toData()}getValue(m,y){const h=typeof m=="string"?m:void 0,S=(0,O.isConfigurationOverrides)(m)?m:(0,O.isConfigurationOverrides)(y)?y:{};return this.a.getValue(h,S,void 0)}updateValue(m,y,h,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const y=this.a.toData(),h=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(h,y,2)}k(m,y){const h=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(m,y);this.m(S,h,7)}l(m){const y=this.a.toData(),h=this.a.compareAndUpdatePolicyConfiguration(m);this.m(h,y,7)}m(m,y,h){const S=new P.ConfigurationChangeEvent(m,{data:y},this.a);S.source=h,S.sourceConfig=this.n(h),this.h.fire(S)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(oe[222],ae([0,1,9,5]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class c extends D.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof c&&I._code===R.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof c&&I._code===R.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof c&&I._code===R.NoResolverFound}static isHandled(I){return I instanceof c&&I.isHandled}constructor(I,E=R.Unknown,C){super(I),this._message=I,this._code=E,this._detail=C,this.isHandled=E===R.NotAvailable&&C===!0,Object.setPrototypeOf(this,c.prototype)}}e.RemoteAuthorityResolverError=c;function O(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.getRemoteAuthorityPrefix=O}),define(oe[75],ae([0,1,26]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=T;function R(E){if(!E)return;const C=E.indexOf("+");return C<0?E:E.substr(0,C)}e.getRemoteName=R;function c(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=c;function O(E){const{host:C,port:w}=I(E);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:w}}e.parseAuthorityWithPort=O;function P(E,C){let{host:w,port:m}=I(E);return typeof m>"u"&&(m=C),{host:w,port:m}}e.parseAuthorityWithOptionalPort=P;function I(E){const C=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const w=E.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=E.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:E,port:void 0}}}),define(oe[42],ae([0,1,27,5,75]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function c(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=c;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(S){this.value=S,this.c=S.toLowerCase()}static equals(S,u){if(typeof S>"u"||S===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof S=="string"||typeof u=="string"){const l=typeof S=="string"?S:S.value,g=typeof u=="string"?u:u.value;return D.equalsIgnoreCase(l,g)}return S.c===u.c}static toKey(S){return typeof S=="string"?S.toLowerCase():S.c}}e.ExtensionIdentifier=E;function C(h){return w(h)}e.isApplicationScopedExtension=C;function w(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function m(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function y(h,S){if(S){const u=`onResolveRemoteAuthority:${(0,R.getRemoteName)(S)}`;return h.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[223],ae([0,1,2,13,28,42]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends D.Disposable{constructor(I,E){super(),this.b=I,this.a=(0,T.join)(this.b.userDataPath,c.MANIFEST_CACHE_FOLDER,c.USER_MANIFEST_CACHE_FILE),this.B(E.onDidInstallExtensions(C=>this.c(C))),this.B(E.onDidUninstallExtension(C=>this.f(C)))}c(I){I.some(E=>!!E.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){R.Promises.rm(this.a,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(oe[224],ae([0,1,6,17,25,9,3,2,102,88,31,93,222,75]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const h=30*1e3;var S;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function u(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(W){const q=new R.CancellationTokenSource;return setTimeout(()=>q.cancel(),W),q.token}function g(W,q){if(W.isCancellationRequested||q.isCancellationRequested)return R.CancellationToken.Cancelled;const Y=new R.CancellationTokenSource;return W.onCancellationRequested(()=>Y.cancel()),q.onCancellationRequested(()=>Y.cancel()),Y.token}class p{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((Y,ee)=>{this.f=Y,this.g=ee}),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function b(W,q){const Y=new p(q);return Y.registerDisposable(W.onControlMessage(ee=>{const K=JSON.parse(ee.toString()),Z=J(K);Z?Y.reject(Z):Y.resolve(K)})),Y.promise}function A(W,q,Y,ee,K,Z,se,le,ue){const pe=new p(ue),ve=E.StopWatch.create(!1);return W.info(`Creating a socket (${le})...`),I.mark(`code/willCreateSocket/${se}`),q.connect(Y,ee,K,Z,le,(be,Ee)=>{pe.didTimeout?(I.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) finished after ${ve.elapsed()} ms, but this is too late and has timed out already.`),be&&W.error(be),Ee?.dispose()):be||!Ee?(I.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) returned an error after ${ve.elapsed()} ms.`),pe.reject(be)):(I.mark(`code/didCreateSocketOK/${se}`),W.info(`Creating a socket (${le}) was successful after ${ve.elapsed()} ms.`),pe.resolve(Ee))}),pe.promise}function i(W,q){const Y=new p(q);return W.then(ee=>{Y.didTimeout||Y.resolve(ee)},ee=>{Y.didTimeout||Y.reject(ee)}),Y.promise}async function r(W,q,Y,ee){const K=U(W,q);W.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await A(W.logService,W.socketFactory,W.host,W.port,(0,y.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,u(q),`renderer-${u(q)}-${W.reconnectionToken}`,ee)}catch(ve){throw W.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ve),ve}W.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let se,le;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Z,null),se=W.reconnectionProtocol,le=!1):(se=new w.PersistentProtocol({socket:Z,measureRoundTripTime:!0}),le=!0),W.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const ue=await i(W.signService.createNewMessage((0,C.generateUuid)()),ee),pe={type:"auth",auth:W.connectionToken||"00000000000000000000",data:ue.data};se.sendControl(T.VSBuffer.fromString(JSON.stringify(pe)));try{const ve=await b(se,g(ee,l(1e4)));if(ve.type!=="sign"||typeof ve.data!="string"){const Ue=new Error("Unexpected handshake message");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}if(W.logService.trace(`${K} 4/6. received SignRequest control message.`),!await i(W.signService.validate(ue,ve.signedData),ee)){const Ue=new Error("Refused to connect to unsupported server");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}const Ee=await i(W.signService.sign(ve.data),ee),Oe={type:"connectionType",commit:W.commit,signedData:Ee,desiredConnectionType:q};return Y&&(Oe.args=Y),W.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(T.VSBuffer.fromString(JSON.stringify(Oe))),{protocol:se,ownsProtocol:le}}catch(ve){throw ve&&ve.code==="ETIMEDOUT"&&(W.logService.error(`${K} the handshake timed out. Error:`),W.logService.error(ve)),ve&&ve.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${K} received error control message when negotiating connection. Error:`),W.logService.error(ve)),le&&V(se),ve}}async function t(W,q,Y,ee){const K=Date.now(),Z=U(W,q),{protocol:se,ownsProtocol:le}=await r(W,q,Y,ee),ue=new p(ee);return ue.registerDisposable(se.onControlMessage(pe=>{const ve=JSON.parse(pe.toString()),be=J(ve);be?(W.logService.error(`${Z} received error control message when negotiating connection. Error:`),W.logService.error(be),le&&V(se),ue.reject(be)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${B(K)}!`),ue.resolve({protocol:se,firstMessage:ve}))})),ue.promise}async function n(W,q){const{protocol:Y}=await t(W,1,void 0,q);return{protocol:Y}}async function s(W,q,Y){const{protocol:ee,firstMessage:K}=await t(W,2,q,Y),Z=K&&K.debugPort;return{protocol:ee,debugPort:Z}}async function a(W,q,Y){const ee=Date.now(),K=U(W,3),{protocol:Z}=await r(W,3,q,Y);return W.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${B(ee)}!`),Z}async function o(W,q,Y){const{host:ee,port:K,connectionToken:Z}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:ee,port:K,connectionToken:Z,reconnectionToken:q,reconnectionProtocol:Y,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function f(W,q,Y){return v(W,async ee=>{const{protocol:K}=await n(ee,R.CancellationToken.None);return new H(W,q,Y,ee.reconnectionToken,K)})}e.connectRemoteAgentManagement=f;async function d(W,q){return v(W,async Y=>{const{protocol:ee,debugPort:K}=await s(Y,q,R.CancellationToken.None);return new j(W,q,Y.reconnectionToken,ee,K)})}e.connectRemoteAgentExtensionHost=d;async function v(W,q){for(let ee=1;;ee++)try{const K=(0,C.generateUuid)(),Z=await o(W,K,null);return await q(Z)}catch(K){if(ee<5)W.logService.error(`[remote-connection][attempt ${ee}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(K);else throw W.logService.error(`[remote-connection][attempt ${ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(K),ie.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(K)),K}}async function L(W,q,Y){const ee=await o(W,(0,C.generateUuid)(),null);return await a(ee,{host:q,port:Y},R.CancellationToken.None)}e.connectRemoteAgentTunnel=L;function N(W){return(0,D.createCancelablePromise)(q=>new Promise((Y,ee)=>{const K=setTimeout(Y,W*1e3);q.onCancellationRequested(()=>{clearTimeout(K),Y()})}))}var F;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class M{constructor(q,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.type=0}}e.ConnectionLostEvent=M;class k{constructor(q,Y,ee,K){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.durationSeconds=ee,this.c=K,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=k;class ${constructor(q,Y,ee){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.attempt=ee,this.type=2}}e.ReconnectionRunningEvent=$;class z{constructor(q,Y,ee){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.attempt=ee,this.type=4}}e.ConnectionGainEvent=z;class x{constructor(q,Y){this.reconnectionToken=q,this.connectionHealth=Y,this.type=5}}e.ConnectionHealthChangedEvent=x;class X{constructor(q,Y,ee,K){this.reconnectionToken=q,this.millisSinceLastIncomingData=Y,this.attempt=ee,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=X;class ie extends P.Disposable{static triggerPermanentFailure(q,Y,ee){this._permanentFailure=!0,this.f=q,this.g=Y,this.h=ee,this.i.forEach(K=>K.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(q=>q.r())}static debugPauseSocketWriting(){this.i.forEach(q=>q.v())}get k(){return this.c||ie._permanentFailure}constructor(q,Y,ee,K,Z){super(),this.m=q,this.n=Y,this.reconnectionToken=ee,this.protocol=K,this.p=Z,this.j=this.B(new O.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new z(this.reconnectionToken,0,0)),this.B(K.onSocketClose(se=>{const le=te(this.m,this.reconnectionToken,!0);se?se.type===0?(this.n.logService.info(`${le} received socket close event (hadError: ${se.hadError}).`),se.error&&this.n.logService.error(se.error)):(this.n.logService.info(`${le} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.n.logService.error(se.event)):this.n.logService.info(`${le} received socket close event.`),this.r()})),this.B(K.onSocketTimeout(se=>{const le=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(K.onHighRoundTripTime(se=>{const le=re(this.m,this.reconnectionToken);this.n.logService.info(`${le} high roundtrip time: ${se.roundTripTime}ms (${se.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(K.onDidChangeConnectionHealth(se=>{this.j.fire(new x(this.reconnectionToken,se))})),ie.i.push(this),this.B((0,P.toDisposable)(()=>{const se=ie.i.indexOf(this);se>=0&&ie.i.splice(se,1)})),this.k&&this.u(ie.f,ie.g,ie.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const q=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Y=[0,5,5,10,10,10,10,10,30];let ee=-1;do{ee++;const K=ee<Y.length?Y[ee]:Y[Y.length-1];try{if(K>0){const se=N(K);this.j.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,se)),this.n.logService.info(`${q} waiting for ${K} seconds before reconnecting...`);try{await se}catch{}}if(this.k){this.n.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1)),this.n.logService.info(`${q} resolving connection...`);const Z=await o(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${q} connecting to ${Z.host}:${Z.port}...`),await this.w(Z,l(h)),this.n.logService.info(`${q} reconnected!`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(ee>360){this.n.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this.n.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.n.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if((0,c.isCancellationError)(Z)){this.n.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if(Z instanceof m.RemoteAuthorityResolverError){this.n.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,m.RemoteAuthorityResolverError.isHandled(Z));break}this.n.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}}while(!this.k)}t(q,Y,ee){this.p?ie.triggerPermanentFailure(q,Y,ee):this.u(q,Y,ee)}u(q,Y,ee){this.j.fire(new X(this.reconnectionToken,q,Y,ee)),V(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie.f=0,ie.g=0,ie.h=!1,ie.i=[];class H extends ie{constructor(q,Y,ee,K,Z){super(1,q,K,Z,!0),this.client=this.B(new w.Client(Z,{remoteAuthority:Y,clientId:ee},q.ipcLogger))}async w(q,Y){await n(q,Y)}}e.ManagementPersistentConnection=H;class j extends ie{constructor(q,Y,ee,K,Z){super(2,q,ee,K,!1),this.y=Y,this.debugPort=Z}async w(q,Y){await s(q,this.y,Y)}}e.ExtensionHostPersistentConnection=j;function V(W){try{W.acceptDisconnect();const q=W.getSocket();W.dispose(),q.dispose()}catch(q){(0,c.onUnexpectedError)(q)}}function J(W){if(W&&W.type==="error"){const q=new Error(`Connection error: ${W.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(W,q){for(;W.length<q;)W+=" ";return W}function re(W,q){return`[remote-connection][${_(u(W),13)}][${q.substr(0,5)}\u2026]`}function te(W,q,Y){return`${re(W,q)}[${Y?"reconnect":"initial"}]`}function U(W,q){return`${te(q,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function B(W){return`${Date.now()-W} ms`}}),define(oe[225],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[226],ae([0,1,86,152]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,c,O,P,I,E){const C=m=>E(m,void 0),w=D.createConnection({host:R,port:c},()=>{w.removeListener("error",C);const m=Buffer.alloc(16);for(let u=0;u<16;u++)m[u]=Math.round(Math.random()*256);const y=m.toString("base64"),h=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${c}${O}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];w.write(h.join(`\r
`)+`\r
\r
`);const S=u=>{u.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),E(void 0,new T.NodeSocket(w,I)))};w.on("data",S)});w.setNoDelay(!0),w.once("error",C)}}}),define(oe[107],ae([0,1,5,170]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var R;(function(c){c.disconnected={type:"disconnected"},c.uninitialized={type:"uninitialized"},c.connected=O=>({type:"connected",info:O}),c.connecting=O=>({type:"connecting",progress:O})})(R=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,T.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[227],ae([0,1,136,16,8]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let c=class{constructor(P,I){this.a=P,this.b=I}async request(P,I){this.b.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const E=await(0,D.request)(P,I);return this.b.trace("RequestService#request (browser) - success",P.url),E}catch(E){throw this.b.error("RequestService#request (browser) - error",P.url,E),E}}async resolveProxy(P){}};c=ye([G(0,T.IConfigurationService),G(1,R.ILogService)],c),e.RequestService=c}),define(oe[60],ae([0,1,17,172,46,5,40]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,c.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function I(S){return S.res.statusCode===204}async function E(S){return I(S)?null:(await(0,D.streamToBuffer)(S.stream)).toString()}e.asText=E;async function C(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return E(S)}e.asTextOrError=C;async function w(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(I(S))return null;const l=(await(0,D.streamToBuffer)(S.stream)).toString();try{return JSON.parse(l)}catch(g){throw g.message+=`:
`+l,g}}e.asJson=w;function m(S){h(S)}e.updateProxyConfigurationsScope=m;let y;function h(S){const u=O.Registry.as(R.Extensions.Configuration),l=y;y={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[y],remove:l?[l]:[]})}h(2)}),define(oe[228],ae([0,1,25,26,14,60]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(I,E){this.a=I,this.b=E}async download(I,E,C=D.CancellationToken.None){if(I.scheme===T.Schemas.file||I.scheme===T.Schemas.vscodeRemote){await this.b.copy(I,E);return}const w={type:"GET",url:I.toString(!0)},m=await this.a.request(w,C);if(m.res.statusCode===200)await this.b.writeFile(E,m.stream);else{const y=await(0,c.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${y}`)}}};O=ye([G(0,c.IRequestService),G(1,R.IFileService)],O),e.DownloadService=O}),define(oe[229],ae([0,1,17,25]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.a=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,E,C=T.CancellationToken.None){switch(I){case"request":return this.a.request(E[0],C).then(async({res:w,stream:m})=>{const y=await(0,D.streamToBuffer)(m);return[{statusCode:w.statusCode,headers:w.headers},y]});case"resolveProxy":return this.a.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class c{constructor(P){this.a=P}async request(P,I){const[E,C]=await this.a.call("request",[P],I);return{res:E,stream:(0,D.bufferToStream)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=c}),define(oe[230],ae([0,1,12,227,229]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class c{constructor(P,I,E,C){this.c=I,this.d=E,this.e=C,this.a=new T.RequestService(I,C),this.b=new R.RequestChannelClient(P.getChannel("request"))}request(P,I){return this.f().request(P,I)}async resolveProxy(P){return this.f().resolveProxy(P)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const P=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,D.isBoolean)(P)?P:this.d.quality!=="stable"}}e.SharedProcessRequestService=c}),define(oe[108],ae([0,1,66,5]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(c){return(0,D.hash)({moduleId:c.process.moduleId,windowId:c.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,T.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[231],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(T){T.Spawn="vscode:shared-process->shared-process-worker=spawn",T.Terminate="vscode:shared-process->shared-process-worker=terminate",T.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",T.Ready="vscode:shared-process-worker->shared-process=ready",T.Ack="vscode:shared-process-worker->shared-process=ack",T.Trace="vscode:shared-process-worker->shared-process=trace",T.Info="vscode:shared-process-worker->shared-process=info",T.Warn="vscode:shared-process-worker->shared-process=warn",T.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[232],ae([0,1,94,6,25,3,2,26,31,8,108,231]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(S){this.d=S,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(S){const u=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${u})`);const l=(0,C.hash)(S);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${u})`),this.f(S));const g=new R.CancellationTokenSource;let p,b,A;this.b.set(l,n=>{g.dispose(!0),p?.terminate(S,R.CancellationToken.None),b?.close(),A?.close(),this.b.delete(l);const s=this.c.get(l);s&&(this.c.delete(l),s({reason:n}))}),p=await this.e(S);const i=new Promise(n=>{this.c.set(l,n)});if(g.token.isCancellationRequested)return i;const{port1:r,port2:t}=new MessageChannel;return b=r,A=t,await p.spawn(S,A,g.token),g.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${u})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[b])),i}e(S){let u=this.a.get(S.process.moduleId);if(!u){this.d.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const l=new y(S.process.type,this.d);u=l.init(),l.onDidProcessSelfTerminate(({configuration:g,reason:p})=>{this.f(g,p)}),this.a.set(S.process.moduleId,u)}return u}async disposeWorker(S){return this.f(S)}f(S,u){const l=this.b.get((0,C.hash)(S));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),l(u))}};m=ye([G(0,E.ILogService)],m),e.SharedProcessWorkerService=m;class y extends O.Disposable{constructor(S,u){super(),this.f=S,this.g=u,this.a=this.B(new c.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const S=new T.DeferredPromise,u=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return u.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},u.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},u.onmessage=l=>{const{id:g,message:p,configuration:b,nonce:A}=l.data;switch(g){case w.SharedProcessWorkerMessages.Ready:S.complete(u);break;case w.SharedProcessWorkerMessages.Ack:if(A){const i=this.c.get(A);i&&(this.c.delete(A),i())}break;case w.SharedProcessWorkerMessages.SelfTerminated:b&&p&&this.a.fire({configuration:b,reason:JSON.parse(p)});break;case w.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Info:p&&this.g.info(p);break;case w.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,p);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},u.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async i(S,u,l){const g=await this.b;if(!u.isCancellationRequested)return new Promise(p=>{const b=(0,I.generateUuid)();this.c.set(b,p);const A={...S,nonce:b};l?g.postMessage(A,[l]):g.postMessage(A),u.onCancellationRequested(()=>{this.c.delete(b)&&p()})})}spawn(S,u,l){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(g,l,u)}terminate(S,u){const l={id:w.SharedProcessWorkerMessages.Terminate,configuration:S};return this.i(l,u)}}}),define(oe[233],ae([0,1,63,26,191]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class c extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:T.Schemas.vscodeUserData})}}ye([D.memoize],c.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=c}),define(oe[234],ae([0,1,50,13,173,25,38,9,4,31,149,189,6,130]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let h;async function S(l,g,p,b){return p["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(b)&&!p["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(b)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(A,i)=>{const r=new c.CancellationTokenSource;let t=1e4;const n=l.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,y.clamp)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,R.localize)(0,null)))},t);try{A(await u(g,r.token))}catch(a){!(0,P.isCancellationError)(a)&&!r.token.isCancellationRequested?i(new Error((0,R.localize)(1,null,(0,O.toErrorMessage)(a)))):A({})}finally{clearTimeout(s),r.dispose()}})),h)}e.getResolvedShellEnv=S;async function u(l,g){const p=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",p);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",b);const A=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(A+"({.*})"+A),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,C.getSystemShell)(I.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(g.isCancellationRequested)return s(new P.CancellationError);const a=(0,T.basename)(t);let o,f;const d=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${d} -p '''${A}'' + JSON.stringify(process.env) + ''${A}'''`,f=["-Login","-Command"]):(o=`'${process.execPath}' ${d} -p '"${A}" + JSON.stringify(process.env) + "${A}"'`,a==="tcsh"||a==="csh"?f=["-ic"]:f=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),o);const v=(0,D.spawn)(t,[...f,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(v.kill(),s(new P.CancellationError))),v.on("error",F=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(F)),s(F)});const L=[];v.stdout.on("data",F=>L.push(F));const N=[];v.stderr.on("data",F=>N.push(F)),v.on("close",(F,M)=>{const k=Buffer.concat(L).toString("utf8");l.trace("getUnixShellEnvironment#raw",k);const $=Buffer.concat(N).toString("utf8");if($.trim()&&l.trace("getUnixShellEnvironment#stderr",$),F||M)return s(new Error((0,R.localize)(2,null,F,M)));const z=i.exec(k),x=z?z[1]:"{}";try{const X=JSON.parse(x);p?X.ELECTRON_RUN_AS_NODE=p:delete X.ELECTRON_RUN_AS_NODE,b?X.ELECTRON_NO_ATTACH_CONSOLE=b:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",X),n(X)}catch(X){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(X)),s(X)}})})}}),define(oe[109],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[235],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.b=new Map}c(){return new Promise((R,c)=>Q(["vsda"],R,c))}async createNewMessage(R){try{const c=await this.c(),O=new c.validator;if(O){const P=String(D.a++);return this.b.set(P,O),{id:P,data:O.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,c){if(!R.id)return!0;const O=this.b.get(R.id);if(!O)return!1;this.b.delete(R.id);try{return O.validate(c)==="ok"}catch{return!1}}async sign(R){try{const c=await this.c(),O=new c.signer;if(O)return O.sign(R)}catch{}return R}}e.SignService=D,D.a=1}),define(oe[76],ae([0,1,3,2]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends T.Disposable{constructor(w,m,y){super(),this.a=w,this.b=m,this.c=y}async getItems(){const w={profile:this.b,workspace:this.c},m=await this.a.call("getItems",w);return new Map(m)}updateItems(w){const m={profile:this.b,workspace:this.c};return w.insert&&(m.insert=Array.from(w.insert.entries())),w.delete&&(m.delete=Array.from(w.delete.values())),this.a.call("updateItems",m)}}class c extends R{constructor(w,m){super(w,m,void 0),this.f=this.B(new D.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(w=>this.h(w)))}h(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this.f.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class O extends c{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=O;class P extends c{constructor(w,m){super(w,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends R{constructor(w,m){super(w,void 0,m),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class E{constructor(w){this.a=w}isUsed(w){const m={payload:w,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.StorageClient=E}),define(oe[110],ae([0,1,4,36,11,31]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,C,w,m,y,h,S,u,l,g){const p=Object.create(null);p["common.machineId"]=S,p.sessionID=(0,c.generateUuid)()+Date.now(),p.commitHash=y,p.version=h,p["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,D.PlatformToString)(D.platform),p["common.nodePlatform"]=T.platform,p["common.nodeArch"]=m,p["common.product"]=g||"desktop",u&&(p["common.msftInternal"]=u);let b=0;const A=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-A,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),D.isLinuxSnap&&(p["common.snap"]="true");const i=O(w);i&&(p["common.platformDetail"]=i);try{const r=await E.readFile(R.URI.file(l));p["common.source"]=r.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=P;function I(E){const C=T.env.USERDNSDOMAIN;if(!C)return!1;const w=C.toLowerCase();return E.some(m=>w===m)}e.verifyMicrosoftInternalDomain=I}),define(oe[19],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(c){c[c.NONE=0]="NONE",c[c.CRASH=1]="CRASH",c[c.ERROR=2]="ERROR",c[c.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(c){c.OFF="off",c.CRASH="crash",c.ERROR="error",c.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[236],ae([0,1,34,6,35,26,13,4,11,146,28,148,96,14,23,19]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const u=new Map;async function l(i,r){const t=`${i}::${r.join(":")}`,n=u.get(t);if(n)return n;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,o=new Map,f=2e4;function d(L,N,F,M){const k=N.substring(L.length+1);return T.Promises.withAsyncBody(async $=>{let z;try{z=await C.Promises.readdir(N,{withFileTypes:!0})}catch{$();return}if(M.count>=f){M.count+=z.length,M.maxReached=!0,$();return}let x=z.length;if(x===0){$();return}let X=z;M.count+z.length>f&&(M.maxReached=!0,x=f-M.count,X=z.slice(0,x)),M.count+=z.length;for(const ie of X)if(ie.isDirectory()){if(F.includes(ie.name)||await d(L,(0,O.join)(N,ie.name),F,M),--x===0){$();return}}else{const H=ie.name.lastIndexOf(".");if(H>=0){const j=ie.name.substring(H+1);j&&a.set(j,(a.get(j)??0)+1)}for(const j of s)j.relativePathPattern?.test(k)!==!1&&j.filePattern.test(ie.name)&&o.set(j.tag,(o.get(j.tag)??0)+1);if(--x===0){$();return}}})}const v=T.Promises.withAsyncBody(async L=>{const N={count:0,maxReached:!1};await d(i,i,r,N);const F=await b(i);L({configFiles:g(o),fileTypes:g(a),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:F})});return u.set(t,v),v}e.collectWorkspaceStats=l;function g(i){return Array.from(i.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function p(){const i={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},r=D.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=p;async function b(i){try{const r=new Map,t=(0,O.join)(i,".vscode","launch.json"),n=await C.Promises.readFile(t),s=[],a=(0,R.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,R.getNodeType)(a)==="object"&&a.configurations)for(const o of a.configurations){const f=o.type;f&&(r.has(f)?r.set(f,r.get(f)+1):r.set(f,1))}return g(r)}catch{return[]}}e.collectLaunchConfigs=b;let A=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(D.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,w.listProcesses)(r.mainPID),this.k(r)]).then(async n=>{let[s,a]=n,o=this.m(r,s);return t.forEach(f=>{if((0,m.isRemoteDiagnosticError)(f))o+=`
${f.errorMessage}`,a+=`
${f.errorMessage}`;else if(o+=`

Remote: ${f.hostName}`,f.processes&&(o+=`
${this.m(r,f.processes)}`),f.workspaceMetadata){a+=`
|  Remote: ${f.hostName}`;for(const d of Object.keys(f.workspaceMetadata)){const v=f.workspaceMetadata[d];let L=`${v.fileCount} files`;v.maxFilesReached&&(L=`more than ${L}`),a+=`|    Folder (${d}): ${L}`,a+=this.h(v)}}}),{processInfo:o,workspaceInfo:a}})}async getSystemInfo(r,t){const{memory:n,vmHint:s,os:a,cpus:o}=p(),f={os:a,memory:n,cpus:o,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(f.load=`${D.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(r,t){const n=[];return(0,w.listProcesses)(r.mainPID).then(async s=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,s)),r.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),t.forEach(a=>{if((0,m.isRemoteDiagnosticError)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.f(a.machineInfo)),a.processes&&n.push(this.m(r,a.processes)),a.workspaceMetadata)for(const o of Object.keys(a.workspaceMetadata)){const f=a.workspaceMetadata[o];let d=`${f.fileCount} files`;f.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${o}): ${d}`),n.push(this.h(f))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const t=[];let s=0;const a=(v,L)=>{const N=` ${v}(${L})`;s+N.length>60?(t.push(o),o="|                 ",s=o.length):s+=N.length,o+=N};let o="|      File types:";const f=10,d=r.fileTypes.length>f?f:r.fileTypes.length;for(let v=0;v<d;v++){const L=r.fileTypes[v];a(L.name,L.count)}if(t.push(o),r.configFiles.length>=0&&(o="|      Conf files:",s=0,r.configFiles.forEach(v=>{a(v.name,v.count)}),t.push(o)),r.launchConfigFiles.length>0){let v="|      Launch Configs:";r.launchConfigFiles.forEach(L=>{v+=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`}),t.push(v)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const t=[],n=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const o=I.URI.revive(a);if(o.scheme===c.Schemas.file){const f=o.fsPath;n.push(l(f,["node_modules",".git"]).then(d=>{let v=`${d.fileCount} files`;d.maxFilesReached&&(v=`more than ${v}`),t.push(`|    Folder (${(0,O.basename)(f)}): ${v}`),t.push(this.h(d))}).catch(d=>{t.push(`|      Error: Unable to collect workspace stats for folder ${f} (${d.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const n=new Map;r.windows.forEach(a=>n.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,n,s,t,0),s.join(`
`)}n(r,t,n,s,a){const o=a===0;let f;o?f=s.pid===r?`${this.d.applicationName} main`:"remote agent":(f=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(f=`${f} (${t.get(s.pid)})`));const d=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(d/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(v=>this.n(r,t,n,v,a+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:n}of r.folders){const s=I.URI.revive(n);if(s.scheme!==c.Schemas.file)continue;const a=s.fsPath;try{(await l(a,["node_modules",".git"])).fileTypes.forEach(f=>t.add(f.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const n=I.URI.revive(t);if(n.scheme!==c.Schemas.file)continue;const s=n.fsPath;try{const a=await l(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),a.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),a.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),a.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};A=ye([G(0,S.ITelemetryService),G(1,h.IProductService)],A),e.DiagnosticsService=A}),define(oe[237],ae([0,1,107,3,19,15,2,8,13,50,23,4,6,103,16,171,34,11]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let g=class extends O.Disposable{constructor(b,A,i,r,t,n){super(),this.p=b,this.r=A,this.s=i,this.t=n,this.b=new T.Emitter,this.onDidTokenFailed=this.b.event,this.c=new T.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new T.Emitter,this.onDidChangeAccount=this.f.event,this.j=D.TunnelStates.disconnected;const s=l.URI.file((0,I.join)(i.logsPath,D.LOG_FILE_NAME));this.g=this.B(r.createLogger(s,{name:D.LOGGER_NAME,id:D.LOG_CHANNEL_ID})),this.k=new m.Delayer(100),this.B(this.g.onDidChangeLogLevel(a=>this.g.info("Log level changed to "+(0,P.LogLevelToString)(a)))),this.B(t.onWillShutdown(a=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(n.onDidChangeConfiguration(a=>{a.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(b){if(b&&this.h?b.token!==this.h.token||b.providerId!==this.h.providerId:b!==this.h){this.h=b,this.f.fire(b),b?this.g.info(`Account updated: ${b.accountLabel} (${b.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!b});try{await this.k.trigger(()=>this.v())}catch(A){this.g.error(A)}}return this.j}u(){if(!this.n){let b;w.isMacintosh?b=this.s.appRoot:b=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.n=(0,I.join)(b,"bin",`${this.r.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(D.TunnelStates.disconnected);return}const{token:b,providerId:A,accountLabel:i}=this.h;this.w(D.TunnelStates.connecting((0,S.localize)(0,null,i,A)));const r=(o,f)=>{o=o.replaceAll(b,"*".repeat(4)),f?this.g.error(o):this.g.info(o),!this.s.isBuilt&&o.startsWith("   Compiling")&&this.w(D.TunnelStates.connecting((0,S.localize)(1,null)))},t=this.y("login",["user","login","--provider",A,"--access-token",b,"--log",(0,P.LogLevelToString)(this.g.getLevel())],r);this.i=t;try{if(await t,this.i!==t)return}catch(o){this.g.error(o),this.i=void 0,this.b.fire(!0),this.w(D.TunnelStates.disconnected);return}const n=this.z();n?this.w(D.TunnelStates.connecting((0,S.localize)(2,null,n))):this.w(D.TunnelStates.connecting((0,S.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,P.LogLevelToString)(this.g.getLevel())];n?s.push("--name",n):s.push("--random-name");const a=this.y("tunnel",s,(o,f)=>{f?this.g.error(o):this.g.info(o);const d=o.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(d){const v={link:d[1],domain:d[2],hostName:d[4]};this.w(D.TunnelStates.connected(v))}else o.match(/error refreshing token/)&&(a.cancel(),this.b.fire(!0),this.w(D.TunnelStates.disconnected))});this.i=a,a.finally(()=>{a===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(b){this.j=b,this.c.fire(b)}y(b,A,i=()=>{}){return(0,m.createCancelablePromise)(r=>new Promise((t,n)=>{r.isCancellationRequested&&t();let s;if(r.onCancellationRequested(()=>{s&&(this.g.info(`${b} terminating(${s.pid})`),s.kill())}),!this.s.isBuilt)i("Building tunnel CLI from sources and run",!1),i(`${b} Spawning: cargo run -- tunnel ${A.join(" ")}`,!1),s=(0,E.spawn)("cargo",["run","--","tunnel",...A],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{i("Running tunnel CLI",!1);const a=this.u();i(`${b} Spawning: ${a} tunnel ${A.join(" ")}`,!1),s=(0,E.spawn)(a,["tunnel",...A],{cwd:(0,u.homedir)()})}s.stdout.on("data",a=>{if(s){const o=a.toString();i(o,!1)}}),s.stderr.on("data",a=>{if(s){const o=a.toString();i(o,!0)}}),s.on("exit",a=>{s&&(i(`${b} exit(${s.pid}): + ${a} `,!1),s=void 0,a===0?t():n())}),s.on("error",a=>{s&&(i(`${b} error(${s.pid}): + ${a} `,!0),s=void 0,n())})}))}async getHostName(){return this.z()}z(){let b=this.t.getValue(D.CONFIGURATION_KEY_HOST_NAME)||(0,u.hostname)();return b=b.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),b||void 0}};g=ye([G(0,R.ITelemetryService),G(1,C.IProductService),G(2,c.INativeEnvironmentService),G(3,P.ILoggerService),G(4,y.ISharedProcessLifecycleService),G(5,h.IConfigurationService)],g),e.RemoteTunnelService=g}),define(oe[111],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(c){this.b=c}listen(c,O){throw new Error(`Event not found: ${O}`)}call(c,O,{eventName:P,data:I}){return this.b.forEach(E=>E.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class T{constructor(c){this.b=c}log(c,O){return this.b.call("log",{eventName:c,data:O}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(oe[47],ae([0,1,32,12,3,16,75,110,19]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class E{constructor(o){this.value=o}}e.TelemetryTrustedValue=E;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,f){return Promise.resolve(void 0)}publicLog2(o,f){return this.publicLog(o,f)}publicLogError(o,f){return Promise.resolve(void 0)}publicLogError2(o,f){return this.publicLogError(o,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class w{async publicLog(o,f,d){}async publicLogError(o,f,d){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(a,o){return R.Event.debounce(o.onDidChangeConfiguration,(d,v)=>{const L=d?new Set([...d.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:L}},1e3,!0)(d=>{d.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,c.ConfigurationTargetToString)(d.source),configurationKeys:b(d.affectedKeys)})})}e.configurationTelemetry=m;function y(a,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!a.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=y;function h(a,o){return!(o.isBuilt||o.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=h;function S(a){const o=a.getValue(I.TELEMETRY_SETTING_ID),f=a.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function u(a){const o={},f={},d={};p(a,d);for(let v in d){v=v.length>150?v.substr(v.length-149):v;const L=d[v];typeof L=="number"?f[v]=L:typeof L=="boolean"?f[v]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${L.length}`),o[v]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(o[v]=L)}return{properties:o,measurements:f}}e.validateTelemetryData=u;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(a){if(!a)return"none";const o=(0,O.getRemoteName)(a);return l.has(o)?o:"other"}e.cleanRemoteAuthority=g;function p(a,o,f=0,d){if(!!a)for(const v of Object.getOwnPropertyNames(a)){const L=a[v],N=d?d+v:v;Array.isArray(L)?o[N]=(0,D.safeStringify)(L):L instanceof Date?o[N]=L.toISOString():(0,T.isObject)(L)?f<2?p(L,o,f+1,N+"."):o[N]=(0,D.safeStringify)(L):o[N]=L}}function b(a){if(!a)return[];const o=[];return A(o,"",a),o}function A(a,o,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(d=>A(a,o?`${o}.${d}`:d,f[d])):a.push(o)}function i(a,o){const f=a.msftInternalDomains||[],d=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(f)||d}e.isInternalTelemetry=i;function r(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=r;function t(a,o){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let f=a;const d=[];for(const F of o)for(;;){const M=F.exec(a);if(!M)break;d.push([M.index,F.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(f="";;){const F=L.exec(a);if(!F)break;const M=d.some(([k,$])=>F.index<$&&k<L.lastIndex);!v.test(F[0])&&!M&&(f+=a.substring(N,F.index)+"<REDACTED: user-file-path>",N=L.lastIndex)}return N<a.length&&(f+=a.substr(N)),f}function n(a){if(!a)return a;const o=a.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return a}function s(a,o){return(0,D.cloneAndChange)(a,f=>{if(f instanceof E)return f.value;if(typeof f=="string"){let d=f.replaceAll("%20"," ");d=t(d,o);for(const v of o)d=d.replace(v,"");return d=n(d),d}})}e.cleanData=s}),define(oe[33],ae([0,1,27,30,42,4,11,9,36,47]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,D.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=C;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const s=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,s,a)}static parse(n){const s=w.exec(n);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?C(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(t){const n=y.exec(t);return n&&n[1]?[u(n[1]),n[2]]:[u(t),void 0]}e.getIdAndVersion=h;function S(t,n){return`${t}.${n}`}e.getExtensionId=S;function u(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function l(t,n){return u(S(t,n))}e.getGalleryExtensionId=l;function g(t,n){const s=[],a=o=>{for(const f of s)if(f.some(d=>C(n(d),n(o))))return f;return null};for(const o of t){const f=a(o);f?f.push(o):s.push([o])}return s}e.groupByExtension=g;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function b(t){return{id:new E.TelemetryTrustedValue(t.identifier.id),name:new E.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function A(t,n){const s=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&s.every(f=>!C(f.identifier,{id:o}))){const f=t.filter(d=>C(d.identifier,{id:o}));f.length===1&&(s.push(f[0]),a.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=A;async function i(t,n){if(!c.isLinux)return!1;let s;try{s=(await t.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function r(t,n){const s=await i(t,n),a=(0,T.getTargetPlatform)(s?"alpine":c.platform,I.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=r}),define(oe[238],ae([0,1,25,33]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(c,O,P,I,E){try{const C=await c.getExtensionsControlManifest();if(!C.deprecated)return;const w=await c.getInstalled(1);for(const[m,y]of Object.entries(C.deprecated)){if(!y?.extension)continue;const{id:h,autoMigrate:S,preRelease:u}=y.extension;if(!S)continue;const l=w.find(p=>(0,T.areSameExtensions)(p.identifier,{id:m}));if(!l)continue;const g=(await O.getExtensions([{id:h,preRelease:u}],{targetPlatform:await c.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!g){E.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{E.info(`Migrating '${l.identifier.id}' extension to '${h}' extension...`);const p=!I.getDisabledExtensions().some(A=>(0,T.areSameExtensions)(A,l.identifier));await c.uninstall(l),E.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let b=w.find(A=>(0,T.areSameExtensions)(A.identifier,{id:h}));(!b||!b.isPreReleaseVersion&&p)&&(b=await c.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${b.identifier.id}'`),p||(await I.disableExtension(b.identifier),E.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),S.storage&&(P.addToMigrationList((0,T.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,T.getExtensionId)(b.manifest.publisher,b.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${l.identifier.id}' extension to '${h}' extension.`)}catch(p){E.error(p)}}}catch(C){E.error(C)}}e.migrateUnsupportedExtensions=R}),define(oe[239],ae([0,1,6,9,2,26,4,22,54,12,31,28,16,15,30,33,98,14,8,23]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let b=class yt extends R.Disposable{constructor(i,r,t,n,s,a,o){super(),this.h=r,this.i=t,this.j=n,this.k=s,this.l=a,this.m=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(i,r){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.w(i));try{await this.t(i,t,s=>this.i.download(i,s,r))}catch(s){throw new h.ExtensionManagementError(s.message,h.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(i)){const s=await this.r(i);try{await this.l.verify(t.fsPath,s.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`)}catch(a){const o=a.code;if(o==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`);else throw await this.delete(s),await this.delete(t),new h.ExtensionManagementError(o,h.ExtensionManagementErrorCode.Signature)}}return{location:t,verificationStatus:n}}async n(i){if(!i.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,E.isBoolean)(r)?r:this.k.quality!=="stable"}async r(i){await this.g;const r=(0,P.joinPath)(this.extensionsDownloadDir,`${this.w(i)}${yt.c}`);return await this.t(i,r,t=>this.i.downloadSignatureArchive(i,t)),r}async t(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==c.Schemas.file){await t(r);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.h.exists(n)||await t(n);try{await this.u(n,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.m.info(`Rename failed because of ${(0,T.getErrorMessage)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async u(i,r,t){try{await w.Promises.rename(i.fsPath,r.fsPath)}catch(n){if(O.isWindows&&n&&n.code==="EPERM"&&Date.now()<t)return this.m.info(`Failed renaming ${i} to ${r} with 'EPERM' error. Trying again...`),this.u(i,r,t);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const o of i.children)if(o.name.endsWith(yt.c))n.push(o.resource);else{const f=S.ExtensionKey.parse(o.name);f&&t.push([f,o])}const s=(0,S.groupByExtension)(t,([o])=>o),a=[];for(const o of s)o.sort((f,d)=>I.rcompare(f[0].version,d[0].version)),r.push(...o.slice(1).map(f=>f[1].resource)),a.push(o[0][1]);a.sort((o,f)=>o.mtime-f.mtime),r.push(...a.slice(0,Math.max(0,a.length-this.f)).map(o=>o.resource)),r.push(...n),await D.Promises.settled(r.map(o=>(this.m.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(i){this.m.error(i)}}w(i){return this.f?S.ExtensionKey.create(i).toString().toLowerCase():(0,C.generateUuid)()}};b.c=".sigzip",b=ye([G(0,y.INativeEnvironmentService),G(1,l.IFileService),G(2,h.IExtensionGalleryService),G(3,m.IConfigurationService),G(4,p.IProductService),G(5,u.IExtensionSignatureVerificationService),G(6,g.ILogService)],b),e.ExtensionsDownloader=b}),define(oe[240],ae([0,1,3,2,37,33,42]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends T.Disposable{constructor(E,C,w,m,y,h,S){super(),this.f=E,this.g=C,this.h=w,this.i=m,this.j=y,this.k=h,this.l=S,this.a=this.B(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new T.DisposableMap),this.m().then(null,u=>S.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(E=>this.p(E.added,E.removed))),this.B(this.i.onAddExtensions(E=>this.r(E))),this.B(this.i.onDidAddExtensions(E=>this.s(E))),this.B(this.i.onRemoveExtensions(E=>this.t(E))),this.B(this.i.onDidRemoveExtensions(E=>this.u(E))),this.B(this.k.onDidFilesChange(E=>this.v(E)))}async p(E,C){try{await Promise.all(C.map(w=>(this.c.deleteAndDispose(w.id),this.z(w.extensionsResource)))),E.length&&await Promise.all(E.map(w=>(this.c.set(w.id,(0,T.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(E){for(const C of E.extensions)this.D(this.G(C.identifier,C.version),E.profileLocation)}async s(E){for(const C of E.extensions){const w=this.G(C.identifier,C.version);E.error?this.F(w,E.profileLocation):this.D(w,E.profileLocation)}}async t(E){for(const C of E.extensions)this.F(this.G(C.identifier,C.version),E.profileLocation)}async u(E){let C=!1;for(const w of E.extensions){const m=this.G(w.identifier,w.version);E.error?this.D(m,E.profileLocation):(this.F(m,E.profileLocation),C=C||!this.b.has(m))}C&&await this.C()}v(E){for(const C of this.h.profiles)E.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(E){const C=[],w=[],m=await this.i.scanProfileExtensions(E),y=new Set,h=new Set;for(const[S,u]of this.b)u.has(E)&&h.add(S);for(const S of m){const u=this.G(S.identifier,S.version);y.add(u),h.has(u)||(C.push(S.identifier),this.D(u,E))}for(const S of h)if(!y.has(S)){const u=this.H(S);u&&(w.push(u.identifier),this.F(S,E))}(C.length||w.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:E}:void 0,removed:w.length?{extensions:w,profileLocation:E}:void 0})}async y(E){const C=await this.i.scanProfileExtensions(E);for(const w of C)this.D(this.G(w.identifier,w.version),E)}async z(E){for(const C of[...this.b.keys()])this.F(C,E);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(w=>w.installedTimestamp&&!this.b.has(this.G(w.identifier,w.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(E,C){let w=this.b.get(E);w||this.b.set(E,w=new R.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),w.add(C)}F(E,C){const w=this.b.get(E);w&&w.delete(C),w?.size||this.b.delete(E)}G(E,C){return`${O.ExtensionIdentifier.toKey(E.id)}@${C}`}H(E){const[C,w]=(0,c.getIdAndVersion)(E);return w?{identifier:{id:C},version:w}:void 0}}e.ExtensionsWatcher=P}),define(oe[241],ae([0,1,45,47]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(c,O,P,I,E,C,w){const m={"X-Market-Client-Id":`VSCode ${c}`,"User-Agent":`VSCode ${c} (${O.nameShort})`};if((0,T.supportsTelemetry)(O,P)&&(0,T.getTelemetryLevel)(I)===3){const y=await(0,D.getServiceMachineId)(P,E,C),{machineId:h}=await w.getTelemetryInfo();m["X-Market-User-Id"]=y,m["VSCode-SessionId"]=h||y}return m}e.resolveMarketplaceHeaders=R}),define(oe[242],ae([0,1,100,21,6,2,26,13,28,15,30,33,8,73,4,11]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let u=class extends y.LanguagePackBaseService{constructor(b,A,i,r){super(i),this.h=b,this.i=r,this.g=this.B(new l(A,r)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(b){const i=(await this.g.getLanguagePacks())[h.Language.value()];if(!i){this.i.warn(`No language pack found for ${h.Language.value()}`);return}const r=i.translations[b];return r?S.URI.file(r):void 0}async getInstalledLanguages(){const b=await this.g.getLanguagePacks(),A=Object.keys(b).map(i=>{const r=b[i];return{...this.f(i,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return A.push({...this.f("en","English"),extensionId:"default"}),A.sort((i,r)=>i.label.localeCompare(r.label)),A}async j(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",b.identifier.id),await this.update())}async k(b){const A=await this.g.getLanguagePacks();Object.keys(A).some(i=>A[i]&&A[i].extensions.some(r=>(0,w.areSameExtensions)(r.extensionIdentifier,b.identifier)))&&(this.i.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,A]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(A);return!(0,T.equals)(Object.keys(b),Object.keys(i))}};u=ye([G(0,C.IExtensionManagementService),G(1,E.INativeEnvironmentService),G(2,C.IExtensionGalleryService),G(3,m.ILogService)],u),e.NativeLanguagePackService=u;let l=class extends c.Disposable{constructor(b,A){super(),this.i=A,this.c={},this.f=(0,P.join)(b.userDataPath,"languagepacks.json"),this.g=new R.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(b){return this.m(A=>{Object.keys(A).forEach(i=>delete A[i]),this.j(A,...b)}).then(()=>this.c)}j(b,...A){for(const i of A)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(b,i);Object.keys(b).forEach(i=>this.l(b[i]))}k(b,A){const i=A.identifier,r=A.manifest.contributes&&A.manifest.contributes.localizations?A.manifest.contributes.localizations:[];for(const t of r)if(A.location.scheme===O.Schemas.file&&g(t)){let n=b[t.languageId];n||(n={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},b[t.languageId]=n);const s=n.extensions.filter(a=>(0,w.areSameExtensions)(a.extensionIdentifier,i))[0];s?s.version=A.manifest.version:n.extensions.push({extensionIdentifier:i,version:A.manifest.version});for(const a of t.translations)n.translations[a.id]=(0,P.join)(A.location.fsPath,a.path)}}l(b){if(b){const A=(0,D.createHash)("md5");for(const i of b.extensions)A.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);b.hash=A.digest("hex")}}m(b=()=>null){return this.g.queue(()=>{let A=null;return I.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(A=b(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),I.Promises.writeFile(this.f,r)}).then(()=>A,i=>this.i.error(i))})}};l=ye([G(0,E.INativeEnvironmentService),G(1,m.ILogService)],l);function g(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const b of p.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(oe[243],ae([0,1,9,32,47]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const c="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function P(E,C,w){const m=await new Promise((l,g)=>{Q(["@microsoft/1ds-core-js"],l,g)}),y=await new Promise((l,g)=>{Q(["@microsoft/1ds-post-js"],l,g)}),h=new m.AppInsightsCore,S=new y.PostChannel,u={instrumentationKey:E,endpointUrl:c,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[S]]};if(w){u.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:w};u.extensionConfig[S.identifier]=l}return h.initialize(u,[]),h.addTelemetryInitializer(l=>{C&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),h}class I{constructor(C,w,m,y,h){this.e=C,this.f=w,this.g=m,this.h=h,this.c=c,this.d=O,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(C){if(!!this.a){if(typeof this.a!="string"){C(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(w=>{C(w)},w=>{(0,D.onUnexpectedError)(w),console.error(w)})}}log(C,w){if(!this.a)return;w=(0,T.mixin)(w,this.g),w=(0,R.validateTelemetryData)(w);const m=this.f+"/"+C;try{this.i(y=>{y.pluginVersionString=w?.properties.version??"Unknown",y.track({name:m,baseData:{name:m,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(C=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(oe[112],ae([0,1,2,174,15,8,23,47]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends D.Disposable{constructor(C,w,m,y,h=""){super(),this.b=h;const S=w.getLogger(m.telemetryLogResource);if(S)this.a=this.B(S);else{const l=(0,P.isLoggingOnly)(y,m)?" (Not Sent)":"",g=m.telemetryLogResource,p=()=>(0,P.supportsTelemetry)(y,m)&&C.getLevel()===c.LogLevel.Trace;this.a=this.B(w.createLogger(g,{id:P.telemetryLogChannelId,name:(0,T.localize)(0,null,l),hidden:!p()})),this.B(C.onDidChangeLogLevel(()=>w.setVisibility(g,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,w){this.a.trace(`${this.b}telemetry/${C}`,(0,P.validateTelemetryData)(w))}};I=ye([G(0,c.ILogService),G(1,c.ILoggerService),G(2,R.IEnvironmentService),G(3,O.IProductService)],I),e.TelemetryLogAppender=I}),define(oe[113],ae([0,1,2,32,4,27,175,16,46,105,23,40,19,47]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(l,g,p){this.k=g,this.l=p,this.d={},this.i=new D.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,c.escapeRegExpCharacters)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,c.escapeRegExpCharacters)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(m.TELEMETRY_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,g){this.d[l]=g}m(){let l=(0,y.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const p=g.usage?3:g.error?2:0;l=Math.min(l,p)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,g=l.sessionID,p=l["common.machineId"],b=l["common.firstSessionDate"],A=l["common.msftInternal"];return{sessionId:g,machineId:p,firstSessionDate:b,msftInternal:A}}dispose(){this.i.dispose()}n(l,g,p){return this.g<g?Promise.resolve(void 0):this.c.then(b=>{p=(0,T.mixin)(p,this.d),p=(0,y.cleanData)(p,this.j),p=(0,T.mixin)(p,b),this.b.forEach(A=>A.log(l,p))},b=>{console.error(b)})}publicLog(l,g){return this.n(l,3,g)}publicLog2(l,g){return this.publicLog(l,g)}publicLogError(l,g){return this.h?this.n(l,2,g):Promise.resolve(void 0)}publicLogError2(l,g){return this.publicLogError(l,g)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=ye([G(1,P.IConfigurationService),G(2,C.IProductService)],h),e.TelemetryService=h;function S(){const u=(0,O.localize)(0,null,E.default.nameLong),l=E.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=R.isWeb?"":(0,O.localize)(3,null),p=(0,O.localize)(4,null),b=(0,O.localize)(5,null),A=(0,O.localize)(6,null),i=(0,O.localize)(7,null),r=`
|       | ${p} | ${b} | ${A} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,O.localize)(8,null);return`
${u} ${l} ${g}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}w.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,O.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,O.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[244],ae([0,1,295,243]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends T.AbstractOneDataSystemAppender{constructor(O,P,I,E){const C={sendPOST:(w,m)=>{const y={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const h=D.request(w.urlString,y,S=>{S.on("data",function(u){m(S.statusCode??200,S.headers,u.toString())}),S.on("error",function(u){m(0,{})})});h.write(w.data),h.end()}catch{m(0,{})}}};super(O,P,I,E,C)}}e.OneDataSystemAppender=R}),define(oe[245],ae([0,1,26,68,16,15,8,23,19,111,112,113]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(h,S,u,l,g,p){this.b=h,this.c=S,this.d=u,this.e=l,this.f=g,this.g=p,this.a=new Map}async h(h){if(!this.a.has(h.id)){const{machineId:S,sessionId:u}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=S,l["common.vscodesessionid"]=u;const g=[h.id,JSON.stringify(l),h.aiKey],b=new T.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),A=[new E.TelemetryAppenderClient(b),new C.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${h.id}] `)];this.a.set(h.id,new w.TelemetryService({appenders:A,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.g))}return this.a.get(h.id)}async publicLog(h,S,u){await(await this.h(h)).publicLog(S,u)}async publicLogError(h,S,u){await(await this.h(h)).publicLogError(S,u)}};m=ye([G(0,R.IConfigurationService),G(1,I.ITelemetryService),G(2,O.ILogService),G(3,O.ILoggerService),G(4,c.IEnvironmentService),G(5,P.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(oe[114],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var D;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(D=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(oe[246],ae([0,1,4,114]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class R{constructor(I){this.collections=I,this.map=new Map,I.forEach((E,C)=>{const w=E.map.entries();let m=w.next();for(;!m.done;){const y=m.value[0];let h=this.map.get(y);if(h||(h=[],this.map.set(y,h)),h.length>0&&h[0].type===T.EnvironmentVariableMutatorType.Replace){m=w.next();continue}const S=m.value[1];h.unshift({extensionIdentifier:C,value:S.value,type:S.type}),m=w.next()}})}async applyToProcessEnvironment(I,E){let C;D.isWindows&&(C={},Object.keys(I).forEach(w=>C[w.toLowerCase()]=w));for(const[w,m]of this.map){const y=D.isWindows&&C[w.toLowerCase()]||w;for(const h of m){const S=E?await E(h.value):h.value;switch(h.type){case T.EnvironmentVariableMutatorType.Append:I[y]=(I[y]||"")+S;break;case T.EnvironmentVariableMutatorType.Prepend:I[y]=S+(I[y]||"");break;case T.EnvironmentVariableMutatorType.Replace:I[y]=S;break}}}}diff(I){const E=new Map,C=new Map,w=new Map;if(I.map.forEach((m,y)=>{const h=this.map.get(y),S=c(m,h);S&&E.set(y,S)}),this.map.forEach((m,y)=>{const h=I.map.get(y),S=c(m,h);S&&w.set(y,S)}),this.map.forEach((m,y)=>{const h=I.map.get(y),S=O(m,h);S&&C.set(y,S)}),!(E.size===0&&C.size===0&&w.size===0))return{added:E,changed:C,removed:w}}}e.MergedEnvironmentVariableCollection=R;function c(P,I){if(!I)return P;const E=new Set;I.forEach(w=>E.add(w.extensionIdentifier));const C=[];return P.forEach(w=>{E.has(w.extensionIdentifier)||C.push(w)}),C.length===0?void 0:C}function O(P,I){if(!I)return;const E=new Map;I.forEach(w=>E.set(w.extensionIdentifier,w));const C=[];return P.forEach(w=>{const m=E.get(w.extensionIdentifier);m&&(w.type!==m.type||w.value!==m.value)&&C.push(m)}),C.length===0?void 0:C}}),define(oe[247],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function D(O){return[...O.entries()]}e.serializeEnvironmentVariableCollection=D;function T(O){return new Map(O)}e.deserializeEnvironmentVariableCollection=T;function R(O){return Array.from(O.entries()).map(P=>[P[0],D(P[1].map)])}e.serializeEnvironmentVariableCollections=R;function c(O){return new Map(O.map(P=>[P[0],{map:T(P[1])}]))}e.deserializeEnvironmentVariableCollections=c}),define(oe[248],ae([0,1,6,25,3,2,8]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends c.Disposable{constructor(E,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new R.Emitter),this.onCreateRequest=this.g.event,this.b=E===void 0?15e3:E}createRequest(E){return new Promise((C,w)=>{const m=++this.a;this.c.set(m,C),this.g.fire({requestId:m,...E});const y=new T.CancellationTokenSource;(0,D.timeout)(this.b,y.token).then(()=>w(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,c.toDisposable)(()=>y.cancel())])})}acceptReply(E,C){const w=this.c.get(E);w?(this.c.delete(E),(0,c.dispose)(this.f.get(E)||[]),this.f.delete(E),w(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=ye([G(1,O.ILogService)],P),e.RequestStore=P}),define(oe[115],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var c;(function(p){p.FileName="ptyhost"})(c=e.TerminalLogConstants||(e.TerminalLogConstants={}));var O;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(O=e.PosixShellType||(e.PosixShellType={}));var P;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Logger="logger",p.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var C;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(p){p.TerminalView="view",p.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var u;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(u=e.ProfileSource||(e.ProfileSource={}));var l;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[249],ae([0,1,52,11,177,132]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function O(m,y){const h=[{name:null,description:(0,R.localize)(0,null)}];return h.push(...m.map(S=>({name:S.profileName,description:P(S)}))),y&&h.push(...y.map(S=>({name:S.title,description:I(S)}))),{values:h.map(S=>S.name),markdownDescriptions:h.map(S=>S.description)}}e.createProfileSchemaEnums=O;function P(m){let y=`$(${c.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:D.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?y+=`
- args: "${m.args}"`:y+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(y+=`
- overrideName: ${m.overrideName}`),m.color&&(y+=`
- color: ${m.color}`),m.env&&(y+=`
- env: ${JSON.stringify(m.env)}`),y}function I(m){return`$(${c.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:D.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function E(m,y){if(!m&&!y)return!0;if(typeof m=="string"&&typeof y=="string")return m===y;if(Array.isArray(m)&&Array.isArray(y)){if(m.length!==y.length)return!1;for(let h=0;h<m.length;h++)if(m[h]!==y[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function C(m,y){if(!m&&!y)return!0;if(!m||!y)return!1;if(c.ThemeIcon.isThemeIcon(m)&&c.ThemeIcon.isThemeIcon(y))return m.id===y.id&&m.color===y.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof y=="object"&&"light"in y&&"dark"in y){const h=m,S=y;if((T.URI.isUri(h.light)||w(h.light))&&(T.URI.isUri(h.dark)||w(h.dark))&&(T.URI.isUri(S.light)||w(S.light))&&(T.URI.isUri(S.dark)||w(S.dark)))return h.light.path===S.light.path&&h.dark.path===S.dark.path}if(T.URI.isUri(m)&&T.URI.isUri(y)||w(m)||w(y)){const h=m,S=y;return h.path===S.path&&h.scheme===S.scheme}return!1}e.terminalIconsEqual=C;function w(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=w}),define(oe[250],ae([0,1,52,176,46,40,249]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,D.getAllCodicons)(),b=>b.id),markdownEnumDescriptions:Array.from((0,D.getAllCodicons)(),b=>`$(${b.id})`)};const P={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),...e.terminalIconSchema},color:{description:(0,T.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(6,null),type:["string"],items:{type:"string"}},...P}},C=(0,T.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,T.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,T.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,T.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,T.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,T.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),u={id:"terminal",order:100,title:(0,T.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(26,null)}},{type:"string",markdownDescription:(0,T.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(30,null),type:"string"},id:{description:(0,T.localize)(31,null),type:"string"},title:{description:(0,T.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(34,null),type:"string"},id:{description:(0,T.localize)(35,null),type:"string"},title:{description:(0,T.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(38,null),type:"string"},id:{description:(0,T.localize)(39,null),type:"string"},title:{description:(0,T.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,T.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){c.Registry.as(R.Extensions.Configuration).registerConfiguration(u),p()}e.registerTerminalPlatformConfiguration=l;let g;function p(b,A){const i=c.Registry.as(R.Extensions.Configuration);let r;b&&(r=(0,O.createProfileSchemaEnums)(b?.profiles,A));const t=g;g={id:"terminal",order:100,title:(0,T.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?r?.values:void 0,markdownEnumDescriptions:b?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?r?.values:void 0,markdownEnumDescriptions:b?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?r?.values:void 0,markdownEnumDescriptions:b?.os===1?r?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(oe[251],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(oe[252],ae([0,1,34,26,32,13,4,36,27,12,28,114,247,246]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function h(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let s=0;return n&&n.length===4&&(s=parseInt(n[3])),s}e.getWindowsBuildNumber=h;async function S(n,s,a,o=P.env,f=C.Promises.exists){if(c.isAbsolute(n))return await f(n)?n:void 0;if(s===void 0&&(s=P.cwd()),c.dirname(n)!=="."){const N=c.join(s,n);return await f(N)?N:void 0}const v=(0,R.getCaseInsensitive)(o,"PATH");if(a===void 0&&(0,E.isString)(v)&&(a=v.split(c.delimiter)),a===void 0||a.length===0){const N=c.join(s,n);return await f(N)?N:void 0}for(const N of a){let F;if(c.isAbsolute(N)?F=c.join(N,n):F=c.join(s,N,n),await f(F))return F;if(O.isWindows){let M=F+".com";if(await f(M)||(M=F+".exe",await f(M)))return M}}const L=c.join(s,n);return await f(L)?L:void 0}e.findExecutable=S;function u(n,s,a,o,f){if(!s.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||O.isWindows&&!s.windowsEnableConpty)return;const d=n.args,v=P.platform==="win32"?c.basename(n.executable).toLowerCase():c.basename(n.executable),L=c.dirname(T.FileAccess.asFileUri("").fsPath);let N;const F={VSCODE_INJECTION:"1"};if(O.isWindows){if(v==="pwsh.exe"||v==="powershell.exe")return!d||r(d)?N=p.get(g.WindowsPwsh):i(d)&&(N=p.get(g.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],L,""),{newArgs:N,envMixin:F}):void 0;o.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(v){case"bash":return!d||d.length===0?N=p.get(g.Bash):t(d)&&(F.VSCODE_SHELL_LOGIN="1",l(s,F),N=p.get(g.Bash)),N?(N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],L),{newArgs:N,envMixin:F}):void 0;case"fish":{const M=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",k=c.join(L,"out/vs/workbench/contrib/xdg_data");return F.XDG_DATA_DIRS=`${M}:${k}`,l(s,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!d||r(d)?N=p.get(g.Pwsh):i(d)&&(N=p.get(g.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],L,""),{newArgs:N,envMixin:F}):void 0;case"zsh":{if(!d||d.length===0?N=p.get(g.Zsh):t(d)?(N=p.get(g.ZshLogin),l(s,F)):(d===p.get(g.Zsh)||d===p.get(g.ZshLogin))&&(N=d),!N)return;N=[...N],N[N.length-1]=(0,I.format)(N[N.length-1],L);let M;try{M=D.userInfo().username}catch{M="unknown"}const k=c.join(D.tmpdir(),`${M}-${f.applicationName}-zsh`);F.ZDOTDIR=k;const $=a?.ZDOTDIR??D.homedir()??"~";F.USER_ZDOTDIR=$;const z=[];return z.push({source:c.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:c.join(k,".zshrc")}),z.push({source:c.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:c.join(k,".zprofile")}),z.push({source:c.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:c.join(k,".zshenv")}),z.push({source:c.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:c.join(k,".zlogin")}),{newArgs:N,envMixin:F,filesToCopy:z}}}o.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=u;function l(n,s){if(O.isMacintosh&&n.environmentVariableCollections){const a=(0,m.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),f=new y.MergedEnvironmentVariableCollection(a).map.get("PATH"),d=[];if(f)for(const v of f)v.type===w.EnvironmentVariableMutatorType.Prepend&&d.push(v.value);d.length>0&&(s.VSCODE_PATH_PREFIX=d.join(""))}}var g;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(g||(g={}));const p=new Map;p.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(g.Zsh,["-i"]),p.set(g.ZshLogin,["-il"]),p.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],A=["-nol","-nologo"];function i(n){return typeof n=="string"?b.includes(n.toLowerCase()):n.length===1&&b.includes(n[0].toLowerCase())||n.length===2&&(b.includes(n[0].toLowerCase())||b.includes(n[1].toLowerCase()))&&(A.includes(n[0].toLowerCase())||A.includes(n[1].toLowerCase()))}function r(n){return typeof n=="string"?A.includes(n.toLowerCase()):n.length===0||n?.length===1&&A.includes(n[0].toLowerCase())}function t(n){return n==="string"&&b.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&b.includes(n[0].toLowerCase())}}),define(oe[253],ae([0,1,50,52,13,4,12,28,91,252]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,w=!0;function m(r,t,n,s,a=process.env,o,f,d,v){return o=o||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},c.isWindows?y(n,o,a,f,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),v,d):b(o,f,n,r&&typeof r=="object"?{...r}:s.getValue(c.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(c.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,d,a)}e.detectAvailableProfiles=m;async function y(r,t,n,s,a,o,f,d,v){const L=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${L?"Sysnative":"System32"}`;let F=!1;(0,E.getWindowsBuildNumber)()>=16299&&(F=!0),await u(d);const M=new Map;if(r){M.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),M.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0}),M.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),M.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:T.Codicon.terminalBash,isAutoDetected:!0});const $=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;M.set("Cmder",{path:`${N}\\cmd.exe`,args:["/K",$],requiresPath:process.env.CMDER_ROOT?$:{path:$,isUnsafe:!0},isAutoDetected:!0})}A(o,M);const k=await h(M.entries(),f,t,n,s,v);if(r||a)try{const $=await g(`${N}\\${F?"wsl":"bash"}.exe`,f);for(const z of $)(!o||!(z.profileName in o))&&k.push(z)}catch{w&&(s?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return k}async function h(r,t,n,s=process.env,a,o){const f=[];for(const[d,v]of r){if(v===null)continue;let L,N,F;if("source"in v){const z=C?.get(v.source);if(!z)continue;L=z.paths,N=v.args||z.args,v.icon?F=S(v.icon):z.icon&&(F=z.icon)}else L=Array.isArray(v.path)?v.path:[v.path],N=c.isWindows||Array.isArray(v.args)?v.args:void 0,F=S(v.icon);let M;if(o){const z=L.map(X=>typeof X=="string"?X:X.path),x=await o(z);M=new Array(L.length);for(let X=0;X<L.length;X++)typeof L[X]=="string"?M[X]=x[X]:M[X]={path:x[X],isUnsafe:!0}}else M=L.slice();let k;if(v.requiresPath){let z;if((0,O.isString)(v.requiresPath)?z=v.requiresPath:(z=v.requiresPath.path,v.requiresPath.isUnsafe&&(k=z)),!await n.existsFile(z))continue}const $=await i(d,t,M,n,s,N,v.env,v.overrideName,v.isAutoDetected,k);$?($.isAutoDetected=v.isAutoDetected,$.icon=F,$.color=v.color,f.push($)):a?.debug("Terminal profile not validated",d,L)}return a?.debug("Validated terminal profiles",f),f}function S(r){return typeof r=="string"?{id:r}:r}async function u(r){C&&!r||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),C.set("PowerShell",{profileName:"PowerShell",paths:r||await l(),icon:T.Codicon.terminalPowershell}))}async function l(){const r=[];for await(const t of(0,I.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function g(r,t){const n=[],s=await new Promise((f,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(v,L)=>{if(v)return d("Problem occurred when getting wsl distros");f(L)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),o=s.split(a).filter(f=>f.trim().length>0&&f!=="");for(const f of o){if(f===""||f.startsWith("docker-desktop"))continue;const d=`${f} (WSL)`,v={profileName:d,path:r,args:["-d",`${f}`],isDefault:d===t,icon:p(f),isAutoDetected:!1};n.push(v)}return n}function p(r){return r.includes("Ubuntu")?T.Codicon.terminalUbuntu:r.includes("Debian")?T.Codicon.terminalDebian:T.Codicon.terminalLinux}async function b(r,t,n,s,a,o,f,d){const v=new Map;if(n){const L=(await r.readFile("/etc/shells")).toString(),N=o||L.split(`
`).filter(M=>M.trim().includes("#")&&M.trim().length>0),F=new Map;for(const M of N){let k=(0,R.basename)(M),$=F.get(k)||0;$++,$>1&&(k=`${k} (${$})`),F.set(k,$),v.set(k,{path:M,isAutoDetected:!0})}}return A(s,v),await h(v.entries(),a,r,d,t,f)}function A(r,t){if(!!r)for(const[n,s]of Object.entries(r))s===null||!("path"in s)&&!("source"in s)?t.delete(n):(s.icon=s.icon||t.get(n)?.icon,t.set(n,s))}async function i(r,t,n,s,a,o,f,d,v,L){if(n.length===0)return Promise.resolve(void 0);const N=n.shift();if(N==="")return i(r,t,n,s,a,o,f,d,v);const F=typeof N!="string"&&N.isUnsafe,M=typeof N=="string"?N:N.path,k={profileName:r,path:M,args:o,env:f,overrideName:d,isAutoDetected:v,isDefault:r===t,isUnsafePath:F,requiresUnsafePath:L};if((0,R.basename)(M)===M){const z=a.PATH?a.PATH.split(R.delimiter):void 0,x=await(0,E.findExecutable)(M,void 0,z,void 0,s.existsFile);return x?(k.path=x,k.isFromPath=!0,k):i(r,t,n,s,a,o)}return await s.existsFile((0,R.normalize)(M))?k:i(r,t,n,s,a,o,f,d,v)}}),define(oe[254],ae([0,1,3,2,26,4,39,68,16,15,95,234,8,248,115,250,253,104]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(A){A[A.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let p=0,b=class extends T.Disposable{constructor(i,r,t,n,s,a){super(),this.C=i,this.D=r,this.F=t,this.G=n,this.H=s,this.I=a,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new D.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new D.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new D.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new D.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new D.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new D.Emitter),this.onProcessData=this.s.event,this.t=this.B(new D.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new D.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new D.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new D.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new D.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new D.Emitter),this.onProcessExit=this.z.event,(0,S.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,T.toDisposable)(()=>this.O())),this.f=this.B(new y.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(c.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(i){return this.H.error("ptyHost was unable to resolve shell environment",i),{}}}N(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:p,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,C.parsePtyHostPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?i.debugBrk=r.port:!r.break&&r.port&&(i.debug=r.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),O.ProxyChannel.toService(t.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=g.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this.B(new l.RemoteLoggerChannelClient(this.I,t.getChannel(h.TerminalIpcChannels.Logger)));const s=O.ProxyChannel.toService(t.getChannel(h.TerminalIpcChannels.PtyHost));return this.B(s.onProcessData(a=>this.s.fire(a))),this.B(s.onProcessReady(a=>this.t.fire(a))),this.B(s.onProcessExit(a=>this.z.fire(a))),this.B(s.onDidChangeProperty(a=>this.y.fire(a))),this.B(s.onProcessReplay(a=>this.u.fire(a))),this.B(s.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(s.onDidRequestDetach(a=>this.w.fire(a))),[t,s]}dispose(){this.i=!0,super.dispose()}async createProcess(i,r,t,n,s,a,o,f,d,v,L){const N=setTimeout(()=>this.S(),h.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(i,r,t,n,s,a,o,f,d,v,L);return clearTimeout(N),p=Math.max(p,F),F}updateTitle(i,r,t){return this.b.updateTitle(i,r,t)}updateIcon(i,r,t,n){return this.b.updateIcon(i,r,t,n)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,r){return this.b.detachFromProcess(i,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,r){return this.b.shutdown(i,r)}input(i,r){return this.b.input(i,r)}processBinary(i,r){return this.b.processBinary(i,r)}resize(i,r,t){return this.b.resize(i,r,t)}acknowledgeDataEvent(i,r){return this.b.acknowledgeDataEvent(i,r)}setUnicodeVersion(i,r){return this.b.setUnicodeVersion(i,r)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,r){return this.b.installAutoReply(i,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,r,t,n=!1){const s=await this.c;return(0,u.detectAvailableProfiles)(r,t,n,this.F,s,void 0,this.H,this.W.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i,r){return this.b.getWslPath(i,r)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,r){return this.b.requestDetachInstance(i,r)}async acceptDetachInstanceReply(i,r){return this.b.acceptDetachInstanceReply(i,r)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,r){return this.b.reviveTerminalProcesses(i,r)}async refreshProperty(i,r){return this.b.refreshProperty(i,r)}async updateProperty(i,r,t){return this.b.updateProperty(i,r,t)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(i,r){return this.f.createRequest({workspaceId:i,originalText:r})}async acceptPtyHostResolvedVariables(i,r){this.f.acceptReply(i,r)}};b=ye([G(2,I.IConfigurationService),G(3,E.IEnvironmentService),G(4,m.ILogService),G(5,m.ILoggerService)],b),e.PtyHostService=b}),define(oe[77],ae([0,1,3,16,5,8]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var O;(function(S){S.Http="http",S.Https="https"})(O=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=w;function m(S,u,l,g){if(l===1)return!1;if(l===2&&w(u)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(p?.length===4&&parseInt(p[1])>=18)return!1}return S<1024}e.isPortPrivileged=m;class y{constructor(u,l,g){this.remoteAddress=u,this.localAddress=l,this.b=g,this.a=new D.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let h=class{constructor(u,l){this.i=u,this.j=l,this.a=new D.Emitter,this.onTunnelOpened=this.a.event,this.b=new D.Emitter,this.onTunnelClosed=this.b.event,this.c=new D.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const u=this.j.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.e=u,u?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.f=u.elevation,this.g=u.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const u=[],l=Array.from(this.d.values());for(const g of l){const p=Array.from(g.values());for(const b of p){const A=await b.value;A&&u.push(A)}}return u}async dispose(){for(const u of this.d.values()){for(const{value:l}of u.values())await l.then(g=>g?.dispose());u.clear()}this.d.clear()}setEnvironmentTunnel(u,l,g,p,b){this.o(u,l,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:l,localAddress:g,privacy:p,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,l){(w(u)||C(u))&&(u=e.LOCALHOST_ADDRESSES[0]);const g=this.q(u,l);if(g)return++g.refcount,g.value}openTunnel(u,l,g,p,b,A=!1,i,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${g} on local port ${b}.`),!u)return;if(l||(l="localhost"),p||(p=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(u,l,g,p,b,A,i,r);return t?t.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(n);return(n.tunnelRemoteHost!==l||n.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const l=this.d.get(u.tunnelRemoteHost);if(l){const g=l.get(u.tunnelRemotePort);g&&(g.refcount--,await this.n(u.tunnelRemoteHost,u.tunnelRemotePort,g))}}}}async n(u,l,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${l}.`);const p=g.value.then(async b=>{b&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.d.has(u)&&this.d.get(u).delete(l),p}}async closeTunnel(u,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${l} `);const g=this.d.get(u);if(g&&g.has(l)){const p=g.get(l);p.refcount=0,await this.n(u,l,p)}}o(u,l,g){this.d.has(u)||this.d.set(u,new Map),this.d.get(u).set(l,{refcount:1,value:g})}async p(u,l){const g=this.d.get(u);g&&(await g.get(l)||g.delete(l),g.size===0&&this.d.delete(u))}q(u,l){const g=[u];C(u)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(u)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const p=g.map(b=>this.d.get(b));for(const b of p){const A=b?.get(l);if(A)return A}}canTunnel(u){return!!E(u)}s(u,l,g,p,b,A,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${g} on local port ${p}.`);const r=g;this.h.add(r);const t=p===void 0?g:p,n={elevationRequired:b?this.isPortPrivileged(t):!1},s={remoteAddress:{host:l,port:g},localAddressPort:p,privacy:A,public:A?A!==P.Private:void 0,protocol:i},a=u.forwardPort(s,n);return a?(this.o(l,g,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),a}};h=ye([G(0,c.ILogService),G(1,T.IConfigurationService)],h),e.AbstractTunnelService=h}),define(oe[255],ae([0,1,8,77,2,9,6]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let I=class kt extends R.Disposable{constructor(C,w){super(),this.f=C,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(C,w,m,y,h,S,u){const l=new P,g=await Promise.resolve(this.f.openTunnel(C,l,m,y,h,S,u));if(!g)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${y} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),l.dispose(),await g.dispose(),(0,c.canceled)();return l.setTunnel(g),this.b.set(w,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${g.localAddress} (local) to ${m}:${y} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(C,w){const m=this.b.get(C);!m||m.setAddress(w)}async destroyTunnel(C){const w=this.b.get(C);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await w.dispose();return}this.c.add(C)}};I.a=0,I=ye([G(0,T.ISharedTunnelsService),G(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(oe[256],ae([0,1,86,34,134,226,6,2,16,8,23,224,77,109,4]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(b,A,i,r,t){let n;for(let s=3;s&&(n?.dispose(),n=await new u(b,A,i,r,t).waitForReady(),!(t&&R.BROWSER_RESTRICTED_PORTS[t]||!R.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));s--);return n}class u extends P.Disposable{constructor(A,i,r,t,n){super(),this.j=i,this.k=n,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=A,this.b=D.createServer(),this.c=new O.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const A=this.k??this.tunnelRemotePort,i=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,R.findFreePortFaster)(A,2,1e3,i),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(A){A.pause();const i=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,w.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),t=r.getSocket().socket,n=r.readEntireBuffer();r.dispose(),n.byteLength>0&&A.write(n.buffer),A.on("end",()=>{A.localAddress&&this.i.delete(A.localAddress),t.end()}),A.on("close",()=>t.end()),A.on("error",()=>{A.localAddress&&this.i.delete(A.localAddress),t.destroy()}),t.on("end",()=>A.end()),t.on("close",()=>A.end()),t.on("error",()=>{A.destroy()}),A.pipe(t),t.pipe(A),A.localAddress&&this.i.set(A.localAddress,()=>{A.end(),t.end()})}}let l=class extends m.AbstractTunnelService{constructor(A,i,r,t,n){super(i,n),this.t=A,this.u=r,this.v=t}isPortPrivileged(A){return(0,m.isPortPrivileged)(A,this.k,h.OS,T.release())}r(A,i,r,t,n,s,a,o){const f=this.q(i,r);if(f)return++f.refcount,f.value;if(this.e)return this.s(this.e,i,r,n,s,a,o);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${n}.`);const d={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:A,signService:this.u,logService:this.i,ipcLogger:null},v=S(d,t,i,r,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,v),v}}};l=ye([G(1,E.ILogService),G(2,y.ISignService),G(3,C.IProductService),G(4,I.IConfigurationService)],l),e.BaseTunnelService=l;let g=class extends l{constructor(A,i,r,t){super(c.nodeSocketFactory,A,i,r,t)}};g=ye([G(0,E.ILogService),G(1,y.ISignService),G(2,C.IProductService),G(3,I.IConfigurationService)],g),e.TunnelService=g;let p=class extends P.Disposable{constructor(A,i,r,t){super(),this.b=A,this.c=i,this.f=r,this.g=t,this.a=new Map}async openTunnel(A,i,r,t,n,s,a,o,f){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(A)){const d=new g(this.b,this.f,this.c,this.g);this.B(d),this.a.set(A,d),d.onTunnelClosed(async()=>{(await d.tunnels).length===0&&(d.dispose(),this.a.delete(A))})}return this.a.get(A).openTunnel(i,r,t,n,s,a,o,f)}};p=ye([G(0,E.ILogService),G(1,C.IProductService),G(2,y.ISignService),G(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(oe[29],ae([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(oe[257],ae([0,1,29,71,14,22,131,3,2]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(m){this.uri=m,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let C=class{constructor(m){this.g=m,this.c=new I.DisposableStore,this.f=2**16;const y=new Map,h=S=>{let u=y.get(S.scheme);return u===void 0&&(u=m.hasProvider(S)&&!this.g.hasCapability(S,1024),y.set(S.scheme,u)),u};this.c.add(P.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new c.ExtUri(h),this.d=new O.SkipList((S,u)=>this.extUri.compare(S,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,c.normalizePath)(m));const y=this.d.get(m);return y?y.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new E(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);E._clock=0,this.d.clear();const y=this.f*.5;for(let h=0;h<y;h++)this.d.set(m[h][0],m[h][1].touch())}};C=ye([G(0,R.IFileService)],C),e.UriIdentityService=C,(0,T.registerSingleton)(D.IUriIdentityService,C,1)}),define(oe[258],ae([0,1,3,2,14,44,49,17]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends T.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,w,m,y){super(),this.c=C,this.f=w,this.g=m,this.h=y,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(h=>this.i(h)))}watch(C,w){this.b.set(C,C);const m=this.f.watch(this.j(C),w);return(0,T.toDisposable)(()=>{this.b.delete(C),m.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,w,m){return this.f.rename(this.j(C),this.j(w),m)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,w,m){const y=(0,c.newWriteableStream)(h=>P.VSBuffer.concat(h.map(S=>P.VSBuffer.wrap(S))).buffer);return(async()=>{try{const h=await this.readFile(C);y.end(h)}catch(h){y.error(h),y.end()}})(),y}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,w,m){return this.f.writeFile(this.j(C),w,m)}delete(C,w){return this.f.delete(this.j(C),w)}copy(C,w,m){if((0,R.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(w),m);throw new Error("copy not supported")}i(C){const w=[];for(const m of C){if(m.resource.scheme!==this.c)continue;const y=this.k(m.resource);this.b.findSubstr(y)&&w.push({resource:y,type:m.type})}w.length&&(this.h.debug("User data changed"),this.a.fire(w))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(oe[61],ae([0,1,83]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(O,P,I,E){const C=(0,D.setProperty)(O,P,I,E)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=T;function R(O,P,I){let E=I;for(;E>=0;){if(O.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&O.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function c(O,P,I){let E=I;for(;E>=0;)if(O.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&O.charAt(E)===P.charAt(1)))return E;return O.length-1}e.getLineEndOffset=c}),define(oe[259],ae([0,1,32,54,12]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function c(y,h,S,u,l,g){const p=[],b=[],A=[];if(!h){const $=y.filter(({identifier:z})=>l.every(x=>x.toLowerCase()!==z.id.toLowerCase()));return{local:{added:p,removed:b,updated:A},remote:$.length>0?{added:$,updated:[],removed:[],all:$}:null}}y=y.map(w),h=h.map(w),S=S?S.map(w):null;const i=new Map,r=$=>{$.uuid&&i.set($.id.toLowerCase(),$.uuid)};y.forEach(({identifier:$})=>r($)),h.forEach(({identifier:$})=>r($)),S?.forEach(({identifier:$})=>r($));const t=$=>{const z=$.identifier.uuid||i.get($.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${$.identifier.id.toLowerCase()}`},n=($,z)=>($.set(t(z),z),$),s=y.reduce(n,new Map),a=h.reduce(n,new Map),o=h.reduce(($,z)=>n($,(0,D.deepClone)(z)),new Map),f=S?S.reduce(n,new Map):null,d=u.reduce(n,new Map),v=l.reduce(($,z)=>{const x=i.get(z.toLowerCase());return $.add(x?`uuid:${x}`:`id:${z.toLowerCase()}`)},new Set),L=g.reduce(($,{id:z,uuid:x})=>(x=x??i.get(z.toLowerCase()),$.add(x?`uuid:${x}`:`id:${z.toLowerCase()}`)),new Set),N=O(s,a,v,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const $=O(f,s,v,!1),z=O(f,a,v,!0),x=(X,ie,H,j)=>{let V,J,_;return ie.installed?(V=j.pinned,_=j.preRelease,V&&(J=j.version)):(V=H.pinned,_=H.preRelease,V&&(J=H.version)),V===void 0&&(V=ie.pinned,V&&(J=ie.version)),_===void 0&&(_=ie.preRelease),{...j,installed:ie.installed||H.installed,pinned:V,preRelease:_,version:J??(H.version&&(!ie.installed||T.gt(H.version,ie.version))?H.version:ie.version),state:I(ie,H,f?.get(X))}};for(const X of z.removed.values()){const ie=s.get(X);if(!ie)continue;const H=(0,R.assertIsDefined)(f?.get(X)),j=!L.has(X)&&H.installed;ie.installed&&j?b.push(ie.identifier):o.set(X,ie)}for(const X of z.added.values()){const ie=(0,R.assertIsDefined)(a.get(X)),H=s.get(X);if(H){if(N.updated.has(X)){const j=x(X,H,ie,ie);P(H,ie,!1,!1)||A.push(m(j,X)),o.set(X,j)}}else ie.installed&&p.push(m(ie,X))}for(const X of z.updated.values()){const ie=(0,R.assertIsDefined)(a.get(X)),H=(0,R.assertIsDefined)(f?.get(X)),j=s.get(X);if(j)if(!L.has(X)&&H.installed&&j.installed&&!ie.installed)b.push(j.identifier);else{const J=x(X,j,ie,ie);A.push(m(J,X)),o.set(X,J)}else ie.installed&&p.push(m(ie,X))}for(const X of $.added.values())z.added.has(X)||o.set(X,(0,R.assertIsDefined)(s.get(X)));for(const X of $.updated.values()){if(z.removed.has(X)||z.updated.has(X))continue;const ie=(0,R.assertIsDefined)(s.get(X)),H=(0,R.assertIsDefined)(a.get(X));o.set(X,x(X,ie,H,ie))}for(const X of $.removed.values())z.updated.has(X)||z.removed.has(X)||d.has(X)||!(0,R.assertIsDefined)(a.get(X)).installed||L.has(X)||!(0,R.assertIsDefined)(f?.get(X)).installed||o.delete(X)}const F=[],M=O(a,o,new Set,!0),k=M.added.size>0||M.updated.size>0||M.removed.size>0;return k&&o.forEach(($,z)=>F.push(m($,z))),{local:{added:p,removed:b,updated:A},remote:k?{added:[...M.added].map($=>o.get($)),updated:[...M.updated].map($=>o.get($)),removed:[...M.removed].map($=>a.get($)),all:F}:null}}e.merge=c;function O(y,h,S,u){const l=y?[...y.keys()].filter(i=>!S.has(i)):[],g=[...h.keys()].filter(i=>!S.has(i)),p=g.filter(i=>l.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),b=l.filter(i=>g.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),A=new Set;for(const i of l){if(b.has(i))continue;const r=y.get(i),t=h.get(i);(!t||!P(r,t,u,!0))&&A.add(i)}return{added:p,removed:b,updated:A}}function P(y,h,S,u){return!(y.disabled!==h.disabled||u&&y.installed!==h.installed||y.installed&&h.installed&&(y.preRelease!==h.preRelease||y.pinned!==h.pinned||h.pinned&&y.version!==h.version)||!C(y.state,h.state)||S&&y.version!==h.version)}function I(y,h,S){const u=y.state,l=h.state,g=S?.state;if(!h.version||u&&T.gt(y.version,h.version))return u;if(l&&T.gt(h.version,y.version)||!u)return l;if(!l)return u;const p=(0,D.deepClone)(u),b=g?E(g,l):{added:Object.keys(l).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set},A=g?E(g,u):{added:Object.keys(u).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set};for(const i of[...b.added.values(),...b.updated.values()])p[i]=l[i];for(const i of b.removed.values())A.updated.has(i)||delete p[i];return p}function E(y,h){const S=Object.keys(y),u=Object.keys(h),l=u.filter(b=>S.indexOf(b)===-1).reduce((b,A)=>(b.add(A),b),new Set),g=S.filter(b=>u.indexOf(b)===-1).reduce((b,A)=>(b.add(A),b),new Set),p=new Set;for(const b of S){if(g.has(b))continue;const A=y[b],i=h[b];(0,D.equals)(A,i)||p.add(b)}return{added:l,removed:g,updated:p}}function C(y={},h={}){const{added:S,removed:u,updated:l}=E(y,h);return S.size===0&&u.size===0&&l.size===0}function w(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function m(y,h){const S={identifier:{id:y.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},version:y.version,preRelease:!!y.preRelease,pinned:!!y.pinned};return y.disabled&&(S.disabled=!0),y.installed&&(S.installed=!0),y.state&&(S.state=y.state),S}}),define(oe[116],ae([0,1,21,16,5]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let c=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let E=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}updateSynchronizedExtensions(P,I){let E=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}getIgnoredExtensions(P){const I=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),E=this.b().map(m=>m.toLowerCase()),C=[],w=[];if(Array.isArray(E))for(const m of E)m.startsWith("-")?w.push(m.substring(1)):C.push(m);return(0,D.distinct)([...I,...C].filter(m=>w.indexOf(m)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};c=ye([G(0,T.IConfigurationService)],c),e.IgnoredExtensionsManagementService=c}),define(oe[260],ae([0,1,21,35,32,198,61]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(b){return(0,T.parse)(b)||[]}e.parseKeybindings=P;async function I(b,A,i,r,t){const n=P(b),s=P(A),a=i?P(i):null,o=[...n,...s,...a||[]].map(x=>x.key),f=await t.resolveUserBindings(o),d=C(n,s,a,f);if(!d.hasLocalForwarded&&!d.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!d.hasLocalForwarded&&d.hasRemoteForwarded)return{mergeContent:A,hasChanges:!0,hasConflicts:!1};if(d.hasLocalForwarded&&!d.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const v=m(n),L=m(s),N=a?m(a):null,F=h(v,L,f),M=N?h(N,v,f):{added:[...v.keys()].reduce((x,X)=>(x.add(X),x),new Set),removed:new Set,updated:new Set},k=N?h(N,L,f):{added:[...L.keys()].reduce((x,X)=>(x.add(X),x),new Set),removed:new Set,updated:new Set},$=E(F,M,k);let z=b;for(const x of $.removed.values())$.conflicts.has(x)||(z=g(z,x,r));for(const x of $.added.values()){if($.conflicts.has(x))continue;const X=L.get(x);if(X.some(ie=>ie.command!==`-${x}`&&d.conflicts.has(f[ie.key]))){$.conflicts.add(x);continue}z=l(z,X,r)}for(const x of $.updated.values()){if($.conflicts.has(x))continue;const X=L.get(x);if(X.some(ie=>ie.command!==`-${x}`&&d.conflicts.has(f[ie.key]))){$.conflicts.add(x);continue}z=p(z,x,X,r)}return{mergeContent:z,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=I;function E(b,A,i){const r=new Set,t=new Set,n=new Set,s=new Set;for(const a of A.removed.values())i.updated.has(a)&&s.add(a);for(const a of i.removed.values())s.has(a)||(A.updated.has(a)?s.add(a):t.add(a));for(const a of A.added.values())s.has(a)||i.added.has(a)&&b.updated.has(a)&&s.add(a);for(const a of i.added.values())s.has(a)||(A.added.has(a)?b.updated.has(a)&&s.add(a):r.add(a));for(const a of A.updated.values())s.has(a)||i.updated.has(a)&&b.updated.has(a)&&s.add(a);for(const a of i.updated.values())s.has(a)||(A.updated.has(a)?b.updated.has(a)&&s.add(a):n.add(a));return{added:r,removed:t,updated:n,conflicts:s}}function C(b,A,i,r){const t=new Set,n=w(b,r),s=w(A,r),a=i?w(i,r):null,o=y(n,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const f=a?y(a,n):{added:[...n.keys()].reduce((M,k)=>(M.add(k),M),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const d=a?y(a,s):{added:[...s.keys()].reduce((M,k)=>(M.add(k),M),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:v,removed:L,updated:N,conflicts:F}=E(o,f,d);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:L,updated:N,conflicts:F}}function w(b,A){const i=new Map;for(const r of b){const t=A[r.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(r)}return i}function m(b){const A=new Map;for(const i of b){const r=i.command[0]==="-"?i.command.substring(1):i.command;let t=A.get(r);t||(t=[],A.set(r,t)),t.push(i)}return A}function y(b,A){const i=[...b.keys()],r=[...A.keys()],t=r.filter(a=>i.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),n=i.filter(a=>r.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),s=new Set;for(const a of i){if(n.has(a))continue;const o=b.get(a).map(d=>({...d,key:a})),f=A.get(a).map(d=>({...d,key:a}));(0,D.equals)(o,f,(d,v)=>u(d,v))||s.add(a)}return{added:t,removed:n,updated:s}}function h(b,A,i){const r=[...b.keys()],t=[...A.keys()],n=t.filter(o=>r.indexOf(o)===-1).reduce((o,f)=>(o.add(f),o),new Set),s=r.filter(o=>t.indexOf(o)===-1).reduce((o,f)=>(o.add(f),o),new Set),a=new Set;for(const o of r){if(s.has(o))continue;const f=b.get(o).map(v=>({...v,key:i[v.key]})),d=A.get(o).map(v=>({...v,key:i[v.key]}));S(f,d)||a.add(o)}return{added:n,removed:s,updated:a}}function S(b,A){return!(!(0,D.equals)(b.filter(({command:i})=>i[0]!=="-"),A.filter(({command:i})=>i[0]!=="-"),(i,r)=>u(i,r))||!(0,D.equals)(b.filter(({command:i})=>i[0]==="-"),A.filter(({command:i})=>i[0]==="-"),(i,r)=>u(i,r)))}function u(b,A){if(b.command!==A.command||b.key!==A.key)return!1;const i=c.ContextKeyExpr.deserialize(b.when),r=c.ContextKeyExpr.deserialize(A.when);return!(i&&!r||!i&&r||i&&r&&!i.equals(r)||!R.equals(b.args,A.args))}function l(b,A,i){for(const r of A)b=O.edit(b,[-1],r,i);return b}function g(b,A,i){const r=P(b);for(let t=r.length-1;t>=0;t--)(r[t].command===A||r[t].command===`-${A}`)&&(b=O.edit(b,[t],void 0,i));return b}function p(b,A,i,r){const t=P(b),n=t.findIndex(s=>s.command===A||s.command===`-${A}`);for(let s=t.length-1;s>=0;s--)(t[s].command===A||t[s].command===`-${A}`)&&(b=O.edit(b,[s],void 0,r));for(let s=i.length-1;s>=0;s--)b=O.edit(b,[n],i[s],r);return b}}),define(oe[261],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(c,O,P){const I={},E={},C=new Set;if(!O)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:c,updated:{},removed:[]},conflicts:[]};const w=T(c,O);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=T(P,c),y=T(P,O),h={},S={},u=new Set,l=new Set;for(const g of m.removed.values())y.updated.has(g)?I[g]=O[g]:u.add(g);for(const g of y.removed.values())l.has(g)||(m.updated.has(g)?l.add(g):C.add(g));for(const g of m.updated.values())l.has(g)||(y.updated.has(g)?w.updated.has(g)&&l.add(g):S[g]=c[g]);for(const g of y.updated.values())l.has(g)||(m.updated.has(g)?w.updated.has(g)&&l.add(g):c[g]!==void 0&&(E[g]=O[g]));for(const g of m.added.values())l.has(g)||(y.added.has(g)?w.updated.has(g)&&l.add(g):h[g]=c[g]);for(const g of y.added.values())l.has(g)||(m.added.has(g)?w.updated.has(g)&&l.add(g):I[g]=O[g]);return{local:{added:I,removed:[...C.values()],updated:E},remote:{added:h,removed:[...u.values()],updated:S},conflicts:[...l.values()]}}e.merge=D;function T(c,O){const P=c?Object.keys(c):[],I=O?Object.keys(O):[],E=I.filter(m=>P.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),C=P.filter(m=>I.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),w=new Set;for(const m of P){if(C.has(m))continue;const y=c[m],h=O[m];y!==h&&w.add(m)}return{added:E,removed:C,updated:w}}function R(c,O){const{added:P,removed:I,updated:E}=T(c,O);return P.size===0&&I.size===0&&E.size===0}e.areSame=R}),define(oe[262],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,c,O,P){const I={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!c){const w=R.filter(({id:m})=>!P.includes(m));return w.length?E.added=w:E=null,{local:I,remote:E}}const C=T(R,c,P);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const w=T(O,R,P),m=T(O,c,P);for(const y of m.removed){const h=R.find(S=>S.id===y);h&&I.removed.push(h)}for(const y of m.added){const h=c.find(S=>S.id===y);w.added.includes(y)?C.updated.includes(y)&&I.updated.push(h):I.added.push(h)}for(const y of m.updated)I.updated.push(c.find(h=>h.id===y));for(const y of w.added)m.added.includes(y)||E.added.push(R.find(h=>h.id===y));for(const y of w.updated)m.removed.includes(y)||m.updated.includes(y)||E.updated.push(R.find(h=>h.id===y));for(const y of w.removed){const h=c.find(S=>S.id===y);h&&E.removed.push(h)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:I,remote:E}}e.merge=D;function T(R,c,O){R=R?R.filter(({id:m})=>!O.includes(m)):[],c=c.filter(({id:m})=>!O.includes(m));const P=R.map(({id:m})=>m),I=c.map(({id:m})=>m),E=I.filter(m=>P.indexOf(m)===-1),C=P.filter(m=>I.indexOf(m)===-1),w=[];for(const{id:m,name:y,shortName:h}of R){if(C.includes(m))continue;const S=c.find(u=>u.id===m);(!S||S.name!==y||S.shortName!==h)&&w.push(m)}return{added:E,removed:C,updated:w}}}),define(oe[24],ae([0,1,21,12,183,46,30,5,106,40]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EXTENSIONS_SYNC_CONTEXT_KEY=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=E.Registry.as(c.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function w(){const s=E.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(d=>!!s[d].ignoreSync),o=Object.keys(s).filter(d=>s[d].scope===2||s[d].scope===6),f=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...o,...f])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const s="vscode://schemas/ignoredSettings",a=E.Registry.as(c.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=E.Registry.as(I.Extensions.JSONContribution),f=()=>{const d=C(),v=w().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),L=Object.keys(c.allSettings.properties).filter(M=>v.indexOf(M)===-1),N=v.filter(M=>d.indexOf(M)===-1),F={items:{type:"string",enum:[...L,...N.map(M=>`-${M}`)]}};o.registerSchema(s,F)};return a.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=m;function y(s){return s&&(0,T.isObject)(s)&&(0,T.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=y;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function S(s,...a){return s?[s,...a]:a}e.getPathSegments=S;function u(s,a,o,f){return f.joinPath(o.userDataSyncHome,...S(s,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=u,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=l;var g;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(a,o,f,d){super(a),this.code=o,this.resource=f,this.operationId=d,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class b extends p{constructor(a,o,f,d,v){super(a,f,void 0,v),this.url=o,this.serverCode=d}}e.UserDataSyncStoreError=b;class A extends p{constructor(a,o){super(a,o)}}e.UserDataAutoSyncError=A,function(s){function a(o){if(o instanceof s)return o;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(f&&f[1]){const d=f[2]==="unknown"?void 0:f[2],v=f[3]==="unknown"?void 0:f[3];return new s(o.message,f[1],d,v)}return new s(o.message,"Unknown")}s.toUserDataSyncError=a}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview",e.EXTENSIONS_SYNC_CONTEXT_KEY="extensionsSync"}),define(oe[263],ae([0,1,32,24]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(O,P,I,E,C){if(!P)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const w=c(O,P);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=I?c(I,P):{added:Object.keys(P).reduce((g,p)=>(g.add(p),g),new Set),removed:new Set,updated:new Set},y=I?c(I,O):{added:Object.keys(O).reduce((g,p)=>(g.add(p),g),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},S=D.deepClone(P),u=!I;for(const g of y.added.values())g!==T.SYNC_SERVICE_URL_TYPE&&u&&m.added.has(g)||(S[g]=O[g]);for(const g of y.updated.values())S[g]=O[g];for(const g of y.removed.values())E.unregistered.includes(g)||delete S[g];for(const g of m.added.values()){const p=P[g];if(E.machine.includes(g)){C.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(I&&y.added.has(g))continue;const b=O[g];b&&b.value===p.value||g===T.SYNC_SERVICE_URL_TYPE&&u&&y.added.has(g)||(b?h.updated[g]=p:h.added[g]=p)}for(const g of m.updated.values()){const p=P[g];if(E.machine.includes(g)){C.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(y.updated.has(g)||y.removed.has(g))continue;const b=O[g];b&&b.value===p.value||(h.updated[g]=p)}for(const g of m.removed.values()){if(E.machine.includes(g)){C.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}y.updated.has(g)||y.removed.has(g)||h.removed.push(g)}const l=c(P,S);return{local:h,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:S}}}e.merge=R;function c(O,P){const I=Object.keys(O),E=Object.keys(P),C=E.filter(y=>I.indexOf(y)===-1).reduce((y,h)=>(y.add(h),y),new Set),w=I.filter(y=>E.indexOf(y)===-1).reduce((y,h)=>(y.add(h),y),new Set),m=new Set;for(const y of I){if(w.has(y))continue;const h=O[y],S=P[y];D.equals(h,S)||m.add(y)}return{added:C,removed:w,updated:m}}}),define(oe[264],ae([0,1,21,35,83,43,32,61,24]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function E(o,f,d){let v=[];d?v=w(d):v=C(f);const L=[],N=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const F of v)F.startsWith("-")?N.push(F.substring(1)):L.push(F);return(0,D.distinct)([...o,...L].filter(F=>N.indexOf(F)===-1))}e.getIgnoredSettings=E;function C(o){let f=o.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=o.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:o.getValue("settingsSync.ignoredSettings")||[]}function w(o){const f=(0,T.parse)(o);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function m(o,f){const d=(0,T.parse)(o)||{};let v="{}";for(const L of Object.keys(d)){const N=(0,R.setProperty)(v,[L],d[L],f);v=(0,R.applyEdits)(v,N)}return v}e.removeComments=m;function y(o,f,d,v){if(d.length){const L=a(f),N=(0,T.parse)(f)||{},F=(0,T.parse)(o);if(!F)return o;const M=[];for(const k of d){const $=N[k],z=F[k];$===void 0?o=P.edit(o,[k],void 0,v):z!==void 0?o=P.edit(o,[k],$,v):M.push(i(k,L))}M.sort((k,$)=>k.startOffset-$.startOffset),M.forEach(k=>o=g(k.setting.key,f,o,v))}return o}e.updateIgnoredSettings=y;function h(o,f,d,v,L,N){const F=y(o,f,v,N),M=d!==F,k=d!==f;if(!M&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!k)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(k&&!M)return{conflictsSettings:[],localContent:y(f,o,v,N),remoteContent:null,hasConflicts:!1};if(d===null&&u(o)){const q=S(o,f,v)?null:y(f,o,v,N);return{conflictsSettings:[],localContent:q,remoteContent:null,hasConflicts:!1}}let $=o,z=f;const x=(0,T.parse)(o),X=(0,T.parse)(f),ie=d?(0,T.parse)(d):null,H=v.reduce((q,Y)=>(q.add(Y),q),new Set),j=l(x,X,H),V=l(ie,x,H),J=l(ie,X,H),_=new Map,re=new Set,te=q=>{re.add(q);const Y=L.filter(({key:ee})=>ee===q)[0];Y?($=P.edit($,[q],Y.value,N),z=P.edit(z,[q],Y.value,N)):_.set(q,{key:q,localValue:x[q],remoteValue:X[q]})};for(const q of V.removed.values())J.updated.has(q)?te(q):z=P.edit(z,[q],void 0,N);for(const q of J.removed.values())re.has(q)||(V.updated.has(q)?te(q):$=P.edit($,[q],void 0,N));for(const q of V.updated.values())re.has(q)||(J.updated.has(q)?j.updated.has(q)&&te(q):z=P.edit(z,[q],x[q],N));for(const q of J.updated.values())re.has(q)||(V.updated.has(q)?j.updated.has(q)&&te(q):$=P.edit($,[q],X[q],N));for(const q of V.added.values())re.has(q)||(J.added.has(q)?j.updated.has(q)&&te(q):z=g(q,$,z,N));for(const q of J.added.values())re.has(q)||(V.added.has(q)?j.updated.has(q)&&te(q):$=g(q,z,$,N));const U=_.size>0||!S($,z,v),B=U||!S($,o,[]),W=U||!S(z,f,[]);return{localContent:B?$:null,remoteContent:W?z:null,conflictsSettings:[..._.values()],hasConflicts:U}}e.merge=h;function S(o,f,d){if(o===f)return!0;const v=(0,T.parse)(o),L=(0,T.parse)(f),N=d.reduce((k,$)=>(k.add($),k),new Set),F=a(o).filter(k=>!(k.setting&&N.has(k.setting.key))),M=a(f).filter(k=>!(k.setting&&N.has(k.setting.key)));if(F.length!==M.length)return!1;for(let k=0;k<F.length;k++){const $=F[k],z=M[k];if($.setting&&z.setting){if($.setting.key!==z.setting.key||!O.equals(v[$.setting.key],L[$.setting.key]))return!1}else if(!$.setting&&!z.setting){if($.value!==z.value)return!1}else return!1}return!0}e.areSame=S;function u(o){return o?a(o).length===0:!0}e.isEmpty=u;function l(o,f,d){const v=o?Object.keys(o).filter(k=>!d.has(k)):[],L=Object.keys(f).filter(k=>!d.has(k)),N=L.filter(k=>v.indexOf(k)===-1).reduce((k,$)=>(k.add($),k),new Set),F=v.filter(k=>L.indexOf(k)===-1).reduce((k,$)=>(k.add($),k),new Set),M=new Set;if(o)for(const k of v){if(F.has(k))continue;const $=o[k],z=f[k];O.equals($,z)||M.add(k)}return{added:N,removed:F,updated:M}}function g(o,f,d,v){const L=(0,T.parse)(f),N=a(f),F=a(d),M=p(o,N,F);return b(d,o,L[o],M,F,v)}e.addSetting=g;function p(o,f,d){const v=f.findIndex(N=>N.setting?.key===o),L=f[v-1];if(L){if(L.setting){const F=i(L.setting.key,d);if(F)return{index:d.indexOf(F),insertAfter:!0}}else{const F=r(v,f);if(F){const M=i(F.setting.key,d);if(M){const k=t(d.indexOf(M),d),$=n(f,F,f[v]);if(k){const z=n(d,M,k),x=s($,z);return x?{index:d.indexOf(x),insertAfter:!0}:{index:d.indexOf(k),insertAfter:!1}}else{const z=n(d,M,d[d.length-1]),x=s($,z);return x?{index:d.indexOf(x),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const N=f[v+1];if(N)if(N.setting){const F=i(N.setting.key,d);if(F)return{index:d.indexOf(F),insertAfter:!1}}else{const F=t(v,f);if(F){const M=i(F.setting.key,d);if(M){const k=r(d.indexOf(M),d),$=n(f,f[v],F);if(k){const z=n(d,k,M),x=s($.reverse(),z.reverse());return x?{index:d.indexOf(x),insertAfter:!1}:{index:d.indexOf(k),insertAfter:!0}}else{const z=n(d,d[0],M),x=s($.reverse(),z.reverse());return x?{index:d.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function b(o,f,d,v,L,N){let F;return v.index===-1?F=(0,R.setProperty)(o,[f],d,N):F=A(o,f,d,v,L,N).map(M=>(0,R.withFormatting)(o,M,N)[0]),(0,R.applyEdits)(o,F)}function A(o,f,d,v,L,N){const F=`${JSON.stringify(f)}: ${JSON.stringify(d)}`,M=(0,c.getEOL)(N,o),k=L[v.index];if(v.insertAfter){const $=[];if(k.setting)$.push({offset:k.endOffset,length:0,content:","+F});else{const z=t(v.index,L),x=r(v.index,L),X=x?.setting?.commaOffset;x&&X===void 0&&$.push({offset:x.endOffset,length:0,content:","});const ie=X!==void 0&&X>k.endOffset;$.push({offset:ie?X+1:k.endOffset,length:0,content:z?M+F+",":M+F})}return $}else{if(k.setting)return[{offset:k.startOffset,length:0,content:F+","}];const $=(L[v.index-1]&&!L[v.index-1].setting?M:"")+F+(t(v.index,L)?",":"")+M;return[{offset:k.startOffset,length:0,content:$}]}}function i(o,f){return f.filter(d=>d.setting?.key===o)[0]}function r(o,f){for(let d=o-1;d>=0;d--)if(f[d].setting)return f[d]}function t(o,f){for(let d=o+1;d<f.length;d++)if(f[d].setting)return f[d]}function n(o,f,d){const v=o.indexOf(f),L=o.indexOf(d);return o.filter((N,F)=>v<F&&F<L)}function s(o,f){if(o.length&&f.length){let d=0;for(;d<f.length&&d<o.length;d++)if(o[d].value!==f[d].value)return f[d-1];return f[d-1]}}function a(o){const f=[];let d=-1,v,L;const N={onObjectBegin:F=>{d++},onObjectProperty:(F,M,k)=>{d===0&&(v=M,L=F)},onObjectEnd:(F,M)=>{d--,d===0&&f.push({startOffset:v,endOffset:F+M,value:o.substring(v,F+M),setting:{key:L,commaOffset:void 0}})},onArrayBegin:(F,M)=>{d++},onArrayEnd:(F,M)=>{d--,d===0&&f.push({startOffset:v,endOffset:F+M,value:o.substring(v,F+M),setting:{key:L,commaOffset:void 0}})},onLiteralValue:(F,M,k)=>{d===0&&f.push({startOffset:v,endOffset:M+k,value:o.substring(v,M+k),setting:{key:L,commaOffset:void 0}})},onSeparator:(F,M,k)=>{if(d===0&&F===","){let $=f.length-1;for(;$>=0&&!f[$].setting;$--);const z=f[$];z&&f.splice($,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:M}})}},onComment:(F,M)=>{d===0&&f.push({startOffset:F,endOffset:F+M,value:o.substring(F,F+M)})}};return(0,T.visit)(o,N),f}}),define(oe[78],ae([0,1,3,2,5,24]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let O=class extends T.Disposable{get account(){return this.a}constructor(I,E){super(),this.g=I,this.h=E,this.b=this.B(new D.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};O=ye([G(0,c.IUserDataSyncStoreService),G(1,c.IUserDataSyncLogService)],O),e.UserDataSyncAccountService=O}),define(oe[265],ae([0,1,2,11]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(m){this.a=m}listen(m,y){switch(y){case"onError":return this.a.onError}throw new Error(`Event not found: ${y}`)}call(m,y,h){switch(y){case"triggerSync":return this.a.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class c{constructor(m){this.a=m}listen(m,y){throw new Error(`Event not found: ${y}`)}call(m,y,h){switch(y){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(T.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=c;class O{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=O;class P{constructor(m){this.a=m}listen(m,y){switch(y){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${y}`)}async call(m,y,h){switch(y){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(h[0],h[1]);case"setEnablements":return this.a.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(m){this.a=m}listen(m,y){switch(y){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(m,y,h){switch(y){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class E{constructor(m){this.a=m}listen(m,y){switch(y){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(m,y,h){switch(y){case"switch":return this.a.switch(h[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class C extends D.Disposable{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:T.URI.revive(m.url),type:m.type,defaultUrl:T.URI.revive(m.defaultUrl),insidersUrl:T.URI.revive(m.insidersUrl),stableUrl:T.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(oe[266],ae([0,1,184,15,8,24]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let O=class extends R.AbstractLogger{constructor(I,E){super(),this.g=this.B(I.createLogger(E.userDataSyncLogResource,{id:c.USER_DATA_SYNC_LOG_ID,name:(0,D.localize)(0,null)}))}trace(I,...E){this.g.trace(I,...E)}debug(I,...E){this.g.debug(I,...E)}info(I,...E){this.g.info(I,...E)}warn(I,...E){this.g.warn(I,...E)}error(I,...E){this.g.error(I,...E)}flush(){this.g.flush()}};O=ye([G(0,R.ILoggerService),G(1,T.IEnvironmentService)],O),e.UserDataSyncLogService=O}),define(oe[267],ae([0,1,6,3,2]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class c extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:E}){super(),this.a=this.B(new R.DisposableStore),T.Event.latch(T.Event.any(P,I))(this.f,this,this.a),this.b=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=c}),define(oe[117],ae([0,1,187,13,49,22,11,5,26]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function E(t){const n=t;return typeof n?.id=="string"&&O.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=E;function C(t){return typeof t?.id=="string"&&!E(t)&&!m(t)}e.isEmptyWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,T.basename)(t)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=t;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=w;function m(t){const n=t;return typeof n?.id=="string"&&O.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=m;function y(t){const n=t;if(n?.uri)return{id:n.id,uri:O.URI.revive(n.uri)};const s=t;if(s?.configPath)return{id:s.id,configPath:O.URI.revive(s.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=y;var h;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function S(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=S;function u(t){const n=t;return!!(n&&typeof n=="object"&&O.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=u;class l{constructor(n,s,a,o,f){this.h=n,this.j=a,this.k=o,this.l=f,this.c=R.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class g{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,c.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function p(t){return new g({uri:t,index:0,name:(0,c.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(t,n){return c.extUriBiasedIgnorePathCase.isEqualOrParent(t,n.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function A(t){let n;return O.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=A;function i(t,n){return!b(t,n)&&!A(t)}e.isSavedWorkspace=i;function r(t){return(typeof t=="string"?(0,T.extname)(t):(0,c.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(oe[18],ae([0,1,66,3,2,22,11,178,15,14,5,8,117,37,29,6,31,27,12]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&O.URI.isUri(n.location)&&O.URI.isUri(n.globalStorageHome)&&O.URI.isUri(n.settingsResource)&&O.URI.isUri(n.keybindingsResource)&&O.URI.isUri(n.tasksResource)&&O.URI.isUri(n.snippetsHome)&&O.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function b(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:O.URI.revive(t.location).with({scheme:n}),globalStorageHome:O.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:O.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:O.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:O.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:O.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:O.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=b;function A(t,n,s,a){return{id:t,name:n,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,c.joinPath)(s,"globalStorage"),settingsResource:(0,c.joinPath)(s,"settings.json"),keybindingsResource:(0,c.joinPath)(s,"keybindings.json"),tasksResource:(0,c.joinPath)(s,"tasks.json"),snippetsHome:(0,c.joinPath)(s,"snippets"),extensionsResource:(0,c.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=A;let i=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,s,a,o){super(),this.m=n,this.n=s,this.r=a,this.s=o,this.f=!1,this.g=this.B(new T.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new T.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new T.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new T.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new y.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,c.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const f of this.G()){if(!f.name||!(0,g.isString)(f.name)||!f.location){this.s.warn("Skipping the invalid stored profile",f.location||f.name);continue}n.push(A((0,c.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}const s=new y.ResourceMap,a=new Map,o=A((0,D.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...o,extensionsResource:this.L()??o.extensionsResource,isDefault:!0}),n.length){const f=this.I();if(f.workspaces)for(const[d,v]of Object.entries(f.workspaces)){const L=O.URI.parse(d),N=O.URI.parse(v),F=n.find(M=>this.r.extUri.isEqual(M.location,N));F&&s.set(L,F)}if(f.emptyWindows)for(const[d,v]of Object.entries(f.emptyWindows)){const L=O.URI.parse(v),N=n.find(F=>this.r.extUri.isEqual(F.location,L));N&&a.set(d,N)}}this.t={profiles:n,workspaces:s,emptyWindows:a}}return this.t}async createTransientProfile(n){const s="Temp",a=new RegExp(`${(0,l.escapeRegExpCharacters)(s)}\\s(\\d+)`);let o=0;for(const d of this.profiles){const v=a.exec(d.name),L=v?parseInt(v[1]):0;o=L>o?L:o}const f=`${s} ${o+1}`;return this.createProfile((0,D.hash)((0,u.generateUuid)()).toString(16),f,{transient:!0},n)}async createNamedProfile(n,s,a){return this.createProfile((0,D.hash)((0,u.generateUuid)()).toString(16),n,s,a)}async createProfile(n,s,a,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.v(n,s,a);return o&&await this.setProfileForWorkspace(o,f),f}async v(n,s,a){if(!(0,g.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(s);return o||(o=(async()=>{try{const f=this.profiles.find(L=>L.name===s||L.id===n);if(f)return f;const d=A(n,s,(0,c.joinPath)(this.profilesHome,n),a);await this.n.createFolder(d.location);const v=[];return this.h.fire({profile:d,join(L){v.push(L)}}),await S.Promises.settled(v),this.z([d],[],[]),d}finally{this.k.delete(s)}})(),this.k.set(s,o)),o}async updateProfile(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=A(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(o=>o.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:s,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.F(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(o=>o.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.D(n,a)}unsetWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.w(n);return O.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}w(n){return(0,m.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,m.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location)))}z(n,s,a){const o=[...this.profiles,...n],f=[];this.l.profiles=[];for(let d of o)d.isDefault||s.some(v=>d.id===v.id)||(d=a.find(v=>d.id===v.id)??d,d.isTransient?this.l.profiles.push(d):f.push({location:d.location,name:d.name,shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}));this.H(f),this.t=void 0,this.C(n,s,a)}C(n,s,a){this.g.fire({added:n,removed:s,updated:a,all:this.profiles})}D(n,s,a){a=s?.isTransient?!0:a,a||this.D(n,void 0,!0);const o=this.w(n),f=a?this.l:this.u;O.URI.isUri(o)?(f.workspaces.delete(o),s&&f.workspaces.set(o,s)):(f.emptyWindows.delete(o),s&&f.emptyWindows.set(o,s)),a||this.F()}F(){const n={};for(const[a,o]of this.u.workspaces.entries())n[a.toString()]=o.location.toString();const s={};for(const[a,o]of this.u.emptyWindows.entries())s[a.toString()]=o.location.toString();this.J({workspaces:n,emptyWindows:s}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=ye([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,h.IUriIdentityService),G(3,w.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=r}),define(oe[268],ae([0,1,6,2,18]),function(Q,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let c=class extends T.Disposable{constructor(P){super(),this.B(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};c=ye([G(0,R.IUserDataProfilesService)],c),e.UserDataProfilesCleaner=c}),define(oe[269],ae([0,1,21,6,25,9,3,2,4,11,157,30,33,42,8,23,19,18]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var g;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(g=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let p=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,s,a,o,f){super(),this.t=n,this.u=s,this.v=a,this.w=o,this.y=f,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new O.Emitter),this.m=this.B(new O.Emitter),this.n=this.B(new O.Emitter),this.p=this.B(new O.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:d})=>d.cancel()),this.k.forEach(d=>d.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,w.isTargetPlatformCompatible)(a,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(C.localize(0,null),w.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(a.manifest,a.extension,s)}catch(a){throw i(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),A(a)}}async uninstall(n,s={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,s,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:E.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,y.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},f=M=>`${m.ExtensionKey.create(M).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!E.URI.isUri(s)){const M=this.j.get(f(s));if(M){this.v.info("Extensions is already requested to install",s.identifier.id);const{local:k}=await M.task.waitUntilTaskIsFinished();return k}}const d=[],v=[],L=[],N=this.Q(n,s,o);E.URI.isUri(s)||this.j.set(f(s),{task:N,waitingTasks:[]}),this.l.fire({identifier:N.identifier,source:s,profileLocation:o.profileLocation}),this.v.info("Installing extension:",N.identifier.id),d.push({task:N,manifest:n});let F=!1;try{if(o.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const k=await this.F(N.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),$=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:z,manifest:x}of(0,D.distinct)(k,({gallery:X})=>X.identifier.id)){F=F||!!x.extensionDependencies?.some(H=>(0,m.areSameExtensions)({id:H},N.identifier));const X=f(z),ie=this.j.get(X);if(ie){if(this.C(N,ie.task)){const H=ie.task.identifier;this.v.info("Waiting for already requested installing extension",H.id,N.identifier.id),ie.waitingTasks.push(N),v.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,j=>j.some(V=>(0,m.areSameExtensions)(V.identifier,H)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",H.id,N.identifier.id),!j.find(J=>(0,m.areSameExtensions)(J.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!$.some(({identifier:H})=>(0,m.areSameExtensions)(H,z.identifier))){const H=this.Q(x,z,{...o,donotIncludePackAndDependencies:!0});this.j.set(X,{task:H,waitingTasks:[N]}),this.l.fire({identifier:H.identifier,source:z,profileLocation:o.profileLocation}),this.v.info("Installing extension:",H.identifier.id,N.identifier.id),d.push({task:H,manifest:x})}}}catch(k){if(E.URI.isUri(N.source))(0,D.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",N.identifier.id,k.message),(0,D.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",N.identifier.id,k.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),k}const M=d.reduce((k,{task:$,manifest:z})=>(k.set($.identifier.id.toLowerCase(),{task:$,manifest:z}),k),new Map);for(;M.size;){let k;const $=[...M.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(x=>M.has(x.toLowerCase())));$.length?k=M.size===1?$:$.filter(({task:z})=>!(z===N&&!F)):(this.v.info("Found extensions with circular dependencies",$.map(({task:z})=>z.identifier.id)),k=[...M.values()]),await this.D(k.map(async({task:z})=>{const x=new Date().getTime();try{const{local:X}=await z.run();if(await this.D(this.s.map(ie=>ie.postInstall(X,z.source,o,R.CancellationToken.None))),!E.URI.isUri(z.source)){const ie=z.operation===3,H=ie?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(i(this.u,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-x,durationSinceUpdate:H}),I.isWeb&&z.operation!==3)try{await this.t.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}L.push({local:X,identifier:z.identifier,operation:z.operation,source:z.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw E.URI.isUri(z.source)||i(this.u,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-x,error:X}),this.v.error("Error while installing the extension:",z.identifier.id),X}finally{M.delete(z.identifier.id.toLowerCase())}}))}return v.length&&await this.D(v),L.forEach(({identifier:k})=>this.v.info("Extension installed successfully:",k.id)),this.m.fire(L),L.filter(({identifier:k})=>(0,m.areSameExtensions)(k,N.identifier))[0].local}catch(M){if(d.forEach(({task:k})=>k.cancel()),L.length)try{const k=await Promise.allSettled(L.map(({local:$})=>this.R($,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let $=0;$<k.length;$++){const z=k[$],{identifier:x}=L[$];z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",x.id):this.v.warn("Rollback: Error while uninstalling extension",x.id,(0,c.getErrorMessage)(z.reason))}}catch(k){this.v.warn("Error while rolling back extensions",(0,c.getErrorMessage)(k),L.map(({identifier:$})=>$.id))}throw this.m.fire(d.map(({task:k})=>({identifier:k.identifier,operation:2,source:k.source,context:o.context,profileLocation:o.profileLocation}))),M}finally{for(const{task:M}of d)M.source&&!E.URI.isUri(M.source)&&this.j.delete(f(M.source))}}C(n,s){for(const[,{task:a,waitingTasks:o}]of this.j.entries())if(a===n&&(o.includes(s)||o.some(f=>this.C(f,s)))||a===s&&o[0]&&!this.C(n,o[0]))return!1;return!0}async D(n){const s=[],a=[],o=await Promise.allSettled(n);for(const f of o)f.status==="fulfilled"?s.push(f.value):a.push(f.reason);if(a.length)throw b(a);return s}async F(n,s,a,o,f){if(!this.t.isEnabled())return[];const d=await this.getInstalled(void 0,f),v=[],L=[],N=async(F,M)=>{v.push(F);const k=M.extensionDependencies||[],$=[...k];if(M.extensionPack){const z=a?d.find(x=>(0,m.areSameExtensions)(x.identifier,F)):void 0;for(const x of M.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(X=>(0,m.areSameExtensions)({id:X},{id:x}))||$.every(X=>!(0,m.areSameExtensions)({id:X},{id:x}))&&$.push(x)}if($.length){const z=$.filter(x=>v.every(X=>!(0,m.areSameExtensions)(X,{id:x})));if(z.length){const x=await this.t.getExtensions(z.map(X=>({id:X,preRelease:o})),R.CancellationToken.None);for(const X of x){if(v.find(j=>(0,m.areSameExtensions)(j,X.identifier)))continue;const ie=k.some(j=>(0,m.areSameExtensions)({id:j},X.identifier));let H;try{H=await this.G(X,!1,o)}catch(j){if(j instanceof w.ExtensionManagementError&&j.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ie){this.v.info("Skipping the packed extension as it cannot be installed",X.identifier.id);continue}else throw j}L.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(n,s),L}async G(n,s,a){if((await this.getExtensionsControlManifest()).malicious.some(v=>(0,m.areSameExtensions)(n.identifier,v)))throw new w.ExtensionManagementError(C.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const v=await this.getTargetPlatform();throw new w.ExtensionManagementError(C.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(v)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const f=await this.H(n,s,a);if(f){if(a&&!s&&n.hasPreReleaseVersion&&!f.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(C.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],R.CancellationToken.None))[0]?new w.ExtensionManagementError(C.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(C.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",f.identifier.id);const d=await this.t.getManifest(f,R.CancellationToken.None);if(d===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(d.version!==f.version)throw new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:f,manifest:d}}async H(n,s,a){const o=await this.getTargetPlatform();let f=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(f=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},R.CancellationToken.None))[0]||null),!f&&await this.t.isExtensionCompatible(n,a,o)&&(f=n),f||(s?f=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},R.CancellationToken.None))[0]||null:f=await this.t.getCompatibleExtension(n,a,o)),f}async I(n,s){const a={...s,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},o=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,f=this.k.get(o(n.identifier));if(f)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),f.waitUntilTaskIsFinished();const d=F=>{const M=this.R(F,a);return this.k.set(o(M.extension.identifier),M),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},v=(F,M)=>{M?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.v.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),i(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(F),error:M}),this.p.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},L=[],N=[];try{L.push(d(n));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const M=this.M(n,F);for(const k of M)this.k.has(o(k.identifier))?this.v.info("Extensions is already requested to uninstall",k.identifier.id):L.push(d(k))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(L.map(M=>M.extension),F,n),await this.D(L.map(async M=>{try{if(await M.run(),await this.D(this.s.map(k=>k.postUninstall(M.extension,a,R.CancellationToken.None))),M.extension.identifier.uuid)try{await this.t.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}v(M.extension)}catch(k){const $=k instanceof w.ExtensionManagementError?k:new w.ExtensionManagementError((0,c.getErrorMessage)(k),w.ExtensionManagementErrorCode.Internal);throw v(M.extension,$),$}finally{N.push(M)}}))}catch(F){const M=F instanceof w.ExtensionManagementError?F:new w.ExtensionManagementError((0,c.getErrorMessage)(F),w.ExtensionManagementErrorCode.Internal);for(const k of L){try{k.cancel()}catch{}N.includes(k)||v(k.extension,M)}throw M}finally{for(const F of L)this.k.delete(o(F.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(n,s,a){for(const o of n){const f=this.N(o,s);if(f.length){const d=f.filter(v=>!n.some(L=>(0,m.areSameExtensions)(L.identifier,v.identifier)));if(d.length)throw new Error(this.L(o,d,a))}}}L(n,s,a){return a===n?s.length===1?C.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?C.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(n,s,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const f=s.filter(v=>!v.isBuiltin&&o.some(L=>(0,m.areSameExtensions)({id:L},v.identifier))),d=[];for(const v of f)d.push(...this.M(v,s,a));return[...f,...d]}return[]}N(n,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,m.areSameExtensions)({id:o},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=ye([G(0,w.IExtensionGalleryService),G(1,u.ITelemetryService),G(2,h.ILogService),G(3,S.IProductService),G(4,l.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function b(t){const n=Array.isArray(t)?t:[t];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=b;function A(t){if(t instanceof w.ExtensionManagementError)return t;const n=new w.ExtensionManagementError(t.message,w.ExtensionManagementErrorCode.Internal);return n.stack=t.stack,n}function i(t,n,{extensionData:s,verificationStatus:a,duration:o,error:f,durationSinceUpdate:d}){let v,L;f&&(f instanceof w.ExtensionManagementError?(v=f.code,f.code===w.ExtensionManagementErrorCode.Signature&&(L=f.message)):v=w.ExtensionManagementErrorCode.Internal),t.publicLog(n,{...s,verificationStatus:a,success:!f,duration:o,errorcode:v,errorcodeDetail:L,durationSinceUpdate:d})}e.reportTelemetry=i;class r{constructor(){this.d=new T.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,T.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,T.createCancelablePromise)(n=>new Promise((s,a)=>{const o=n.onCancellationRequested(()=>{o.dispose(),a(new c.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(oe[51],ae([0,1,6,17,2,3,37,11,33,42,14,5,8,18,29,12,9,19]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let b=class extends R.Disposable{constructor(t,n,s,a,o,f){super(),this.h=t,this.i=n,this.j=s,this.k=a,this.l=o,this.m=f,this.a=this.B(new c.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new c.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new c.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new c.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new O.ResourceMap}scanProfileExtensions(t,n){return this.n(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],a=[];try{return await this.n(n,o=>{const f=[];for(const d of o)t.some(([v])=>(0,I.areSameExtensions)(v.identifier,d.identifier)&&v.manifest.version!==d.version)?s.push(d):f.push(d);for(const[d,v]of t)if(!f.some(L=>(0,I.areSameExtensions)(L.identifier,d.identifier)&&L.version===d.manifest.version)){const L={identifier:d.identifier,version:d.manifest.version,location:d.location,metadata:v};a.push(L),f.push(L)}return a.length&&this.a.fire({extensions:a,profileLocation:n}),s.length&&this.c.fire({extensions:s,profileLocation:n}),f}),a.length&&this.b.fire({extensions:a,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),a}catch(o){throw a.length&&this.b.fire({extensions:a,error:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,error:o,profileLocation:n}),o}}async updateMetadata(t,n){const s=[];return await this.n(n,a=>{const o=[];for(const f of a){const d=t.find(([v])=>(0,I.areSameExtensions)(v.identifier,f.identifier)&&v.manifest.version===f.version);d&&(f.metadata={...f.metadata,...d[1]},s.push(f)),o.push(f)}return o}),s}async removeExtensionFromProfile(t,n){const s=[];this.c.fire({extensions:s,profileLocation:n});try{await this.n(n,a=>{const o=[];for(const f of a)(0,I.areSameExtensions)(f.identifier,t.identifier)?s.push(f):o.push(f);return s.length&&this.c.fire({extensions:s,profileLocation:n}),o}),s.length&&this.f.fire({extensions:s,profileLocation:n})}catch(a){throw s.length&&this.f.fire({extensions:s,error:a,profileLocation:n}),a}}async n(t,n,s){return this.v(t).queue(async()=>{let a=[],o;try{const f=await this.i.readFile(t);o=JSON.parse(f.value.toString())}catch(f){if((0,C.toFileOperationResult)(f)!==1)throw f;if(this.k.extUri.isEqual(t,this.j.defaultProfile.extensionsResource)&&(o=await this.u()),!o&&s?.bailOutWhenFileNotFound)throw new p((0,u.getErrorMessage)(f),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.p(t);let f=!1;for(const d of o){A(d)||this.p(t);let v;if((0,S.isString)(d.location))v=this.s(d.location);else{v=P.URI.revive(d.location);const L=this.r(v);L&&(f=!0,d.location=L)}a.push({identifier:d.identifier,location:v,version:d.version,metadata:d.metadata})}f&&await this.i.writeFile(t,T.VSBuffer.fromString(JSON.stringify(o)))}if(n){a=n(a);const f=a.map(d=>({identifier:d.identifier,version:d.version,location:this.r(d.location)??d.location.toJSON(),metadata:d.metadata}));await this.i.writeFile(t,T.VSBuffer.fromString(JSON.stringify(f)))}return a})}p(t){const n=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(t){return this.k.extUri.isEqualOrParent(t,this.h)?this.k.extUri.relativePath(this.h,t):void 0}s(t){return this.k.extUri.joinPath(this.h,t)}async u(){return this.t||(this.t=(async()=>{const t=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(t)).value.toString()}catch(a){if((0,C.toFileOperationResult)(a)===1)return;throw a}this.m.info("Migrating extensions from old default profile location",t.toString());let s;try{const a=JSON.parse(n);Array.isArray(a)&&a.every(o=>A(o))?s=a:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.m.error(a)}if(s)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",t.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.toFileOperationResult)(a)===3)this.m.info("Migration from old default profile location to new location is done by another window",t.toString(),this.j.defaultProfile.extensionsResource.toString());else throw a}try{await this.i.del(t)}catch(a){(0,C.toFileOperationResult)(a)!==1&&this.m.error(a)}return s})()),this.t}v(t){let n=this.g.get(t);return n||(n=new D.Queue,this.g.set(t,n)),n}};b=ye([G(1,C.IFileService),G(2,y.IUserDataProfilesService),G(3,h.IUriIdentityService),G(4,l.ITelemetryService),G(5,m.ILogService)],b),e.AbstractExtensionsProfileScannerService=b;function A(r){return(0,S.isObject)(r)&&(0,E.isIExtensionIdentifier)(r.identifier)&&(i(r.location)||(0,S.isString)(r.location))&&r.version&&(0,S.isString)(r.version)}function i(r){return r?(0,S.isString)(r.path)&&(0,S.isString)(r.scheme):!1}}),define(oe[79],ae([0,1,21,6,32,17,9,35,140,2,26,13,4,22,54,89,12,11,160,15,33,42,70,14,5,8,23,3,67,51,18,29,193,194]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A,i,r,t,n,s,a,o,f,d,v,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(ie){function H(j,V){if(j===V)return!0;const J=Object.keys(j),_=new Set;for(const re of Object.keys(V))_.add(re);if(J.length!==_.size)return!1;for(const re of J){if(j[re]!==V[re])return!1;_.delete(re)}return _.size===0}ie.equals=H})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=class extends E.Disposable{constructor(H,j,V,J,_,re,te,U,B,W,q,Y){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=j,this.l=V,this.m=J,this.n=_,this.p=re,this.r=te,this.s=U,this.t=B,this.u=W,this.v=q,this.w=Y,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,y.joinPath)(this.m,A.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,y.joinPath)(this.m,A.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance($,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,b.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(H,j,V){const[J,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(j)]),re=V?await this.scanExtensionsUnderDevelopment(H,[...J,..._]):[];return this.F(J,_,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const j=[];j.push(this.G(!!H.useCache,H.language)),j.push(this.H(H.language,!!H.checkControlFile));const[V,J]=await Promise.all(j);return this.D([...V,...J],0,H,!1)}async scanUserExtensions(H){const j=H.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const V=this.v.extUri.isEqual(H.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,J=await this.J(j,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,V),_=H.useCache&&!J.devMode&&J.excludeObsolete?this.j:this.k;let re;try{re=await _.scanExtensions(J)}catch(te){if(te instanceof f.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),re=await _.scanExtensions(J);else throw te}return re=await this.D(re,1,H,!0),this.s.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(H,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(J=>J.scheme===C.Schemas.file).map(async J=>{const _=await this.J(J,!1,1,!0,H.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(_)).map(te=>(te.type=j.find(U=>(0,b.areSameExtensions)(U.identifier,te.identifier))?.type??te.type,this.k.validate(te,_)))}))).flat();return this.D(V,"development",H,!0)}return[]}async scanExistingExtension(H,j,V){const J=await this.J(H,!1,j,!0,V.language,!0,void 0),_=await this.k.scanExtension(J);return!_||!V.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,j,V){const J=await this.J(H,!1,j,!0,V.language,!0,void 0),_=await this.k.scanOneOrMultipleExtensions(J);return this.D(_,j,V,!0)}async scanMetadata(H){const j=(0,y.joinPath)(H,"package.json"),V=(await this.r.readFile(j)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(H,j){const V=(0,y.joinPath)(H,"package.json"),J=(await this.r.readFile(V)).value.toString(),_=JSON.parse(J);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,_.__metadata={..._.__metadata,...j},await this.r.writeFile((0,y.joinPath)(H,"package.json"),c.VSBuffer.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof f.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw H}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.p.addExtensionsToProfile(H.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,c.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,r.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.s.error(H)}finally{this.z=void 0}})()),this.z}async D(H,j,V,J){return V.includeAllVersions||(H=this.F(j===0?H:void 0,j===1?H:void 0,j==="development"?H:void 0,await this.getTargetPlatform(),J)),V.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,re)=>{const te=w.basename(_.location.fsPath),U=w.basename(re.location.fsPath);return te<U?-1:te>U?1:0})}F(H,j,V,J,_){const re=(U,B,W)=>{if(U.isValid&&!B.isValid)return!1;if(U.isValid===B.isValid){if(_&&h.gt(U.manifest.version,B.manifest.version))return this.s.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(h.eq(U.manifest.version,B.manifest.version)){if(U.type===0)return this.s.debug(`Skipping extension ${B.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===J)return this.s.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${U.location.path} with ${B.location.path}.`):this.s.debug(`Overwriting user extension ${U.location.path} with ${B.location.path}.`),!0},te=new Map;return H?.forEach(U=>{const B=A.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!1))&&te.set(B,U)}),j?.forEach(U=>{const B=A.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);if(!W&&H&&U.type===0){this.s.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!W||re(W,U,!1))&&te.set(B,U)}),V?.forEach(U=>{const B=A.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!0))&&te.set(B,U),te.set(B,U)}),[...te.values()]}async G(H,j){this.s.trace("Started scanning system extensions");const V=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),_=await(H&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",_.length),_}async H(H,j){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const J=j?await this.I():{},_=[],re=l.URI.file(w.normalize(w.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of V){const B=J[U.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":_.push((0,y.joinPath)(re,U.name));break;default:_.push(l.URI.file(B));break}}const te=await Promise.all(_.map(async U=>this.k.scanExtension(await this.J(U,!1,0,!0,H,!0,void 0))));return this.s.trace("Scanned dev system extensions:",te.length),(0,D.coalesce)(te)}async I(){try{const H=await this.r.readFile(this.l);return JSON.parse(H.value.toString())}catch{return{}}}async J(H,j,V,J,_,re,te){const U=await this.f(_??m.language),B=await this.L(H),W=j&&!this.v.extUri.isEqual(H,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,q=W?await this.L(W):void 0;return new k(H,B,W,q,j,te,V,J,re,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,_,U)}async L(H){try{const j=await this.r.stat(H);if(typeof j.mtime=="number")return j.mtime}catch{}}};M=ye([G(4,d.IUserDataProfilesService),G(5,f.IExtensionsProfileScannerService),G(6,r.IFileService),G(7,n.ILogService),G(8,p.IEnvironmentService),G(9,s.IProductService),G(10,v.IUriIdentityService),G(11,t.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class k{constructor(H,j,V,J,_,re,te,U,B,W,q,Y,ee,K,Z){this.location=H,this.mtime=j,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=J,this.profile=_,this.profileScanOptions=re,this.type=te,this.excludeObsolete=U,this.validate=B,this.productVersion=W,this.productDate=q,this.productCommit=Y,this.devMode=ee,this.language=K,this.translations=Z}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,j){return(0,y.isEqual)(H.location,j.location)&&H.mtime===j.mtime&&(0,y.isEqual)(H.applicationExtensionslocation,j.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&H.profile===j.profile&&R.equals(H.profileScanOptions,j.profileScanOptions)&&H.type===j.type&&H.excludeObsolete===j.excludeObsolete&&H.validate===j.validate&&H.productVersion===j.productVersion&&H.productDate===j.productDate&&H.productCommit===j.productCommit&&H.devMode===j.devMode&&H.language===j.language&&F.equals(H.translations,j.translations)}}e.ExtensionScannerInput=k;let $=class extends E.Disposable{constructor(H,j,V,J,_){super(),this.f=H,this.g=j,this.h=V,this.i=J,this.j=_}async scanExtensions(H){const j=H.profile?await this.l(H):await this.k(H);let V={};if(H.excludeObsolete&&H.type===1)try{const J=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(J)}catch{}return(0,u.isEmptyObject)(V)?j:j.filter(J=>!V[b.ExtensionKey.create(J).toString()])}async k(H){const j=await this.i.resolve(H.location);if(!j.children?.length)return[];const V=await Promise.all(j.children.map(async J=>{if(!J.isDirectory||H.type===1&&(0,y.basename)(J.resource).indexOf(".")===0)return null;const _=new k(J.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,D.coalesce)(V).sort((J,_)=>J.location.path<_.location.path?-1:1)}async l(H){let j=await this.m(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){j=j.filter(J=>!J.metadata?.isApplicationScoped);const V=await this.m(H.applicationExtensionslocation,J=>!!J.metadata?.isApplicationScoped,H);j.push(...V)}return j}async m(H,j,V){const J=await this.g.scanProfileExtensions(H,V.profileScanOptions);if(!J.length)return[];const _=await Promise.all(J.map(async re=>{if(j(re)){const te=new k(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te,re.metadata)}return null}));return(0,D.coalesce)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.i.exists((0,y.joinPath)(H.location,"package.json"))){const j=await this.scanExtension(H);return j?[j]:[]}else return await this.scanExtensions(H)}catch(j){return this.j.error(`Error scanning extensions at ${H.location.path}:`,(0,O.getErrorMessage)(j)),[]}}async scanExtension(H,j){try{let V=await this.scanExtensionManifest(H.location);if(V){V.publisher||(V.publisher=A.UNDEFINED_PUBLISHER),j=j??V.__metadata,delete V.__metadata;const J=(0,b.getGalleryExtensionId)(V.publisher,V.name),_=j?.id?{id:J,uuid:j.id}:{id:J},re=j?.isSystem?0:H.type,te=re===0||!!j?.isBuiltin;N.ImplicitActivationEvents.updateManifest(V),V=await this.n(H.location,V,k.createNlsConfiguration(H));const U={type:re,identifier:_,manifest:V,location:H.location,isBuiltin:te,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return H.validate?this.validate(U,H):U}}catch(V){H.type!==0&&this.j.error(V)}return null}validate(H,j){let V=!0;const J=(0,i.validateExtensionManifest)(j.productVersion,j.productDate,j.location,H.manifest,H.isBuiltin);for(const[_,re]of J)_===S.default.Error&&(V=!1,this.j.error(this.t(j.location,re)));return H.isValid=V,H.validations=J,H}async scanExtensionManifest(H){const j=(0,y.joinPath)(H,"package.json");let V;try{V=(await this.i.readFile(j)).value.toString()}catch(_){return(0,r.toFileOperationResult)(_)!==1&&this.j.error(this.t(H,(0,g.localize)(0,null,j.path,_.message))),null}let J;try{J=JSON.parse(V)}catch{const re=[];(0,P.parse)(V,re);for(const te of re)this.j.error(this.t(H,(0,g.localize)(1,null,j.path,te.offset,te.length,(0,I.getParseErrorMessage)(te.error))));return null}return(0,P.getNodeType)(J)!=="object"?(this.j.error(this.t(H,(0,g.localize)(2,null,j.path))),null):J}async n(H,j,V){const J=await this.p(H,j,V);if(J)try{const _=[],re=await this.r(J.default,_);if(_.length>0)return _.forEach(U=>{this.j.error(this.t(H,(0,g.localize)(3,null,J.default?.path,(0,I.getParseErrorMessage)(U.error))))}),j;if((0,P.getNodeType)(J)!=="object")return this.j.error(this.t(H,(0,g.localize)(4,null,J.default?.path))),j;const te=J.values||Object.create(null);return(0,L.localizeManifest)(j,te,re)}catch{}return j}async p(H,j,V){const J=(0,y.joinPath)(H,"package.nls.json"),_=(B,W)=>{W.forEach(q=>{this.j.error(this.t(H,(0,g.localize)(5,null,B?.path,(0,I.getParseErrorMessage)(q.error))))})},re=B=>{this.j.error(this.t(H,(0,g.localize)(6,null,B?.path)))},te=`${j.publisher}.${j.name}`,U=V.translations[te];if(U)try{const B=l.URI.file(U),W=(await this.i.readFile(B)).value.toString(),q=[],Y=(0,P.parse)(W,q);return q.length>0?(_(B,q),{values:void 0,default:J}):(0,P.getNodeType)(Y)!=="object"?(re(B),{values:void 0,default:J}):{values:Y.contents?Y.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.i.exists(J))return;let W;try{W=await this.s(H,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const q=(await this.i.readFile(W.localized)).value.toString(),Y=[],ee=(0,P.parse)(q,Y);return Y.length>0?(_(W.localized,Y),{values:void 0,default:W.original}):(0,P.getNodeType)(ee)!=="object"?(re(W.localized),{values:void 0,default:W.original}):{values:ee,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(H,j){if(H)try{const V=(await this.i.readFile(H)).value.toString();return(0,P.parse)(V,j)}catch{}}s(H,j){return new Promise((V,J)=>{const _=re=>{const te=(0,y.joinPath)(H,`package.nls.${re}.json`);this.i.exists(te).then(U=>{U&&V({localized:te,original:(0,y.joinPath)(H,"package.nls.json")});const B=re.lastIndexOf("-");B===-1?V({localized:(0,y.joinPath)(H,"package.nls.json"),original:null}):(re=re.substring(0,B),_(re))})};if(j.devMode||j.pseudo||!j.language)return V({localized:(0,y.joinPath)(H,"package.nls.json"),original:null});_(j.language)})}t(H,j){return`[${H.path}]: ${j}`}};$=ye([G(1,f.IExtensionsProfileScannerService),G(2,v.IUriIdentityService),G(3,r.IFileService),G(4,n.ILogService)],$);let z=class extends ${constructor(H,j,V,J,_,re){super(j,V,J,_,re),this.y=H,this.v=this.B(new T.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(H){const j=await this.z();if(this.u=H,j&&j.input&&k.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",H.location.toString()),this.v.trigger(()=>this.D()),j.result.map(J=>(J.location=l.URI.revive(J.location),J));const V=await super.scanExtensions(H);return await this.C({input:H,result:V}),V}async z(){try{const H=await this.i.readFile(this.y),j=JSON.parse(H.value.toString());return{result:j.result,input:(0,o.revive)(j.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,O.getErrorMessage)(H))}return null}async C(H){try{await this.i.writeFile(this.y,c.VSBuffer.fromString(JSON.stringify(H)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,O.getErrorMessage)(j))}}async D(){if(!this.u)return;const H=await this.z();if(!H)return;const j=H.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!R.equals(V,j))try{await this.i.del(this.y),this.w.fire()}catch(J){this.j.error(J)}}};z=ye([G(2,f.IExtensionsProfileScannerService),G(3,v.IUriIdentityService),G(4,r.IFileService),G(5,n.ILogService)],z);function x(ie,H){const j=(0,b.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:j,identifier:new A.ExtensionIdentifier(j),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:H,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=x;class X extends M{constructor(H,j,V,J,_,re,te,U,B,W,q,Y){super(H,j,(0,y.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(J,A.MANIFEST_CACHE_FOLDER),_,re,te,U,B,W,q,Y),this.M=(async()=>{if(m.translationsConfigFile)try{const ee=await this.r.readFile(l.URI.file(m.translationsConfigFile));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(H){return this.M}}e.NativeExtensionsScannerService=X}),define(oe[270],ae([0,1,8,18,29,19,51,14,15,11]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let C=class extends O.AbstractExtensionsProfileScannerService{constructor(m,y,h,S,u,l){super(E.URI.file(m.extensionsPath),y,h,S,u,l)}};C=ye([G(0,I.INativeEnvironmentService),G(1,P.IFileService),G(2,T.IUserDataProfilesService),G(3,R.IUriIdentityService),G(4,c.ITelemetryService),G(5,D.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(oe[271],ae([0,1,50,6,38,3,2,26,13,28,8,18]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends O.Disposable{constructor(h,S){super(),this.b=h,this.f=S,this.a=new T.Limiter(5)}async postUninstall(h){const S=this.g(h,"uninstall");return S&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(S.script,"uninstall",S.args,!0,h).then(()=>this.f.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),u=>this.f.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${u}`)))),E.Promises.rm(this.j(h)).then(void 0,u=>this.f.error("Error while removing extension storage path",u))}g(h,S){const u=`vscode:${S}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[u]=="string"){const l=h.manifest.scripts[u].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${u} should be a node script`),null):{script:(0,I.join)(h.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(h,S,u,l,g){return new Promise((p,b)=>{const A=this.i(h,S,u,g);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?b(t):p(void 0)};A.on("error",t=>{r((0,R.toErrorMessage)(t)||"Unknown")}),A.on("exit",(t,n)=>{r(t?`post-${S} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,A.kill(),b("timed out")},5e3))})}i(h,S,u,l){const g={silent:!0,execArgv:void 0},p=(0,D.fork)(h,[`--type=extension-post-${S}`,...u],g);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const b=c.Event.fromNodeEventEmitter(p.stdout,"data"),A=c.Event.fromNodeEventEmitter(p.stderr,"data");b(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${S}`,t)),A(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${S}`,t));const i=c.Event.any(c.Event.map(b,t=>({data:`%c${t}`,format:[""]})),c.Event.map(A,t=>({data:`%c${t}`,format:["color: red"]})));return c.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}j(h){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=ye([G(0,w.IUserDataProfilesService),G(1,C.ILogService)],m),e.ExtensionsLifecycle=m}),define(oe[272],ae([0,1,11,15,51,79,14,5,8,23,29,18]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends c.NativeExtensionsScannerService{constructor(h,S,u,l,g,p,b,A){super(D.URI.file(g.builtinExtensionsPath),D.URI.file(g.extensionsPath),g.userHome,D.URI.file(g.userDataPath),h,S,u,l,g,p,b,A)}};m=ye([G(0,w.IUserDataProfilesService),G(1,R.IExtensionsProfileScannerService),G(2,O.IFileService),G(3,I.ILogService),G(4,T.INativeEnvironmentService),G(5,E.IProductService),G(6,C.IUriIdentityService),G(7,P.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(oe[20],ae([0,1,6,3,2,102,12,69,5,18]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var C;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function y(g){const p=g.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=y;class h extends R.Disposable{constructor(p={flushInterval:h.a}){super(),this.j=p,this.b=this.B(new T.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new T.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new D.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,D.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,c.mark)("code/willInitStorage");try{await this.J()}finally{(0,c.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,b){if(b===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:b,target:this.F(p)[b]})}r(p){this.f.fire({reason:p})}get(p,b,A){return this.L(b)?.get(p,A)}getBoolean(p,b,A){return this.L(b)?.getBoolean(p,A)}getNumber(p,b,A){return this.L(b)?.getNumber(p,A)}store(p,b,A,i){if((0,O.isUndefinedOrNull)(b)){this.remove(p,A);return}this.t(()=>{this.u(p,A,i),this.L(A)?.set(p,b)})}remove(p,b){this.t(()=>{this.u(p,b,void 0),this.L(b)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,b){const A=[],i=this.F(p);for(const r of Object.keys(i))i[r]===b&&A.push(r);return A}u(p,b,A){const i=this.F(b);typeof A=="number"?i[p]!==A&&(i[p]=A,this.L(b)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[p]=="number"&&(delete i[p],this.L(b)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const b=this.L(p);return b?y(b):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=C.NONE){this.f.fire({reason:p});const b=this.L(-1),A=this.L(0),i=this.L(1);switch(p){case C.NONE:await D.Promises.settled([b?.whenFlushed()??Promise.resolve(),A?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([b?.flush(0)??Promise.resolve(),A?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,b=this.L(0)?.items??new Map,A=this.L(1)?.items??new Map;return l(p,b,A,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,b){return this.r(C.NONE),(0,E.isUserDataProfile)(p)?this.N(p,b):this.O(p,b)}H(p,b){return!(p.id===b.id||S(b)&&S(p))}I(p,b,A,i){this.t(()=>{if(i)for(const[r,t]of p)b.set(r,t);else{const r=new Set;for(const[t,n]of p)r.add(t),b.get(t)!==n&&this.n(A,t);for(const[t]of b.items)r.has(t)||this.n(A,t)}})}}e.AbstractStorageService=h,h.a=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class u extends h{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=u;async function l(g,p,b,A,i,r){const t=N=>{try{return JSON.parse(N)}catch{return N}},n=new Map,s=new Map;g.forEach((N,F)=>{n.set(F,N),s.set(F,t(N))});const a=new Map,o=new Map;p.forEach((N,F)=>{a.set(F,N),o.set(F,t(N))});const f=new Map,d=new Map;b.forEach((N,F)=>{f.set(F,N),d.set(F,t(N))}),console.group(A!==i?`Storage: Application (path: ${A})`:`Storage: Application & Profile (path: ${A}, default profile)`);const v=[];if(n.forEach((N,F)=>{v.push({key:F,value:N})}),console.table(v),console.groupEnd(),console.log(s),A!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const N=[];a.forEach((F,M)=>{N.push({key:M,value:F})}),console.table(N),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const L=[];f.forEach((N,F)=>{L.push({key:F,value:N})}),console.table(L),console.groupEnd(),console.log(d)}e.logStorage=l}),define(oe[118],ae([0,1,3,2,12,30,33,20]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends T.Disposable{constructor(w,m){super(),this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new E(w)),this.B(this.b.onDidChange(y=>this.a.fire({extensions:y,source:"storage"}))),this.B(m.onDidInstallExtensions(y=>y.forEach(({local:h,operation:S})=>{h&&S===4&&this.f(h.identifier)})))}async enableExtension(w,m){return this.f(w)?(this.a.fire({extensions:[w],source:m}),!0):!1}async disableExtension(w,m){return this.c(w)?(this.a.fire({extensions:[w],source:m}),!0):!1}getDisabledExtensions(){return this.h(c.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(w){const m=this.getDisabledExtensions();return m.every(y=>!(0,O.areSameExtensions)(y,w))?(m.push(w),this.g(m),!0):!1}f(w){const m=this.getDisabledExtensions();for(let y=0;y<m.length;y++){const h=m[y];if((0,O.areSameExtensions)(h,w))return m.splice(y,1),this.g(m),!0}return!1}g(w){this.i(c.DISABLED_EXTENSIONS_STORAGE_PATH,w)}h(w){return this.b.get(w,0)}i(w,m){this.b.set(w,m,0)}};I=ye([G(0,P.IStorageService),G(1,c.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class E extends T.Disposable{constructor(w){super(),this.c=w,this.a=Object.create(null),this.b=this.B(new D.Emitter),this.onDidChange=this.b.event,this.B(w.onDidChangeValue(m=>this.f(m)))}get(w,m){let y;return m===0?((0,R.isUndefinedOrNull)(this.a[w])&&(this.a[w]=this.g(w,m)),y=this.a[w]):y=this.g(w,m),JSON.parse(y)}set(w,m,y){const h=JSON.stringify(m.map(({id:u,uuid:l})=>({id:u,uuid:l})));this.g(w,y)!==h&&(y===0&&(m.length?this.a[w]=h:delete this.a[w]),this.h(w,m.length?h:void 0,y))}f(w){if(w.scope===0&&!(0,R.isUndefinedOrNull)(this.a[w.key])&&this.g(w.key,w.scope)!==this.a[w.key]){const y=this.get(w.key,w.scope);delete this.a[w.key];const h=this.get(w.key,w.scope),S=y.filter(l=>!h.some(g=>(0,O.areSameExtensions)(l,g))),u=h.filter(l=>!y.some(g=>(0,O.areSameExtensions)(g,l)));(S.length||u.length)&&this.b.fire([...S,...u])}}g(w,m){return this.c.get(w,m,"[]")}h(w,m,y){m?this.c.store(w,m,y,1):this.c.remove(w,y)}}e.StorageManager=E}),define(oe[273],ae([0,1,21,25,9,4,36,12,11,16,15,30,33,70,14,8,23,60,241,20,19]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const A=c.isWeb?"web":(0,w.getTargetPlatform)(c.platform,O.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(...U){return String(U.reduce((B,W)=>B|W,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class f{constructor(B=o){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,W=this.d.pageSize){return new f({...this.d,pageNumber:B,pageSize:W})}withFilter(B,...W){const q=[...this.d.criteria,...W.length?W.map(Y=>({filterType:B,value:Y})):[{filterType:B}]];return new f({...this.d,criteria:q})}withSortBy(B){return new f({...this.d,sortBy:B})}withSortOrder(B){return new f({...this.d,sortOrder:B})}withFlags(...B){return new f({...this.d,flags:B.reduce((W,q)=>W|q,0)})}withAssetTypes(...B){return new f({...this.d,assetTypes:B})}withSource(B){return new f({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:W,pageSize:q,sortBy:Y,sortOrder:ee,flags:K,assetTypes:Z}=this.d;return{filters:[{criteria:B,pageNumber:W,pageSize:q,sortBy:Y,sortOrder:ee}],assetTypes:Z,flags:K}}get searchText(){const B=this.d.criteria.filter(W=>W.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function d(U,B){const W=(U||[]).filter(q=>q.statisticName===B)[0];return W?W.value:0}function v(U){const B="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(q=>q.assetType.indexOf(B)===0).reduce((q,Y)=>{const ee=F(U,Y.assetType);return ee&&q.push([Y.assetType.substring(B.length),ee]),q},[])}function L(U){if(U.properties){const B=U.properties.filter(Y=>Y.key===n.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=B.filter(Y=>W.test(Y.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return F(U,n.Repository)}function N(U){return{uri:`${U.fallbackAssetUri}/${n.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${n.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function F(U,B){return U.files.filter(q=>q.assetType===B)[0]?{uri:`${U.assetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function M(U,B){const W=U.properties?U.properties.filter(Y=>Y.key===B):[],q=W.length>0&&W[0].value;return q?q.split(",").map(Y=>(0,m.adoptToGalleryExtensionId)(Y)):[]}function k(U){const B=U.properties?U.properties.filter(W=>W.key===s.Engine):[];return B.length>0&&B[0].value||""}function $(U){const B=U.properties?U.properties.filter(W=>W.key===s.PreRelease):[];return B.length>0&&B[0].value==="true"}function z(U){const B=U.properties?U.properties.filter(q=>q.key===s.LocalizedLanguages):[],W=B.length>0&&B[0].value||"";return W?W.split(","):[]}function x(U){return U.properties?.find(B=>B.key===s.SponsorLink)?.value}function X(U){return U.indexOf("preview")!==-1}function ie(U){return U.targetPlatform?(0,w.toTargetPlatform)(U.targetPlatform):"undefined"}function H(U){const B=(0,D.distinct)(U.versions.map(ie)),W=!!U.tags?.includes(w.WEB_EXTENSION_TAG),q=B.indexOf("web");return W?q===-1&&B.push("web"):q!==-1&&B.splice(q,1),B}function j(U,B){const W=(0,w.getFallbackTargetPlarforms)(B);for(let q=0;q<U.length;q++){const Y=U[q];if(Y.version===U[q-1]?.version){let ee=q;const K=ie(Y);if(K===B)for(;ee>0&&U[ee-1].version===Y.version;)ee--;else if(W.includes(K))for(;ee>0&&U[ee-1].version===Y.version&&ie(U[ee-1])!==B;)ee--;ee!==q&&(U.splice(q,1),U.splice(ee,0,Y))}}return U}e.sortExtensionVersions=j;function V(U,B,W){U.telemetryData={index:B,querySource:W}}function J(U,B,W){const q=U.versions[0],Y={manifest:F(B,n.Manifest),readme:F(B,n.Details),changelog:F(B,n.Changelog),license:F(B,n.License),repository:L(B),download:N(B),icon:F(B,n.Icon),signature:F(B,n.Signature),coreTranslations:v(B)};return{identifier:{id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:B.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(q),description:U.shortDescription||"",installCount:d(U.statistics,"install"),rating:d(U.statistics,"averagerating"),ratingCount:d(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:W,assets:Y,properties:{dependencies:M(B,s.Dependency),extensionPack:M(B,s.ExtensionPack),engine:k(B),localizedLanguages:z(B),targetPlatform:ie(B),isPreReleaseVersion:$(B)},hasPreReleaseVersion:$(q),hasReleaseVersion:!0,preview:X(U.flags),isSigned:!!Y.signature}}let _=class{constructor(B,W,q,Y,ee,K,Z,se){this.k=W,this.l=q,this.n=Y,this.o=ee,this.q=K,this.u=Z,this.w=se;const le=Z.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,g.resolveMarketplaceHeaders)(Z.version,Z,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,W,q){const Y=T.CancellationToken.isCancellationToken(W)?{}:W,ee=T.CancellationToken.isCancellationToken(W)?W:q,K=[],Z=[],se=[],le=[];let ue=!0;for(const be of B){be.uuid?Z.push(be.uuid):K.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!Z.length&&!K.length)return[];let pe=new f().withPage(1,B.length);Z.length&&(pe=pe.withFilter(t.ExtensionId,...Z)),K.length&&(pe=pe.withFilter(t.ExtensionName,...K)),(Y.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),Y.source&&(pe=pe.withSource(Y.source));const{extensions:ve}=await this.z(pe,{targetPlatform:Y.targetPlatform??A,includePreRelease:se,versions:le,compatible:!!Y.compatible},ee);return Y.source&&ve.forEach((be,Ee)=>V(be,Ee,Y.source)),ve}async getCompatibleExtension(B,W,q){if((0,w.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(B,W,q))return B;const Y=new f().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:ee}=await this.z(Y,{targetPlatform:q,compatible:!0,includePreRelease:W},T.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(B,W,q){if(!(0,w.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,q)||!W&&B.properties.isPreReleaseVersion)return!1;let Y=B.properties.engine;if(!Y){const ee=await this.getManifest(B,T.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");Y=ee.engines.vscode}return(0,y.isEngineValid)(Y,this.u.version,this.u.date)}async y(B,W,q,Y,ee){if(!(0,w.isTargetPlatformCompatible)(ie(B),Y,ee)||W!=="any"&&$(B)!==(W==="prerelease"))return!1;if(q)try{const K=await this.E(B);if(!(0,y.isEngineValid)(K,this.u.version,this.u.date))return!1}catch(K){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,R.getErrorMessage)(K)),!1}return!0}async query(B,W){let q=B.text||"";const Y=B.pageSize??50;let ee=new f().withPage(1,Y);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,ve)=>(ee=ee.withFilter(t.Category,ve||pe),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,ve)=>(ee=ee.withFilter(t.Tag,ve||pe),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),ee=ee.withFilter(t.SearchText,q)),ee=ee.withSortBy(0)):B.ids?ee=ee.withFilter(t.ExtensionId,...B.ids):B.names?ee=ee.withFilter(t.ExtensionName,...B.names):ee=ee.withSortBy(4),typeof B.sortBy=="number"&&(ee=ee.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ee=ee.withSortOrder(B.sortOrder)),B.source&&(ee=ee.withSource(B.source));const K=async(ue,pe)=>{const{extensions:ve,total:be}=await this.z(ue,{targetPlatform:A,compatible:!1,includePreRelease:!!B.includePreRelease},pe);return ve.forEach((Ee,Oe)=>V(Ee,(ue.pageNumber-1)*ue.pageSize+Oe,B.source)),{extensions:ve,total:be}},{extensions:Z,total:se}=await K(ee,W),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new R.CancellationError;const{extensions:ve}=await K(ee.withPage(ue+1),pe);return ve};return{firstPage:Z,total:se,pageSize:ee.pageSize,getPage:le}}async z(B,W,q){const Y=B.flags;!!(B.flags&i.IncludeLatestVersionOnly)&&!!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(B.flags&i.IncludeLatestVersionOnly)&&!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(B=B.withFlags(B.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),B=B.withFlags(B.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ee,total:K}=await this.B(B,q);if(!(B.flags&i.IncludeLatestVersionOnly)){const ue=[];for(const pe of ee){const ve=await this.A(pe,W);ve&&ue.push(ve)}return{extensions:ue,total:K}}const se=[],le=new Map;for(let ue=0;ue<ee.length;ue++){const pe=ee[ue],ve={id:(0,m.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,P.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Oe=>(0,m.areSameExtensions)(Oe,ve))?.includePreRelease;if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(H(pe),W.targetPlatform))continue;const Ee=await this.A(pe,W);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==W.targetPlatform&&Ee.hasPreReleaseVersion?le.set(pe.extensionId,ue):se.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),pe=new f().withFlags(Y&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:ve}=await this.z(pe,W,q);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of ve){const Ee=le.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:K}}async A(B,W){const q={id:(0,m.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},Y=W.versions?.find(se=>(0,m.areSameExtensions)(se,q))?.version,ee=(0,P.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(se=>(0,m.areSameExtensions)(se,q))?.includePreRelease,K=H(B),Z=j(B.versions,W.targetPlatform);if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(K,W.targetPlatform))return null;for(let se=0;se<Z.length;se++){const le=Z[se];if(!(Y&&le.version!==Y)){if(await this.y(le,ee?"any":"release",W.compatible,K,W.targetPlatform))return J(B,le,K);if(Y&&le.version===Y)return null}}return Y||W.compatible?null:J(B,B.versions[0],K)}async B(B,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(i.Unpublished));const q=await this.j,Y=JSON.stringify(B.raw),ee={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},K=new Date().getTime();let Z,se,le=0;try{if(Z=await this.k.request({type:"POST",url:this.g&&B.criteria.some(pe=>pe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:Y,headers:ee},W),Z.res.statusCode&&Z.res.statusCode>=400&&Z.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,l.asJson)(Z);if(ue){const pe=ue.results[0],ve=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-K,success:!!Z&&(0,l.isSuccess)(Z),responseBodySize:Z?.res.headers["Content-Length"],statusCode:Z?String(Z.res.statusCode):void 0,errorCode:se?(0,R.isCancellationError)(se)?"canceled":(0,R.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(B,W,q,Y){if(!this.isEnabled())return;const ee=c.isWeb?this.x(`/itemName/${B}.${W}/version/${q}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${W}/${q}/stats?statType=${Y}`),K=c.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:K};try{await this.k.request({type:"POST",url:ee,headers:se},T.CancellationToken.None)}catch{}}async download(B,W,q){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const Y=(0,m.getGalleryExtensionTelemetryData)(B),ee=new Date().getTime(),K=ue=>this.o.publicLog("galleryService:downloadVSIX",{...Y,duration:ue}),Z=q===2?"install":q===3?"update":"",se=Z?{uri:`${B.assets.download.uri}${I.URI.parse(B.assets.download.uri).query?"&":"?"}${Z}=true`,fallbackUri:`${B.assets.download.fallbackUri}${I.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${Z}=true`}:B.assets.download,le=await this.D(se);await this.q.writeFile(W,le.stream),K(new Date().getTime()-ee)}async downloadSignatureArchive(B,W){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const q=await this.D(B.assets.signature);await this.q.writeFile(W,q.stream)}async getReadme(B,W){if(B.assets.readme){const q=await this.D(B.assets.readme,{},W);return await(0,l.asTextOrError)(q)||""}return""}async getManifest(B,W){if(B.assets.manifest){const q=await this.D(B.assets.manifest,{},W),Y=await(0,l.asTextOrError)(q);return Y?JSON.parse(Y):null}return null}async C(B,W){const q=F(B,n.Manifest);if(!q)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ee=await this.D(q,{headers:Y});return await(0,l.asJson)(ee)}async getCoreTranslation(B,W){const q=B.assets.coreTranslations.filter(Y=>Y[0]===W.toUpperCase())[0];if(q){const Y=await this.D(q[1]),ee=await(0,l.asTextOrError)(Y);return ee?JSON.parse(ee):null}return null}async getChangelog(B,W){if(B.assets.changelog){const q=await this.D(B.assets.changelog,{},W);return await(0,l.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(B,W,q){let Y=new f().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?Y=Y.withFilter(t.ExtensionId,B.identifier.uuid):Y=Y.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:ee}=await this.B(Y,T.CancellationToken.None);if(!ee.length)return[];const K=H(ee[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(K,q))return[];const Z=[];await Promise.all(ee[0].versions.map(async ue=>{try{await this.y(ue,W?"any":"release",!0,K,q)&&Z.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of j(Z,q))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:$(ue)}));return se}async D(B,W={},q=T.CancellationToken.None){const Y=await this.j,ee={type:"GET"},K={...Y,...W.headers||{}};W={...W,...ee,headers:K};const Z=B.uri,se=B.fallbackUri,le={...W,url:Z};try{const ue=await this.k.request(le,q);if(ue.res.statusCode===200)return ue;const pe=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,R.isCancellationError)(ue))throw ue;const pe=(0,R.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:Z,message:pe});const ve={...W,url:se};return this.k.request(ve,q)}}async E(B){let W=k(B);if(!W){const q=await this.C(B,T.CancellationToken.None);if(!q)throw new Error("Manifest was not found");W=q.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const B=await this.k.request({type:"GET",url:this.h},T.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,l.asJson)(B),q=[],Y={};if(W){for(const ee of W.malicious)q.push({id:ee});if(W.migrateToPreRelease)for(const[ee,K]of Object.entries(W.migrateToPreRelease))(!K.engine||(0,y.isEngineValid)(K.engine,this.u.version,this.u.date))&&(Y[ee.toLowerCase()]={disallowInstall:!0,extension:{id:K.id,displayName:K.displayName,autoMigrate:{storage:!!K.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[ee,K]of Object.entries(W.deprecated))K&&(Y[ee.toLowerCase()]=(0,P.isBoolean)(K)?{}:K)}return{malicious:q,deprecated:Y}}};_=ye([G(1,l.IRequestService),G(2,S.ILogService),G(3,C.IEnvironmentService),G(4,b.ITelemetryService),G(5,h.IFileService),G(6,u.IProductService),G(7,E.IConfigurationService)],_);let re=class extends _{constructor(B,W,q,Y,ee,K,Z,se){super(B,W,q,Y,ee,K,Z,se)}};re=ye([G(0,p.IStorageService),G(1,l.IRequestService),G(2,S.ILogService),G(3,C.IEnvironmentService),G(4,b.ITelemetryService),G(5,h.IFileService),G(6,u.IProductService),G(7,E.IConfigurationService)],re),e.ExtensionGalleryService=re;let te=class extends _{constructor(B,W,q,Y,ee,K,Z){super(void 0,B,W,q,Y,ee,K,Z)}};te=ye([G(0,l.IRequestService),G(1,S.ILogService),G(2,C.IEnvironmentService),G(3,b.ITelemetryService),G(4,h.IFileService),G(5,u.IProductService),G(6,E.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(oe[80],ae([0,1,5,3,2,20,33,23,21,8,12]),function(Q,e,D,T,R,c,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Qe extends R.Disposable{static b(h){return`extensionKeys/${(0,O.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static c(h){const S=w.exec(h);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(h,S){const u=await h.getInstalled(),l=[];for(const[g,p]of Qe.f(S)){const b=u.find(A=>(0,O.areSameExtensions)(A.identifier,{id:g}))?.manifest.version;for(const A of p)b!==A&&l.push(Qe.b({id:g,version:A}))}for(const g of l)S.remove(g,0)}static f(h){const S=new Map,u=h.keys(0,1);for(const l of u){const g=Qe.c(l);if(g){let p=S.get(g.id.toLowerCase());p||S.set(g.id.toLowerCase(),p=[]),p.push(g.version)}}return S}constructor(h,S,u){super(),this.i=h,this.j=S,this.k=u,this.g=this.B(new T.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Qe.f(h),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(h){if(h.scope!==0)return;if(this.h.has(h.key.toLowerCase())){this.g.fire();return}const S=Qe.c(h.key);if(S){if(this.i.get(h.key,0)===void 0)this.h.delete(S.id.toLowerCase());else{let u=this.h.get(S.id.toLowerCase());u||this.h.set(S.id.toLowerCase(),u=[]),u.push(S.version),this.g.fire()}return}}m(h){if((0,C.isString)(h))return h;const S=h.manifest?h.manifest.publisher:h.publisher,u=h.manifest?h.manifest.name:h.name;return(0,O.getExtensionId)(S,u)}getExtensionState(h,S){const u=this.m(h),l=this.getExtensionStateRaw(h,S);if(l)try{return JSON.parse(l)}catch(g){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${S}): ${g}`)}}getExtensionStateRaw(h,S){const u=this.m(h),l=this.i.get(u,S?0:1);return l&&l?.length>Qe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${S}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(h,S,u){const l=this.m(h);S===void 0?this.i.remove(l,u?0:1):this.i.store(l,JSON.stringify(S),u?0:1,1)}setKeysForSync(h,S){this.i.store(Qe.b(h),JSON.stringify(S),0,1)}getKeysForSync(h){const S=this.j.extensionSyncedKeys?.[h.id.toLowerCase()],u=this.i.get(Qe.b(h),0),l=u?JSON.parse(u):void 0;return l&&S?(0,I.distinct)([...l,...S]):l||S}addToMigrationList(h,S){if(h!==S){const u=this.n.filter(l=>!l.includes(h)&&!l.includes(S));u.push([h,S]),this.n=u}}getSourceExtensionToMigrate(h){const S=this.n.find(([,u])=>h===u);return S?S[0]:void 0}get n(){const h=this.i.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(h);if(Array.isArray(S))return S}catch{}return[]}set n(h){h.length?this.i.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};m.a=512*1024,m=ye([G(0,c.IStorageService),G(1,P.IProductService),G(2,E.ILogService)],m),e.ExtensionStorageService=m}),define(oe[274],ae([0,1,21,6,3,13,4,36,11,161,15,30,33,217,99,14,58,23,20,19]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const b="extensionTips/promptedExecutableTips",A="extensionTips/lastPromptedMediumImpExeTime";let i=class extends y.ExtensionTipsService{constructor(t,n,s,a,o,f,d,v){super(d,v),this.m=t,this.n=n,this.p=s,this.r=a,this.s=o,this.t=f,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,v.exeBasedExtensionTips&&Object.entries(v.exeBasedExtensionTips).forEach(([L,N])=>{const F=[],M=[],k=[];Object.entries(N.recommendations).forEach(([$,z])=>{z.important?N.important?F.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):M.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):k.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),F.length&&this.g.set(L,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:F}),M.length&&this.h.set(L,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:M}),k.length&&this.j.set(L,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:k})}),(0,T.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),n=await this.I(this.h);return[...t,...n]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),n=await this.I(this.h),s=await this.p.getInstalled();this.k=this.v(t,s),this.l=this.v(n,s)}v(t,n){const s=new Map;t.forEach(v=>s.set(v.extensionId.toLowerCase(),v));const{installed:a,uninstalled:o}=this.H([...s.keys()],n);for(const v of a){const L=s.get(v);L&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:v,exeName:L.exeName})}for(const v of o){const L=s.get(v);L&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:v,exeName:L.exeName})}const f=this.F(),d=new Map;for(const v of o){const L=s.get(v);if(L&&(!f[L.exeName]||!f[L.exeName].includes(L.extensionId))){let N=d.get(L.exeName);N||(N=[],d.set(L.exeName,N)),N.push(L)}}return d}w(){if(this.k.size===0)return;const[t,n]=[...this.k.entries()][0];this.z(n).then(s=>{switch(s){case"reacted":this.G(n[0].exeName,n);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const a=R.Event.once(R.Event.latch(R.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(a(()=>this.w()));break}case"toomany":{const a=this.B((0,T.disposableTimeout)(()=>{a.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),n=Date.now()-t,s=7*24*60*60*1e3;if(n<s){const f=this.B((0,T.disposableTimeout)(()=>{f.dispose(),this.y()},s-n));return}const[a,o]=[...this.l.entries()][0];this.z(o).then(f=>{switch(f){case"reacted":{this.D(Date.now()),this.l.delete(a),this.G(o[0].exeName,o);const d=this.B((0,T.disposableTimeout)(()=>{d.dispose(),this.y()},s));break}case"ignored":this.l.delete(a),this.y();break;case"incompatibleWindow":{const d=R.Event.once(R.Event.latch(R.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(d(()=>this.y()));break}case"toomany":{const d=this.B((0,T.disposableTimeout)(()=>{d.dispose(),this.y()},36e5));break}}})}async z(t){const n=await this.p.getInstalled(1),s=t.filter(o=>!o.whenNotInstalled||o.whenNotInstalled.every(f=>n.every(d=>!(0,m.areSameExtensions)(d.identifier,{id:f})))).map(({extensionId:o})=>o.toLowerCase()),a=(0,E.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(s,a,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(A,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(A,t,-1,1)}F(){return JSON.parse(this.r.get(b,-1,"{}"))}G(t,n){const s=this.F();s[t]=n.map(({extensionId:a})=>a.toLowerCase()),this.r.store(b,JSON.stringify(s),-1,0)}H(t,n){const s=[],a=[],o=n.reduce((f,d)=>(f.add(d.identifier.id.toLowerCase()),f),new Set);return t.forEach(f=>{o.has(f.toLowerCase())?s.push(f):a.push(f)}),{installed:s,uninstalled:a}}async I(t){const n=[],s=new Map;for(const a of t.keys()){const o=t.get(a);if(!o||!(0,D.isNonEmptyArray)(o.recommendations))continue;const f=[];O.isWindows?o.windowsPath&&f.push(o.windowsPath.replace("%USERPROFILE%",()=>P.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>P.env.ProgramFiles).replace("%APPDATA%",()=>P.env.APPDATA).replace("%WINDIR%",()=>P.env.WINDIR)):(f.push((0,c.join)("/usr/local/bin",a)),f.push((0,c.join)("/usr/bin",a)),f.push((0,c.join)(this.m.userHome.fsPath,a)));for(const d of f){let v=s.get(d);if(v===void 0&&(v=await this.b.exists(I.URI.file(d)),s.set(d,v)),v)for(const{extensionId:L,extensionName:N,isExtensionPack:F,whenNotInstalled:M}of o.recommendations)n.push({extensionId:L,extensionName:N,isExtensionPack:F,exeName:a,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:M})}}return n}};i=ye([G(0,C.INativeEnvironmentService),G(1,p.ITelemetryService),G(2,w.IExtensionManagementService),G(3,g.IStorageService),G(4,u.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,S.IFileService),G(7,l.IProductService)],i),e.ExtensionTipsService=i}),define(oe[275],ae([0,1,6,2,22,69,20,76,18]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends O.AbstractStorageService{constructor(w,m,y,h){super(),this.X=w,this.Y=m,this.Z=y,this.ab=h,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new T.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new T.DisposableStore),this.W=this.db(this.X)}bb(){const w=this.B(new P.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),m=this.B(new c.Storage(w));return this.B(m.onDidChangeStorage(y=>this.n(-1,y))),m}cb(w){this.Q.clear(),this.P=w;let m;if((0,O.isProfileUsingDefaultStorage)(w))m=this.s;else{const y=this.Q.add(new P.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),w));m=this.Q.add(new c.Storage(y))}return this.Q.add(m.onDidChangeStorage(y=>this.n(0,y))),m}db(w){this.U.clear(),this.S=w?.id;let m;if(w){const y=this.U.add(new P.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),w));m=this.U.add(new c.Storage(y)),this.U.add(m.onDidChangeStorage(h=>this.n(1,h)))}return m}async J(){await D.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(w){switch(w){case-1:return this.s;case 0:return this.R;default:return this.W}}M(w){switch(w){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,R.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(O.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(w,m){if(!this.H(this.P,w))return;const y=this.R,h=y.items;y!==this.s&&await y.close(),this.R=this.cb(w),await this.R.init(),this.I(h,this.R,0,m)}async O(w,m){const y=this.W,h=y?.items??new Map;await y?.close(),this.W=this.db(w),await this.W.init(),this.I(h,this.W,1,m)}hasScope(w){return(0,I.isUserDataProfile)(w)?this.P.id===w.id:this.S===w.id}}e.NativeStorageService=E}),define(oe[62],ae([0,1,2,69,5,20]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,R.createDecorator)("IUserDataProfileStorageService");let O=class extends D.Disposable{constructor(E){super(),this.a=E}async readStorageData(E){return this.withProfileScopedStorageService(E,async C=>this.b(C))}async updateStorageData(E,C,w){return this.withProfileScopedStorageService(E,async m=>this.c(m,C,w))}async withProfileScopedStorageService(E,C){if(this.a.hasScope(E))return C(this.a);const w=await this.createStorageDatabase(E),m=new P(w);try{await m.initialize();const y=await C(m);return await m.flush(),y}finally{m.dispose(),await this.f(w)}}b(E){const C=new Map,w=m=>{for(const y of E.keys(0,m))C.set(y,{value:E.get(y,0),target:m})};return w(0),w(1),C}c(E,C,w){for(const[m,y]of C)E.store(m,y,0,w)}async f(E){try{await E.close()}finally{(0,D.isDisposable)(E)&&E.dispose()}}};O=ye([G(0,c.IStorageService)],O),e.AbstractUserDataProfileStorageService=O;class P extends c.AbstractStorageService{constructor(E){super({flushInterval:100}),this.p=this.B(new T.Storage(E))}J(){return this.p.init()}L(E){return E===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[276],ae([0,1,3,2,22,15,57,18]),function(Q,e,D,T,R,c,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends T.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,w,m){super(),this.b=[],this.c=this.B(new D.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=w.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(m.userRoamingDataHome,"profiles"),this.b=C.map(y=>(0,P.reviveProfile)(y,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(y=>{const h=y.added.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),S=y.removed.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),u=y.updated.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme));this.b=y.all.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:h,removed:S,updated:u,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,w,m){const y=await this.a.call("createNamedProfile",[C,w,m]);return(0,P.reviveProfile)(y,this.profilesHome.scheme)}async createProfile(C,w,m,y){const h=await this.a.call("createProfile",[C,w,m,y]);return(0,P.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(C){const w=await this.a.call("createTransientProfile",[C]);return(0,P.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(C,w){await this.a.call("setProfileForWorkspace",[C,w])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,w){const m=await this.a.call("updateProfile",[C,w]);return(0,P.reviveProfile)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=ye([G(1,O.IMainProcessService),G(2,c.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(oe[277],ae([0,1,3,2,57,8,62,20,76,18,71]),function(Q,e,D,T,R,c,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let w=class extends O.AbstractUserDataProfileStorageService{constructor(y,h,S,u){super(S),this.h=y;const l=y.getChannel("profileStorageListener"),g=this.B(new T.MutableDisposable);this.g=this.B(new D.Emitter({onWillAddFirstListener:()=>{g.value=l.listen("onDidChange")(p=>{u.trace("profile storage changes",p),this.g.fire({targetChanges:p.targetChanges.map(b=>(0,E.reviveProfile)(b,h.profilesHome.scheme)),valueChanges:p.valueChanges.map(b=>({...b,profile:(0,E.reviveProfile)(b.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>g.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(y){const h=this.h.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(y)?new I.ApplicationStorageDatabaseClient(h):new I.ProfileStorageDatabaseClient(h,y)}};w=ye([G(0,R.IMainProcessService),G(1,E.IUserDataProfilesService),G(2,P.IStorageService),G(3,c.ILogService)],w),e.UserDataProfileStorageService=w,(0,C.registerSingleton)(O.IUserDataProfileStorageService,w,1)}),define(oe[41],ae([0,1,21,6,17,25,3,35,2,27,12,179,16,15,14,8,45,20,19,29,24,18]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(f){return!!(f&&f.ref!==void 0&&typeof f.ref=="string"&&f.ref!==""&&f.syncData!==void 0&&(f.syncData===null||r(f.syncData)))}e.isRemoteUserData=i;function r(f){return!!(f&&f.version!==void 0&&typeof f.version=="number"&&f.content!==void 0&&typeof f.content=="string"&&(Object.keys(f).length===2||Object.keys(f).length===3&&f.machineId!==void 0&&typeof f.machineId=="string"))}e.isSyncData=r;function t(f,d){return`${(0,E.uppercaseFirstLetter)(f)}${d.isDefault?"":` (${d.name})`}`}e.getSyncResourceLogLabel=t;let n=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(d,v,L,N,F,M,k,$,z,x,X,ie){super(),this.syncResource=d,this.collection=v,this.C=L,this.D=N,this.F=F,this.G=M,this.H=k,this.I=$,this.J=z,this.L=x,this.M=X,this.c=null,this.k="idle",this.l=this.B(new O.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new O.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new T.ThrottledDelayer(50),this.t=this.B(new O.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(d.syncResource,d.profile),this.h=ie.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,b.getPathSegments)(d.profile.isDefault?void 0:d.profile.id,d.syncResource)),this.g=this.h.joinPath(this.f,b.PREVIEW_DIR_NAME),this.u=(0,b.getLastSyncResourceUri)(d.profile.isDefault?void 0:d.profile.id,d.syncResource,N,this.h),this.j=(0,u.getServiceMachineId)(N,L,F)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const d=await this.c;this.c=null;const v=await this.S(d.remoteUserData,d.lastSyncUserData,!0,this.lb());this.O(v)}else{this.L.trace(`${this.y}: Checking for local changes...`);const d=await this.getLastSyncUserData();(d?await this.rb(d):!0)&&this.t.fire()}}O(d){this.k!==d&&(this.k=d,this.l.fire(d))}async sync(d,v={}){await this.P(d,!0,this.lb(),v)}async preview(d,v,L={}){return this.P(d,!1,v,L)}async apply(d,v={}){try{this.z={...v};const L=await this.X(d);return this.O(L),this.c}finally{this.z={}}}async P(d,v,L,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let F="idle";try{const M=await this.getLastSyncUserData(),k=await this.R(d,M);return F=await this.S(k,M,v,L),F==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(F)}}finally{this.z={}}}async replace(d){const v=this.hb(d);if(!v)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const L=await this.getLastSyncUserData(),N=await this.R(null,L),F=await this.Q(N),M=await this.nb({ref:N.ref,syncData:v},L,F,this.lb(),c.CancellationToken.None),k=[];for(const $ of M){const z=await this.pb($,$.remoteResource,void 0,c.CancellationToken.None),{remoteChange:x}=await this.pb($,$.previewResource,$.remoteContent,c.CancellationToken.None);k.push([$,{...z,remoteChange:x!==0?x:2}])}await this.qb(N,L,k,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(d){const v=await this.j;return!!d.syncData?.machineId&&d.syncData.machineId===v}async R(d,v){if(v){const L=d?d[this.resource]:void 0;if(v.ref===L||L===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async S(d,v,L,N){if(d.syncData&&d.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new b.UserDataSyncError((0,w.localize)(0,null,this.resource,this.mb,d.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(d,v,L,N)}catch(F){if(F instanceof b.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(d,v,L,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),d=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.S(d,v,L,N)}throw F}}async U(d,v,L,N){try{const F=await this.Q(d),M=!F&&v===null&&this.db()!==void 0,k=L&&!M;this.c||(this.c=(0,T.createCancelablePromise)(z=>this.bb(d,v,F,k,N,z)));let $=await this.c;if(L&&M){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of $.resourcePreviews)$=await this.accept(z.remoteResource)||$}return this.Z($.resourcePreviews),$.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":L?await this.X(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(d){return await this.W(d,async v=>{const L=await this.ob(v,c.CancellationToken.None);await this.C.writeFile(v.previewResource,R.VSBuffer.fromString(L?.content||""));const N=L&&!L.hasConflicts?await this.pb(v,v.previewResource,void 0,c.CancellationToken.None):void 0;return v.acceptResult=N,v.mergeState=L.hasConflicts?"conflict":N?"accepted":"preview",v.localChange=N?N.localChange:L.localChange,v.remoteChange=N?N.remoteChange:L.remoteChange,v}),this.c}async accept(d,v){return await this.W(d,async L=>{const N=await this.pb(L,d,v,c.CancellationToken.None);return L.acceptResult=N,L.mergeState="accepted",L.localChange=N.localChange,L.remoteChange=N.remoteChange,L}),this.c}async discard(d){return await this.W(d,async v=>{const L=await this.ob(v,c.CancellationToken.None);return await this.C.writeFile(v.previewResource,R.VSBuffer.fromString(L.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=L.localChange,v.remoteChange=L.remoteChange,v}),this.c}async W(d,v){if(!this.c)return;let L=await this.c;const N=L.resourcePreviews.findIndex(({localResource:F,remoteResource:M,previewResource:k})=>this.h.isEqual(F,d)||this.h.isEqual(M,d)||this.h.isEqual(k,d));N!==-1&&(this.c=(0,T.createCancelablePromise)(async F=>{const M=[...L.resourcePreviews];return M[N]=await v(M[N]),{...L,resourcePreviews:M}}),L=await this.c,this.Z(L.resourcePreviews),L.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(d){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:L})=>L==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:L})=>L!=="accepted")?"syncing":(await this.qb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(L=>[L,L.acceptResult]),d),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(d){const v=d.filter(({mergeState:L})=>L==="conflict");(0,D.equals)(this.m,v,(L,N)=>this.h.isEqual(L.previewResource,N.previewResource))||(this.m=v,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const d=await this.getLastSyncUserData();return!!d&&d.syncData!==null}async ab(d){const v=this.c?await this.c:null;if(v)for(const L of v.resourcePreviews){if(this.h.isEqual(L.acceptedResource,d))return L.acceptResult?L.acceptResult.content:null;if(this.h.isEqual(L.remoteResource,d))return L.remoteContent;if(this.h.isEqual(L.localResource,d))return L.localContent;if(this.h.isEqual(L.baseResource,d))return L.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(d){(0,h.toFileOperationResult)(d)!==1&&this.L.error(d)}}async bb(d,v,L,N,F,M){const k=await this.nb(d,v,L,F,M),$=[];for(const z of k){const x=z.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)$.push({...z,acceptedResource:x,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=N?await this.ob(z,M):void 0;if(M.isCancellationRequested)break;await this.C.writeFile(z.previewResource,R.VSBuffer.fromString(X?.content||""));const ie=X&&!X.hasConflicts?await this.pb(z,z.previewResource,void 0,M):void 0;$.push({...z,acceptResult:ie,mergeState:X?.hasConflicts?"conflict":ie?"accepted":"preview",localChange:ie?ie.localChange:X?X.localChange:z.localChange,remoteChange:ie?ie.remoteChange:X?X.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:d,lastSyncUserData:v,resourcePreviews:$,isLastSyncFromCurrentMachine:L}}async getLastSyncUserData(){let d=this.db();if(d||(d=await this.gb()),!d)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const v=JSON.parse(d),L=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!v.version&&!!L&&v.version!==L,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${L}.`),await this.resetLocal(),null;let N,F=1;for(;N===void 0&&F++<6;)try{const M=await this.eb();M&&(M.ref===v.ref?N=M.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof h.FileOperationError&&M.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(M instanceof b.UserDataSyncError)throw M;this.L.error(M,F)}}if(N===void 0)try{const M=await this.G.resolveResourceContent(this.resource,v.ref,this.collection,this.z);N=M===null?null:this.hb(M),await this.fb({ref:v.ref,syncData:N})}catch(M){if(M instanceof b.UserDataSyncError&&M.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw M}return N===void 0?null:{...v,syncData:N}}async cb(d,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const L=this.I.getResourceSyncStateVersion(this.resource),N={ref:d.ref,version:L,...v};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(d)}db(){return this.F.get(this.v,-1)}async eb(){const d=(await this.C.readFile(this.u)).value.toString();try{const v=d?JSON.parse(d):void 0;if(i(v))return v}catch(v){this.L.error(v)}}async fb(d){await this.C.writeFile(this.u,R.VSBuffer.fromString(JSON.stringify(d)))}async gb(){try{const d=await this.C.readFile(this.u),v=JSON.parse(d.value.toString());await this.C.del(this.u),v.ref&&v.content!==void 0&&(this.F.store(this.v,JSON.stringify({...v,content:void 0}),-1,1),await this.fb({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)}))}catch(d){d instanceof h.FileOperationError&&d.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(d)}return this.F.get(this.v,-1)}async getRemoteUserData(d){const{ref:v,content:L}=await this.ib(d);let N=null;return L!==null&&(N=this.hb(L)),{ref:v,syncData:N}}hb(d){try{const v=JSON.parse(d);if(r(v))return v}catch(v){this.L.error(v)}throw new b.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(d){const v=d?{ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null}:null;return this.G.readResource(this.resource,v,this.collection,this.z)}async jb(d,v){const L=await this.j,N={version:this.mb,machineId:L,content:d};try{return v=await this.G.writeResource(this.resource,JSON.stringify(N),v,this.collection,this.z),{ref:v,syncData:N}}catch(F){throw F instanceof b.UserDataSyncError&&F.code==="TooLarge"&&(F=new b.UserDataSyncError(F.message,F.code,this.resource)),F}}async kb(d){const v={version:this.mb,content:d};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(b.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=ye([G(2,h.IFileService),G(3,y.IEnvironmentService),G(4,l.IStorageService),G(5,b.IUserDataSyncStoreService),G(6,b.IUserDataSyncBackupStoreService),G(7,b.IUserDataSyncEnablementService),G(8,g.ITelemetryService),G(9,b.IUserDataSyncLogService),G(10,m.IConfigurationService),G(11,p.IUriIdentityService)],n),e.AbstractSynchroniser=n;let s=class extends n{constructor(d,v,L,N,F,M,k,$,z,x,X,ie,H){super(v,L,N,F,M,k,$,z,x,X,ie,H),this.i=d,this.B(this.C.watch(this.h.dirname(d))),this.B(this.C.onDidFilesChange(j=>this.tb(j)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(d,v,L){try{v?await this.C.writeFile(this.i,R.VSBuffer.fromString(d),L?void 0:v):await this.C.createFile(this.i,R.VSBuffer.fromString(d),{overwrite:L})}catch(N){throw N instanceof h.FileOperationError&&N.fileOperationResult===1||N instanceof h.FileOperationError&&N.fileOperationResult===3?new b.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(d){if(!(d instanceof h.FileOperationError&&d.fileOperationResult===1))throw d}}tb(d){!d.contains(this.i)||this.triggerLocalChange()}};s=ye([G(3,h.IFileService),G(4,y.IEnvironmentService),G(5,l.IStorageService),G(6,b.IUserDataSyncStoreService),G(7,b.IUserDataSyncBackupStoreService),G(8,b.IUserDataSyncEnablementService),G(9,g.ITelemetryService),G(10,b.IUserDataSyncLogService),G(11,m.IConfigurationService),G(12,p.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let a=class extends s{constructor(d,v,L,N,F,M,k,$,z,x,X,ie,H,j){super(d,v,L,N,F,M,k,$,z,x,X,H,j),this.ub=ie,this.wb=void 0}vb(d,v){const L=[],N=(0,P.parse)(d,L,{allowEmptyContent:!0,allowTrailingComma:!0});return L.length>0||!(0,C.isUndefined)(N)&&v!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};a=ye([G(3,h.IFileService),G(4,y.IEnvironmentService),G(5,l.IStorageService),G(6,b.IUserDataSyncStoreService),G(7,b.IUserDataSyncBackupStoreService),G(8,b.IUserDataSyncEnablementService),G(9,g.ITelemetryService),G(10,b.IUserDataSyncLogService),G(11,b.IUserDataSyncUtilService),G(12,m.IConfigurationService),G(13,p.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let o=class{constructor(d,v,L,N,F,M,k){this.resource=d,this.g=v,this.h=L,this.j=N,this.k=F,this.l=M,this.d=k.extUri,this.f=(0,b.getLastSyncResourceUri)(void 0,this.resource,L,this.d)}async initialize({ref:d,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const L=this.m(v);if(!!L)try{await this.doInitialize({ref:d,syncData:L})}catch(N){this.j.error(N)}}m(d){try{const v=JSON.parse(d);if(r(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(d,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const L={ref:d.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(L),-1,1),await this.k.writeFile(this.f,R.VSBuffer.fromString(JSON.stringify(d)))}};o=ye([G(1,A.IUserDataProfilesService),G(2,y.IEnvironmentService),G(3,S.ILogService),G(4,h.IFileService),G(5,l.IStorageService),G(6,p.IUriIdentityService)],o),e.AbstractInitializer=o}),define(oe[119],ae([0,1,6,25,9,3,43,2,27,16,15,118,30,33,80,14,5,72,8,20,19,29,18,41,259,116,24,62]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A,i,r,t,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(F,M){const k=JSON.parse(F.content);if(F.version===1||F.version===2){const $=(await M.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of k)F.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),F.version===2&&$.every(x=>!(0,y.areSameExtensions)(x.identifier,z.identifier))&&(z.installed=!0)}return k}function f(F){return JSON.parse(F.content)}e.parseExtensions=f;function d(F,M){return F.sort((k,$)=>!k.identifier.uuid&&$.identifier.uuid?-1:k.identifier.uuid&&!$.identifier.uuid?1:(0,I.compare)(k.identifier.id,$.identifier.id)),M?(0,O.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=d;let v=class extends r.AbstractSynchroniser{constructor(M,k,$,z,x,X,ie,H,j,V,J,_,re,te,U,B,W){super({syncResource:"extensions",profile:M},k,z,$,x,X,ie,_,re,V,J,U),this.yb=H,this.zb=j,this.Ab=W,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(L),this.B(c.Event.any(c.Event.filter(this.yb.onDidInstallExtensions,q=>q.some(({local:Y})=>!!Y)),c.Event.filter(this.yb.onDidUninstallExtension,q=>!q.error),c.Event.filter(B.onDidChange,q=>q.valueChanges.some(({profile:Y,changes:ee})=>this.syncResource.profile.id===Y.id&&ee.some(K=>K.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),te.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(M,k){const $=M.syncData?await o(M.syncData,this.yb):null,z=k?.skippedExtensions||[],x=k?.builtinExtensions||[],X=k?.syncData?await o(k.syncData,this.yb):null,{localExtensions:ie,ignoredExtensions:H}=await this.xb.getLocalExtensions(this.syncResource.profile);$?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:V}=(0,t.merge)(ie,$,X,z,H,x),J={local:j,remote:V,content:this.Db(ie,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:V!==null?2:0},_=this.Jb(ie,!1);return[{skippedExtensions:z,builtinExtensions:x,baseResource:this.tb,baseContent:X?this.Jb(X,!1):_,localResource:this.ub,localContent:_,localExtensions:ie,remoteResource:this.vb,remoteExtensions:$,remoteContent:$?this.Jb($,!1):null,previewResource:this.sb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.wb}]}async rb(M){const k=M.syncData?await o(M.syncData,this.yb):null,{localExtensions:$,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.merge)($,k,k,M.skippedExtensions||[],z,M.builtinExtensions||[]);return x!==null}Db(M,k,$,z){const x=[...k,...$],X=new Set,ie=H=>{X.add(H.id.toLowerCase()),H.uuid&&X.add(H.uuid)};x.forEach(({identifier:H})=>ie(H)),z.forEach(ie);for(const H of M)X.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&X.has(H.identifier.uuid)||x.push(H);return this.Jb(x,!1)}async ob(M,k){return{...M.previewResult,hasConflicts:!1}}async pb(M,k,$,z){if(this.h.isEqual(k,this.ub))return this.Gb(M);if(this.h.isEqual(k,this.vb))return this.Hb(M);if(this.h.isEqual(k,this.sb))return M.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async Gb(M){const k=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(k),z=(0,t.merge)(M.localExtensions,null,null,M.skippedExtensions,$,M.builtinExtensions),{local:x,remote:X}=z;return{content:M.localContent,local:x,remote:X,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:X!==null?2:0}}async Hb(M){const k=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(k),z=M.remoteContent?JSON.parse(M.remoteContent):null;if(z!==null){const x=(0,t.merge)(M.localExtensions,z,M.localExtensions,[],$,M.builtinExtensions),{local:X,remote:ie}=x;return{content:M.remoteContent,local:X,remote:ie,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:ie!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(M,k,$,z){let{skippedExtensions:x,localExtensions:X}=$[0][0];const{local:ie,remote:H,localChange:j,remoteChange:V}=$[0][1];if(j===0&&V===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),j!==0&&(await this.kb(JSON.stringify(X)),x=await this.xb.updateLocalExtensions(ie.added,ie.removed,ie.updated,x,this.syncResource.profile)),H){this.L.trace(`${this.y}: Updating remote extensions...`);const J=JSON.stringify(H.all);M=await this.jb(J,z?null:M.ref),this.L.info(`${this.y}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(_=>_.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(_=>_.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(_=>_.identifier.id))}.`:""}`)}if(k?.ref!==M.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const J=X.filter(_=>!_.installed).map(_=>_.identifier);await this.cb(M,{skippedExtensions:x,builtinExtensions:J}),this.L.info(`${this.y}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`)}}async resolveContent(M){if(this.h.isEqual(this.vb,M)||this.h.isEqual(this.tb,M)||this.h.isEqual(this.ub,M)||this.h.isEqual(this.wb,M)){const k=await this.ab(M);return k&&this.Jb(JSON.parse(k),!0)}return null}Jb(M,k){return d(M,k)}async hasLocalData(){try{const{localExtensions:M}=await this.xb.getLocalExtensions(this.syncResource.profile);if(M.some(k=>k.installed||k.disabled))return!0}catch{}return!1}};v=ye([G(2,C.IEnvironmentService),G(3,S.IFileService),G(4,p.IStorageService),G(5,s.IUserDataSyncStoreService),G(6,s.IUserDataSyncBackupStoreService),G(7,m.IExtensionManagementService),G(8,n.IIgnoredExtensionsManagementService),G(9,s.IUserDataSyncLogService),G(10,E.IConfigurationService),G(11,s.IUserDataSyncEnablementService),G(12,b.ITelemetryService),G(13,h.IExtensionStorageService),G(14,A.IUriIdentityService),G(15,a.IUserDataProfileStorageService),G(16,u.IInstantiationService)],v),e.ExtensionsSynchroniser=v;let L=class{constructor(M,k,$,z,x,X){this.a=M,this.b=k,this.c=$,this.d=z,this.f=x,this.g=X}async getLocalExtensions(M){const k=await this.a.getInstalled(void 0,M.extensionsResource),$=this.d.getIgnoredExtensions(k);return{localExtensions:await this.j(M,async(x,X)=>{const ie=x.getDisabledExtensions();return k.map(H=>{const{identifier:j,isBuiltin:V,manifest:J,preRelease:_,pinned:re}=H,te={identifier:j,preRelease:_,version:J.version,pinned:!!re};ie.some(U=>(0,y.areSameExtensions)(U,j))&&(te.disabled=!0),V||(te.installed=!0);try{const U=X.getKeysForSync({id:j.id,version:J.version});if(U){const B=X.getExtensionState(H,!0)||{};te.state=Object.keys(B).reduce((W,q)=>(U.includes(q)&&(W[q]=B[q]),W),{})}}catch(U){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",M)}: Error while parsing extension state`,(0,R.getErrorMessage)(U))}return te})}),ignoredExtensions:$}}async updateLocalExtensions(M,k,$,z,x){const X=(0,r.getSyncResourceLogLabel)("extensions",x),ie=[],H=[],j=[],V=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||$.length)&&await this.j(x,async(_,re)=>{await D.Promises.settled([...M,...$].map(async te=>{const U=V.find(q=>(0,y.areSameExtensions)(q.identifier,te.identifier));if(U&&U.isBuiltin){te.state&&U.manifest.version===te.version&&this.h(te.state,U,U.manifest.version,re),_.getDisabledExtensions().some(Y=>(0,y.areSameExtensions)(Y,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id),await _.disableExtension(te.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id),await _.enableExtension(te.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id))),H.push(te.identifier);return}const B=te.pinned?te.version:void 0,W=(await this.c.getExtensions([{...te.identifier,version:B,preRelease:B?void 0:te.preRelease}],T.CancellationToken.None))[0];if(te.state&&(U?U.manifest.version===te.version:!!W)&&this.h(te.state,U||W,U?.manifest.version,re),W)try{_.getDisabledExtensions().some(Y=>(0,y.areSameExtensions)(Y,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id,W.version),await _.disableExtension(W.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id,W.version)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id,W.version),await _.enableExtension(W.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id,W.version))),(!U||U.preRelease!==te.preRelease||U.pinned!==te.pinned||B&&U.manifest.version!==B)&&(await this.a.canInstall(W)?ie.push([te,W]):(this.g.info(`${X}: Skipped synchronizing extension because it cannot be installed.`,W.displayName||W.identifier.id),j.push(te)))}catch(q){j.push(te),this.g.error(q),this.g.info(`${X}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else j.push(te),this.g.info(`${X}: Skipped synchronizing extension because the extension is not found.`,te.identifier.id)}))}),k.length){const _=V.filter(({identifier:re,isBuiltin:te})=>!te&&k.some(U=>(0,y.areSameExtensions)(re,U)));await D.Promises.settled(_.map(async re=>{this.g.trace(`${X}: Uninstalling local extension...`,re.identifier.id),await this.a.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${X}: Uninstalled local extension.`,re.identifier.id),H.push(re.identifier)}))}for(const[_,re]of ie)try{this.g.trace(`${X}: Installing extension...`,re.identifier.id,re.version),await this.a.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:_.pinned&&!!_.version,installPreReleaseVersion:_.preRelease,profileLocation:x.extensionsResource,context:{[s.EXTENSIONS_SYNC_CONTEXT_KEY]:!0}}),this.g.info(`${X}: Installed extension.`,re.identifier.id,re.version),H.push(re.identifier)}catch(te){j.push(_),te instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(te.code)?this.g.info(`${X}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.g.error(te),this.g.info(`${X}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const J=[];for(const _ of z)H.some(re=>(0,y.areSameExtensions)(re,_.identifier))||J.push(_);for(const _ of j)J.some(re=>(0,y.areSameExtensions)(re.identifier,_.identifier))||J.push(_);return J}h(M,k,$,z){const x=z.getExtensionState(k,!0)||{},X=$?z.getKeysForSync({id:k.identifier.id,version:$}):void 0;X?X.forEach(ie=>{x[ie]=M[ie]}):Object.keys(M).forEach(ie=>x[ie]=M[ie]),z.setExtensionState(k,x,!0)}async j(M,k){return this.b.withProfileScopedStorageService(M,async $=>{const z=new P.DisposableStore,x=this.f.createChild(new l.ServiceCollection([p.IStorageService,$])),X=z.add(x.createInstance(w.GlobalExtensionEnablementService)),ie=z.add(x.createInstance(h.ExtensionStorageService));try{return await k(X,ie)}finally{z.dispose()}})}};L=ye([G(0,m.IExtensionManagementService),G(1,a.IUserDataProfileStorageService),G(2,m.IExtensionGalleryService),G(3,n.IIgnoredExtensionsManagementService),G(4,u.IInstantiationService),G(5,s.IUserDataSyncLogService)],L),e.LocalExtensionsProvider=L;let N=class extends r.AbstractInitializer{constructor(M,k,$,z,x,X,ie,H){super("extensions",z,x,X,$,ie,H),this.o=M,this.p=k}async q(M){return M.syncData?await o(M.syncData,this.o):null}t(M,k){const $=[],z=[],x=[];for(const X of M){if(this.p.hasToNeverSyncExtension(X.identifier.id))continue;const ie=k.find(H=>(0,y.areSameExtensions)(H.identifier,X.identifier));ie?($.push(ie),X.disabled&&x.push(X.identifier)):X.installed&&(z.push({...X.identifier,preRelease:!!X.preRelease}),X.disabled&&x.push(X.identifier))}return{installedExtensions:$,newExtensions:z,disabledExtensions:x,remoteExtensions:M}}};N=ye([G(0,m.IExtensionManagementService),G(1,n.IIgnoredExtensionsManagementService),G(2,S.IFileService),G(3,i.IUserDataProfilesService),G(4,C.IEnvironmentService),G(5,g.ILogService),G(6,p.IStorageService),G(7,A.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(oe[120],ae([0,1,17,9,3,35,43,4,31,16,15,14,8,45,20,19,29,41,61,263,24,18,62,5]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",n=["locale"];function s(L,N){const F=L.storage?Object.keys(L.storage).sort():[],M={};return F.forEach(k=>M[k]=L.storage[k]),L.storage=M,N?(0,O.toFormattedString)(L,{}):JSON.stringify(L)}e.stringify=s;const a=1;let o=class extends l.AbstractSynchroniser{constructor(N,F,M,k,$,z,x,X,ie,H,j,V,J,_){super({syncResource:"globalState",profile:N},F,k,X,V,$,z,ie,H,x,j,J),this.wb=M,this.mb=a,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=_.createInstance(f),this.B(k.watch(this.h.dirname(this.D.argvResource))),this.B(R.Event.any(R.Event.filter(k.onDidFilesChange,re=>re.contains(this.D.argvResource)),R.Event.filter(M.onDidChange,re=>!!(re.targetChanges.some(te=>this.syncResource.profile.id===te.id)||re.valueChanges.some(({profile:te,changes:U})=>this.syncResource.profile.id===te.id&&U.some(B=>B.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,F,M){const k=N.syncData?JSON.parse(N.syncData.content):null;F=F===null&&M?N:F;const $=F&&F.syncData?JSON.parse(F.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);k?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const x=await this.Eb($),{local:X,remote:ie}=(0,p.merge)(z.storage,k?k.storage:null,$?$.storage:null,x,this.L),H={content:null,local:X,remote:ie,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:ie.all!==null?2:0},j=s(z,!1);return[{baseResource:this.r,baseContent:$?s($,!1):j,localResource:this.sb,localContent:j,localUserData:z,remoteResource:this.tb,remoteContent:k?s(k,!1):null,previewResource:this.p,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.ub,storageKeys:x}]}async rb(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(F===null)return!0;const M=await this.vb.getLocalGlobalState(this.syncResource.profile),k=await this.Eb(F),{remote:$}=(0,p.merge)(M.storage,F.storage,F.storage,k,this.L);return $.all!==null}async ob(N,F){return{...N.previewResult,hasConflicts:!1}}async pb(N,F,M,k){if(this.h.isEqual(F,this.sb))return this.Bb(N);if(this.h.isEqual(F,this.tb))return this.Cb(N);if(this.h.isEqual(F,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const F=JSON.parse(N.remoteContent),{local:M,remote:k}=(0,p.merge)(N.localUserData.storage,F.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:M,remote:k,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,F,M,k){const{localUserData:$}=M[0][0],{local:z,remote:x,localChange:X,remoteChange:ie}=M[0][1];if(X===0&&ie===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),X!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify($)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),ie!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const H=JSON.stringify({storage:x.all});N=await this.jb(H,k?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${x.added.length?` Added: ${x.added}.`:""}${x.updated.length?` Updated: ${x.updated}.`:""}${x.removed.length?` Removed: ${x.removed}.`:""}`)}F?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const F=await this.ab(N);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const F=await this.wb.readStorageData(this.syncResource.profile),M=[],k=[];for(const[x,X]of F)X.target===0?M.push(x):X.target===1&&k.push(x);const $=[...M,...k],z=N?.storage?Object.keys(N.storage).filter(x=>!x.startsWith(t)&&!$.includes(x)&&F.get(x)!==void 0):[];if(!P.isWeb){const x=[...b.ALL_SYNC_RESOURCES.map(X=>(0,b.getEnablementKey)(X)),b.SYNC_SERVICE_URL_TYPE];z.push(...x),k.push(...x)}return{user:M,machine:k,unregistered:z}}};o=ye([G(2,i.IUserDataProfileStorageService),G(3,w.IFileService),G(4,b.IUserDataSyncStoreService),G(5,b.IUserDataSyncBackupStoreService),G(6,b.IUserDataSyncLogService),G(7,C.IEnvironmentService),G(8,b.IUserDataSyncEnablementService),G(9,S.ITelemetryService),G(10,E.IConfigurationService),G(11,h.IStorageService),G(12,u.IUriIdentityService),G(13,r.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let f=class{constructor(N,F,M,k){this.a=N,this.b=F,this.c=M,this.d=k}async getLocalGlobalState(N){const F={};if(N.isDefault){const k=await this.f(),$=(0,c.parse)(k);for(const z of n)$[z]!==void 0&&(F[`${t}${z}`]={version:1,value:$[z]})}const M=await this.c.readStorageData(N);for(const[k,$]of M)$.value&&$.target===0&&(F[k]={version:1,value:$.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,T.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:F,updated:M},k){const $=(0,l.getSyncResourceLogLabel)("globalState",k),z={},x=new Map,X=await this.c.readStorageData(k),ie=(H,j)=>{for(const V of H){if(V.startsWith(t)){z[V.substring(t.length)]=j?j[V].value:void 0;continue}if(j){const J=j[V];J.value!==X.get(V)?.value&&x.set(V,J.value)}else X.get(V)!==void 0&&x.set(V,void 0)}};if(ie(Object.keys(N),N),ie(Object.keys(M),M),ie(F),Object.keys(z).length){this.d.trace(`${$}: Updating locale...`);const H=await this.f();let j=H;for(const V of Object.keys(z))j=(0,g.edit)(j,[V],z[V],{});H!==j&&(this.d.trace(`${$}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.VSBuffer.fromString(j)),this.d.info(`${$}: Updated locale.`)),this.d.info(`${$}: Updated locale`)}x.size&&(this.d.trace(`${$}: Updating global state...`),await this.c.updateStorageData(k,x,0),this.d.info(`${$}: Updated global state`,[...x.keys()]))}};f=ye([G(0,w.IFileService),G(1,C.IEnvironmentService),G(2,i.IUserDataProfileStorageService),G(3,b.IUserDataSyncLogService)],f),e.LocalGlobalStateProvider=f;let d=class extends l.AbstractInitializer{constructor(N,F,M,k,$,z){super("globalState",M,k,$,F,N,z)}async doInitialize(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},k={};for(const $ of Object.keys(F.storage))$.startsWith(t)?M[$.substring(t.length)]=F.storage[$].value:this.l.get($,0)===void 0&&(k[$]=F.storage[$].value);if(Object.keys(M).length){let $="{}";try{$=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys(M))$=(0,g.edit)($,[z],M[z],{});await this.k.writeFile(this.h.argvResource,D.VSBuffer.fromString($))}if(Object.keys(k).length)for(const $ of Object.keys(k))this.l.store($,k[$],0,0)}};d=ye([G(0,h.IStorageService),G(1,w.IFileService),G(2,A.IUserDataProfilesService),G(3,C.IEnvironmentService),G(4,b.IUserDataSyncLogService),G(5,u.IUriIdentityService)],d),e.GlobalStateInitializer=d;let v=class{constructor(N,F,M,k,$){this.a=N,this.b=F,this.c=M,this.d=k,this.f=$}getSyncStoreType(N){return this.h(N)?.storage[b.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const F=(0,b.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(N,F)}catch(M){if(M instanceof b.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,F)}throw M}}async g(N,F){const M=await this.a.readResource("globalState",null,void 0,F),k=this.h(M)||{storage:{}};k.storage[b.SYNC_SERVICE_URL_TYPE]={value:N,version:a};const $=await(0,y.getServiceMachineId)(this.c,this.d,this.b),z={version:a,machineId:$,content:s(k,!1)};await this.a.writeResource("globalState",JSON.stringify(z),M.ref,void 0,F)}h({content:N}){if(!N)return null;const F=JSON.parse(N);if((0,l.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};v=ye([G(1,h.IStorageService),G(2,C.IEnvironmentService),G(3,w.IFileService),G(4,m.ILogService)],v),e.UserDataSyncStoreTypeSynchronizer=v}),define(oe[121],ae([0,1,21,17,3,35,4,12,180,16,15,14,20,19,29,18,41,260,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(i,r,t){try{const n=JSON.parse(i);if(!r)return(0,P.isUndefined)(n.all)?null:n.all;switch(O.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=p;let b=class extends u.AbstractJsonFileSynchroniser{constructor(r,t,n,s,a,o,f,d,v,L,N,F,M){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,d,v,L,n,s,f,F,a,N,o,M),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(R.Event.filter(o.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(r,t,n,s){const a=r.syncData?p(r.syncData.content,s.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&n?r:t;const o=t?this.Jb(t):null,f=await this.p(),d=await this.xb();let v=null,L=!1,N=!1,F=!1;if(a){let $=f?f.value.toString():"[]";if($=$||"[]",this.vb($,!0))throw new g.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==a){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,l.merge)($,a,o,d,this.ub);z.hasChanges&&(v=z.mergeContent,F=z.hasConflicts,L=F||z.mergeContent!==$,N=F||z.mergeContent!==a)}}else f&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=f.value.toString(),N=!0);const M={content:F?o:v,localChange:L?f?2:1:0,remoteChange:N?2:0,hasConflicts:F},k=f?f.value.toString():null;return[{fileContent:f,baseResource:this.Ab,baseContent:o,localResource:this.Bb,localContent:k,localChange:M.localChange,remoteResource:this.Cb,remoteContent:a,remoteChange:M.remoteChange,previewResource:this.zb,previewResult:M,acceptedResource:this.Db}]}async rb(r){const t=this.Jb(r);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString():"",a=await this.xb(),o=await(0,l.merge)(s||"[]",t,t,a,this.ub);return o.hasConflicts||o.mergeContent!==t}async ob(r,t){return r.previewResult}async pb(r,t,n,s){if(this.h.isEqual(t,this.Bb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,n,s){const{fileContent:a}=n[0][0];let{content:o,localChange:f,remoteChange:d}=n[0][1];if(f===0&&d===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.vb(o,!0)))throw new g.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(f!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),a&&await this.kb(this.Kb(a.value.toString())),await this.r(o||"[]",a,s),this.L.info(`${this.y}: Updated local keybindings`)),d!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const v=this.Kb(o||"[]",r.syncData?.content);r=await this.jb(v,s?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(r,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,c.parse)(r.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Ab,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Db,r)?this.ab(r):null}Jb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Lb()?null:p(r.syncData.content,this.Lb(),this.L)}Kb(r,t){let n={};try{n=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Lb()?delete n.all:n.all=r,O.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}Lb(){return!!this.M.getValue(g.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};b=ye([G(2,g.IUserDataSyncStoreService),G(3,g.IUserDataSyncBackupStoreService),G(4,g.IUserDataSyncLogService),G(5,E.IConfigurationService),G(6,g.IUserDataSyncEnablementService),G(7,w.IFileService),G(8,C.IEnvironmentService),G(9,m.IStorageService),G(10,g.IUserDataSyncUtilService),G(11,y.ITelemetryService),G(12,h.IUriIdentityService)],b),e.KeybindingsSynchroniser=b;let A=class extends u.AbstractInitializer{constructor(r,t,n,s,a,o){super("keybindings",t,n,s,r,a,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,T.VSBuffer.fromString(t)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,c.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}i(r){try{return p(r,!0,this.j)}catch(t){return this.j.error(t),null}}};A=ye([G(0,w.IFileService),G(1,S.IUserDataProfilesService),G(2,C.IEnvironmentService),G(3,g.IUserDataSyncLogService),G(4,m.IStorageService),G(5,h.IUriIdentityService)],A),e.KeybindingsInitializer=A}),define(oe[122],ae([0,1,17,3,181,16,74,15,30,14,20,19,29,18,41,61,264,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const r=JSON.parse(i);return g(r)?r:{settings:i}}e.parseSettingsSyncContent=p;let b=class extends h.AbstractJsonFileSynchroniser{constructor(r,t,n,s,a,o,f,d,v,L,N,F,M,k){super(r.settingsResource,{syncResource:"settings",profile:r},t,n,s,a,o,f,N,F,d,v,L,k),this.zb=M,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),n=await this.R(r,t),s=this.Gb(n),a=new O.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&a.parse(s.settings),a.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(r,t,n){const s=await this.p(),a=await this.xb(),o=this.Gb(r);t=t===null&&n?r:t;const f=t?this.Gb(t):null,d=await this.Kb();let v=null,L=!1,N=!1,F=!1;if(o){let z=s?s.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const x=(0,u.merge)(z,o.settings,f?f.settings:null,d,[],a);v=x.localContent||x.remoteContent,L=x.localContent!==null,N=x.remoteContent!==null,F=x.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),v=s.value.toString().trim()||"{}",this.Lb(v),N=!0);const M=s?s.value.toString():null,k=f?.settings??null,$={content:F?k:v,localChange:L?2:0,remoteChange:N?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:k,localResource:this.localResource,localContent:M,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async rb(r){const t=this.Gb(r);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString().trim():"",a=await this.Kb(),o=await this.xb();return(0,u.merge)(s||"{}",t.settings,t.settings,a,[],o).remoteContent!==null}async ob(r,t){const n=await this.xb(),s=await this.Kb();return{...r.previewResult,content:r.previewResult.content?(0,u.updateIgnoredSettings)(r.previewResult.content,"{}",s,n):null}}async pb(r,t,n,s){const a=await this.xb(),o=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,u.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,a):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,u.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,r.fileContent?r.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,n,s){const{fileContent:a}=n[0][0];let{content:o,localChange:f,remoteChange:d}=n[0][1];if(f===0&&d===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Lb(o),f!==0&&(this.L.trace(`${this.y}: Updating local settings...`),a&&await this.kb(JSON.stringify(this.Ib(a.value.toString()))),await this.r(o,a,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),d!==0){const v=await this.xb(),L=this.Gb(r),N=await this.Kb(o);o=(0,u.updateIgnoredSettings)(o,L?L.settings:"{}",N,v),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.jb(JSON.stringify(this.Ib(o)),s?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.xb(),n=(0,S.edit)(r.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,u.isEmpty)(n)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.ab(r):null}async ab(r){let t=await super.ab(r);if(t){const n=await this.xb(),s=await this.Kb();t=(0,u.updateIgnoredSettings)(t,"{}",s,n)}return t}Gb(r){return r.syncData?this.Hb(r.syncData.content):null}Hb(r){try{return p(r)}catch(t){this.L.error(t)}return null}Ib(r){return{settings:r}}async Kb(r){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const n=T.Event.any(T.Event.filter(this.zb.onDidInstallExtensions,s=>s.some(({local:a})=>!!a)),T.Event.filter(this.zb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,u.getIgnoredSettings)(t,this.M,r)}Lb(r){if(this.vb(r,!1))throw new l.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};b=ye([G(2,E.IFileService),G(3,P.IEnvironmentService),G(4,C.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncLogService),G(8,l.IUserDataSyncUtilService),G(9,c.IConfigurationService),G(10,l.IUserDataSyncEnablementService),G(11,w.ITelemetryService),G(12,I.IExtensionManagementService),G(13,m.IUriIdentityService)],b),e.SettingsSynchroniser=b;let A=class extends h.AbstractInitializer{constructor(r,t,n,s,a,o){super("settings",t,n,s,r,a,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,u.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}i(r){try{return p(r)}catch(t){this.j.error(t)}return null}};A=ye([G(0,E.IFileService),G(1,y.IUserDataProfilesService),G(2,P.IEnvironmentService),G(3,l.IUserDataSyncLogService),G(4,C.IStorageService),G(5,m.IUriIdentityService)],A),e.SettingsInitializer=A}),define(oe[123],ae([0,1,17,3,32,16,15,14,20,19,29,18,41,261,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function S(g){return JSON.parse(g.content)}e.parseSnippets=S;let u=class extends m.AbstractSynchroniser{constructor(p,b,A,i,r,t,n,s,a,o,f,d){super({syncResource:"snippets",profile:p},b,i,A,r,t,n,o,f,s,a,d),this.mb=1,this.p=p.snippetsHome,this.B(this.C.watch(A.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(T.Event.filter(this.C.onDidFilesChange,v=>v.affects(this.p))(()=>this.triggerLocalChange()))}async nb(p,b,A){const i=await this.Cb(),r=this.Bb(i),t=p.syncData?this.Ab(p.syncData):null;b=b===null&&A?p:b;const n=b&&b.syncData?this.Ab(b.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,y.merge)(r,t,n);return this.wb(s,i,t||{},n||{})}async rb(p){const b=p.syncData?this.Ab(p.syncData):null;if(b===null)return!0;const A=await this.Cb(),i=this.Bb(A),r=(0,y.merge)(i,b,b);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async ob(p,b){return p.previewResult}async pb(p,b,A,i){if(this.h.isEqualOrParent(b,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:p.fileContent?p.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(b,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:p.remoteContent,localChange:p.remoteContent!==null?p.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(b,this.g))return A===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:A,localChange:A===null?p.fileContent!==null?3:0:2,remoteChange:A===null?p.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async qb(p,b,A,i){const r=A.map(([t,n])=>({...t,acceptResult:n}));r.every(({localChange:t,remoteChange:n})=>t===0&&n===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.xb(r),await this.yb(r,i)),r.some(({remoteChange:t})=>t!==0)&&(p=await this.zb(r,p,i)),b?.ref!==p.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(p),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}wb(p,b,A,i){const r=new Map;for(const t of Object.keys(p.local.added)){const n={content:p.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:A[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.local.updated)){const n={content:p.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=b[t]?b[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:A[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=b[t]?b[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.added)){const n={content:p.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=b[t]?b[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.updated)){const n={content:p.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=b[t]?b[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:A[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:A[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.conflicts){const n={content:i[t]??null,hasConflicts:!0,localChange:b[t]?2:1,remoteChange:A[t]?2:1},s=b[t]?b[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:A[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(b))if(!r.has(t)){const n={content:b[t]?b[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=b[t]?b[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:A[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(p){return this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(p):null}async hasLocalData(){try{const p=await this.Cb();if(Object.keys(p).length)return!0}catch{}return!1}async xb(p){const b={};for(const A of p)A.fileContent&&(b[this.h.basename(A.localResource)]=A.fileContent);await this.kb(JSON.stringify(this.Bb(b)))}async yb(p,b){for(const{fileContent:A,acceptResult:i,localResource:r,remoteResource:t,localChange:n}of p)if(n!==0){const s=t?this.h.basename(t):this.h.basename(r),a=this.h.joinPath(this.p,s);n===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(a)),await this.C.del(a),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(a))):n===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(a)),await this.C.createFile(a,D.VSBuffer.fromString(i.content),{overwrite:b}),this.L.info(`${this.y}: Created snippet`,this.h.basename(a))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(a)),await this.C.writeFile(a,D.VSBuffer.fromString(i.content),b?void 0:A),this.L.info(`${this.y}: Updated snippet`,this.h.basename(a)))}}async zb(p,b,A){const i=b.syncData?this.Ab(b.syncData):{},r=(0,R.deepClone)(i);for(const{acceptResult:t,localResource:n,remoteResource:s,remoteChange:a}of p)if(a!==0){const o=n?this.h.basename(n):this.h.basename(s);a===3?delete r[o]:r[o]=t.content}return(0,y.areSame)(i,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),b=await this.jb(JSON.stringify(r),A?null:b.ref),this.L.info(`${this.y}: Updated remote snippets`)),b}Ab(p){return S(p)}Bb(p){const b={};for(const A of Object.keys(p))b[A]=p[A].value.toString();return b}async Cb(){const p={};let b;try{b=await this.C.resolve(this.p)}catch(A){if(A instanceof P.FileOperationError&&A.fileOperationResult===1)return p;throw A}for(const A of b.children||[]){const i=A.resource,r=this.h.extname(i);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,i),n=await this.C.readFile(i);p[t]=n}}return p}};u=ye([G(2,O.IEnvironmentService),G(3,P.IFileService),G(4,I.IStorageService),G(5,h.IUserDataSyncStoreService),G(6,h.IUserDataSyncBackupStoreService),G(7,h.IUserDataSyncLogService),G(8,c.IConfigurationService),G(9,h.IUserDataSyncEnablementService),G(10,E.ITelemetryService),G(11,C.IUriIdentityService)],u),e.SnippetsSynchroniser=u;let l=class extends m.AbstractInitializer{constructor(p,b,A,i,r,t){super("snippets",b,A,i,p,r,t)}async doInitialize(p){const b=p.syncData?JSON.parse(p.syncData.content):null;if(!b){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(b)){const r=b[i];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(t,D.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(p)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(p){return p.fileOperationResult===1}}};l=ye([G(0,P.IFileService),G(1,w.IUserDataProfilesService),G(2,O.IEnvironmentService),G(3,h.IUserDataSyncLogService),G(4,I.IStorageService),G(5,C.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(oe[124],ae([0,1,17,16,15,14,20,19,29,18,41,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(u,l){try{return JSON.parse(u).tasks??null}catch(g){return l.error(g),null}}e.getTasksContentFromSyncContent=m;let y=class extends C.AbstractFileSynchroniser{constructor(l,g,p,b,A,i,r,t,n,s,a,o){super(l.tasksResource,{syncResource:"tasks",profile:l},g,t,n,s,p,b,r,a,A,i,o),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,g,p,b){const A=l.syncData?m(l.syncData.content,this.L):null;g=g===null&&p?l:g;const i=g?.syncData?m(g.syncData.content,this.L):null,r=await this.p();let t=null,n=!1,s=!1,a=!1;if(l.syncData){const d=r?r.value.toString():null;if(!i||i!==d||i!==A){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const v=S(d,A,i);t=v.content,a=v.hasConflicts,n=v.hasLocalChanged,s=v.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const o={content:a?i:t,localChange:n?r?2:1:0,remoteChange:s?2:0,hasConflicts:a},f=r?r.value.toString():null;return[{fileContent:r,baseResource:this.wb,baseContent:i,localResource:this.xb,localContent:f,localChange:o.localChange,remoteResource:this.yb,remoteContent:A,remoteChange:o.remoteChange,previewResource:this.vb,previewResult:o,acceptedResource:this.zb}]}async rb(l){const g=l?.syncData?m(l.syncData.content,this.L):null;if(g===null)return!0;const p=await this.p(),b=p?p.value.toString():null,A=S(b,g,g);return A.hasLocalChanged||A.hasRemoteChanged}async ob(l,g){return l.previewResult}async pb(l,g,p,b){if(this.h.isEqual(g,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(g,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(g,this.vb))return p===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:p,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async qb(l,g,p,b){const{fileContent:A}=p[0][0],{content:i,localChange:r,remoteChange:t}=p[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),A&&await this.kb(JSON.stringify(this.Fb(A.value.toString()))),i?await this.r(i,A,b):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const n=JSON.stringify(this.Fb(i));l=await this.jb(n,b?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}g?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};y=ye([G(2,w.IUserDataSyncStoreService),G(3,w.IUserDataSyncBackupStoreService),G(4,w.IUserDataSyncLogService),G(5,T.IConfigurationService),G(6,w.IUserDataSyncEnablementService),G(7,c.IFileService),G(8,R.IEnvironmentService),G(9,O.IStorageService),G(10,P.ITelemetryService),G(11,I.IUriIdentityService)],y),e.TasksSynchroniser=y;let h=class extends C.AbstractInitializer{constructor(l,g,p,b,A,i){super("tasks",g,p,b,l,A,i),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const g=l.syncData?m(l.syncData.content,this.j):null;if(!g){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.VSBuffer.fromString(g)),await this.n(l)}async i(){return this.k.exists(this.c)}};h=ye([G(0,c.IFileService),G(1,E.IUserDataProfilesService),G(2,R.IEnvironmentService),G(3,w.IUserDataSyncLogService),G(4,O.IStorageService),G(5,I.IUriIdentityService)],h),e.TasksInitializer=h;function S(u,l,g){if(u===null&&l===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(u===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const p=g!==u,b=g!==l;return!p&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:p&&!b?{content:u,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!p?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:u,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[125],ae([0,1,43,16,15,14,20,19,29,18,41,262,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let y=class extends C.AbstractSynchroniser{constructor(l,g,p,b,A,i,r,t,n,s,a,o,f){super({syncResource:"profiles",profile:l},g,b,A,i,r,t,a,o,n,s,f),this.r=p,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?S(l.syncData):null}async getRemoteSyncedProfiles(l){const g=await this.getLastSyncUserData(),p=await this.R(l,g);return p?.syncData?S(p.syncData):null}async nb(l,g,p){if(!this.r.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const b=l.syncData?S(l.syncData):null,A=g?.syncData?S(g.syncData):null,i=this.zb(),{local:r,remote:t}=(0,w.merge)(i,b,A,[]),n={local:r,remote:t,content:A?this.Ab(A):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=h(i,!1);return[{baseResource:this.baseResource,baseContent:A?this.Ab(A):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:b?this.Ab(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const g=l?.syncData?S(l.syncData):null,p=this.zb(),{remote:b}=(0,w.merge)(p,g,g,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async ob(l,g){return{...l.previewResult,hasConflicts:!1}}async pb(l,g,p,b){if(this.h.isEqual(g,this.localResource))return this.wb(l);if(this.h.isEqual(g,this.remoteResource))return this.xb(l);if(this.h.isEqual(g,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async wb(l){const g=this.zb(),p=(0,w.merge)(g,null,null,[]),{local:b,remote:A}=p;return{content:l.localContent,local:b,remote:A,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:A!==null?2:0}}async xb(l){const g=l.remoteContent?JSON.parse(l.remoteContent):null,p=[],b=[];for(const A of this.zb()){const i=g?.find(r=>r.id===A.id);i&&(p.push({id:A.id,name:A.name,collection:i.collection}),b.push(A))}if(g!==null){const A=(0,w.merge)(b,g,p,[]),{local:i,remote:r}=A;return{content:l.remoteContent,local:i,remote:r,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,g,p,b){const{local:A,remote:i,localChange:r,remoteChange:t}=p[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const n=p[0][0].remoteProfiles||[];if(n.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.kb(h(this.zb(),!1));const s=[];for(const a of A.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${a.name}' profile...`),await this.r.createProfile(a.id,a.name,{shortName:a.shortName}),this.L.info(`${this.y}: Created profile '${a.name}'.`)})());for(const a of A.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${a.name}' profile...`),await this.r.removeProfile(a),this.L.info(`${this.y}: Removed profile '${a.name}'.`)})());for(const a of A.updated){const o=this.r.profiles.find(f=>f.id===a.id);o?s.push((async()=>{this.L.trace(`${this.y}: Updating '${a.name}' profile...`),await this.r.updateProfile(o,{name:a.name,shortName:a.shortName}),this.L.info(`${this.y}: Updated profile '${a.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],a=n.length+(i?.added.length??0)<=20;if(a)for(const o of i?.added||[]){const f=await this.G.createCollection(this.z);s.push(f),n.push({id:o.id,name:o.name,collection:f,shortName:o.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const o of i?.removed||[])n.splice(n.findIndex(({id:f})=>o.id===f),1);for(const o of i?.updated||[]){const f=n.find(({id:d})=>o.id===d);f&&n.splice(n.indexOf(f),1,{id:o.id,name:o.name,collection:f.collection,shortName:o.shortName})}try{l=await this.updateRemoteProfiles(n,b?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${a&&i?.added.length?` Added: ${JSON.stringify(i.added.map(o=>o.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(o=>o.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const f of s)await this.G.deleteCollection(f,this.z)}throw o}for(const o of i?.removed||[])await this.G.deleteCollection(o.collection,this.z)}g?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,g){return this.jb(this.Ab(l),g)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const g=await this.ab(l);return g&&(0,D.toFormattedString)(JSON.parse(g),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((g,p)=>g.name.localeCompare(p.name)))}};y=ye([G(2,E.IUserDataProfilesService),G(3,c.IFileService),G(4,R.IEnvironmentService),G(5,O.IStorageService),G(6,m.IUserDataSyncStoreService),G(7,m.IUserDataSyncBackupStoreService),G(8,m.IUserDataSyncLogService),G(9,T.IConfigurationService),G(10,m.IUserDataSyncEnablementService),G(11,P.ITelemetryService),G(12,I.IUriIdentityService)],y),e.UserDataProfilesManifestSynchroniser=y;function h(u,l){const g=[...u].sort((p,b)=>p.name.localeCompare(b.name)).map(p=>({id:p.id,name:p.name}));return l?(0,D.toFormattedString)(g,{}):JSON.stringify(g)}e.stringifyLocalProfiles=h;function S(u){return JSON.parse(u.content)}e.parseUserDataProfilesManifest=S}),define(oe[278],ae([0,1,6,17,65,2,22,16,15,14,18,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends c.Disposable{constructor(h,S,u,l,g){super(),this.a=h,this.b=S,this.c=u,this.f=l,this.g=g,this.h()}async h(){for(const S of this.g.profiles)for(const u of w.ALL_SYNC_RESOURCES)try{await this.j(this.i(S,u))}catch(l){this.f.error(l)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(S){(0,E.toFileOperationResult)(S)!==1&&this.f.error(S);return}if(h.children){for(const S of h.children)if(S.isDirectory&&!this.g.profiles.some(u=>u.id===S.name))try{this.f.info("Deleting non existing profile from backup",S.resource.path),await this.b.del(S.resource,{recursive:!0})}catch(u){this.f.error(u)}}}async getAllRefs(h,S){const u=this.i(h,S),l=await this.b.resolve(u);return l.children?l.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.k(p)})):[]}async resolveContent(h,S,u){const l=this.i(h,S),g=(0,O.joinPath)(l,u);try{return(await this.b.readFile(g)).value.toString()}catch(p){return this.f.error(p),null}}async backup(h,S,u){const l=this.i(h,S),g=(0,O.joinPath)(l,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,T.VSBuffer.fromString(u))}catch(p){this.f.error(p)}try{this.j(l)}catch{}}i(h,S){return(0,O.joinPath)(this.a.userDataSyncHome,...h.isDefault?[S]:[h.id,S])}async j(h){try{try{if(!await this.b.exists(h))return}catch{return}const S=await this.b.resolve(h);if(S.children){const u=S.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let g=u.filter(b=>Date.now()-this.k(b)>l);const p=u.length-g.length;p<10&&(g=g.slice(10-p)),await D.Promises.settled(g.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(S){this.f.error(S)}}k(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};m=ye([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,P.IConfigurationService),G(3,w.IUserDataSyncLogService),G(4,C.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(oe[279],ae([0,1,3,2,4,15,20,19,24]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let C=class extends T.Disposable{constructor(m,y,h,S){super(),this.c=m,this.f=y,this.g=h,this.h=S,this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new D.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(u=>this.j(u)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(E,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(E,{enabled:m}),this.c.store(E,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,I.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,y){if(this.isResourceEnabled(m)!==y){const h=(0,I.getEnablementKey)(m);this.i(h,y)}}getResourceSyncStateVersion(m){}i(m,y){this.c.store(m,y,-1,R.isWeb?0:1)}j(m){if(m.scope!==-1)return;if(E===m.key){this.a.fire(this.isEnabled());return}const y=I.ALL_SYNC_RESOURCES.filter(h=>(0,I.getEnablementKey)(h)===m.key)[0];if(y){this.b.fire([y,this.isResourceEnabled(y)]);return}}};C=ye([G(0,O.IStorageService),G(1,P.ITelemetryService),G(2,c.IEnvironmentService),G(3,I.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(oe[81],ae([0,1,3,2,4,27,185,15,14,5,23,45,20,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",S="Safari",u="Chrome",l="Edge",g="Firefox",p="Android";function b(r){switch(r){case S:case u:case l:case g:case p:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=b;function A(){return R.isSafari?S:R.isChrome?u:R.isEdge?l:R.isFirefox?g:R.isAndroid?p:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let i=class st extends T.Disposable{constructor(t,n,s,a,o,f){super(),this.h=s,this.i=a,this.j=o,this.k=f,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,w.getServiceMachineId)(t,n,s)}async getMachines(t){const n=await this.f;return(await this.m(t)).machines.map(a=>({...a,isCurrent:a.id===n}))}async addCurrentMachine(t){const n=await this.f,s=await this.m(t);s.machines.some(({id:a})=>a===n)||(s.machines.push({id:n,name:this.l(s.machines),platform:A()}),await this.n(s))}async removeCurrentMachine(t){const n=await this.f,s=await this.m(t),a=s.machines.filter(({id:o})=>o!==n);a.length!==s.machines.length&&(s.machines=a,await this.n(s))}async renameMachine(t,n,s){const a=await this.m(s),o=a.machines.find(({id:f})=>f===t);if(o){o.name=n,await this.n(a);const f=await this.f;t===f&&this.h.store(h,n,-1,1)}}async setEnablements(t){const n=await this.m();for(const[s,a]of t){const o=n.machines.find(f=>f.id===s);o&&(o.disabled=a?void 0:!0)}await this.n(n)}l(t){const n=this.h.get(h,-1);if(n)return n;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${A()} (${this.k.nameShort})`,a=new RegExp(`${(0,c.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let o=0;for(const f of t){const d=a.exec(f.name),v=d?parseInt(d[1]):0;o=v>o?v:o}return`${s} #${o+1}`}async m(t){this.g=await this.p(t);const n=this.r(this.g);if(n.version!==st.a)throw new Error((0,O.localize)(0,null,this.k.nameLong));return n}async n(t){const n=JSON.stringify(t),s=await this.i.writeResource(st.b,n,this.g?.ref||null);this.g={ref:s,content:n},this.c.fire()}async p(t){if(this.g){const n=t&&t.latest?t.latest[st.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(st.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.j.error(n)}return{version:st.a,machines:[]}}};i.a=1,i.b="machines",i=ye([G(0,P.IEnvironmentService),G(1,I.IFileService),G(2,m.IStorageService),G(3,y.IUserDataSyncStoreService),G(4,y.IUserDataSyncLogService),G(5,C.IProductService)],i),e.UserDataSyncMachinesService=i}),define(oe[280],ae([0,1,6,65,38,9,3,2,4,22,11,182,23,20,19,24,78,81]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",p="sync.sessionId",b="sync.storeUrl",A="sync.productQuality";let i=class extends P.Disposable{get j(){const n=this.z.get(b,-1);return n?C.URI.parse(n):void 0}set j(n){n?this.z.store(b,n.toString(),-1,1):this.z.remove(b,-1)}get l(){return this.z.get(A,-1)}set l(n){n?this.z.store(A,n,-1,1):this.z.remove(A,-1)}constructor(n,s,a,o,f,d,v,L,N,F){super(),this.n=s,this.p=a,this.r=o,this.s=f,this.u=d,this.v=v,this.w=L,this.y=N,this.z=F,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new D.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(v.onDidChangeAccount(()=>this.C())),this.B(a.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(f.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.r.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:s}=this.F();n?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(a=>this.I(a))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,s,a){try{this.v.account&&!a&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(o){if(this.u.error(o),s)this.G(!1);else throw o}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const s=S.UserDataSyncError.toUserDataSyncError(n);s instanceof S.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(g,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(g,-1,!1)}M(){this.z.remove(g,-1)}async triggerSync(n,s,a){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const o=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:o}),this.N=[],this.a.value&&await this.a.value.sync("Activity",a)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};i=ye([G(0,m.IProductService),G(1,S.IUserDataSyncStoreManagementService),G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncEnablementService),G(4,S.IUserDataSyncService),G(5,S.IUserDataSyncLogService),G(6,u.IUserDataSyncAccountService),G(7,h.ITelemetryService),G(8,l.IUserDataSyncMachinesService),G(9,y.IStorageService)],i),e.UserDataAutoSyncService=i;class r extends P.Disposable{constructor(n,s,a,o,f,d,v,L){super(),this.j=n,this.k=s,this.l=a,this.m=o,this.n=f,this.p=d,this.r=v,this.s=L,this.b=this.B(new P.MutableDisposable),this.c=this.B(new O.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new O.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,D.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(n,s){const a=(0,D.createCancelablePromise)(async o=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(f){if((0,c.isCancellationError)(f))return}return this.y(n,s,o)});return this.i=a,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,E.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!n&&(!(0,E.isEqual)(s.defaultUrl,n.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,n.insidersUrl)||!(0,E.isEqual)(s.stableUrl,n.stableUrl))}async y(n,s,a){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let o;try{await this.z(s,a)}catch(f){if(this.r.error(f),o=f,S.UserDataSyncError.toUserDataSyncError(f).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(s,a),o=void 0}catch(d){this.r.error(d),o=d}}this.f.fire(o)}async z(n,s){if(this.h=await this.n.createSyncTask(this.g,n),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const a=this.s.get(p,-1);if(a&&this.g&&a!==this.g.session)throw this.v()?await this.w()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const o=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const f=o.find(d=>d.isCurrent);if(f?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(d){throw new S.UserDataAutoSyncError((0,R.toErrorMessage)(d),d instanceof S.UserDataSyncError?d.code:"Unknown")}this.g&&this.g.session!==a&&this.s.store(p,this.g.session,-1,1),!s.isCancellationRequested&&(f||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}r.a="Interval"}),define(oe[281],ae([0,1,11,186,15,14,45,20,29,24,18,41,123,122,121,16,124,119,120,5,125,43]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class Ve{constructor(t,n,s,a,o,f,d,v,L,N){this.e=t,this.f=n,this.g=s,this.h=o,this.i=f,this.j=d,this.k=v,this.l=L,this.m=N,this.d=a.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const n=this.K(t.content,"profiles");return(0,b.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(t,n){return(await this.e.getAllResourceRefs(t,n?.collection)).map(({created:a,ref:o})=>({created:a,uri:this.I({remote:!0,syncResource:t,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,n){return(await this.f.getAllRefs(n,t)).map(({created:a,ref:o})=>({created:a,uri:this.I({remote:!1,syncResource:t,profile:n.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const n=this.J(t),s=n?this.k.profiles.find(a=>a.id===n.profile):void 0;return n&&s?{profile:s,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:t}){const n=this.J(t);if(!n)return[];const s=this.k.profiles.find(a=>a.id===n.profile);switch(n.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const n=this.J(t);if(!!n){if(n.remote){if(n.ref){const{content:s}=await this.L(n.syncResource,n.ref,n.collection);if(s)return this.K(s,n.syncResource)?.machineId}return}return(0,O.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const n=this.J(t);if(!n||n.node===Ve.a)return null;if(n.ref){const s=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&s?this.o(n.syncResource,s,n.node):s}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(t,n,s,a,o){if(t){const{content:d}=await this.L(n,o,a);return d}const f=this.k.profiles.find(d=>d.id===s);return f?this.f.resolveContent(f,n,o):null}o(t,n,s){const a=this.K(n,t);switch(t){case"settings":return this.s(a,s);case"keybindings":return this.u(a,s);case"tasks":return this.w(a,s);case"snippets":return this.y(a,s);case"globalState":return this.D(a,s);case"extensions":return this.A(a,s);case"profiles":return this.G(a,s)}}async q(t,n){const s=this.k.profiles.find(a=>a.id===n);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,n){const s=this.d.joinPath(t,"settings.json"),a=n?n.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}s(t,n){switch(n){case"settings.json":return(0,y.parseSettingsSyncContent)(t.content).settings}return null}t(t,n){const s=this.d.joinPath(t,"keybindings.json"),a=n?n.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}u(t,n){switch(n){case"keybindings.json":return(0,h.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(E.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,n){const s=this.d.joinPath(t,"tasks.json"),a=n?n.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}w(t,n){switch(n){case"tasks.json":return(0,u.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,n){const s=await this.resolveContent(t);if(s){const a=this.K(s,"snippets");if(a){const o=(0,m.parseSnippets)(a),f=[];for(const d of Object.keys(o)){const v=this.d.joinPath(t,d),L=n?this.d.joinPath(n.snippetsHome,d):this.d.joinPath(t,Ve.a);f.push({resource:v,comparableResource:L})}return f}}return[]}y(t,n){return(0,m.parseSnippets)(t)[n]||null}z(t,n){const s=this.d.joinPath(t,"extensions.json"),a=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}A(t,n){switch(n){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:n}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(n,!0)}C(t,n){const s=this.d.joinPath(t,"globalState.json"),a=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:a}]}D(t,n){switch(n){case"globalState.json":return(0,g.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const n=await this.m.createInstance(g.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,g.stringify)(n,!0)}F(t,n){const s=this.d.joinPath(t,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:a}]}G(t,n){switch(n){case"profiles.json":return(0,A.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,b.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(t){const n=t.remote?Ve.b:Ve.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(D.URI.from({scheme:E.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...s)}J(t){if(t.scheme!==E.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const n=[];for(;t.path!=="/";)n.unshift(this.d.basename(t)),t=this.d.dirname(t);if(n.length<2)return;const s=t.authority===Ve.b,a=n.shift(),o=n.shift();let f,d,v;for(;n.length;){const L=n.shift();L.startsWith("collection:")?f=L.substring(11):L.startsWith("ref:")?d=L.substring(4):v=L}return{remote:s,syncResource:a,profile:o,collection:f,ref:d,node:v}}K(t,n){try{const s=JSON.parse(t);if((0,w.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new E.UserDataSyncError((0,T.localize)(0,null),"IncompatibleRemoteContent",n)}async L(t,n,s){const a=await this.e.resolveResourceContent(t,n,s);return{ref:n,content:a}}};i.a="not-existing-resource",i.b="remote-backup",i.c="local-backup",i=ye([G(0,E.IUserDataSyncStoreService),G(1,E.IUserDataSyncBackupStoreService),G(2,E.IUserDataSyncLogService),G(3,I.IUriIdentityService),G(4,R.IEnvironmentService),G(5,P.IStorageService),G(6,c.IFileService),G(7,C.IUserDataProfilesService),G(8,S.IConfigurationService),G(9,p.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(oe[282],ae([0,1,21,6,25,38,3,2,22,12,31,16,30,5,20,19,18,119,120,121,122,123,124,125,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A,i,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let s=class extends P.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(v,L,N,F,M,k,$,z,x){super(),this.v=v,this.w=L,this.y=N,this.z=F,this.C=M,this.D=k,this.F=$,this.G=z,this.H=x,this.f="uninitialized",this.g=this.B(new O.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new O.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new O.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new O.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new O.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new O.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=L.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,P.toDisposable)(()=>this.W()))}async createSyncTask(v,L){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),F=(0,C.generateUuid)();try{const z=(0,t.createSyncHeaders)(F);L&&(z["Cache-Control"]="no-cache"),v=await this.v.manifest(v,z)}catch(z){const x=t.UserDataSyncError.toUserDataSyncError(z);throw f(x,F,this.w,this.C),x}const M=!1,k=this;let $;return{manifest:v,async run(){if(M)throw new Error("Can run a task only once");$=(0,T.createCancelablePromise)(z=>k.I(v,!1,F,z)),await $.finally(()=>$=void 0),k.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),k.S()},stop(){return $?.cancel(),k.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const v=new Date().getTime(),L=(0,C.generateUuid)(),N=(0,t.createSyncHeaders)(L);let F;try{F=await this.v.manifest(null,N)}catch($){const z=t.UserDataSyncError.toUserDataSyncError($);throw f(z,L,this.w,this.C),z}await this.resetLocal();const M=this,k=new R.CancellationTokenSource;return{id:L,async merge(){return M.I(F,!0,L,k.token)},async apply(){try{try{await M.L(F,L,k.token)}catch($){if(t.UserDataSyncError.toUserDataSyncError($).code==="MethodNotFound")M.z.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.z.info("Applying manual sync again..."),await M.L(F,L,k.token);else throw $}}catch($){throw M.z.error($),$}M.z.info(`Sync done. Took ${new Date().getTime()-v}ms`),M.S()},async stop(){k.cancel(),await M.N(),await M.resetLocal()}}}async I(v,L,N,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(M,v,L,N,F));const k=M.enabled.find($=>$.resource==="profiles");if(k){const $=await k.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J($,v,L,N,F)}}finally{this.l.fire(this.k)}}async J(v,L,N,F,M){for(const k of v){if(M.isCancellationRequested)return;const $=this.G.profiles.find(x=>x.id===k.id);if(!$){this.z.error(`Profile with id:${k.id} and name: ${k.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",k.name);const z=this.getOrCreateActiveProfileSynchronizer($,k);this.k.push(...await this.M(z,L,N,F,M))}for(const[k,$]of this.u.entries())this.G.profiles.some(z=>z.id===$[0].profile.id)||($[1].dispose(),this.u.delete(k))}async L(v,L,N){const F=this.U();for(const x of F){if(N.isCancellationRequested)return;await x.apply(L,N)}const M=F.find(x=>x.profile.isDefault);if(!M)return;const k=M.enabled.find(x=>x.resource==="profiles");if(!k)return;const z=(await k.getRemoteSyncedProfiles(v?.latest??null)||[]).filter(x=>F.every(X=>X.profile.id!==x.id));z.length&&await this.J(z,v,!1,L,N)}async M(v,L,N,F,M){return(await v.sync(L,N,F,M)).map(([$,z])=>({profile:v.profile,syncResource:$,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(v=>v.stop()))}async resolveContent(v){const L=await this.H.resolveContent(v);if(L)return L;for(const N of this.U())for(const F of N.enabled){const M=await F.resolveContent(v);if(M)return M}return null}async replace(v){this.X();const L=this.H.resolveUserDataSyncResource(v);if(!L)return;const N=await this.resolveContent(v.uri);!N||await this.O(L.profile,async F=>{if(L.syncResource===F.resource)return await F.replace(N),!0})}async accept(v,L,N,F){this.X(),await this.O(v.profile,async M=>{if(v.syncResource===M.resource)return await M.accept(L,N),F&&await M.apply((0,E.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(v,L){return this.H.getRemoteSyncResourceHandles(v,L)}async getLocalSyncResourceHandles(v,L){return this.H.getLocalSyncResourceHandles(v,L??this.G.defaultProfile)}async getAssociatedResources(v){return this.H.getAssociatedResources(v)}async getMachineId(v){return this.H.getMachineId(v)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async L=>{if(L.resource!=="globalState"&&await L.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async L=>{if(await L.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(v){this.z.error(v)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[v]of this.u.values())try{await v.resetLocal()}catch(L){this.z.error(L)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const v=await this.H.getRemoteSyncedProfiles(),L=v.map(k=>k.collection),N=await this.v.getAllCollections(),F=N.filter(k=>!L.includes(k));F.length&&(this.z.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(k=>this.v.deleteCollection(k))),this.z.info("Deleted redundant collections on server"));const M=v.filter(k=>N.includes(k.collection));if(M.length!==v.length){this.z.info("Updating remote profiles with invalid collections on server");const k=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await k.updateRemoteProfiles(M,null),this.z.info("Updated remote profiles on server")}finally{k.dispose()}}}async O(v,L){const N=new P.DisposableStore;try{const F=this.u.get(v.id);if(F){const x=await this.P(F[0],L,N);return(0,E.isUndefined)(x)?null:x}if(v.isDefault){const x=N.add(this.y.createInstance(a,v,void 0)),X=await this.P(x,L,N);return(0,E.isUndefined)(X)?null:X}if(this.G.isEnabled())return null;const M=N.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,v,void 0)),k=await this.v.manifest(null),z=(await M.getRemoteSyncedProfiles(k?.latest??null)||[]).find(x=>x.id===v.id);if(z){const x=N.add(this.y.createInstance(a,v,z.collection)),X=await this.P(x,L,N);return(0,E.isUndefined)(X)?null:X}return null}finally{N.dispose()}}async P(v,L,N){const F=[...v.enabled,...v.disabled.map(M=>N.add(v.createSynchronizer(M)))];for(const M of F){const k=await L(M);if(!(0,E.isUndefined)(k))return k}}Q(v){const L=this.f;this.f!==v&&(this.f=v,this.g.fire(v),L==="hasConflicts"&&this.S())}R(){const v=this.U().map(L=>L.conflicts).flat();(0,D.equals)(this.i,v,(L,N)=>L.profile.id===N.profile.id&&L.syncResource===N.syncResource&&(0,D.equals)(L.conflicts,N.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this.i=v,this.j.fire(v))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(v,L){let N=this.u.get(v.id);if(N&&N[0].collection!==L?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(v.id)),!N){const F=new P.DisposableStore,M=F.add(this.y.createInstance(a,v,L?.collection));F.add(M.onDidChangeStatus(k=>this.Q(k))),F.add(M.onDidChangeConflicts(k=>this.R())),F.add(M.onDidChangeLocal(k=>this.h.fire(k))),this.u.set(v.id,N=[M,F])}return N[0]}U(){const v=[];for(const[L]of this.u.values())v.push(L);return v}W(){this.u.forEach(([,v])=>v.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};s=ye([G(0,t.IUserDataSyncStoreService),G(1,t.IUserDataSyncStoreManagementService),G(2,y.IInstantiationService),G(3,t.IUserDataSyncLogService),G(4,S.ITelemetryService),G(5,h.IStorageService),G(6,t.IUserDataSyncEnablementService),G(7,u.IUserDataProfilesService),G(8,t.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let a=class extends P.Disposable{get enabled(){return this.f.sort((v,L)=>v[1]-L[1]).map(([v])=>v)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(v=>!this.l.isResourceEnabled(v))}get status(){return this.g}get conflicts(){return this.j}constructor(v,L,N,F,M,k,$,z,x,X){super(),this.profile=v,this.collection=L,this.l=N,this.m=F,this.n=M,this.r=k,this.t=$,this.u=z,this.v=x,this.w=X,this.f=[],this.g="idle",this.h=this.B(new O.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new O.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new O.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([ie,H])=>this.y(ie,H))),this.B((0,P.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(ie)&&this.z(ie)}y(v,L){L?this.z(v):this.C(v)}z(v){if(this.f.some(([M])=>M.resource===v))return;if(v==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(v==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const L=new P.DisposableStore,N=L.add(this.createSynchronizer(v));L.add(N.onDidChangeStatus(()=>this.G())),L.add(N.onDidChangeConflicts(()=>this.H())),L.add(N.onDidChangeLocal(()=>this.i.fire(v)));const F=this.I(v);this.f.push([N,F,L])}C(v){const L=this.f.findIndex(([N])=>N.resource===v);if(L!==-1){const[[N,,F]]=this.f.splice(L,1);F.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.u.error(M))}}createSynchronizer(v){switch(v){case"settings":return this.m.createInstance(b.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(A.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(g.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(v,L,N,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const k=[],$=(0,t.createSyncHeaders)(N),z=(this.collection?v?.collections?.[this.collection]?.latest:v?.latest)??null,x=L?await this.D(z):{};for(const X of M){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(X.resource))return[];try{if(L){const ie=await X.preview(z,x,$);if(ie)for(const H of ie.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await X.merge(H.previewResource)}else await X.sync(z,$)}catch(ie){const H=t.UserDataSyncError.toUserDataSyncError(ie);if(f(H,N,this.r,this.t),o(ie))throw H;this.u.error(ie),this.u.error(`${X.resource}: ${(0,c.toErrorMessage)(ie)}`),k.push([X.resource,H])}}return k}finally{this.G()}}async apply(v,L){const N=(0,t.createSyncHeaders)(v);for(const F of this.enabled){if(L.isCancellationRequested)return;try{await F.apply(!1,N)}catch(M){const k=t.UserDataSyncError.toUserDataSyncError(M);if(f(k,v,this.r,this.t),o(M))throw k;this.u.error(M),this.u.error(`${F.resource}: ${(0,c.toErrorMessage)(M)}`)}}}async stop(){for(const v of this.enabled)try{v.status!=="idle"&&await v.stop()}catch(L){this.u.error(L)}}async resetLocal(){for(const v of this.enabled)try{await v.resetLocal()}catch(L){this.u.error(`${v.resource}: ${(0,c.toErrorMessage)(L)}`),this.u.error(L)}}async D(v){if(!this.profile.isDefault)return{};const L=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(F=>F instanceof b.SettingsSynchroniser);if(N){const F=await N.getRemoteUserDataSyncConfiguration(v);return{...L,...F}}return L}F(v){this.g!==v&&(this.g=v,this.h.fire(v))}G(){return this.H(),this.enabled.some(v=>v.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(v=>v.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const v=this.enabled.filter(L=>L.status==="hasConflicts").filter(L=>L.conflicts.conflicts.length>0).map(L=>L.conflicts);(0,D.equals)(this.j,v,(L,N)=>L.syncResource===N.syncResource&&(0,D.equals)(L.conflicts,N.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this.j=v,this.k.fire(v))}I(v){switch(v){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=ye([G(2,t.IUserDataSyncEnablementService),G(3,y.IInstantiationService),G(4,m.IExtensionGalleryService),G(5,t.IUserDataSyncStoreManagementService),G(6,S.ITelemetryService),G(7,t.IUserDataSyncLogService),G(8,u.IUserDataProfilesService),G(9,w.IConfigurationService)],a);function o(d){if(d instanceof t.UserDataSyncError)switch(d.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function f(d,v,L,N){N.publicLog2("sync/error",{code:d.code,serverCode:d instanceof t.UserDataSyncStoreError?String(d.serverCode):void 0,url:d instanceof t.UserDataSyncStoreError?d.url:void 0,resource:d.resource,executionId:v,service:L.userDataSyncStore.url.toString()})}}),define(oe[283],ae([0,1,3,2,11,18,24]),function(Q,e,D,T,R,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(m,y){return{...m,profile:(0,c.reviveProfile)(m.profile,y.profilesHome.scheme)}}function I(m){return{created:m.created,uri:R.URI.revive(m.uri)}}class E{constructor(y,h,S){this.c=y,this.d=h,this.f=S,this.a=new Map,this.b=new D.Emitter}listen(y,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${h}`)}async call(y,h,S){try{return await this.g(y,h,S)}catch(u){throw this.f.error(u),u}}async g(y,h,S){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(R.URI.revive(S[0]));case"accept":return this.c.accept(P(S[0],this.d),R.URI.revive(S[1]),S[2],S[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(S[0],(0,c.reviveProfile)(S[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(S[0],S[1]);case"replace":return this.c.replace(I(S[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(S[0]));case"getMachineId":return this.c.getMachineId(I(S[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const u=h.substring(11),l=S[0],g=this.h(l);switch(S=S.slice(1),u){case"merge":return g.merge();case"apply":return g.apply().then(()=>this.a.delete(this.j(g.id)));case"stop":return g.stop().finally(()=>this.a.delete(this.j(g.id)))}}throw new Error("Invalid call")}h(y){const h=this.a.get(this.j(y));if(!h)throw new Error(`Manual sync taks not found: ${y}`);return h}async i(){const y=await this.c.createManualSyncTask();return this.a.set(this.j(y.id),y),y.id}j(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=E;let C=class extends T.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(y,h){super(),this.k=h,this.b="uninitialized",this.c=this.B(new D.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new D.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new D.Emitter),this.onSyncErrors=this.j.event,this.a={call(S,u,l){return y.call(S,u,l).then(null,g=>{throw O.UserDataSyncError.toUserDataSyncError(g)})},listen(S,u){return y.listen(S,u)}},this.a.call("_getInitialData").then(([S,u,l])=>{this.l(S),this.m(u),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(g=>this.l(g))),this.B(this.a.listen("onDidChangeLastSyncTime")(g=>this.n(g)))}),this.B(this.a.listen("onDidChangeConflicts")(S=>this.m(S))),this.B(this.a.listen("onSyncErrors")(S=>this.j.fire(S.map(u=>({...u,error:O.UserDataSyncError.toUserDataSyncError(u.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const y=await this.a.call("createManualSyncTask"),h=this;return new w(y,{async call(u,l,g){return h.a.call(`manualSync/${u}`,[y,...Array.isArray(l)?l:[l]],g)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(y,h,S,u){return this.a.call("accept",[y,h,S,u])}resolveContent(y){return this.a.call("resolveContent",[y])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(y,h){return(await this.a.call("getLocalSyncResourceHandles",[y,h])).map(({created:u,uri:l})=>({created:u,uri:R.URI.revive(l)}))}async getRemoteSyncResourceHandles(y,h){return(await this.a.call("getRemoteSyncResourceHandles",[y,h])).map(({created:u,uri:l})=>({created:u,uri:R.URI.revive(l)}))}async getAssociatedResources(y){return(await this.a.call("getAssociatedResources",[y])).map(({resource:S,comparableResource:u})=>({resource:R.URI.revive(S),comparableResource:R.URI.revive(u)}))}getMachineId(y){return this.a.call("getMachineId",[y])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(y){return this.a.call("replace",[y])}async l(y){this.b=y,this.c.fire(y)}async m(y){this.f=y.map(h=>({syncResource:h.syncResource,profile:(0,c.reviveProfile)(h.profile,this.k.profilesHome.scheme),conflicts:h.conflicts.map(S=>({...S,baseResource:R.URI.revive(S.baseResource),localResource:R.URI.revive(S.localResource),remoteResource:R.URI.revive(S.remoteResource),previewResource:R.URI.revive(S.previewResource)}))})),this.g.fire(this.f)}n(y){this.h!==y&&(this.h=y,this.i.fire(y))}};C=ye([G(1,c.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class w extends T.Disposable{constructor(y,h){super(),this.id=y,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[284],ae([0,1,6,25,9,3,2,142,4,22,12,11,31,16,15,14,23,60,45,20,24]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const A="sync.previous.store",i="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",n=100,s=1e3*60*5;let a=class extends O.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(b.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,F,M){super(),this.f=N,this.g=F,this.h=M,this.a=this.B(new c.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(c.Event.filter(M.onDidChangeValue,k=>k.key===b.SYNC_SERVICE_URL_TYPE&&k.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[b.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(b.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,F){N=I.isWeb&&N?.web?{...N,...N.web}:N;const M={...N||{},...F||{}};if(M&&(0,C.isString)(M.url)&&(0,C.isObject)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(k=>Array.isArray(M.authenticationProviders[k].scopes))){const k=M,$=!!k.canSwitch&&!F?.url,z=k.url===k.insidersUrl?"insiders":"stable",x=($?this.c:void 0)||z,X=F?.url||(x==="insiders"?k.insidersUrl:x==="stable"?k.stableUrl:k.url);return{url:w.URI.parse(X),type:x,defaultType:z,defaultUrl:w.URI.parse(k.url),stableUrl:w.URI.parse(k.stableUrl),insidersUrl:w.URI.parse(k.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(k.authenticationProviders).reduce((ie,H)=>(ie.push({id:H,scopes:k.authenticationProviders[H].scopes}),ie),[])}}}};a=ye([G(0,u.IProductService),G(1,y.IConfigurationService),G(2,p.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let o=class extends a{constructor(N,F,M){super(N,F,M);const k=this.h.get(A,-1);k&&(this.k=JSON.parse(k));const $=this.f[b.CONFIGURATION_SYNC_STORE_KEY];$?this.h.store(A,JSON.stringify($),-1,1):this.h.remove(A,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};o=ye([G(0,u.IProductService),G(1,y.IConfigurationService),G(2,p.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let f=class extends O.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,F,M,k,$,z,x){super(),this.k=M,this.l=k,this.n=x,this.g=this.B(new c.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new c.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new c.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,g.getServiceMachineId)($,z,x).then(X=>{const ie={"X-Client-Name":`${F.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new v(n,s,this.k,this.l),this.r(),this.B((0,O.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}p(N){this.a=N?(0,E.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(i,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(i,this.i.getTime(),-1,1),this.s=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.t(void 0))),this.s.then(null,F=>null)):this.n.remove(i,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.w(F,{type:"GET",headers:N},[],T.CancellationToken.None);return(await(0,l.asJson)(M))?.map(({id:k})=>k)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=P.Mimes.text;const M=await this.w(F,{type:"POST",headers:N},[],T.CancellationToken.None),k=await(0,l.asTextOrError)(M);if(!k)throw new b.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[b.HEADER_OPERATION_ID]);return k}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,E.joinPath)(this.a,"collection",N).toString():(0,E.joinPath)(this.a,"collection").toString();F={...F},await this.w(M,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.u(this.a,F,N),k={},$=await this.w(M.toString(),{type:"GET",headers:k},[],T.CancellationToken.None);return(await(0,l.asJson)($)||[]).map(({url:x,created:X})=>({ref:(0,E.relativePath)(M,M.with({path:x})),created:X*1e3}))}async resolveResourceContent(N,F,M,k={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.u(this.a,M,N),F).toString();k={...k},k["Cache-Control"]="no-cache";const z=await this.w($,{type:"GET",headers:k},[],T.CancellationToken.None);return await(0,l.asTextOrError)(z)}async deleteResource(N,F,M){if(!this.a)throw new Error("No settings sync store url configured.");const k=F!==null?(0,E.joinPath)(this.u(this.a,M,N),F).toString():this.u(this.a,M,N).toString(),$={};await this.w(k,{type:"DELETE",headers:$},[],T.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.a,"resource").toString(),F={"Content-Type":P.Mimes.text};await this.w(N,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async readResource(N,F,M,k={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.u(this.a,M,N),"latest").toString();k={...k},k["Cache-Control"]="no-cache",F&&(k["If-None-Match"]=F.ref);const z=await this.w($,{type:"GET",headers:k},[304],T.CancellationToken.None);let x=null;if(z.res.statusCode===304&&(x=F),x===null){const X=z.res.headers.etag;if(!X)throw new b.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",z.res.statusCode,z.res.headers[b.HEADER_OPERATION_ID]);const ie=await(0,l.asTextOrError)(z);if(!ie&&z.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",$,"EmptyResponse",z.res.statusCode,z.res.headers[b.HEADER_OPERATION_ID]);x={ref:X,content:ie}}return x}async writeResource(N,F,M,k,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,k,N).toString();$={...$},$["Content-Type"]=P.Mimes.text,M&&($["If-Match"]=M);const x=await this.w(z,{type:"POST",data:F,headers:$},[],T.CancellationToken.None),X=x.res.headers.etag;if(!X)throw new b.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",x.res.statusCode,x.res.headers[b.HEADER_OPERATION_ID]);return X}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const k=await this.w(M,{type:"GET",headers:F},[304],T.CancellationToken.None);let $=null;if(k.res.statusCode===304&&($=N),!$){const x=k.res.headers.etag;if(!x)throw new b.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",k.res.statusCode,k.res.headers[b.HEADER_OPERATION_ID]);const X=await(0,l.asTextOrError)(k);if(!X&&k.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",M,"EmptyResponse",k.res.statusCode,k.res.headers[b.HEADER_OPERATION_ID]);X&&($={...JSON.parse(X),ref:x})}const z=this.n.get(r,-1);return z&&$&&z!==$.session&&this.v(),$===null&&z&&this.v(),$&&this.n.store(r,$.session,-1,1),$}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,F,M){return F?(0,E.joinPath)(N,"collection",F,"resource",M):(0,E.joinPath)(N,"resource",M)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(N,F,M,k){if(!this.b)throw new b.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const $=await this.c;F.headers={...F.headers||{},...$,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(F.headers),this.l.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let z;try{z=await this.f.request(N,F,k)}catch(j){if(!(j instanceof b.UserDataSyncStoreError)){let V="RequestFailed";const J=(0,R.getErrorMessage)(j).toLowerCase();J.includes("xhr timeout")?V="RequestTimeout":J.includes("protocol")&&J.includes("not supported")?V="RequestProtocolNotSupported":J.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":J.includes("headers must be an object")?V="RequestHeadersNotObject":(0,R.isCancellationError)(j)&&(V="RequestCanceled"),j=new b.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,V,void 0,void 0)}throw this.l.info("Request failed",N),j}const x=z.res.headers[b.HEADER_OPERATION_ID],X={url:N,status:z.res.statusCode,"execution-id":F.headers[b.HEADER_EXECUTION_ID],"operation-id":x},ie=(0,l.isSuccess)(z)||z.res.statusCode&&M.indexOf(z.res.statusCode)!==-1;let H="";if(ie?this.l.trace("Request succeeded",X):(this.l.info("Request failed",X),H=await(0,l.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new b.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",z.res.statusCode,x);if(this.h.fire(),z.res.statusCode===404)throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",z.res.statusCode,x);if(z.res.statusCode===405)throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,"MethodNotFound",z.res.statusCode,x);if(z.res.statusCode===409)throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",z.res.statusCode,x);if(z.res.statusCode===410)throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",z.res.statusCode,x);if(z.res.statusCode===412)throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",z.res.statusCode,x);if(z.res.statusCode===413)throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",z.res.statusCode,x);if(z.res.statusCode===426)throw new b.UserDataSyncStoreError(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",z.res.statusCode,x);if(z.res.statusCode===429){const j=z.res.headers["retry-after"];throw j?(this.t(new Date(Date.now()+parseInt(j)*1e3)),new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",z.res.statusCode,x)):new b.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",z.res.statusCode,x)}if(!ie)throw new b.UserDataSyncStoreError("Server returned "+z.res.statusCode,N,"Unknown",z.res.statusCode,x);return z}y(N){let F=this.n.get(t,-1);F===void 0&&(F=(0,m.generateUuid)(),this.n.store(t,F,-1,1)),N["X-Machine-Session-Id"]=F;const M=this.n.get(r,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};f=ye([G(1,u.IProductService),G(2,l.IRequestService),G(3,b.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,S.IFileService),G(6,p.IStorageService)],f),e.UserDataSyncStoreClient=f;let d=class extends f{constructor(N,F,M,k,$,z,x){super(N.userDataSyncStore?.url,F,M,k,$,z,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};d=ye([G(0,b.IUserDataSyncStoreManagementService),G(1,u.IProductService),G(2,l.IRequestService),G(3,b.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,S.IFileService),G(6,p.IStorageService)],d),e.UserDataSyncStoreService=d;class v{constructor(N,F,M,k){this.c=N,this.d=F,this.f=M,this.g=k,this.a=[],this.b=void 0}request(N,F,M){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=v}),define(oe[285],ae([0,1,3,58,23,20,19,280,24,78,81]),function(Q,e,D,T,R,c,O,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(y,h,S,u,l,g,p,b,A,i,r){super(y,h,S,u,l,p,b,A,i,r),this.B(D.Event.debounce(D.Event.any(D.Event.map(g.onDidFocusWindow,()=>"windowFocus"),D.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=ye([G(0,R.IProductService),G(1,I.IUserDataSyncStoreManagementService),G(2,I.IUserDataSyncStoreService),G(3,I.IUserDataSyncEnablementService),G(4,I.IUserDataSyncService),G(5,T.INativeHostService),G(6,I.IUserDataSyncLogService),G(7,E.IUserDataSyncAccountService),G(8,O.ITelemetryService),G(9,C.IUserDataSyncMachinesService),G(10,c.IStorageService)],w),e.UserDataAutoSyncService=w}),define(oe[286],ae([0,1,100,26,4,22]),function(Q,e,D,T,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function O(E){function C(){let w=E.scheme===T.Schemas.file?(0,c.originalFSPath)(E):E.toString();return R.isLinux||(w=w.toLowerCase()),(0,D.createHash)("md5").update(w).digest("hex")}return{id:C(),configPath:E}}e.getWorkspaceIdentifier=O;function P(E,C){function w(){if(E.scheme!==T.Schemas.file)return(0,D.createHash)("md5").update(E.toString()).digest("hex");if(!C)return;let y;return R.isLinux?y=C.ino:R.isMacintosh?y=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?y=Math.floor(C.birthtimeMs):y=C.birthtime.getTime()),(0,D.createHash)("md5").update(E.fsPath).update(y?String(y):"").digest("hex")}const m=w();if(typeof m=="string")return{id:m,uri:E}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[287],ae([0,1,6,9,2,13,28,15,57,8,58,76,117,286]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends R.Disposable{constructor(u,l,g,p){super(),this.a=u,this.b=l,this.c=g,this.f=p,this.B(new D.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=await O.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new w.StorageClient(this.f.getChannel("storage"));await Promise.all(u.map(async g=>{const p=(0,c.join)(this.a.workspaceStorageHome.fsPath,g);g.length===y.NON_EMPTY_WORKSPACE_ID_LENGTH||g===m.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(i=>i.workspace?.id===g)||await l.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await O.Promises.rm(p))}))}catch(u){(0,T.onUnexpectedError)(u)}}};h=ye([G(0,P.INativeEnvironmentService),G(1,E.ILogService),G(2,C.INativeHostService),G(3,I.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(oe[126],ae([0,1,53,6,13,12,28,153,296,297]),function(Q,e,D,T,R,c,O,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(i,r){let t=r.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=r}}e.ExtractError=C;function w(A){const i=A.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,t)=>r+t,i&61440)}function m(A){if(A instanceof C)return A;let i;return/end of central directory record signature not found/.test(A.message)&&(i="CorruptZip"),new C(i,A)}function y(A,i,r,t,n,s){const a=R.dirname(i),o=R.join(t,a);if(!o.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const f=R.join(t,i);let d;return s.onCancellationRequested(()=>{d?.destroy()}),Promise.resolve(O.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((v,L)=>{if(!s.isCancellationRequested)try{d=(0,D.createWriteStream)(f,{mode:r}),d.once("close",()=>v()),d.once("error",L),A.once("error",L),A.pipe(d)}catch(N){L(N)}}))}function h(A,i,r,t){let n=(0,T.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{n.cancel(),A.close()}),new Promise((a,o)=>{const f=new T.Sequencer,d=v=>{v.isCancellationRequested||(s++,A.readEntry())};A.once("error",o),A.once("close",()=>n.then(()=>{t.isCancellationRequested||A.entryCount===s?a():o(new C("Incomplete",new Error(P.localize(1,null,s,A.entryCount))))},o)),A.readEntry(),A.on("entry",v=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(v.fileName)){d(t);return}const L=v.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(L)){const M=R.join(i,L);n=(0,T.createCancelablePromise)(k=>O.Promises.mkdir(M,{recursive:!0}).then(()=>d(k)).then(void 0,o));return}const N=u(A,v),F=w(v);n=(0,T.createCancelablePromise)(M=>f.queue(()=>N.then(k=>y(k,L,F,i,r,M).then(()=>d(M)))).then(null,o))})})}function S(A,i=!1){return new Promise((r,t)=>{(0,I.open)(A,i?{lazyEntries:!0}:void 0,(n,s)=>{n?t(m(n)):r((0,c.assertIsDefined)(s))})})}function u(A,i){return new Promise((r,t)=>{A.openReadStream(i,(n,s)=>{n?t(m(n)):r((0,c.assertIsDefined)(s))})})}function l(A,i){return new Promise((r,t)=>{const n=new E.ZipFile;i.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const s=(0,D.createWriteStream)(A);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(A))})}e.zip=l;function g(A,i,r={},t){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=S(A,!0);return r.overwrite&&(s=s.then(a=>O.Promises.rm(i).then(()=>a))),s.then(a=>h(a,i,{sourcePathRegex:n},t))}e.extract=g;function p(A,i){return S(A).then(r=>new Promise((t,n)=>{r.on("entry",s=>{s.fileName===i&&u(r,s).then(a=>t(a),a=>n(a))}),r.once("close",()=>n(new Error(P.localize(2,null,i))))}))}function b(A,i){return p(A,i).then(r=>new Promise((t,n)=>{const s=[];r.once("error",n),r.on("data",a=>s.push(a)),r.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=b}),define(oe[288],ae([0,1,126,163]),function(Q,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(c){return(0,D.buffer)(c,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,T.localize)(0,null))}})}e.getManifest=R}),define(oe[127],ae([0,1,6,25,38,9,3,2,37,26,13,4,22,54,12,11,31,28,126,162,97,15,269,30,33,51,79,239,271,288,223,240,42,70,14,5,8,23,19,29,18]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A,i,r,t,n,s,a,o,f,d,v,L,N,F,M,k,$,z,x,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(r.IExtensionManagementService);let ie=class extends i.AbstractExtensionManagementService{constructor(U,B,W,q,Y,ee,K,Z,se,le,ue,pe){super(U,B,W,le,pe),this.Z=Y,this.ab=ee,this.bb=K,this.cb=se,this.db=ue,this.X=this.B(new O.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new I.ResourceSet;const ve=this.B(Z.createInstance(o.ExtensionsLifecycle));this.S=this.B(Z.createInstance(H,Ee=>ve.postUninstall(Ee))),this.U=this.B(new d.ExtensionsManifestCache(q,this)),this.W=this.B(Z.createInstance(a.ExtensionsDownloader));const be=this.B(new v.ExtensionsWatcher(this,this.Z,pe,ee,ue,se,W));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.kb(Ee))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,t.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(U){this.v.trace("ExtensionManagementService#zip",U.identifier.id);const B=await this.jb(U),W=await(0,g.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,B);return S.URI.file(W)}async unzip(U){return this.v.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:B,cleanup:W}=await this.fb(U),q=C.resolve(B.fsPath);try{return await(0,f.getManifest)(q)}finally{await W()}}getInstalled(U,B){return this.S.scanExtensions(U??null,B)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(U,B={}){this.v.trace("ExtensionManagementService#install",U.toString());const{location:W,cleanup:q}=await this.fb(U);try{const Y=await(0,f.getManifest)(C.resolve(W.fsPath));if(Y.engines&&Y.engines.vscode&&!(0,N.isEngineValid)(Y.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,t.getGalleryExtensionId)(Y.publisher,Y.name),this.w.version));return await this.z(Y,W,B)}finally{await q()}}async installFromLocation(U,B){this.v.trace("ExtensionManagementService#installFromLocation",U.toString());const W=await this.S.scanUserExtensionAtLocation(U);if(!W)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ob([W],B),this.v.info("Successfully installed extension",W.identifier.id,B.toString()),W}getMetadata(U,B=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(U,B)}async updateMetadata(U,B,W=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",U.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.pinned=B.pinned||void 0,U=await this.S.updateMetadata(U,B,W),this.U.invalidate(),this.X.fire(U),U}async reinstallFromGallery(U){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const B=await this.getTargetPlatform(),[W]=await this.t.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:B,compatible:!0},T.CancellationToken.None);if(!W)throw new Error(p.localize(2,null));await this.S.setUninstalled(U);try{await this.S.removeUninstalledExtension(U)}catch(q){throw new Error(p.localize(3,null,(0,R.toErrorMessage)(q)))}return this.installFromGallery(W)}markAsUninstalled(...U){return this.S.setUninstalled(...U)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(U,B){const{location:W}=await this.W.download(U,B);return W}async fb(U){if(U.scheme===E.Schemas.file)return{location:U,async cleanup(){}};this.v.trace("Downloading extension from",U.toString());const B=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(U,B),this.v.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.cb.del(B)}catch(q){this.v.error(q)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(U,B,W){let q;if(S.URI.isUri(B))q=new J(U,B,W,this.t,this.S,this.v);else{const Y=t.ExtensionKey.create(B).toString();q=this.Y.get(Y),q||(this.Y.set(Y,q=new V(U,B,W,this.W,this.S,this.v)),q.waitUntilTaskIsFinished().then(()=>this.Y.delete(Y)))}return new _(q,W.profileLocation,this.db,this.y,this.Z,this.ab)}R(U,B){return new re(U,B.profileLocation,this.ab)}async jb(U){const B=async q=>{let Y=await l.Promises.readdir(q);Y=Y.map(Z=>C.join(q,Z));const ee=await Promise.all(Y.map(Z=>l.Promises.stat(Z)));let K=Promise.resolve([]);return ee.forEach((Z,se)=>{const le=Y[se];Z.isFile()&&(K=K.then(ue=>[...ue,le])),Z.isDirectory()&&(K=K.then(ue=>B(le).then(pe=>[...ue,...pe])))}),K};return(await B(U.location.fsPath)).map(q=>({path:`extension/${C.relative(U.location.fsPath,q)}`,localPath:q}))}async kb({added:U,removed:B}){if(B)for(const W of B.extensions)this.v.info("Extensions removed from another source",W.id,B.profileLocation.toString()),this.p.fire({identifier:W,profileLocation:B.profileLocation});if(U){const q=(await this.S.scanExtensions(1,U.profileLocation)).filter(Y=>U.extensions.some(ee=>(0,t.areSameExtensions)(ee,Y.identifier)));this.m.fire(q.map(Y=>(this.v.info("Extensions added from another source",Y.identifier.id,U.profileLocation.toString()),{identifier:Y.identifier,local:Y,profileLocation:U.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(B=>this.lb.add(B)));const U=await this.cb.resolve(this.Z.userExtensionsLocation);for(const B of U.children??[])B.isDirectory&&this.lb.add(B.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(B=>this.nb(B)))}async nb(U){if(!U.affects(this.Z.userExtensionsLocation,1))return;const B=[];for(const W of U.rawAdded){if(this.lb.has(W)||!this.db.extUri.isEqual(this.db.extUri.dirname(W),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(W,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(W).startsWith(".")||!(await this.cb.stat(W)).isDirectory)continue;const q=await this.S.scanUserExtensionAtLocation(W);q&&q.installedTimestamp===void 0&&(this.lb.add(W),B.push(q))}B.length&&(await this.ob(B,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",B.map(W=>W.identifier.id)))}async ob(U,B){await this.ab.addExtensionsToProfile(U.map(W=>[W,void 0]),B),this.m.fire(U.map(W=>({local:W,identifier:W.identifier,operation:1,profileLocation:B})))}};ie=ye([G(0,r.IExtensionGalleryService),G(1,z.ITelemetryService),G(2,k.ILogService),G(3,A.INativeEnvironmentService),G(4,s.IExtensionsScannerService),G(5,n.IExtensionsProfileScannerService),G(6,b.IDownloadService),G(7,M.IInstantiationService),G(8,F.IFileService),G(9,$.IProductService),G(10,x.IUriIdentityService),G(11,X.IUserDataProfilesService)],ie),e.ExtensionManagementService=ie;let H=class extends P.Disposable{constructor(U,B,W,q,Y){super(),this.j=U,this.k=B,this.l=W,this.m=q,this.n=Y,this.h=this.B(new O.Emitter),this.onExtract=this.h.event,this.c=(0,m.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new D.Queue}async cleanUp(){await this.w()}async scanExtensions(U,B){const W={includeInvalid:!0,profileLocation:B};let q=[];return U===null||U===0?q.push(...await this.l.scanAllExtensions({includeInvalid:!0},W,!1)):U===1&&q.push(...await this.l.scanUserExtensions(W)),q=U!==null?q.filter(Y=>Y.type===U):q,Promise.all(q.map(Y=>this.v(Y)))}async scanAllUserExtensions(U){const B=await this.l.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(B.map(W=>this.v(W)))}async scanUserExtensionAtLocation(U){try{const B=await this.l.scanExistingExtension(U,1,{includeInvalid:!0});if(B)return await this.v(B)}catch(B){this.n.error(B)}return null}async extractUserExtension(U,B,W,q){const Y=U.toString(),ee=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),K=C.join(this.l.userExtensionsLocation.fsPath,Y);try{await l.Promises.rm(K)}catch{throw new r.ExtensionManagementError(p.localize(4,null,K,U.id),r.ExtensionManagementErrorCode.Delete)}await this.s(U,B,ee,q),await this.l.updateMetadata(S.URI.file(ee),W);try{this.h.fire(S.URI.file(K)),await this.t(U,ee,K,Date.now()+2*60*1e3),this.n.info("Renamed to",K)}catch(Z){try{await l.Promises.rm(ee)}catch{}if(Z.code==="ENOTEMPTY")this.n.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.n.info(`Rename failed because of ${(0,c.getErrorMessage)(Z)}. Deleted from extracted location`,ee),Z}return this.u(S.URI.file(K),1)}async scanMetadata(U,B){return B?(await this.m.scanProfileExtensions(B)).find(q=>(0,t.areSameExtensions)(q.identifier,U.identifier))?.metadata:this.l.scanMetadata(U.location)}async updateMetadata(U,B,W){return W?await this.m.updateMetadata([[U,B]],W):await this.l.updateMetadata(U.location,B),this.u(U.location,U.type)}getUninstalledExtensions(){return this.p()}async setUninstalled(...U){const B=U.map(W=>t.ExtensionKey.create(W));await this.p(W=>B.forEach(q=>{W[q.toString()]=!0,this.n.info("Marked extension as uninstalled",q.toString())}))}async setInstalled(U){await this.p(q=>delete q[U.toString()]);const W=(await this.scanAllUserExtensions(!0)).find(q=>t.ExtensionKey.create(q).equals(U))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(U,B){this.n.trace(`Deleting ${B} extension from disk`,U.identifier.id,U.location.fsPath),await l.Promises.rm(U.location.fsPath),this.n.info("Deleted from disk",U.identifier.id,U.location.fsPath)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.p(B=>delete B[t.ExtensionKey.create(U).toString()])}async p(U){return this.g.queue(async()=>{let B;try{B=await l.Promises.readFile(this.c,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let W={};if(B)try{W=JSON.parse(B)}catch{}return U&&(U(W),Object.keys(W).length?await l.Promises.writeFile(this.c,JSON.stringify(W)):await l.Promises.rm(this.c)),W})}async s(U,B,W,q){this.n.trace(`Started extracting the extension from ${B} to ${W}`);try{await l.Promises.rm(W)}catch(Y){throw new r.ExtensionManagementError(this.y(Y).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(B,W,{sourcePath:"extension",overwrite:!0},q),this.n.info(`Extracted extension to ${W}:`,U.id)}catch(Y){try{await l.Promises.rm(W)}catch{}let ee=r.ExtensionManagementErrorCode.Extract;throw Y instanceof g.ExtractError&&(Y.type==="CorruptZip"?ee=r.ExtensionManagementErrorCode.CorruptZip:Y.type==="Incomplete"&&(ee=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(Y.message,ee)}}async t(U,B,W,q){try{await l.Promises.rename(B,W)}catch(Y){if(w.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<q)return this.n.info(`Failed renaming ${B} to ${W} with 'EPERM' error. Trying again...`,U.id),this.t(U,B,W,q);throw new r.ExtensionManagementError(Y.message||p.localize(5,null,B,W),Y.code||r.ExtensionManagementErrorCode.Rename)}}async u(U,B){const W=await this.l.scanExistingExtension(U,B,{includeInvalid:!0});if(W)return this.v(W);throw new Error(p.localize(6,null,U.path))}async v(U){const B=await this.k.resolve(U.location);let W,q;return B.children&&(W=B.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,q=B.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:W,changelogUrl:q,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async w(){const U=await this.getUninstalledExtensions(),B=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const ee of B)U[t.ExtensionKey.create(ee).toString()]||W.add(ee.identifier.id.toLowerCase());const q=(0,t.groupByExtension)(B,ee=>ee.identifier);await D.Promises.settled(q.map(async ee=>{const K=ee.sort((Z,se)=>y.rcompare(Z.manifest.version,se.manifest.version))[0];W.has(K.identifier.id.toLowerCase())||await this.j(await this.v(K))}));const Y=B.filter(ee=>ee.metadata&&U[t.ExtensionKey.create(ee).toString()]);await D.Promises.settled(Y.map(ee=>this.removeUninstalledExtension(ee)))}y(U){const B=Array.isArray(U)?U:[U];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((W,q)=>new Error(`${W.message}${W.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}};H=ye([G(1,F.IFileService),G(2,s.IExtensionsScannerService),G(3,n.IExtensionsProfileScannerService),G(4,k.ILogService)],H),e.ExtensionsScanner=H;class j extends i.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,h.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(U,B,W,q,Y){super(),this.identifier=U,this.source=B,this.l=W,this.m=q,this.n=Y,this.j="Unverified",this.k=2}async o(U,B){try{const W=await this.p(U.key);if(W)return this.m.updateMetadata(W,U.metadata)}catch{throw w.isMacintosh?new r.ExtensionManagementError(p.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(p.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.s(U,B)}async p(U){if(!await this.q(U))return null;this.n.trace("Removing the extension from uninstalled list:",U.id);const W=await this.m.setInstalled(U);return this.n.info("Removed the extension from uninstalled list:",U.id),W}async q(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}async s({zipPath:U,key:B,metadata:W},q){const Y=await this.m.extractUserExtension(B,U,W,q);return this.n.info("Extracting completed.",B.id),Y}}class V extends j{constructor(U,B,W,q,Y,ee){super(B.identifier,B,W,Y,ee),this.t=U,this.u=B,this.v=q}async h(U){const W=(await this.m.scanExtensions(null,this.l.profileLocation)).find(K=>(0,t.areSameExtensions)(K.identifier,this.u.identifier));W&&(this.k=3);const q={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,L.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||W?.isMachineScoped,isBuiltin:this.l.isBuiltin||W?.isBuiltin,isSystem:W?.type===0?!0:void 0,updated:!!W,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.u.properties.isPreReleaseVersion||((0,h.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:W?.preRelease)};if(W?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(W,q),metadata:q};const{location:Y,verificationStatus:ee}=await this.v.download(this.u,this.k);try{return this.j=ee,this.x(Y.fsPath),{local:await this.o({zipPath:Y.fsPath,key:t.ExtensionKey.create(this.u),metadata:q},U),metadata:q}}catch(K){try{await this.v.delete(Y)}catch(Z){this.n.warn("Error while deleting the downloaded file",Y.toString(),(0,c.getErrorMessage)(Z))}throw K}}async x(U){try{await(0,f.getManifest)(U)}catch(B){throw new r.ExtensionManagementError((0,i.joinErrors)(B).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class J extends j{constructor(U,B,W,q,Y,ee){super({id:(0,t.getGalleryExtensionId)(U.publisher,U.name)},B,W,Y,ee),this.t=U,this.u=B,this.v=q}async h(U){const B=new t.ExtensionKey(this.identifier,this.t.version),q=(await this.m.scanExtensions(1,this.l.profileLocation)).find(K=>(0,t.areSameExtensions)(this.identifier,K.identifier)),Y=await this.x(this.identifier.id,this.t.version,U);if(Y.isApplicationScoped=(0,L.isApplicationScopedExtension)(this.t),Y.isMachineScoped=this.l.isMachineScoped||q?.isMachineScoped,Y.isBuiltin=this.l.isBuiltin||q?.isBuiltin,Y.installedTimestamp=Date.now(),Y.pinned=this.l.installGivenVersion?!0:void 0,q)if(this.k=3,B.equals(new t.ExtensionKey(q.identifier,q.manifest.version)))try{await this.m.removeExtension(q,"existing")}catch{throw new Error(p.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&y.gt(q.manifest.version,this.t.version)&&await this.m.setUninstalled(q);else{const K=await this.p(B);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(p.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:C.resolve(this.u.fsPath),key:B,metadata:Y},U),metadata:Y}}async x(U,B,W){try{let[q]=await this.v.getExtensions([{id:U,version:B}],W);if(q||([q]=await this.v.getExtensions([{id:U}],W)),q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class _{get operation(){return this.d.operation}get verificationStatus(){return this.d.verificationStatus}constructor(U,B,W,q,Y,ee){this.d=U,this.g=B,this.h=W,this.j=q,this.k=Y,this.l=ee,this.identifier=this.d.identifier,this.source=this.d.source,this.c=this.m()}async m(){const U=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[U.local,U.metadata]],this.g),U}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class re extends i.AbstractExtensionTask{constructor(U,B,W){super(),this.extension=U,this.j=B,this.k=W}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[289],ae([0,1,2,30,80,238,127,8,20]),function(Q,e,D,T,R,c,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let E=class extends D.Disposable{constructor(w,m,y,h,S,u){super(),w.removeUninstalledExtensions(),(0,c.migrateUnsupportedExtensions)(w,m,y,h,u),R.ExtensionStorageService.removeOutdatedExtensionVersions(w,S)}};E=ye([G(0,O.INativeServerExtensionManagementService),G(1,T.IExtensionGalleryService),G(2,R.IExtensionStorageService),G(3,T.IGlobalExtensionEnablementService),G(4,I.IStorageService),G(5,P.ILogService)],E),e.ExtensionsContributions=E}),define(oe[298],ae([0,1,94,34,38,9,2,26,22,11,39,151,215,216,208,209,287,197,200,16,221,96,236,97,228,15,233,118,273,30,98,199,274,127,99,195,14,211,212,55,5,206,72,207,57,73,242,8,104,58,105,23,60,20,275,110,19,111,112,113,47,245,115,251,254,80,116,24,78,278,265,266,81,279,282,283,284,285,277,62,267,109,235,77,256,225,255,108,232,29,257,4,258,201,219,218,79,272,18,51,214,59,276,230,244,268,237,107,103,281,289,270,7,213]),function(Q,e,D,T,R,c,O,P,I,E,C,w,m,y,h,S,u,l,g,p,b,A,i,r,t,n,s,a,o,f,d,v,L,N,F,M,k,$,z,x,X,ie,H,j,V,J,_,re,te,U,B,W,q,Y,ee,K,Z,se,le,ue,pe,ve,be,Ee,Oe,Ue,Ye,Be,ce,de,ge,Ce,Pe,Le,De,je,Te,Fe,ze,ke,Ne,ne,he,fe,me,Se,Ie,Re,xe,$e,Ae,qe,He,et,rt,vt,Lt,At,St,Ot,Tt,wt,Nt,Ut,Mt,Ft,jt,bt,Et,$t,Bt,zt,Ct,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Wt extends O.Disposable{constructor(we){super(),this.f=we,this.a=this.B(new w.Server),this.b=void 0,this.c=void 0,this.g()}g(){const we=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",we),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",we);const Me="vscode:electron-main->shared-process=disposeWorker",Ge=(Je,it)=>{this.h(it)};D.ipcRenderer.on(Me,Ge),this.B((0,O.toDisposable)(()=>D.ipcRenderer.removeListener(Me,Ge)))}h(we){this.b?.disposeWorker(we)}async open(){const we=await this.i();(0,Be.registerConfiguration)(),we.invokeFunction(Me=>{const Ge=Me.get(re.ILogService);Ge.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(Ge)}),this.B((0,O.combinedDisposable)(we.createInstance(m.CodeCacheCleaner,this.f.codeCachePath),we.createInstance(y.LanguagePackCachedDataCleaner),we.createInstance(u.UnusedWorkspaceStorageDataCleaner),we.createInstance(S.LogsDataCleaner),we.createInstance(h.LocalizationsUpdater),we.createInstance(Bt.ExtensionsContributions),we.createInstance(Ft.UserDataProfilesCleaner)))}async i(){const we=new H.ServiceCollection,Me={_serviceBrand:void 0,...B.default};we.set(W.IProductService,Me);const Ge=new C.StaticRouter(Ze=>Ze==="main"),Je=new j.MessagePortMainProcessService(this.a,Ge);we.set(V.IMainProcessService,Je);const it=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new wt.NullPolicyService;we.set(wt.IPolicyService,it);const Ke=new s.SharedProcessEnvironmentService(this.f.args,Me);we.set(n.INativeEnvironmentService,Ke);const tt=new te.LoggerChannelClient(void 0,this.f.logLevel,this.f.loggers,Je.getChannel("logger"));we.set(re.ILoggerService,tt);const ut=this.B(tt.createLogger((0,I.joinPath)(E.URI.file(Ke.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,Ct.localize)(0,null)})),ht=this.B(new re.ConsoleLogger(this.f.logLevel)),We=this.B(new qt.LogService(ut,[ht]));we.set(re.ILogService,We),this.c=new Et.SharedProcessLifecycleService(We),we.set(Et.ISharedProcessLifecycleService,this.c),this.b=new xe.SharedProcessWorkerService(We),we.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new $.FileService(We));we.set(k.IFileService,_e);const ft=this.B(new z.DiskFileSystemProvider(We));_e.registerProvider(P.Schemas.file,ft);const dt=this.B(new He.FileUserDataProvider(P.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,We));_e.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this.B(new Nt.UserDataProfilesNativeService(this.f.profiles,Je,Ke));we.set(St.IUserDataProfilesService,nt);const Xe=this.B(new b.ConfigurationService(nt.defaultProfile.settingsResource,_e,it,We));we.set(p.IConfigurationService,Xe);const ot=new ee.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);we.set(Y.IStorageService,ot),this.B((0,O.toDisposable)(()=>ot.flush())),await Promise.all([Xe.initialize(),ot.initialize()]);const gt=new Ae.UriIdentityService(_e);we.set($e.IUriIdentityService,gt),we.set(q.IRequestService,new Ut.SharedProcessRequestService(Je,Xe,Me,We)),we.set(l.IChecksumService,new x.SyncDescriptor(g.ChecksumService,void 0,!1)),we.set(vt.IV8InspectProfilingService,new x.SyncDescriptor(rt.InspectProfilingService,void 0,!1));const ct=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});we.set(U.INativeHostService,ct),we.set(r.IDownloadService,new x.SyncDescriptor(t.DownloadService,void 0,!0));const mt=this.B(new Ne.ActiveWindowManager(ct)),xt=new C.StaticRouter(Ze=>mt.getActiveClientId().then(pt=>Ze===pt));we.set(F.IExtensionRecommendationNotificationService,new M.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",xt)));let lt;const at=[],Pt=(0,pe.isInternalTelemetry)(Me,Xe);if((0,pe.supportsTelemetry)(Me,Ke)){const Ze=new le.TelemetryLogAppender(We,tt,Ke,Me);at.push(Ze);const{installSourcePath:pt}=Ke;if(Me.aiConfig?.ariaKey){const Dt=new Mt.OneDataSystemAppender(Pt,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,O.toDisposable)(()=>Dt.flush())),at.push(Dt)}lt=new ue.TelemetryService({appenders:at,commonProperties:(0,K.resolveCommonProperties)(_e,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,Pt,pt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(Ke)},Xe,Me)}else{lt=pe.NullTelemetryService;const Ze=pe.NullAppender;at.push(Ze)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(at)),we.set(Z.ITelemetryService,lt);const Ht=new ve.CustomEndpointTelemetryService(Xe,lt,We,tt,Ke,Me);we.set(Z.ICustomEndpointTelemetryService,Ht),we.set(Ot.IExtensionsProfileScannerService,new x.SyncDescriptor(zt.ExtensionsProfileScannerService,void 0,!0)),we.set(Lt.IExtensionsScannerService,new x.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),we.set(d.IExtensionSignatureVerificationService,new x.SyncDescriptor(d.ExtensionSignatureVerificationService,void 0,!0)),we.set(N.INativeServerExtensionManagementService,new x.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),we.set(f.IExtensionGalleryService,new x.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),we.set(f.IExtensionTipsService,new x.SyncDescriptor(L.ExtensionTipsService,void 0,!1)),we.set(J.ILanguagePackService,new x.SyncDescriptor(_.NativeLanguagePackService,void 0,!1)),we.set(A.IDiagnosticsService,new x.SyncDescriptor(i.DiagnosticsService,void 0,!1)),we.set(ce.IUserDataSyncAccountService,new x.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),we.set(Be.IUserDataSyncLogService,new x.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),we.set(Be.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),we.set(f.IGlobalExtensionEnablementService,new x.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),we.set(Ye.IIgnoredExtensionsManagementService,new x.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),we.set(Ue.IExtensionStorageService,new x.SyncDescriptor(Ue.ExtensionStorageService)),we.set(Be.IUserDataSyncStoreManagementService,new x.SyncDescriptor(Te.UserDataSyncStoreManagementService,void 0,!0)),we.set(Be.IUserDataSyncStoreService,new x.SyncDescriptor(Te.UserDataSyncStoreService,void 0,!0)),we.set(Pe.IUserDataSyncMachinesService,new x.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),we.set(Be.IUserDataSyncBackupStoreService,new x.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),we.set(Be.IUserDataSyncEnablementService,new x.SyncDescriptor(Le.UserDataSyncEnablementService,void 0,!0)),we.set(Be.IUserDataSyncService,new x.SyncDescriptor(De.UserDataSyncService,void 0,!1)),we.set(ke.IUserDataProfileStorageService,new x.SyncDescriptor(ze.UserDataProfileStorageService,void 0,!0)),we.set(Be.IUserDataSyncResourceProviderService,new x.SyncDescriptor($t.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Oe.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,Ct.localize)(1,null),Xe,Ke,We,tt);return Rt.initialize(),we.set(Ee.ILocalPtyService,this.B(Rt)),we.set(ne.ISignService,new x.SyncDescriptor(he.SignService,void 0,!1)),we.set(fe.ISharedTunnelsService,new x.SyncDescriptor(me.SharedTunnelsService)),we.set(Se.ISharedProcessTunnelService,new x.SyncDescriptor(Ie.SharedProcessTunnelService)),we.set(bt.IRemoteTunnelService,new x.SyncDescriptor(jt.RemoteTunnelService)),new ie.InstantiationService(we)}j(we){const Me=new v.ExtensionManagementChannel(we.get(f.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Me);const Ge=C.ProxyChannel.fromService(we.get(J.ILanguagePackService));this.a.registerChannel("languagePacks",Ge);const Je=C.ProxyChannel.fromService(we.get(A.IDiagnosticsService));this.a.registerChannel("diagnostics",Je);const it=new v.ExtensionTipsChannel(we.get(f.IExtensionTipsService));this.a.registerChannel("extensionTipsService",it);const Ke=C.ProxyChannel.fromService(we.get(l.IChecksumService));this.a.registerChannel("checksum",Ke);const tt=C.ProxyChannel.fromService(we.get(vt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",tt);const ut=new ge.UserDataSyncMachinesServiceChannel(we.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ut);const ht=C.ProxyChannel.fromService(we.get(Z.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const We=new ge.UserDataSyncAccountServiceChannel(we.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",We);const _e=new ge.UserDataSyncStoreManagementServiceChannel(we.get(Be.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",_e);const ft=new je.UserDataSyncChannel(we.get(Be.IUserDataSyncService),we.get(St.IUserDataProfilesService),we.get(re.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.B(we.get(X.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),nt=new ge.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",nt);const Xe=we.get(Ee.ILocalPtyService),ot=C.ProxyChannel.fromService(Xe);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ot);const gt=C.ProxyChannel.fromService(we.get(Se.ISharedProcessTunnelService));this.a.registerChannel(Se.ipcSharedProcessTunnelChannelName,gt);const ct=C.ProxyChannel.fromService(we.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,ct);const mt=C.ProxyChannel.fromService(we.get(bt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}k(we){window.addEventListener("unhandledrejection",Me=>{(0,c.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,c.setUnexpectedErrorHandler)(Me=>{const Ge=(0,R.toErrorMessage)(Me,!0);!Ge||we.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}}async function Vt(It){const we=new Wt(It);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await we.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Vt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a0562ccdb202a29ac35da81c2b5482e517158f32/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
